/*
 * Copyright (c) 2001-2014,FineReport Inc, All Rights Reserved.
 */

/**
 * Coder: Sean
 * Date: 14-7-10
 * Time: 下午1:08
 */
$(function () {
    var imgOffsetX, imgOffsetY, loginImgWidth, loginImgHeight, scale;
    //报错蒙板
    var $mask = $('<div class="fs-login-errmask"/>');
    var maskWidth = Math.max(FR.i18nTextWidth("FS-User-User_Can_Not_Be_Null", 8) + 10, 308);
    $mask.css('width', maskWidth + 'px');
    //用户名
    var $username = $('input.fs-login-username').attr("placeholder", FR.i18nText("FS-Generic-Simple_Username")).attr('title', FR.i18nText("FS-Generic-Simple_Username"));
    //密码
    var $password = $('input.fs-login-password').attr("placeholder", FR.i18nText("FS-Generic-Simple_Password")).attr('title', FR.i18nText("FS-Generic-Simple_Password"));

    $('input').focus(function () {
        $(this).parent().addClass('fs-login-input-focus');
        $mask.hide();
    }).blur(function () {
        $(this).parent().removeClass('fs-login-input-focus');
    });
    var loginRemember = $('span.fs-login-remember');
    if (FR.Browser.r.mac) {
        loginRemember.css('background-position-y', '1px');
    }
    //是否保持登录状态
    var $keep = loginRemember.text(FR.i18nText("FS-Generic-Privilege_Keep_Login_State")).click(
        function () {
            $(this).toggleClass('fs-login-remember-selected');
            if (FR.Browser.r.mac) {
                loginRemember.css('background-position-y', '1px');
                var remeberSelected = $("span.fs-login-remember-selected");
                if (remeberSelected) {
                    remeberSelected.css('background-position-y', '-47px');
                }
            }
        }
    );

    //登录按钮
    $('#fs-login-btn').text(FR.i18nText("FS-Generic-Sign_In")).click(
        function () {
            signIN();
        }
    );

    //绑定回车
    $(document).keydown(function (e) {
        if (e.keyCode === 13) {
            signIN();
        }
    });
    var themeTrigger = $('.fs-login-theme-trigger');
    var themes = themeTrigger.attr('themes');
    var supportSwitch = themeTrigger.attr('supportSwitch');
    var items = [];
    if (supportSwitch === 'true') {
        items[0] = {
            text: FR.i18nText('Plugin-Theme_Classic'),
            value: 'default'
        };
        items[1] = {
            text: FR.i18nText('Plugin-Theme_Modern'),
            value: 'bi'
        };
        if (themes.length > 0) {
            $.each(themes.split(','), function (i, item) {
                items[i + 2] = {
                    text: item,
                    value: item
                };
            });
        }
        $('.fs-login-theme-text').text(FR.i18nText('Plugin-Theme_Select'));
        var themeEditor = new FR.ComboBoxEditor({
            renderEl: themeTrigger,
            directEdit: false,
            allowBlank: false,
            widgetUrl: null,
            fontSize: 14,
            width: 226,
            height: 24,
            items: items,
            maxCount: 5,
            sonHeight: 21,
            value: 'default',
            listeners: [{
                eventName: FR.Events.AFTEREDIT,
                action: function () {
                    if ($('#fs-login-btn').attr('expired') === 'true') {
                        FR.Msg.alert(FR.i18nText('Fine-Engine_Alert'), FR.i18nText('Plugin-Theme_License_Expired_Tip'), function (result) {
                        });
                    }
                }
            }]
        });
        $username.blur(function () {
            var username = $username.val();
            if (username) {
                FR.ajax({
                    url: FR.servletURL + '?op=theme&cmd=get',
                    data: {
                        username: $username.val()
                    },
                    complete: function (res) {
                        var data = FR.jsonDecode(res.responseText);
                        if (data.status === 'success' && data.theme) {
                            //下拉框的isValueInList方法在这个场景下只能识别显示值，内置的bi需要单独判断
                            var value = themeEditor.isValueInList(data.theme) || data.theme === 'bi' ? data.theme : 'default';
                            themeEditor.setValue(value, false);
                        }
                    }
                });
            }
        });
        var loginglass = $('#fs-login-glass');
        loginglass.height(loginglass.height() + 50);
    } else {
        themeTrigger.hide();
        $('.fs-login-theme-text').hide();
        $('.fs-login-check').height(0);
    }
    /**
     * 初始化FS的登录背景图片
     */
    var initBackgroundImage = function () {
        // var self = this;
        var ran = new Date().getTime() + "" + (Math.random() * 1000);
        FR.ajax({
            url: FR.servletURL + "?op=fs_load&cmd=getLoginImageInfo&_ran=" + ran,
            complete: function (res, status) {
                if (status === 'success') {
                    var loginInfo = FR.jsonDecode(res.responseText);
                    var loginImgID = loginInfo.id;
                    loginImgWidth = parseInt(loginInfo.width, 10);
                    loginImgHeight = parseInt(loginInfo.height, 10);
                    calcBackgroundScale();

                    var url = FR.servletURL + ((loginImgID && loginImgID !== 'null') ?
                            ('?op=fr_attach&cmd=ah_image&id=' + loginImgID + '&isAdjust=false')
                            : '?op=resource&resource=/com/fr/fs/resources/images/oem/signin.jpg');
                    if ($('body').length > 0) {
                        var loginImg = $('img.fs-login-img');
                        loginImg.attr("src", url);
                        loginImg.css({
                            "margin-left": "-" + imgOffsetX + "px",
                            "margin-top": "-" + imgOffsetY + "px",
                            width: loginImgWidth * scale + "px",
                            height: loginImgHeight * scale + "px"
                        });

                        var offset = $('#fs-login-scalebg').offset();
                        var loginScaleBgImg = $('img.fs-login-scalebg-img');
                        loginScaleBgImg.attr("src", url);
                        loginScaleBgImg.css({
                            "margin-left": "-" + (imgOffsetX + offset.left) + "px",
                            "margin-top": "-" + (imgOffsetY + offset.top) + "px",
                            width: loginImgWidth * scale + "px",
                            height: loginImgHeight * scale + "px"
                        });
                    }
                }
            }
        });
    };

    var calcBackgroundScale = function () {
        var windowWidth = document.body.clientWidth;
        var windowHeight = document.body.clientHeight;

        if (windowWidth / windowHeight >= loginImgWidth / loginImgHeight) {
            scale = windowWidth / loginImgWidth;
            imgOffsetX = 0;
            imgOffsetY = (loginImgHeight * scale - windowHeight) / 2;
        } else {
            scale = windowHeight / loginImgHeight;
            imgOffsetX = (loginImgWidth * scale - windowWidth) / 2;
            imgOffsetY = 0;
        }
    };

    var ssLoginErrmsg = $('#single-login-errmsg');
    ssLoginErrmsg.append($("<div id='single-login-errmsg-text'>" + FR.i18nText("FS-System-Single_Login_Failed") + "<a href='#' id='errMsgContent'>" + FR.i18nText("FS-System-Edit_Personal_Password") + "</a>" + FR.i18nText("FS-System-Single_Login_Failed2") + "</div>"));
    ssLoginErrmsg.height($('#single-login-errmsg-text').innerHeight() + 8);
    var showErrorMsg = function ($pos, msg) {
        $mask.hide().insertAfter($pos).text(msg);
        $mask.click(function () {
            $(this).fadeOut();
            $pos.select();
        }).fadeIn();
    };

    var signIN = function () {
        $mask.hide();
        var user = $username.val();
        var pw = $password.val();
        //用户名为空
        if (FR.isEmpty(user)) {
            showErrorMsg($username, FR.i18nText('FS-User-User_Can_Not_Be_Null'));
            return;
        }
        //密码为空
        if (FR.isEmpty(pw)) {
            showErrorMsg($password, FR.i18nText('FS-Admin-Password_Can_Not_Be_Null'));
            return;
        }
        getIpCity(function(ip, city) {
            FR.ajax({
                url: FR.servletURL + '?op=fs_load&cmd=login',
                data: FR.cjkEncodeDO({
                    fr_username: encodeURIComponent(user),
                    fr_password: encodeURIComponent(pw),
                    fr_remember: $keep.hasClass('fs-login-remember-selected'),
                    ip: ip,
                    city: encodeURIComponent(city),
                    theme: $('#fs-login-btn').attr('expired') === 'true' || themeEditor === undefined ? "" : themeEditor.getValue()
                }),
                type: 'POST',
                async: false,
                error: function () {
                    FR.Msg.toast("Error!");
                },
                complete: function (res) {
                    if (res.responseText === "") {
                        showErrorMsg($username, FR.i18nText('FS-Admin-Authentication_failed'));
                        return;
                    }
                    var signResult = FR.jsonDecode(res.responseText);
                    if (signResult.fail) {
                        if (!signResult.errMsg) {
                            //用户名和密码不匹配
                            showErrorMsg($username, FR.i18nText("FS-Generic-Privilege_Name_Not_Match_Password"));
                        }
                        else {
                            ssLoginErrmsg.show();
                        }
                    } else if (signResult.url) {
                        window.location.href = signResult.url;
                    }
                }
            });
        });
    };
    initBackgroundImage();
    initSingleLoginAndForgetPW(themeEditor);
    $username.focus();
    $(window).resize(function () {
        calcBackgroundScale();
        $('img.fs-login-img').css({
            "margin-left": "-" + imgOffsetX + "px",
            "margin-top": "-" + imgOffsetY + "px",
            width: loginImgWidth * scale + "px",
            height: loginImgHeight * scale + "px"
        });
        var offset = $('#fs-login-scalebg').offset();
        $('img.fs-login-scalebg-img').css({
            "margin-left": "-" + (imgOffsetX + offset.left) + "px",
            "margin-top": "-" + (imgOffsetY + offset.top) + "px",
            width: loginImgWidth * scale + "px",
            height: loginImgHeight * scale + "px"
        });
    });
});