/*
 * Copyright (c) 2001-2014,FineReport Inc, All Rights Reserved.
 * author wei
 * 2014-04-08
 */

//FS权限管理

var Constants = {
    privilegeConfigTableWD: "privilegeConfigTableWD",
    privilegeConfigPanelWD: "privilegeConfigPanelWD",
    entryPrivilegeConfigTableWD: "entryPrivilegeConfigTableWD",
    entryPrivilegeConfigPanelWD: "entryPrivilegeConfigPanelWD",
    userPrivilegeViewHorizontalWD: "userPrivilegeViewHorizontalWD",
    entryAndModulePrivilegeViewHorizontalWD: "entryAndModulePrivilegeViewHorizontalWD",
    entryTableTreeNoCheckWD: "entryTableTreeNoCheckWD",
    entryTableTreeNoCheckInPanelWD: "entryTableTreeNoCheckInPanelWD",
    entryTableTreeWD: "entryTableTreeWD",
    entryTableTreeViewOnlyWD: "entryTableTreeViewOnlyWD",
    departmentTableTreeWD: "departmentTableTreeWD",
    departmentTableTreeNoCheckWD: "departmentTableTreeNoCheckWD",
    depAndCRoleTableTreeWD: "depAndCRoleTableTreeWD",
    customRoleListWD: "customRoleListWD",
    forgedUserListWD: "forgedUserListWD",
    customRoleListNoCheckWD: "customRoleListNoCheckWD",
    forgedUserListNoCheckWD: "forgedUserListNoCheckWD",
    positionAndCustomRoleInsideTabNoCheckWD: "positionAndCustomRoleInsideTabNoCheckWD",
    positionAndCustomRoleInsideTabWD: "positionAndCustomRoleInsideTabWD",
    entryAndModuleInsideTabWD: "entryAndModuleInsideTabWD",
    entryAndModuleViewOnlyTabWD: "entryAndModuleViewOnlyTabWD",
    moduleListViewOnlyWD: "moduleListViewOnlyWD",
    moduleListWD: "moduleListWD",
    moduleListNoCheckWD: "moduleListNoCheckWD",
    userListViewOnlyWD: "userListViewOnlyWD",
    userListNoCheckWD: "userListNoCheckWDL",
    addCustomRoleButtonCls: 'fs_privilege_manager_addCustomRole_button',
    postIdPrefix: "-",
    floatPaneTableLayoutWD: "floatPaneTableLayoutWD",
    customRoleNameTextWD: "customRoleNameTextWD",
    departMultiTreeWD: "departMultiTreeWD",
    userSearchWD: "userSearchWD",
    templateControlCardWD: "templateControlCardWD",
    templateTableTreeWD: "templateTableTreeWD",
    settingRadioGroupWD: "settingRadioGroupWD",
    templateTableTreeInPanelWD: "templateTableTreeInPanelWD",
    templatePanelWD: "templatePanelWD",
    keyURLTextEditorWD: "keyURLTextEditorWD",
    gradeAuthoritySwitchWD: "gradeAuthoritySwitchWD",
    editReportSwitchWD: "editReportSwitchWD",
    dataConnectionSwitchWD: "dataConnectionSwitchWD",
    dataConnectionListWD: "dataConnectionListWD",
    customRoleListSyncItemCls: "fs_sys_user_customRoleSyncItem",
    customRoleListItemCls: "fs_cs_srole_item",
    templatePrivileges: {
        NO_VERIFY_NEEDED: -1,
        USER_PASSWORD_VERIFY_NEEDED: 0,
        ROLE_VERIFY_NEEDED: 1,
        DIGITAL_URL: 2
    },
    depAndCRolePaneCls: "fs_privilege_manager_depAndCRolePane",
    depAndCRolePaneTitleCls: "fs_privilege_manager_depAndCRolePaneTitle",
    templateAndDataConnectionInsideTabWD: "templateAndDataConnectionInsideTabWD",
    departmentAllID: FS.config.departmentAllID ? FS.config.departmentAllID : 0,    //所有部门的ID
    postAllID: FS.config.postAllID ? FS.config.postAllID : 0, //所有职务的ID
    space: {
        UP: "userRole",//用户权限
        SP: "customRole",//普通角色权限
        JP: 'companyRole'//部门角色权限
    },
    index_space: {
        2: "userRole",//用户权限
        1: "customRole",//普通角色权限
        0: 'companyRole'//部门角色权限
    }

};

FS.Plugin.configForCustomRoleUI = function () {


};


FS.PRIVILEGEMANAGER = FSPM = {
    init: function (renderEl) {
        FR.$defaultImport('/com/fr/fs/web/css/manager/fs_privilegemanager.css', 'css');
        // 动态宽度
        this.viewWidth = Math.max(30, FR.i18nTextWidth("FS-Generic-Face_View", 6.5) + 5);
        this.writeWidth = Math.max(30, FR.i18nTextWidth("FS-Generic-Face_Write", 6.5) + 5);
        this.designWidth = Math.max(30, FR.i18nTextWidth("FS-Privilege-Simple_Design", 6.5) + 5);
        this.authorityTitleWidth = this.viewWidth + this.writeWidth + this.designWidth + 30;
        this.templateWidth = Math.max(75, FR.i18nTextWidth("FS-Privilege-Simple_Template", 6.5) + 10);
        this.connectionWidth = Math.max(90, FR.i18nTextWidth("FS-System-Connection_List", 6.5) + 10);
        this.templateTableWidth = this.templateWidth + this.connectionWidth + this.authorityTitleWidth;
        this.templateTableContentWidth = this.templateTableWidth - 2;

        this.VIEW.createTabPane(renderEl);
        this.VIEW.createSetPane(renderEl);
    },

    //705是勾选权限后实时保存，706改成点击保存按钮后一次性保存。因此需要把之前做过的设置都保存起来。
    CACHE: {
        clearCache: function () {
            this.clearEntryCache();
            this.clearRoleCache();
        },

        clearEntryCache: function () {
            this.entryCache = {};
            this.originalEntryCache = {};
        },

        clearRoleCache: function () {
            this.roleCache = {};
            this.roleCache[Constants.space.JP] = {};
            this.roleCache[Constants.space.SP] = {};
            this.roleCache[Constants.space.UP] = {};
            this.originalPrivilege = {};
            this.originalPrivilege[Constants.space.JP] = {};
            this.originalPrivilege[Constants.space.SP] = {};
            this.originalPrivilege[Constants.space.UP] = {};
        },


        /*********** 报表快捷权限配置缓存 ************/
        getEntryCache: function () {
            if (!this.entryCache) {
                this.entryCache = {};
            }
            return this.entryCache;
        },

        dealWithEntryCache: function (entryCache, roles, currentNode, space) {
            entryCache = entryCache || [];
            //bug90592,搜索之后之前的设置会丢掉,这边保存到缓存里,
            // 但是每一次操作都要先把自身节点删掉,然后如果不选中就不管选中就继续加上去
            if (space != Constants.space.JP) {
                $.each(roles, function (rileIndex, itemRole) {
                    entryCache = _.filter(entryCache, function (node) {
                        return node.id != itemRole.id;
                    });
                });
            } else {
                //REPORT-2865
                if (FR.isEmptyArray(roles) && currentNode === undefined) {
                    entryCache = [];
                }
                //需要从cache 中移除的id
                var relationIds = FSPM.VIEW.departmentTableTree.getSelectNodesAttrs('id').concat(FSPM.VIEW.departmentTableTree.getNodeRelationAttrs(currentNode, 'id'));
                entryCache = _.filter(entryCache, function (node) {
                    return relationIds.indexOf(node.id) === -1;
                });
            }
            var extraPrivileges = FS.Plugin.PrivilegeManageExtraPrivilegeProvider.items;
            for (var i = 0, len = roles.length; i < len; i++) {
                var item = {};
                //和getCompanyRoleAuth保持一致，去掉type
                item.id = roles[i].id;
                item.view = roles[i].view;
                if (extraPrivileges && extraPrivileges.length > 0){
                    for (var j = 0; j < extraPrivileges.length;j++){
                        item[extraPrivileges[j].value] = roles[i][extraPrivileges[j].value];
                    }
                }
                if (FS.isGradeAuthorityOpen()) {
                    item.design = roles[i].design;
                } else if (item.view === 1) {
                    item.design = 1;
                }
                if (FS.isEditReportAuthorityOpen()) {
                    item.edit = roles[i].edit;
                } else if (item.view === 1 && (!FS.isGradeAuthorityOpen() || item.design === 1)) {
                    item.edit = 1;
                }
                entryCache.push(item);
            }
            return entryCache;
        },

        setEntryCache: function (entryId, roles, space, currentTreeNode) {
            entryId = entryId + "";
            if (!this.getEntryCache()[entryId]) {
                this.getEntryCache()[entryId] = {};
            }
            this.getEntryCache()[entryId][space] = this.dealWithEntryCache(this.getEntryCache()[entryId][space], roles, currentTreeNode, space);
        },

        keepOriginalEntryCache: function (entryId, roles, space) {
            if (!this.originalEntryCache) {
                this.originalEntryCache = {};
            }
            if (!this.originalEntryCache[entryId]) {
                this.originalEntryCache[entryId] = {};
            }
            if (this.originalEntryCache[entryId][space]) {
                return;
            } else {
                this.setEntryCache(entryId, roles, space);
                this.originalEntryCache[entryId][space] = FR.clone(roles);
            }
        },

        getOriginalEntryCache: function () {
            if (!this.originalEntryCache) {
                this.originalEntryCache = {};
            }
            return this.originalEntryCache;
        },

        refreshOriginalEntryCache: function (entryCache) {
            this.originalEntryCache = entryCache;
        },

        /************* 权限配置缓存 ****************/

        getRoleCache: function (space) {
            if (!this.roleCache) {
                this.roleCache = {};
                this.roleCache[Constants.space.JP] = {};
                this.roleCache[Constants.space.SP] = {};
                this.roleCache[Constants.space.UP] = {};
            }
            return space ? this.roleCache[space] : this.roleCache;
        },

        delecteCache: function (roleId, space) {
            roleId = roleId + "";
            if (roleId) {
                delete this.getRoleCache(space)[roleId];
                delete this.getOriginalPrivilege(space)[roleId];
            }
        },

        dealWithEntryPrivilege: function (roleId, entries, hasType) {
            var entryCache = [];
            var extraPrivileges = FS.Plugin.PrivilegeManageExtraPrivilegeProvider.items;
            for (var i = 0, len = entries.length; i < len; i++) {
                var item = {};
                var entryNode = entries[i];
                //和getCompanyRoleAuth保持一致，去掉type
                if (hasType) {
                    item.id = entryNode.id.substr(1);
                } else {
                    item.id = entryNode.id;
                }
                item.view = entryNode.view;
                if (extraPrivileges && extraPrivileges.length > 0){
                    for (var j = 0; j < extraPrivileges.length;j++){
                        item[extraPrivileges[j].value] = entryNode[extraPrivileges[j].value];
                    }
                }
                if (!FS.isGradeAuthorityOpen()) {
                    item.design = item.view;
                    if (!FS.isEditReportAuthorityOpen()) {
                        item.edit = item.view;
                    }
                } else {
                    item.design = entryNode.design;
                    if (!FS.isEditReportAuthorityOpen()) {
                        item.edit = item.design;
                    }
                }
                if (FS.isEditReportAuthorityOpen()) {
                    item.edit = entryNode.edit;
                }
                item.type = entryNode.type;
                if (this._isNodeSpecial(entryNode)) {
                    //补一个说明 TT-20 假如是分级管理员并不是拿到目录下所有的子节点，强转为2 半选状态
                    if (entryNode.view === 1) {
                        item.view = 2;
                    }
                    if (extraPrivileges && extraPrivileges.length > 0){
                        for (var j = 0; j < extraPrivileges.length;j++){
                            if (entryNode[extraPrivileges[j].value] === 1){
                                item[extraPrivileges[j].value] = 2;
                            }
                        }
                    }
                    if (entryNode.design === 1) {
                        item.design = 2;
                    }
                    if (entryNode.edit === 1) {
                        item.edit = 2;
                    }
                }
                entryCache.push(item);
            }
            return entryCache;
        },

        _isNodeSpecial: function (node) {
            //bugTT-20分级管理员的场景中会根据后台的传过来的isAllChildrenIn判断看到的目录节点是不是真的包含了所有子节点的
            return node ? FS.Plugin.GradeAuthority.isGradeAdmin && !FS.isAdmin() && node.isAllChildrenIn === false : false;
        },

        setEntryPrivilege: function (roleId, entries, hasType, space) {
            roleId = roleId + "";
            if (!this.getRoleCache(space)[roleId]) {
                this.getRoleCache(space)[roleId] = {};
            }
            var entryCache = this.dealWithEntryPrivilege(roleId, entries, hasType);
            this.getRoleCache(space)[roleId].entries = FR.clone(entryCache);
        },

        dealWithModulePrivilege: function (roleId, modules) {
            var moduleCache = [];
            for (var i = 0; i < modules.length; i++) {
                var item = {};
                if (!modules[i].view) {
                    continue;
                } else {
                    item.view = 1;
                    if (!FS.isGradeAuthorityOpen()) {
                        item.design = 1;
                    } else {
                        item.design = modules[i].design;
                    }
                    item.id = modules[i].id;
                }
                moduleCache.push(item);
            }
            return moduleCache;
        },

        setModulePrivilege: function (roleId, modules, space) {
            roleId = roleId + "";
            if (!this.getRoleCache(space)[roleId]) {
                this.getRoleCache(space)[roleId] = {};
            }
            var moduleCache = this.dealWithModulePrivilege(roleId, modules);
            this.getRoleCache(space)[roleId].modules = FR.clone(moduleCache);
        },
        setTemplateCache: function (currentNode, space) {
            space = space || FSPM.VIEW.getCurrentSpace();
            var roleId = FSPM.VIEW.getCurrentRoleId();
            if (!roleId) {
                return;
            }
            if (!this.getRoleCache(space)[roleId].templates) {
                this.getRoleCache(space)[roleId].templates = {};
            }

            this.getRoleCache(space)[roleId].templates = this.dealWithTemplateCache(this.getRoleCache(space)[roleId].templates, FSPM.VIEW.templateTableTree.getSelectedNodes(), currentNode);

        },
        dealWithTemplateCache: function (templateCache, templates, currentNode) {
            templateCache = templateCache || [];
            //当前有选中状态的和当前节点的所有子节点都先从缓存中移除,因为templates包含了这些节点了,不移除会有重复数据
            var relationPaths = FSPM.VIEW.templateTableTree.getSelectNodesAttrs('path').concat(FSPM.VIEW.templateTableTree.getNodeRelationAttrs(currentNode, 'path'));
            templateCache = _.filter(templateCache, function (node) {
                return relationPaths.indexOf(node.path) === -1;
            });
            for (var i = 0, len = templates.length; i < len; i++) {
                var template = templates[i];
                var item = {};
                item.path = template.path;
                item.page = template.page;
                item.write = template.write;
                item.design = template.design;
                if (this._isNodeSpecial(template)) {
                    if (template.page === 1) {
                        item.page = 2;
                    }
                    if (template.write === 1) {
                        item.write = 2;
                    }
                    if (template.design === 1) {
                        item.design = 2;
                    }
                }
                templateCache.push(item);
            }
            return templateCache;
        },

        dealWithTemplatePrivilege: function (roleId, templates) {
            var templateCache = [];
            for (var i = 0, len = templates.length; i < len; i++) {
                var template = templates[i];
                var item = {};
                item.id = template.id;
                item.path = template.path;
                item.page = template.page;
                item.write = template.write;
                item.design = template.design;
                if (this._isNodeSpecial(template)) {
                    if (template.page === 1) {
                        item.page = 2;
                    }
                    if (template.write === 1) {
                        item.write = 2;
                    }
                    if (template.design === 1) {
                        item.design = 2;
                    }
                }
                templateCache.push(item);
            }
            return templateCache;
        },

        dealWithDepAndCRolePrivilege: function (id, depandcroles) {
            var depAndCRoleCache = [];
            for (var i = 0, len = depandcroles.length; i < len; i++) {
                var depandcrole = depandcroles[i].id ? depandcroles[i].id : depandcroles[i];
                depAndCRoleCache.push(depandcrole);
            }
            return depAndCRoleCache;
        },

        setTemplatePrivilege: function (roleId, templates, space) {
            roleId = roleId + "";
            if (!this.getRoleCache(space)[roleId]) {
                this.getRoleCache(space)[roleId] = {};
            }
            var templateCache = this.dealWithTemplatePrivilege(roleId, templates);
            this.getRoleCache(space)[roleId].templates = FR.clone(templateCache);
        },

        setDepAndCRolePrivilege: function (roleId, depandcroles, space) {
            roleId = roleId + "";
            if (!this.getRoleCache(space)[roleId]) {
                this.getRoleCache(space)[roleId] = {};
            }
            var depAndCRoleCache = this.dealWithDepAndCRolePrivilege(roleId, depandcroles);
            this.getRoleCache(space)[roleId].depandcroles = FR.clone(depAndCRoleCache);
        },

        dealWithDataConnectionPrivilege: function (id, dataConnections) {
            var dataConnectionRoleCache = [];
            for (var i = 0, len = dataConnections.length; i < len; i++) {
                if (dataConnections[i].value && dataConnections[i].view === 1) {
                    dataConnectionRoleCache.push(dataConnections[i].value);
                } else if (!dataConnections[i].value) {
                    dataConnectionRoleCache.push(dataConnections[i]);
                }
            }
            return dataConnectionRoleCache;
        },

        setDataConnectionPrivilege: function (roleId, dataConnections, space) {
            roleId = roleId + "";
            if (!this.getRoleCache(space)[roleId]) {
                this.getRoleCache(space)[roleId] = {};
            }
            var dataConnectionCache = this.dealWithDataConnectionPrivilege(roleId, dataConnections);
            this.getRoleCache(space)[roleId].dataconnections = FR.clone(dataConnectionCache);
        },

        getRolePrivilege: function (id, space) {
            return this.getRoleCache(space)[id];
        },

        getEntryPrivilege: function (id, space) {
            if (!this.getRoleCache(space)[id]) {
                return;
            }
            return this.getRoleCache(space)[id].entries;
        },

        getModulePrivilege: function (id, space) {
            if (!this.getRoleCache(space)[id]) {
                return;
            }
            return this.getRoleCache(space)[id].modules;
        },

        getTemplatePrivilege: function (id, space) {
            if (!this.getRoleCache(space)[id]) {
                return;
            }
            return this.getRoleCache(space)[id].templates;
        },

        getDepAndCRolePrivilege: function (id, space) {
            if (!this.getRoleCache(space)[id]) {
                return;
            }
            return this.getRoleCache(space)[id].depandcroles;
        },

        getDataConnectionPrivilege: function (id, space) {
            if (!this.getRoleCache(space)[id]) {
                return;
            }
            return this.getRoleCache(space)[id].dataconnections;
        },

        //保存从服务器端获取的权限信息
        cachePrivilege: function (id, privilege, space) {
            this.keepOriginalPrivilege(id, privilege, space);
            var entries = FR.jsonDecode(privilege.reports);
            var modules = FR.jsonDecode(privilege.modules);
            var templates = FR.jsonDecode(privilege.templates);
            var depAndCRoles = privilege.depandcroles ? privilege.depandcroles.slice(0) : [];
            var dataConnections = privilege.dataconnections ? privilege.dataconnections.slice(0) : [];
            //如果缓存里已经有了，就不加了
            if (!this.getEntryPrivilege(id, space)) {
                this.setEntryPrivilege(id, entries, false, space);
            }
            if (!this.getModulePrivilege(id, space)) {
                this.setModulePrivilege(id, modules, space);
            }
            if (!this.getTemplatePrivilege(id, space)) {
                this.setTemplatePrivilege(id, templates, space);
            }
            if (!this.getDepAndCRolePrivilege(id, space)) {
                this.setDepAndCRolePrivilege(id, depAndCRoles, space);
            }
            if (!this.getDataConnectionPrivilege(id, space)) {
                this.setDataConnectionPrivilege(id, dataConnections, space);
            }
        },

        //记录下更改权限前的配置信息，方便后面保存时对比变动  todo originalPrivilege 里面完全可以分开存储部门角色和普通角色,参照用户权限  REPORT-3282
        keepOriginalPrivilege: function (id, privilege, space) {
            //如果缓存里已经有了，就不加了
            if (!this.originalPrivilege) {
                this.originalPrivilege = {};
                this.originalPrivilege[Constants.space.UP] = {};
                this.originalPrivilege[Constants.space.SP] = {};
                this.originalPrivilege[Constants.space.JP] = {};
            }
            if (this.originalPrivilege[space][id]) {
                return;
            } else {
                this.originalPrivilege[space][id] = {};
            }
            var entries = FR.jsonDecode(privilege.reports);
            var modules = FR.jsonDecode(privilege.modules);
            var templates = FR.jsonDecode(privilege.templates);
            var depAndCRoles = privilege.depandcroles ? privilege.depandcroles.slice(0) : [];
            var dataConnections = privilege.dataconnections ? privilege.dataconnections.slice(0) : [];
            this.originalPrivilege[space][id]['entries'] = this.dealWithEntryPrivilege(id, entries, false);
            this.originalPrivilege[space][id]['modules'] = this.dealWithModulePrivilege(id, modules);
            this.originalPrivilege[space][id]['templates'] = this.dealWithTemplatePrivilege(id, templates);
            this.originalPrivilege[space][id]['depandcroles'] = this.dealWithDepAndCRolePrivilege(id, depAndCRoles);
            this.originalPrivilege[space][id]['dataconnections'] = this.dealWithDataConnectionPrivilege(id, dataConnections);
        },

        getOriginalPrivilege: function (space) {
            if (!this.originalPrivilege) {
                this.originalPrivilege = {};
                this.originalPrivilege[Constants.space.UP] = {};
                this.originalPrivilege[Constants.space.SP] = {};
                this.originalPrivilege[Constants.space.JP] = {};
            }
            return space ? this.originalPrivilege[space] : this.originalPrivilege;
        },

        refreshOriginalPrivilege: function (privileges) {
            this.originalPrivilege = privileges;
        }
    },

    TABLETREESETTINGS: {
        getEntryTableTreeSetting: function (clickFunc, toolLength) {
            function filter(parentNode, node, newNodes, result) {
                if (!newNodes) {
                    return null;
                }

                if (!result) {
                    result = [];
                }
                for (var i = 0, l = newNodes.length; i < l; i++) {
                    var item = newNodes[i];
                    //department/entry
                    var zItem = {};
                    zItem.id = item.id;
                    zItem.pId = item.parentID || item.parentId;
                    zItem.name = item.text;
                    zItem.open = false;
                    zItem.type = item.type;
                    zItem.description = item.description;
                    zItem.isAllChildrenIn = item.isAllChildrenIn;
                    if (item.edit !== 1) {
                        zItem.toolDisAbleIndex = toolLength - 1;
                    }
                    if (item.ChildNodes && item.ChildNodes.length > 0) {
                        filter(parentNode, node, item.ChildNodes, result);
                    }
                    if (FSPM.CONTROL._alreadyExists(zItem.id, result)) {
                        continue;
                    }
                    result.push(zItem);
                }
                return result;
            }

            return {
                async: {
                    enable: true,
                    url: FR.servletURL + "?op=fs_set&cmd=auth_getallreports",
                    dataFilter: filter,
                    data: {
                        serverID: FS.serverID
                    }
                },
                view: {
                    showIcon: false,  //不显示每个节点前的ICON
                    selectedMulti: toolLength > 0
                },
                data: {
                    simpleData: {
                        enable: true,
                        idKey: "id",
                        pidKey: "pId",
                        rootPId: "0-1"
                    }
                },
                callback: {
                    onClick: clickFunc,
                    beforeClick: function () {
                        if (toolLength > 0) {
                            return false;
                        }
                    }
                }
            };
        },

        getTemplateTableTreeSetting: function () {
            function filter(parentNode, node, newNodes) {
                if (!newNodes) {
                    return null;
                }
                for (var i = 0, l = newNodes.length; i < l; i++) {
                    if (newNodes[i].hasChildren && newNodes[i].ChildNodes.length > 0) {
                        filter(null, null, newNodes[i].ChildNodes);
                    }
                    if (newNodes[i].page !== 1) {
                        newNodes[i].toolDisAbleIndex = 0;
                    }
                    if (newNodes[i].write !== 1) {
                        newNodes[i].toolDisAbleIndex = 1;
                    }
                    if (newNodes[i].design !== 1) {
                        newNodes[i].toolDisAbleIndex = 2;
                    }
                    delete newNodes[i].page;
                    delete newNodes[i].write;
                    delete newNodes[i].design;
                }
                return newNodes;
            }

            return {
                async: {
                    enable: true,
                    url: FR.servletURL + "?op=fs_entry&cmd=get_user_reports",
                    dataFilter: filter,
                    data: {
                        serverID: FS.serverID
                    }
                },
                data: {
                    key: {
                        children: "ChildNodes",
                        name: 'value'
                    },
                    simpleData: {
                        pIdKey: "pId"
                    }
                },
                view: {
                    showIcon: false,
                    selectedMulti: true
                },
                callback: {
                    beforeClick: function () {
                        return false;
                    }
                }
            };
        }
    },

    showEntryAuth: function (e, treeId, treeNode) {
        if (!treeNode) {
            return;
        }
        var entryId = treeNode.id;
        var cacheEntryRolePrivilege = FSPM.CACHE.getEntryCache()[entryId];
        if (!cacheEntryRolePrivilege) {
            //没有缓存，要去服务器端取下
            var entryRoles = FS.Trans.getEntryRoles(entryId);
            //缓存下
            var companyRoles = entryRoles[Constants.space.JP];
            var customRoles = entryRoles[Constants.space.SP];
            var userRoles = entryRoles[Constants.space.UP];
            //bug99708
            //无权限时看下父目录的权限情况，与新增报表后预览时权限情况保持一致
            if (companyRoles.length === 0 && customRoles.length === 0 && userRoles.length === 0) {
                if (treeNode.getParentNode()) {
                    var parentEntryRoles = FS.Trans.getEntryRoles(treeNode.getParentNode().id);
                    var comRoles = parentEntryRoles[Constants.space.JP];
                    var cusRoles = parentEntryRoles[Constants.space.SP];
                    var uRoles = parentEntryRoles[Constants.space.UP];
                    for (var i = 0; i < comRoles.length; i++) {
                        if (comRoles[i].view === 1) {
                            companyRoles.push(comRoles[i]);
                        }
                    }
                    for (i = 0; i < cusRoles.length; i++) {
                        if (cusRoles[i].view === 1) {
                            customRoles.push(cusRoles[i]);
                        }
                    }
                    for (i = 0; i < uRoles.length; i++) {
                        if (uRoles[i].view === 1) {
                            userRoles.push(uRoles[i]);
                        }
                    }
                }
            }
            FSPM.CACHE.keepOriginalEntryCache(entryId, companyRoles, Constants.space.JP);
            FSPM.CACHE.keepOriginalEntryCache(entryId, customRoles, Constants.space.SP);
            FSPM.CACHE.keepOriginalEntryCache(entryId, userRoles, Constants.space.UP);
            cacheEntryRolePrivilege = FSPM.CACHE.getEntryCache()[entryId];
        }
        FSPM.VIEW.reportTableTree.clearState();

        var authTabPane = FSPM.VIEW.tabPane.getWidgetByName(Constants.positionAndCustomRoleInsideTabWD);
        if (authTabPane.getActiveIndex() === 0) {
            //部门
            FSPM.VIEW.departmentTableTree.clearState();
            FSPM.VIEW.departmentTableTree.selectNodesByData(cacheEntryRolePrivilege[Constants.space.JP]);
        } else if (authTabPane.getActiveIndex() === 1) {
            var customRoleList = authTabPane.getWidgetByName(Constants.customRoleListWD);
            customRoleList.clearState();
            customRoleList.selectByData(cacheEntryRolePrivilege[Constants.space.SP]);
        } else {
            var forgedUserList = authTabPane.getWidgetByName(Constants.forgedUserListWD);
            forgedUserList.clearState();
            forgedUserList.selectByData(cacheEntryRolePrivilege[Constants.space.UP]);
        }

    },

    showUserAuth: function (auth) {
        if (!auth) {
            return;
        }
        var entryAndModuleTabPane = FSPM.VIEW.tabPane.getWidgetByName(Constants.entryAndModuleViewOnlyTabWD);
        if (entryAndModuleTabPane.getActiveIndex() === 0) {
            //报表
            var entryTableTreeViewOnly = FSPM.VIEW.tabPane.getWidgetByName(Constants.entryTableTreeViewOnlyWD);
            entryTableTreeViewOnly.clearState();
            entryTableTreeViewOnly.selectNodesByData(auth.entries);
        } else {
            //平台管理
            var moduleListViewOnly = FSPM.VIEW.tabPane.getWidgetByName(Constants.moduleListViewOnlyWD);
            moduleListViewOnly.clearState();
            moduleListViewOnly.selectByData(auth.modules);
        }
    },

    showEntryUser: function (e, treeId, treeNode) {
        var userListViewOnly = FSPM.VIEW.tabPane.getWidgetByName(Constants.userListViewOnlyWD);
        var entryId = treeNode.id;
        userListViewOnly.refresh({
            async: {
                url: FR.servletURL + "?op=fs_set&cmd=auth_getEntryUsers",
                data: {
                    entryId: entryId,
                    serverID: FS.serverID
                }
            }
        });
    },

    showModuleUser: function () {
        var moduleId = this.getValue();
        var userListViewOnly = FSPM.VIEW.tabPane.getWidgetByName(Constants.userListViewOnlyWD);
        userListViewOnly.refresh({
            async: {
                url: FR.servletURL + "?op=fs_set&cmd=auth_getModuleUsers",
                data: {
                    moduleId: moduleId,
                    serverID: FS.serverID
                }
            }
        });
    },

    VIEW: {
        //设置界面
        createSetPane: function (anchor) {

            var rowSize = [0, 65, 21, 25];
            var contentHeight = 215;

            var items = [
                [
                    null, null, {el: $('<div/>')}
                ],
                [
                    null,
                    {
                        el: {
                            type: 'llabel',
                            value: FR.i18nText("FS-Privilege-Template_Control"),
                            width: FR.i18nTextWidth("FS-Privilege-Template_Control", 6.5) + 32
                        }
                    },
                    {
                        el: {
                            type: 'radiogroup',
                            assureSelect: true,
                            columnsInRow: 4,
                            width: 600,
                            value: -1,
                            widgetName: Constants.settingRadioGroupWD,
                            items: [
                                {
                                    value: Constants.templatePrivileges.NO_VERIFY_NEEDED,
                                    text: FR.i18nText("FS-Privilege-No_Control")
                                },
                                {
                                    value: Constants.templatePrivileges.USER_PASSWORD_VERIFY_NEEDED,
                                    text: FR.i18nText("FS-Privilege-Username_And_Password")
                                },
                                {
                                    value: Constants.templatePrivileges.ROLE_VERIFY_NEEDED,
                                    text: FR.i18nText("FS-Privilege-Template_Role")
                                },
                                {
                                    value: Constants.templatePrivileges.DIGITAL_URL,
                                    text: FR.i18nText("FS-Privilege-Digital_Sign")
                                }
                            ],
                            listeners: [
                                {
                                    eventName: FR.Events.AFTEREDIT,
                                    action: function () {
                                        var value = this.getValue();
                                        var cardLayout = floatPane.getWidgetByName(Constants.templateControlCardWD);
                                        if (value === Constants.templatePrivileges.ROLE_VERIFY_NEEDED) {
                                            cardLayout.showCardByIndex(1);
                                            cardLayout.getWidgetByName(Constants.dataConnectionSwitchWD).setValue(FS.isDataConnectionAuthorityOpen(), false);
                                        } else if (value == Constants.templatePrivileges.DIGITAL_URL) {
                                            cardLayout.showCardByIndex(2);
                                        } else {
                                            cardLayout.showCardByIndex(0);
                                        }
                                    }
                                }
                            ]
                        }
                    }
                ],
                [
                    null,
                    null,
                    {
                        el: {
                            width: 725,
                            height: 25,
                            type: "card",
                            items: [
                                {
                                    el: $("<div/>")
                                },
                                {
                                    el: {
                                        type: 'absolute',
                                        items: [
                                            {
                                                el: {
                                                    type: 'llabel',
                                                    value: FR.i18nText("FS-Privilege-Data_Connection_Control")
                                                },
                                                x: 0,
                                                y: 0,
                                                width: 180
                                            },
                                            {
                                                el: {
                                                    type: 'switch',
                                                    widgetName: Constants.dataConnectionSwitchWD
                                                },
                                                x: 150,
                                                y: 0
                                            }
                                        ]
                                    }
                                },
                                {
                                    el: {
                                        type: 'absolute',
                                        items: [
                                            {
                                                el: {
                                                    type: 'llabel',
                                                    value: FR.i18nText("FS-Privilege-Digital_Sign_Key_Url"),
                                                    width: FR.i18nTextWidth("FS-Privilege-Digital_Sign_Key_Url", 6.5) > 170 ?
                                                        FR.i18nTextWidth("FS-Privilege-Digital_Sign_Key_Url", 6.5) + 50 : 180
                                                },
                                                x: 0,
                                                y: 0
                                            },
                                            {
                                                el: {
                                                    type: 'text',
                                                    width: 300,
                                                    height: 21,
                                                    widgetName: Constants.keyURLTextEditorWD
                                                },
                                                x: Math.max(140, FR.i18nTextWidth("FS-Privilege-Digital_Sign_Key_Url", 6.5) + 20),
                                                y: 0
                                            }
                                        ]
                                    }
                                }
                            ],
                            widgetName: Constants.templateControlCardWD,
                            defaultShowIndex: 0
                        }
                    }
                ]
            ];
            //不是platform才支持分级授权，报表编辑
            items.splice(1, 0, [
                null,
                {
                    el: {
                        type: 'llabel',
                        height: 52,
                        value: FR.i18nText("FS-Privilege-Grade_Authority_Manager")
                    }
                },
                {
                    el: {
                        type: 'tablelayout',
                        vgap: 12,
                        columnSize: [150, 130],
                        rowSize: [24, 24],
                        items: [
                            [
                                {
                                    el: {
                                        type: 'llabel',
                                        value: FR.i18nText("FS-Privilege-Grade_Authority")
                                    }
                                },
                                {
                                    el: {
                                        type: 'switch',
                                        widgetName: Constants.gradeAuthoritySwitchWD,
                                        onTurnOff: function () {

                                        },
                                        onTurnOn: function () {
                                            if (!FS.hasGradeAuthority()) {
                                                FR.Msg.alert(FR.i18nText("Fine-Engine_FS_Generic_Simple_Alert"), FR.i18nText("FS-Generic-You_Are_Using_Unregisted_Function") + ": " + FR.i18nText("FS-Generic-Re_Multi_Privilege"));
                                                return false;
                                            }
                                        }
                                    }
                                }
                            ],
                            [
                                {
                                    el: {
                                        type: 'llabel',
                                        value: FR.i18nText("FS-Privilege-Template_Edit")
                                    }
                                },
                                {
                                    el: {
                                        type: 'switch',
                                        widgetName: Constants.editReportSwitchWD,
                                        onTurnOff: function () {

                                        },
                                        onTurnOn: function () {
                                            if (!FS.hasGradeAuthority()) {
                                                FR.Msg.alert(FR.i18nText("Fine-Engine_FS_Generic_Simple_Alert"), FR.i18nText("FS-Generic-You_Are_Using_Unregisted_Function") + ": " + FR.i18nText("FS-Generic-Re_Multi_Privilege"));
                                                return false;
                                            }
                                        }
                                    }

                                }
                            ]
                        ]
                    }
                }
            ]);
            if (!FS.isGradeAuthorityOpen() || FS.isAdmin()) {
                //只有没开启分级权限或者是管理员的时候才能看到设置面板
                var floatPane = FR.createWidget({
                    type: 'floatpane',
                    anchor: anchor,
                    contentHeight: contentHeight,
                    contentWidget: {
                        type: 'confirm',
                        fit: true,
                        doSize: true,
                        closeAfterAction: false,
                        btnsAlignment: 'left',
                        needSeparate: 8,
                        onOK: function () {
                            FSPM.CONTROL.setData(floatPane);
                        },
                        onCancel: function () {
                            floatPane.doSlide();
                        },
                        contentWidget: {
                            type: 'tablelayout',
                            scrolly: true,
                            widgetName: Constants.floatPaneTableLayoutWD,
                            columnSize: [
                                40,
                                Math.max(110, FR.i18nTextWidth("FS-Privilege-Template_Control", 6.5) + 10),
                                530
                            ],
                            rowSize: rowSize,
                            vgap: 15,
                            items: items
                        }
                    }
                });
                FSPM.CONTROL.popSettingData(floatPane);
            }
        },
        //权限配置，报表权限快捷配置，用户权限查看，报表/平台关系权限查看的tabPane
        createTabPane: function (renderEl) {
            var self = this;
            this.renderEl = renderEl;
            var tabs = [this.privilegeConfig()];
            tabs = tabs.concat([this.reportPrivilegeConfig(), this.userPrivilegeView(), this.entryAndModulePrivilegeView()]);
            var resizeFns = [
                function (container, width, height) {
                    container.getWidgetByName(Constants.privilegeConfigPanelWD).doResize({
                        width: width,
                        height: height - 70
                    });
                }, function (container, width, height) {
                    container.getWidgetByName(Constants.entryPrivilegeConfigPanelWD).doResize({
                        width: width,
                        height: height - 70
                    });
                }, function (container, width, height) {

                }, function (container, width, height) {

                }
            ];
            this.tabPane = new FS.LTabPane({
                width: '100%',
                height: '100%',
                vgap: 21,
                items: tabs,
                renderEl: renderEl,
                initAfterActions: [
                    function () {
                        FSPM.VIEW.depAndCRolePane = null;
                        this.getWidgetByName(Constants.privilegeConfigTableWD).doLayout();
                        FSPM.VIEW.reportTableTree = this.getWidgetByName(Constants.entryTableTreeWD);
                        FSPM.VIEW.templateTableTree = this.getWidgetByName(Constants.templateTableTreeInPanelWD) ||
                            this.getWidgetByName(Constants.templateTableTreeWD);
                    },
                    function () {
                        this.getWidgetByName(Constants.entryPrivilegeConfigTableWD).doLayout();
                        FSPM.VIEW.departmentTableTree = this.getWidgetByName(Constants.departmentTableTreeWD);
                    },
                    function () {
                        this.getWidgetByName(Constants.userPrivilegeViewHorizontalWD).doLayout();
                    },
                    function () {
                        this.getWidgetByName(Constants.entryAndModulePrivilegeViewHorizontalWD).doLayout();
                    }
                ],
                opAfterActions: [
                    function () {
                        var posAndRoleTab = this.getWidgetByName(Constants.positionAndCustomRoleInsideTabNoCheckWD);
                        posAndRoleTab.options.afterTabClick[posAndRoleTab.getActiveIndex()].apply();
                        resizeFns[0](this, renderEl.width(), renderEl.height());
                    }, function () {
                        var posAndRoleTab = this.getWidgetByName(Constants.positionAndCustomRoleInsideTabWD);
                        posAndRoleTab.options.afterTabClick[posAndRoleTab.getActiveIndex()].apply();
                        resizeFns[1](this, renderEl.width(), renderEl.height());
                    }, function () {
                        FSPM.VIEW.setUserPanelItemPrivilege();
                        resizeFns[2](this, renderEl.width(), renderEl.height());
                    }, function () {
                        this.getWidgetByName(Constants.userListViewOnlyWD).refresh();
                        resizeFns[3](this, renderEl.width(), renderEl.height());
                    }
                ],
                marginLeft: 0
            });
            this.renderEl.css("overflow", "hidden");
            this.renderEl.data("onResize", function (width, height) {
                var tabIdx = self.tabPane.getSelectedIndex();
                if (tabIdx !== null) {
                    resizeFns[tabIdx](self.tabPane, width, height);
                }
            });

        },

        //权限配置
        privilegeConfig: function () {
            var items = [{el: $('<div/>')}, this.privilegeReceptorTabPane()];
            items.push(this.entryAndModuleTabPane());
            if (FS.config.templatePrivilegeType == Constants.templatePrivileges.ROLE_VERIFY_NEEDED) {
                //角色权限控制时才显示
                if (FS.isDataConnectionAuthorityOpen()) {
                    items.push(this.templateAndDataConnectionTabPane());
                } else {
                    items.push(this.templatePanel());
                }
            }
            var widthArr = $.map(items, function (item) {
                if (item.el && $.isNumeric(item.el.width)) {
                    return Number(item.el.width) + 40;
                } else {
                    return 40;
                }
            });
            if (FS.Plugin.MultiLevelReport.pushItem) {//无平台且角色权限控制时才显示
                FS.Plugin.MultiLevelReport.pushItem(items);
            }
            return {
                title: FR.i18nText("FS-Privilege-Simple_Setting"),
                content: {
                    type: 'confirm',
                    widgetName: Constants.privilegeConfigPanelWD,
                    firstBtnMargin: 40,
                    needSeparate: 8,
                    btnsAlignment: 'left',
                    closeAfterAction: false,
                    width: this.renderEl.width(),
                    height: this.renderEl.height() - 70,
                    onOK: function () {
                        FSPM.CONTROL.saveAuth();
                    },
                    doSize: true,
                    text4Cancel: null,
                    text4OK: FR.i18nText("FS-Frame-Simple_Save"),
                    contentWidget: {
                        type: 'tablelayout',
                        columnSize: widthArr,
                        rowSize: [400],
                        widgetName: Constants.privilegeConfigTableWD,
                        scrollable: true,
                        items: [items]
                    }
                }
            };
        },

        //报表权限快捷配置
        reportPrivilegeConfig: function () {
            return {
                title: FR.i18nText("FS-Privilege-Entry_Config"),
                content: {
                    type: 'confirm',
                    widgetName: Constants.entryPrivilegeConfigPanelWD,
                    firstBtnMargin: 40,
                    needSeparate: 8,
                    btnsAlignment: 'left',
                    closeAfterAction: false,
                    width: this.renderEl.width(),
                    height: this.renderEl.height() - 70,
                    onOK: function () {
                        FSPM.CONTROL.saveEntryAuth();
                    },
                    doSize: true,
                    text4Cancel: null,
                    text4OK: FR.i18nText("FS-Frame-Simple_Save"),
                    contentWidget: {
                        type: 'tablelayout',
                        widgetName: Constants.entryPrivilegeConfigTableWD,
                        columnSize: [40, 330, 340 + 3 * Number(FR.i18nText("FS-Privilege_Template_Tool_Margin"))],
                        rowSize: [400],
                        items: [[
                            {el: $('<div/>')},
                            this.entryPanel(),
                            this.positionAndCustomRoleTabPaneWithCheck()
                        ]],
                        scrollable: true
                    }
                }
            };
        },

        //用户权限查看
        userPrivilegeView: function () {
            return {
                title: FR.i18nText("FS-Privilege-User_View"),
                content: {
                    type: 'horizontal',
                    hgap: 40,
                    alignment: "left",
                    widgetName: Constants.userPrivilegeViewHorizontalWD,
                    items: [
                        {el: $('<div/>'), width: 0},
                        this.userPanel(),
                        this.entryAndModuleTabPaneViewOnly()
                    ],
                    height: 400,
                    width: 940
                }
            };
        },

        //报表/平台管理权限查看
        entryAndModulePrivilegeView: function () {
            return {
                title: FR.i18nText("FS-Privilege-Simple_View"),
                content: {
                    type: 'horizontal',
                    hgap: 40,
                    alignment: 'left',
                    widgetName: Constants.entryAndModulePrivilegeViewHorizontalWD,
                    items: [
                        {el: $('<div/>'), width: 0},
                        this.entryAndModuleTabPaneNoCheck(),
                        this.userPanelViewOnly()
                    ],
                    height: 400,
                    width: 940
                }
            };
        },

        //权限受体
        privilegeReceptorTabPane: function () {
            return this.positionAndCustomRoleTabPane();
        },

        //管理平台用的，自定义角色面板
        customRolePanel: function () {
            var content = this.TABS._customRoleTab(338, 346, FS.Plugin.GradeAuthority.Operation, null).content;
            return {
                el: {
                    type: 'panel',
                    fit: false,
                    title: FR.i18nText("FS-Generic-Simple_Role"),
                    width: 340,
                    height: 375,
                    border: true,
                    contentWidget: content,
                    widgetName: 'custonRolePanelWD'
                }
            };
        },
        //部门职位/自定义角色
        positionAndCustomRoleTabPane: function () {
            var self = this;
            this.customRoleTab = this.TABS._customRoleTab(340, 346, FS.Plugin.GradeAuthority.Operation, null);
            this.departmentTab = this.TABS._departmentAndPositionTab(340, 374, "departmentTableTree", false, FSPM.VIEW.showCompanyRoleAuth);
            this.userTab = this.TABS._userTab(340, 346, FS.Plugin.GradeAuthority.Operation, null);
            var actions = [
                function () {
                }, function () {
                    self.TABS._makeCustomRoleListSortable();
                }
            ];
            return {
                el: {
                    type: 'insidetab',
                    items: [this.departmentTab, this.customRoleTab, this.userTab],
                    marginLeft: 0,
                    widgetName: Constants.positionAndCustomRoleInsideTabNoCheckWD,
                    width: 340,
                    height: 400,
                    initAfterActions: actions,
                    afterTabClick: [
                        function () {
                            setTimeout(function () {
                                if (FS.config.templatePrivilegeType == Constants.templatePrivileges.ROLE_VERIFY_NEEDED) {
                                    var target = FSPM.VIEW.tabPane.getWidgetByName(Constants.templatePanelWD) ||
                                        FSPM.VIEW.tabPane.getWidgetByName(Constants.templateAndDataConnectionInsideTabWD);
                                    target.setVisible(true);
                                }
                                var treeNode = FSPM.VIEW.tabPane.getWidgetByName(Constants.departmentTableTreeNoCheckWD).getSelectedNodes()[0];
                                FSPM.VIEW.showCompanyRoleAuth(treeNode);
                            }, 50);
                        }, function () {
                            setTimeout(function () {
                                if (FS.config.templatePrivilegeType == Constants.templatePrivileges.ROLE_VERIFY_NEEDED) {
                                    var target = FSPM.VIEW.tabPane.getWidgetByName(Constants.templatePanelWD) ||
                                        FSPM.VIEW.tabPane.getWidgetByName(Constants.templateAndDataConnectionInsideTabWD);
                                    target.setVisible(true);
                                }
                                var roleList = FSPM.VIEW.customRoleTab.content.resultWidgets.customRoleListNoCheckWD;
                                var roleId = roleList.getValue(),
                                    roleName = roleList.getText();
                                if (roleId !== null) {
                                    FSPM.VIEW.showSpaceAuth({
                                        id: roleId,
                                        name: roleName
                                    });
                                }
                            }, 50);
                        }, function () {
                            setTimeout(function () {
                                if (FS.config.templatePrivilegeType == Constants.templatePrivileges.ROLE_VERIFY_NEEDED) {
                                    var target = FSPM.VIEW.tabPane.getWidgetByName(Constants.templatePanelWD) ||
                                        FSPM.VIEW.tabPane.getWidgetByName(Constants.templateAndDataConnectionInsideTabWD);
                                    target.setVisible(false);
                                }
                                var forgedUserList = FSPM.VIEW.userTab.content.resultWidgets.forgedUserListNoCheckWD;
                                var userid = forgedUserList.getValue();
                                if (userid !== null) {
                                    FSPM.VIEW.showSpaceAuth({
                                        id: userid
                                    }, Constants.space.UP);
                                }
                            }, 50);
                        }

                    ]
                }
            };
        },

        //报表，平台管理
        entryAndModuleTabPane: function () {
            var authorityTitle = $("<div/>").css({
                'textAlign': 'right',
                'paddingRight': '5px'
            });
            var entryToolLen = 1;
            var moduleToolLen = 1;
            var tabPaneWidth = 0;
            var borderWidth = 2;
            var self = this;
            authorityTitle.append(FSPM.MODEL.TabTitle.createTitle(FR.i18nText("FS-Generic-Face_View"), function () {
                var entryAndModuleTab = FSPM.VIEW.tabPane.getWidgetByName(Constants.entryAndModuleInsideTabWD);
                if (entryAndModuleTab.getActiveIndex() === 0) {
                    if (FSPM.VIEW.reportTableTree.hasNodeSelect(0)) {
                        FSPM.VIEW.reportTableTree.deSelectAll(0);
                    } else {
                        FSPM.VIEW.reportTableTree.selectAll(0);
                    }
                    FSPM.VIEW.saveEntryCache();
                } else if (entryAndModuleTab.getActiveIndex() === 1) {
                    var moduleList = entryAndModuleTab.getWidgetByName(Constants.moduleListWD);
                    if (moduleList.hasNodeSelect(moduleToolLen - 1)) {
                        moduleList.deSelectAll(moduleToolLen - 1);
                    } else {
                        moduleList.selectAll(moduleToolLen - 1);
                    }
                    FSPM.VIEW.saveModuleCache();
                } else {
                    $.each(FS.Plugin.PrivilegeManageTabProvider.items, function (index, item) {
                        if (entryAndModuleTab.getActiveIndex() - 2 === index && $.isFunction(item.authorityToolAction)) {
                            item.authorityToolAction.call(self, 0);
                        }
                    });

                }
            }));

            var extraPrivileges = FS.Plugin.PrivilegeManageExtraPrivilegeProvider.items;
            var extraTitles = [];
            for (var i = 0; i < extraPrivileges.length; i++) {
                extraTitles[i] = FSPM.MODEL.TabTitle.createTitle(extraPrivileges[i].text, function (index) {
                    var entryAndModuleTab = FSPM.VIEW.tabPane.getWidgetByName(Constants.entryAndModuleInsideTabWD);
                    if (entryAndModuleTab.getActiveIndex() === 0) {
                        if (FSPM.VIEW.reportTableTree.hasNodeSelect(index + 1)) {
                            FSPM.VIEW.reportTableTree.deSelectAll(index + 1);
                        } else {
                            FSPM.VIEW.reportTableTree.selectAll(index + 1);
                        }
                        FSPM.VIEW.saveEntryCache();
                    }
                },i);
                entryToolLen++;
                authorityTitle.append(extraTitles[i]);
            }

            if (FS.isGradeAuthorityOpen()) {
                entryToolLen++;
                moduleToolLen++;
                authorityTitle.append(FSPM.MODEL.TabTitle.createTitle(FR.i18nText("FS-Privilege-Simple_Authorize"), function () {
                    var entryAndModuleTab = FSPM.VIEW.tabPane.getWidgetByName(Constants.entryAndModuleInsideTabWD);
                    if (entryAndModuleTab.getActiveIndex() === 0) {
                        if (FSPM.VIEW.reportTableTree.hasNodeSelect(FS.isEditReportAuthorityOpen() ? (entryToolLen - 2) : (entryToolLen - 1))) {
                            FSPM.VIEW.reportTableTree.deSelectAll(FS.isEditReportAuthorityOpen() ? (entryToolLen - 2) : (entryToolLen - 1));
                        } else {
                            FSPM.VIEW.reportTableTree.selectAll(FS.isEditReportAuthorityOpen() ? (entryToolLen - 2) : (entryToolLen - 1));
                        }
                        FSPM.VIEW.saveEntryCache();
                    } else if (entryAndModuleTab.getActiveIndex() === 1) {
                        var moduleList = entryAndModuleTab.getWidgetByName(Constants.moduleListWD);
                        if (moduleList.hasNodeSelect(0)) {
                            moduleList.deSelectAll(0);
                        } else {
                            moduleList.selectAll(0);
                        }
                        FSPM.VIEW.saveModuleCache();
                    } else {
                        $.each(FS.Plugin.PrivilegeManageTabProvider.items, function (index, item) {
                            if (entryAndModuleTab.getActiveIndex() - FS.Plugin.PrivilegeManageTabProvider.indexOffset === index && $.isFunction(item.authorityToolAction)) {
                                item.authorityToolAction.call(self, 1);
                            }
                        });
                    }
                }));
            }
            var editPrivilege = FSPM.MODEL.TabTitle.createTitle(FR.i18nText("FS-Generic-Simple_Edit"), function () {
                var entryAndModuleTab = FSPM.VIEW.tabPane.getWidgetByName(Constants.entryAndModuleInsideTabWD);
                if (entryAndModuleTab.getActiveIndex() === 0) {
                    if (FSPM.VIEW.reportTableTree.hasNodeSelect(entryToolLen - 1)) {
                        FSPM.VIEW.reportTableTree.deSelectAll(entryToolLen - 1);
                    } else {
                        FSPM.VIEW.reportTableTree.selectAll(entryToolLen - 1);
                    }
                    FSPM.VIEW.saveEntryCache();
                } else if (entryAndModuleTab.getActiveIndex() > 1) {
                    $.each(FS.Plugin.PrivilegeManageTabProvider.items, function (index, item) {
                        if (entryAndModuleTab.getActiveIndex() - FS.Plugin.PrivilegeManageTabProvider.indexOffset === index && $.isFunction(item.authorityToolAction)) {
                            item.authorityToolAction.call(self, 2);
                        }
                    });
                }
            });
            if (FS.isEditReportAuthorityOpen()) {
                entryToolLen++;
                authorityTitle.append(editPrivilege);
            }
            var items = [
                this.TABS._entryTab(Constants.entryTableTreeWD, 90, 0, 0, "entryTableTree", false, true),
                this.TABS._moduleTab(Constants.moduleListWD, 100, 0, 0, false, true)
            ];
            var afterTabClick = [
                function () {
                    if (FSPM.VIEW.tabPane) {
                        setTimeout(function () {
                            for (var i = 0;i < extraTitles.length;i++) {
                                extraTitles[i].show();
                            }
                            editPrivilege.show();
                            var roleId = self.getCurrentRoleId();
                            if (!roleId) {
                                return;
                            }
                            FSPM.VIEW._showEntryPrivilege(roleId, self.getCurrentSpace());
                        }, 50);
                    }
                },
                function () {
                    if (FSPM.VIEW.tabPane) {
                        setTimeout(function () {
                            for (var i = 0;i < extraTitles.length;i++) {
                                extraTitles[i].hide();
                            }
                            editPrivilege.hide();
                            var entryAndModuleInsideTab = FSPM.VIEW.tabPane.getWidgetByName(Constants.entryAndModuleInsideTabWD);
                            if (FS.isGradeAuthorityOpen() && !FSPM.VIEW.depAndCRolePane) {
                                //分级权限开启了，添加部门/自定义角色树
                                FSPM.VIEW.depAndCRolePane = FSPM.VIEW.createDepAndCRolePane();
                                entryAndModuleInsideTab.getActiveTab().append(FSPM.VIEW.depAndCRolePane);
                            }
                            var roleId = self.getCurrentRoleId();
                            if (!roleId) {
                                return;
                            }
                            FSPM.VIEW._showModulePrivilege(roleId, self.getCurrentSpace());
                        }, 50);
                    }
                }
            ];
            $.each(FS.Plugin.PrivilegeManageTabProvider.items, function (index, item) {
                if (item && item.tab) {
                    if ($.isFunction(item.tab)) {
                        items.push(item.tab.call(self, false, true));
                    } else {
                        items.push(item.tab);
                    }
                }
                if ($.isFunction(item.afterTabClick)) {
                    var decorator = function () {
                        if (FSPM.VIEW.tabPane) {
                            setTimeout(function () {
                                for (var i = 0;i < extraTitles.length;i++) {
                                    extraTitles[i].hide();
                                }
                                if (item.editPrivilege === true) {
                                    editPrivilege.show();
                                } else {
                                    editPrivilege.hide();
                                }
                                var roleId = self.getCurrentRoleId();
                                if (!roleId) {
                                    return;
                                }
                                item.afterTabClick.call(self, roleId);
                            }, 50);
                        }
                    };
                    afterTabClick.push(decorator);
                }
            });
            items.push({
                title: authorityTitle,
                keepActive: true,
                borderWidth: 2,
                width: 90 + (3 + extraPrivileges.length * 2) * Number(FR.i18nText("FS-Privilege_Template_Tool_Margin"))
            });
            $.each(items, function (index, item) {
                tabPaneWidth += item.width;
            });
            $.each(items, function (index, item) {
                if (item.content) {
                    item.content.height = 374;
                    item.content.width = tabPaneWidth - borderWidth;
                }
            });

            return {
                el: {
                    type: 'insidetab',
                    widgetName: Constants.entryAndModuleInsideTabWD,
                    items: items,
                    afterTabClick: afterTabClick,
                    marginLeft: 0,
                    width: tabPaneWidth,
                    height: 400
                }
            };
        },

        //报表，平台管理，只能查看
        entryAndModuleTabPaneViewOnly: function () {
            var tabPaneWidth = 0;
            var borderWidth = 2;
            var self = this;
            var authorityTitle = $("<div/>").css({
                'textAlign': 'right',
                'paddingRight': '5px'
            });
            var entryText = FR.i18nText("FS-Generic-Face_View");
            var extraPrivileges = FS.Plugin.PrivilegeManageExtraPrivilegeProvider.items;
            for (var i = 0; i < extraPrivileges.length; i++) {
                entryText += " " + extraPrivileges[i].text;
            }
            var moduleText = FR.i18nText("FS-Generic-Face_View");
            if (FS.isGradeAuthorityOpen()) {
                entryText = entryText + " " + FR.i18nText("FS-Privilege-Simple_Authorize");
                moduleText = moduleText + " " + FR.i18nText("FS-Privilege-Simple_Authorize");
            }
            if (FS.isEditReportAuthorityOpen()) {
                entryText = entryText + " " + FR.i18nText("FS-Generic-Simple_Edit");
            }
            authorityTitle.text(entryText);
            var items = [
                this.TABS._entryTab(Constants.entryTableTreeViewOnlyWD, 90,
                    278 + 3 * Number(FR.i18nText("FS-Privilege_Template_Tool_Margin")), 374, "entryTableTreeViewOnly", true, true),
                this.TABS._moduleTab(Constants.moduleListViewOnlyWD, 100,
                    278 + 3 * Number(FR.i18nText("FS-Privilege_Template_Tool_Margin")), 374, true, true)
            ];
            var afterTabClick = [
                function () {
                    authorityTitle.text(entryText);
                    if (FSPM.VIEW.userAuth) {
                        FSPM.showUserAuth(FSPM.VIEW.userAuth);
                    }
                },
                function () {
                    authorityTitle.text(moduleText);
                    if (FSPM.VIEW.userAuth) {
                        FSPM.showUserAuth(FSPM.VIEW.userAuth);
                    }
                }
            ];
            $.each(FS.Plugin.PrivilegeManageTabProvider.items, function (index, item) {
                if (item && item.tab) {
                    if ($.isFunction(item.tab)) {
                        items.push(item.tab.call(self, true, true));
                    } else {
                        items.push(item.tab);
                    }
                }
                if ($.isFunction(item.afterViewOnlyTabClick)) {
                    var decorator = function () {
                        if (item.editPrivilege === true) {
                            authorityTitle.text(entryText);
                        } else {
                            authorityTitle.text(moduleText);
                        }
                        if (FSPM.VIEW.userAuth) {
                            var userId = FSPM.VIEW.tabPane.getWidgetByName(Constants.userListNoCheckWD).getValue();
                            item.afterViewOnlyTabClick.call(self, userId);
                        }
                    };
                    afterTabClick.push(decorator);
                }
            });
            items.push({
                title: authorityTitle,
                keepActive: true,
                borderWidth: 2,
                width: 90 + (3 + extraPrivileges.length * 2) * Number(FR.i18nText("FS-Privilege_Template_Tool_Margin"))
            });
            $.each(items, function (index, item) {
                tabPaneWidth += item.width;
            });
            $.each(items, function (index, item) {
                if (item.content) {
                    item.content.height = 374;
                    item.content.width = tabPaneWidth - borderWidth;
                }
            });
            return {
                el: {
                    type: 'insidetab',
                    widgetName: Constants.entryAndModuleViewOnlyTabWD,
                    items: items,
                    afterTabClick: afterTabClick,
                    marginLeft: 0
                },
                width: FSPM.templateTableWidth,
                height: 400
            };
        },

        entryAndModuleTabPaneNoCheck: function () {
            var tabPaneWidth = 0;
            var borderWidth = 2;
            var self = this;
            var items = [
                this.TABS._entryTab(Constants.entryTableTreeNoCheckWD, 115, 228, 374, "entryTableTreeNoCheck", true, false, FSPM.showEntryUser),
                this.TABS._moduleTab(Constants.moduleListNoCheckWD, 115, 228, 374, false, false, FSPM.showModuleUser)
            ];
            $.each(FS.Plugin.PrivilegeManageTabProvider.items, function (index, item) {
                if (item && item.tab) {
                    if ($.isFunction(item.tab)) {
                        items.push(item.tab.call(self, false, false, true));
                    } else {
                        items.push(item.tab);
                    }
                }
            });
            $.each(items, function (index, item) {
                tabPaneWidth += item.width;
            });
            $.each(items, function (index, item) {
                if (item.content) {
                    item.content.height = 374;
                    item.content.width = tabPaneWidth - borderWidth;
                }
            });
            return {
                el: {
                    type: 'insidetab',
                    items: items,
                    marginLeft: 0
                },
                width: tabPaneWidth,
                height: 400
            };
        },

        templatePanel: function () {
            var keyupFunction = function (e) {
                (function () {
                    if (!FR.isNavKeyPress(e)) {
                        var val = this.getValue();
                        var entryNode = FSPM.VIEW.tabPane.getWidgetByName(Constants.templateTableTreeInPanelWD);
                        var result = FS.Sync.ajax({
                            url: FR.servletURL + "?op=fs_entry&cmd=get_user_reports",
                            data: {
                                searchKeyword: val,
                                serverID: FS.serverID
                            },
                            type: 'POST'
                        });
                        var newTreeNodes = entryNode.options.setting.async.dataFilter("templateTableTree", result, result);
                        var allOldNodes = entryNode.getNodes();
                        var allOldNodesNum = allOldNodes.length;
                        //刷新Tree，（1）清空所有Node（2）添加新的Nodes
                        for (var i = 0; i < allOldNodesNum; i++) {
                            entryNode.removeNode(allOldNodes[0]);
                        }
                        entryNode.addNodes(null, newTreeNodes, true);
                        var treeNode;
                        if (FSPM.VIEW.tabPane.getWidgetByName(Constants.departmentTableTreeNoCheckWD)) {
                            treeNode = FSPM.VIEW.tabPane.getWidgetByName(Constants.departmentTableTreeNoCheckWD).getSelectedNodes()[0];
                        }
                        else {
                            return;
                        }
                        FSPM.VIEW.showCompanyRoleAuth(treeNode);
                        var roleList = FSPM.VIEW.customRoleTab.content.resultWidgets.customRoleListNoCheckWD;
                        var roleId = roleList.getValue();
                        var roleName = roleList.getText();
                        if (roleId !== null) {
                            FSPM.VIEW.showSpaceAuth({
                                id: roleId,
                                name: roleName
                            });
                        }
                    }
                }).createDelegate(this).defer(500);
            };
            var items = [
                {
                    region: 'north',
                    el: {
                        type: 'search',
                        width: FSPM.templateTableContentWidth,
                        autoSearch: true,
                        onKeyup: keyupFunction
                    },
                    height: 28
                }, {
                    region: 'center',
                    el: {
                        type: 'panel',
                        fit: false,
                        width: FSPM.templateTableContentWidth,
                        height: 346,
                        border: false,
                        contentWidget: {
                            type: 'fstabletree',
                            height: 374,
                            width: FSPM.templateTableContentWidth,
                            fit: false,
                            treeID: 'templateTableTreeInPanel',
                            widgetName: Constants.templateTableTreeInPanelWD,
                            setting: FSPM.TABLETREESETTINGS.getTemplateTableTreeSetting(),
                            tooltype: 'check',
                            toolMargin: Number(FR.i18nText("FS-Privilege_Template_Tool_Margin")),
                            tools: [
                                {
                                    name: 'page',
                                    //编辑按钮事件
                                    onToolClick: function (e, treeNode, isSelect) {
                                        if (!isSelect && (treeNode["design"] !== 0)) {
                                            FSPM.VIEW.templateTableTree.cancelSelectedNodeWithCascade(treeNode, 2);
                                        }
                                        e.stopEvent();
                                    }
                                },
                                {
                                    name: 'write',
                                    //编辑按钮事件
                                    onToolClick: function (e, treeNode, isSelect) {
                                        if (!isSelect && (treeNode["design"] !== 0)) {
                                            FSPM.VIEW.templateTableTree.cancelSelectedNodeWithCascade(treeNode, 2);
                                        }
                                        e.stopEvent();
                                    }
                                },
                                {
                                    name: 'design',
                                    //编辑按钮事件
                                    onToolClick: function (e, treeNode, isSelect) {
                                        if (isSelect) {
                                            if (treeNode["page"] !== 1) {
                                                FSPM.VIEW.templateTableTree.selectNodeWithCascade(treeNode, true, 0);
                                            }
                                            if (treeNode["write"] !== 1) {
                                                FSPM.VIEW.templateTableTree.selectNodeWithCascade(treeNode, true, 1);
                                            }
                                        }
                                        e.stopEvent();
                                    }
                                }
                            ],

                            onItemToolClick: function (currentNode) {
                                FSPM.CACHE.setTemplateCache(currentNode);
                            }
                        }
                    }
                }
            ];

            return {
                el: {
                    tools: [{
                        text: FR.i18nText("FS-Generic-Face_View"),
                        width: FSPM.viewWidth,
                        iconCls: 'fs_privilegemanager_paneltitle',
                        handler: function () {
                            if (FSPM.VIEW.templateTableTree.hasNodeSelect(0)) {
                                FSPM.VIEW.templateTableTree.deSelectAll(0);
                            } else {
                                FSPM.VIEW.templateTableTree.selectAll(0);
                            }
                            FSPM.VIEW.saveTemplateCache();
                        }
                    }, {
                        text: FR.i18nText("FS-Generic-Face_Write"),
                        width: FSPM.writeWidth,
                        iconCls: 'fs_privilegemanager_paneltitle',
                        handler: function () {
                            if (FSPM.VIEW.templateTableTree.hasNodeSelect(1)) {
                                FSPM.VIEW.templateTableTree.deSelectAll(1);
                            } else {
                                FSPM.VIEW.templateTableTree.selectAll(1);
                            }
                            FSPM.VIEW.saveTemplateCache();
                        }
                    }, {
                        text: FR.i18nText("FS-Privilege-Simple_Design"),
                        width: FSPM.designWidth,
                        iconCls: 'fs_privilegemanager_paneltitle',
                        handler: function () {
                            if (FSPM.VIEW.templateTableTree.hasNodeSelect(2)) {
                                FSPM.VIEW.templateTableTree.deSelectAll(2);
                            } else {
                                FSPM.VIEW.templateTableTree.selectAll(2);
                            }
                            FSPM.VIEW.saveTemplateCache();
                        }
                    }],
                    type: 'panel',
                    fit: false,
                    title: FR.i18nText("FS-Privilege-Simple_Template"),
                    border: true,
                    titleHeight: 25,
                    width: FSPM.templateTableWidth,
                    height: 375,
                    contentWidget: {
                        type: 'border',
                        items: items,
                        width: FSPM.templateTableContentWidth
                    },
                    widgetName: Constants.templatePanelWD
                }
            };
        },

        //模板，数据连接
        templateAndDataConnectionTabPane: function () {
            var self = this;
            var pageTitle = FSPM.MODEL.TabTitle.createTitle(FR.i18nText("FS-Generic-Face_View"), function () {
                var templateAndDataConnectionTab = FSPM.VIEW.tabPane.getWidgetByName(Constants.templateAndDataConnectionInsideTabWD);
                if (templateAndDataConnectionTab.getActiveIndex() === 0) {
                    if (FSPM.VIEW.templateTableTree.hasNodeSelect(0)) {
                        FSPM.VIEW.templateTableTree.deSelectAll(0);
                    } else {
                        FSPM.VIEW.templateTableTree.selectAll(0);
                    }
                    FSPM.VIEW.saveTemplateCache();
                } else {
                    var dataConnectionList = templateAndDataConnectionTab.getWidgetByName(Constants.dataConnectionListWD);
                    if (dataConnectionList.hasNodeSelect(0)) {
                        dataConnectionList.deSelectAll(0);
                    } else {
                        dataConnectionList.selectAll(0);
                    }
                    FSPM.VIEW.saveDataConnectionCache();
                }
            });

            var writeTitle = FSPM.MODEL.TabTitle.createTitle(FR.i18nText("FS-Generic-Face_Write"), function () {
                var templateAndDataConnectionTab = FSPM.VIEW.tabPane.getWidgetByName(Constants.templateAndDataConnectionInsideTabWD);
                if (templateAndDataConnectionTab.getActiveIndex() === 0) {
                    if (FSPM.VIEW.templateTableTree.hasNodeSelect(1)) {
                        FSPM.VIEW.templateTableTree.deSelectAll(1);
                    } else {
                        FSPM.VIEW.templateTableTree.selectAll(1);
                    }
                    FSPM.VIEW.saveTemplateCache();
                }
            });

            var designTitle = FSPM.MODEL.TabTitle.createTitle(FR.i18nText("FS-Privilege-Simple_Design"), function () {
                var templateAndDataConnectionTab = FSPM.VIEW.tabPane.getWidgetByName(Constants.templateAndDataConnectionInsideTabWD);
                if (templateAndDataConnectionTab.getActiveIndex() === 0) {
                    if (FSPM.VIEW.templateTableTree.hasNodeSelect(2)) {
                        FSPM.VIEW.templateTableTree.deSelectAll(2);
                    } else {
                        FSPM.VIEW.templateTableTree.selectAll(2);
                    }
                    FSPM.VIEW.saveTemplateCache();
                }
            });
            var authorityTitle = $("<div/>").css({
                'textAlign': 'right',
                'paddingRight': '5px'
            }).append(pageTitle).append(writeTitle).append(designTitle);


            return {
                el: {
                    type: 'insidetab',
                    widgetName: Constants.templateAndDataConnectionInsideTabWD,
                    items: [
                        this.TABS._templateTab(),
                        this.TABS._dataConnectionTab(),
                        {
                            title: authorityTitle,
                            keepActive: true,
                            borderWidth: 2,
                            width: FSPM.authorityTitleWidth
                        }
                    ],
                    afterTabClick: [
                        function () {
                            setTimeout(function () {
                                if (!FSPM.VIEW.tabPane) {
                                    return;
                                }
                                writeTitle.show();
                                designTitle.show();
                                var roleId = self.getCurrentRoleId();

                                if (!roleId) {
                                    return;
                                }
                                FSPM.VIEW._showTemplatePrivilege(roleId, self.getCurrentSpace());
                            }, 50);
                        }, function () {
                            setTimeout(function () {
                                if (!FSPM.VIEW.tabPane) {
                                    return;
                                }
                                writeTitle.hide();
                                designTitle.hide();
                                var roleId = self.getCurrentRoleId();
                                if (!roleId) {
                                    return;
                                }
                                FSPM.VIEW._showDataConnectionPrivilege(roleId, self.getCurrentSpace());
                            }, 50);
                        }
                    ],
                    marginLeft: 0,
                    width: FSPM.templateTableWidth,
                    height: 400
                }
            };
        },

        //报表
        entryPanel: function () {
            var reportSetting = FSPM.TABLETREESETTINGS.getEntryTableTreeSetting(FSPM.showEntryAuth);
            var keyupFunction = function (e) {
                (function () {
                    if (!FR.isNavKeyPress(e)) {
                        var val = this.getValue();
                        var entryNode = FSPM.VIEW.tabPane.getWidgetByName(Constants.entryTableTreeNoCheckInPanelWD);
                        var result = FS.Sync.ajax({
                            url: FR.servletURL + "?op=fs_set&cmd=auth_getallreports",
                            data: {
                                searchKeyword: val,
                                serverID: FS.serverID
                            },
                            type: 'POST'
                        });
                        var newTreeNodes = entryNode.options.setting.async.dataFilter("entryTableTree", result, result, []);
                        var allOldNodes = entryNode.getNodes();
                        var allOldNodesNum = allOldNodes.length;
                        //刷新Tree，（1）清空所有Node（2）添加新的Nodes
                        for (var i = 0; i < allOldNodesNum; i++) {
                            entryNode.removeNode(allOldNodes[0]);
                        }
                        entryNode.addNodes(null, newTreeNodes, true);
                    }
                }).createDelegate(this).defer(500);
            };
            var self = this;
            var items = [
                {
                    region: 'north',
                    el: {
                        type: 'search',
                        width: 230,
                        autoSearch: true,
                        onKeyup: keyupFunction
                    },
                    height: 28
                },
                {
                    region: 'center',
                    el: {
                        type: 'panel',
                        fit: false,
                        width: 228,
                        height: 375,
                        border: false,
                        contentWidget: {
                            type: 'fstabletree',
                            height: 375,
                            width: 228,
                            fit: false,
                            treeID: 'entryTableTreeNoCheckInPanel',
                            widgetName: Constants.entryTableTreeNoCheckInPanelWD,
                            setting: reportSetting
                        }
                    }
                }
            ];

            return {
                el: {
                    type: 'panel',
                    fit: false,
                    title: FR.i18nText("FS-Generic-Simple_Report"),
                    width: 270,
                    height: 375,
                    border: true,
                    contentWidget: {
                        type: 'border',
                        items: items,
                        width: 270
                    }
                }
            };
        },

        //用户
        userPanel: function () {
            var self = this;
            var items = [
                {
                    region: 'north',
                    el: {
                        type: 'search',
                        width: 230,
                        autoSearch: true,
                        onKeyup: function (e) {
                            if (FSPM.VIEW.searchId !== null) {
                                clearTimeout(FSPM.VIEW.searchId);
                                FSPM.VIEW.searchId = null;
                            }
                            FSPM.VIEW.searchId = setTimeout(function () {
                                if (!FR.isNavKeyPress(e)) {
                                    var val = this.getValue();
                                    var userList = FSPM.VIEW.tabPane.getWidgetByName(Constants.userListNoCheckWD);
                                    userList.refresh({
                                        async: {
                                            url: FR.servletURL + "?op=fs_set&cmd=auth_getallusers",
                                            data: {
                                                dataFilter: val,
                                                serverID: FS.serverID
                                            }
                                        }
                                    });
                                }
                            }.createDelegate(this), 200);
                        }
                    },
                    height: 28
                },
                {
                    region: 'center',
                    el: {
                        type: 'quicklist',
                        width: 228,
                        fit: false,
                        scrollLoading: true,
                        widgetName: Constants.userListNoCheckWD,
                        async: {
                            url: FR.servletURL + "?op=fs_set&cmd=auth_getallusers",
                            data: {
                                serverID: FS.serverID
                            }
                        },
                        dataFilter: function (item) {
                            return {
                                text: item.text,
                                value: item.id,
                                id: item.id
                            };
                        },
                        itemCanBeSelect: true,
                        onCustomItemSelect: self.setUserPanelItemPrivilege
                    }
                }
            ];

            return {
                el: {
                    type: 'panel',
                    fit: false,
                    title: FR.i18nText("FS-Generic-Simple_User"),
                    width: 270,
                    height: 375,
                    border: true,
                    contentWidget: {
                        type: 'border',
                        items: items,
                        width: 270
                    }
                },
                width: 270,
                height: 400
            };
        },

        setUserPanelItemPrivilege: function () {
            // 先调用插件扩展tab的回调
            var entryAndModuleViewOnlyTab = FSPM.VIEW.tabPane.getWidgetByName(Constants.entryAndModuleViewOnlyTabWD);
            var userId = FSPM.VIEW.tabPane.getWidgetByName(Constants.userListNoCheckWD).getValue();
            if (userId !== null && entryAndModuleViewOnlyTab.getActiveIndex() > 1) {
                $.each(FS.Plugin.PrivilegeManageTabProvider.items, function (index, item) {
                    if (entryAndModuleViewOnlyTab.getActiveIndex() - FS.Plugin.PrivilegeManageTabProvider.indexOffset === index && $.isFunction(item.userAction)) {
                        item.userAction.call(entryAndModuleViewOnlyTab, userId);
                    }
                });
            }
            var dealWithEntryType = function (entries) {
                for (var i = 0; i < entries.length; i++) {
                    if (entries[i].type !== 0) {
                        entries[i].id = entries[i].type + entries[i].id + "";
                    }
                    if (entries[i].view === 2 || entries[i].design === 2 || entries[i].edit === 2) {
                        entries.splice(i, 1);
                        i = i - 1;
                    }
                }
            };
            //bug:74500用户多了卡死，改成异步
            if (userId !== null) {
                var config = {
                    url: FR.servletURL + "?op=fs_set&cmd=auth_getUserAuth",
                    async: true,
                    data: {
                        userId: userId
                    }
                };
                var completeFun = function (res, status) {
                    if (status == 'success') {
                        FSPM.VIEW.userAuth = FR.jsonDecode(res.responseText);
                        dealWithEntryType(FSPM.VIEW.userAuth.entries);
                        FSPM.showUserAuth(FSPM.VIEW.userAuth);
                    }
                };

                FS.Async.ajax(config, completeFun);
            }
        },

        //用户面板，只可以查看拥有的报表/平台管理权限
        userPanelViewOnly: function () {
            var tools = [{
                name: "view",
                width: 20
            }];
            var panelTools = [{
                text: FR.i18nText("FS-Generic-Face_View"),
                width: FSPM.viewWidth,
                iconCls: 'fs_privilegemanager_paneltitle'
            }];

            var extraPrivileges = FS.Plugin.PrivilegeManageExtraPrivilegeProvider.items;
            for (var i = 0; i < extraPrivileges.length; i++) {
                tools.unshift({
                    name: extraPrivileges[i].value,
                    width: 20
                });
                panelTools.push({
                    text: extraPrivileges[i].text,
                    width: Math.max(30, extraPrivileges[i].textWidth + 5),
                    iconCls: 'fs_privilegemanager_paneltitle'
                });
            }
            if (FS.isGradeAuthorityOpen()) {
                tools.unshift({
                    name: "design",
                    width: 20
                });
                //授权开启
                panelTools.push({
                    text: FR.i18nText("FS-Privilege-Simple_Authorize"),
                    width: Math.max(30, FR.i18nTextWidth("FS-Privilege-Simple_Authorize") + 5),
                    iconCls: 'fs_privilegemanager_paneltitle'
                });
            }
            if (FS.isEditReportAuthorityOpen()) {
                tools.unshift({
                    name: "edit",
                    width: 20
                });
                //编辑开启
                panelTools.push({
                    text: FR.i18nText("FS-Generic-Simple_Edit"),
                    width: Math.max(30, FR.i18nTextWidth("FS-Generic-Simple_Edit") + 5),
                    iconCls: 'fs_privilegemanager_paneltitle'
                });
            }
            return {
                el: {
                    type: 'panel',
                    fit: false,
                    title: FR.i18nText("FS-Generic-Simple_User"),
                    width: 350,
                    height: 375,
                    border: true,
                    tools: panelTools,
                    contentWidget: {
                        tooltype: 'check',
                        alwaysShowTools: true,
                        toolMargin: Number(FR.i18nText("FS-Privilege_Template_Tool_Margin")),
                        tools: tools,
                        toolUnEditAble: true,
                        onItemToolClick: function (toolindex, index, isSelected, e) {
                        },
                        type: 'quicklist',
                        scrollLoading: true,
                        widgetName: Constants.userListViewOnlyWD,
                        height: 374,
                        width: FSPM.templateTableContentWidth,
                        fit: false,
                        itemCanBeSelect: true,
                        async: {
                            url: FR.servletURL + "?op=fs_set&cmd=auth_getEntryUsers",
                            data: {
                                serverID: FS.serverID
                            }
                        },
                        dataFilter: function (item) {
                            var extraDataFilter = {};
                            for (var i = 0;i < extraPrivileges.length;i++){
                                extraDataFilter[extraPrivileges[i].value] = item[extraPrivileges[i].value];
                            }
                            return $.extend({
                                text: item.text,
                                value: item.id,
                                id: item.id,
                                view: item.view,
                                design: item.design,
                                edit: item.edit
                            }, extraDataFilter);
                        }
                    }
                },
                width: 350,
                height: 400
            };
        },

        //职位列表和自定义角色（有checkbox的工具按钮）
        positionAndCustomRoleTabPaneWithCheck: function () {
            var authorityTitle = $("<div/>").css({
                'textAlign': 'right',
                'paddingRight': '5px'
            });
            var toolLen = 1;
            var viewTitle = FSPM.MODEL.TabTitle.createTitle(FR.i18nText("FS-Generic-Face_View"), function () {
                var positionAndCustomRoleInsideTab = FSPM.VIEW.tabPane.getWidgetByName(Constants.positionAndCustomRoleInsideTabWD);
                if (positionAndCustomRoleInsideTab.getActiveIndex() === 0) {
                    if (FSPM.VIEW.departmentTableTree.hasNodeSelect(0)) {
                        FSPM.VIEW.departmentTableTree.deSelectAll(0);
                    } else {
                        FSPM.VIEW.departmentTableTree.selectAll(0);
                    }
                    FSPM.VIEW.saveEntryDepartmentCache();
                } else {
                    var customRoleList = positionAndCustomRoleInsideTab.getWidgetByName(Constants.customRoleListWD);
                    if (customRoleList.hasNodeSelect(toolLen - 1)) {
                        customRoleList.deSelectAll(toolLen - 1);
                    } else {
                        customRoleList.selectAll(toolLen - 1);
                    }
                    FSPM.VIEW.saveEntryListRoleCache();
                }
            });

            authorityTitle.append(viewTitle);
	    
            var extraPrivileges = FS.Plugin.PrivilegeManageExtraPrivilegeProvider.items;
            for (var i = 0; i < extraPrivileges.length; i++) {
                toolLen++;
                authorityTitle.append(FSPM.MODEL.TabTitle.createTitle(extraPrivileges[i].text, function (index) {
                    var positionAndCustomRoleInsideTab = FSPM.VIEW.tabPane.getWidgetByName(Constants.positionAndCustomRoleInsideTabWD);
                    if (positionAndCustomRoleInsideTab.getActiveIndex() === 0) {
                        if (FSPM.VIEW.departmentTableTree.hasNodeSelect(index + 1)) {
                            FSPM.VIEW.departmentTableTree.deSelectAll(index + 1);
                        } else {
                            FSPM.VIEW.departmentTableTree.selectAll(index + 1);
                        }
                        FSPM.VIEW.saveEntryDepartmentCache();
                    } else {
                        var customRoleList = positionAndCustomRoleInsideTab.getWidgetByName(Constants.customRoleListWD);
                        if (customRoleList.hasNodeSelect(toolLen - 1 - (index + 1))) {
                            customRoleList.deSelectAll(toolLen - 1 - (index + 1));
                        } else {
                            customRoleList.selectAll(toolLen - 1 - (index + 1));
                        }
                        FSPM.VIEW.saveEntryCustomRoleCache();
                    }
                }, i));
            }

            if (FS.isGradeAuthorityOpen()) {
                toolLen++;
                var designTitle = FSPM.MODEL.TabTitle.createTitle(FR.i18nText("FS-Privilege-Simple_Authorize"), function () {
                    var positionAndCustomRoleInsideTab = FSPM.VIEW.tabPane.getWidgetByName(Constants.positionAndCustomRoleInsideTabWD);
                    var index = FS.isEditReportAuthorityOpen() ? (toolLen - 2) : (toolLen - 1);
                    if (positionAndCustomRoleInsideTab.getActiveIndex() === 0) {
                        if (FSPM.VIEW.departmentTableTree.hasNodeSelect(index)) {
                            FSPM.VIEW.departmentTableTree.deSelectAll(index);
                        } else {
                            FSPM.VIEW.departmentTableTree.selectAll(index);
                        }
                        FSPM.VIEW.saveEntryDepartmentCache();
                    } else {
                        var userList = positionAndCustomRoleInsideTab.getWidgetByName(Constants.forgedUserListWD);
                        if (userList.hasNodeSelect(toolLen - 1 - index)) {
                            userList.deSelectAll(toolLen - 1 - index);
                        } else {
                            userList.selectAll(toolLen - 1 - index);
                        }
                        FSPM.VIEW.saveEntryListRoleCache(undefined, Constants.space.UP);
                    }
                });

                authorityTitle.append(designTitle);
            }
            if (FS.isEditReportAuthorityOpen()) {
                toolLen++;
                var editTitle = FSPM.MODEL.TabTitle.createTitle(FR.i18nText("FS-Generic-Simple_Edit"), function () {
                    var positionAndCustomRoleInsideTab = FSPM.VIEW.tabPane.getWidgetByName(Constants.positionAndCustomRoleInsideTabWD);
                    if (positionAndCustomRoleInsideTab.getActiveIndex() === 0) {
                        if (FSPM.VIEW.departmentTableTree.hasNodeSelect(toolLen - 1)) {
                            FSPM.VIEW.departmentTableTree.deSelectAll(toolLen - 1);
                        } else {
                            FSPM.VIEW.departmentTableTree.selectAll(toolLen - 1);
                        }

                    } else if (positionAndCustomRoleInsideTab.getActiveIndex() === 1) {
                        var customRoleList = positionAndCustomRoleInsideTab.getWidgetByName(Constants.customRoleListWD);
                        if (customRoleList.hasNodeSelect(0)) {
                            customRoleList.deSelectAll(0);
                        } else {
                            customRoleList.selectAll(0);
                        }
                        FSPM.VIEW.saveEntryListRoleCache();
                    } else {
                        var userList = positionAndCustomRoleInsideTab.getWidgetByName(Constants.forgedUserListWD);
                        if (userList.hasNodeSelect(0)) {
                            userList.deSelectAll(0);
                        } else {
                            userList.selectAll(0);
                        }
                        FSPM.VIEW.saveEntryListRoleCache(undefined, Constants.space.UP);
                    }
                });

                authorityTitle.append(editTitle);
            }
            var contentWidth = 430 + (3 + extraPrivileges.length * 2) * Number(FR.i18nText("FS-Privilege_Template_Tool_Margin"));
            return {
                el: {
                    type: 'insidetab',
                    widgetName: Constants.positionAndCustomRoleInsideTabWD,
                    items: [
                        this.TABS._departmentAndPositionTab(contentWidth, 374, "departmentTableTreeWithCheck", true, FR.emptyFn),
                        this.TABS._customRoleTab(contentWidth, 346, null, FS.Plugin.GradeAuthority.Tools),
                        this.TABS._userTab(contentWidth, 346, null, FS.Plugin.GradeAuthority.Tools),
                        {
                            title: authorityTitle,
                            keepActive: true,
                            borderWidth: 2,
                            width: 90 + (3 + extraPrivileges.length * 2) * Number(FR.i18nText("FS-Privilege_Template_Tool_Margin"))
                        }
                    ],
                    width: contentWidth,
                    height: 400,
                    marginLeft: 0,
                    afterTabClick: [
                        function () {
                            setTimeout(function () {
                                var treeNode = FSPM.VIEW.tabPane.getWidgetByName(Constants.entryTableTreeNoCheckInPanelWD).getSelectedNodes()[0];
                                FSPM.showEntryAuth(null, null, treeNode);
                            }, 50);
                        },
                        function () {
                            if (FSPM.VIEW.tabPane) {
                                setTimeout(function () {
                                    var treeNode = FSPM.VIEW.tabPane.getWidgetByName(Constants.entryTableTreeNoCheckInPanelWD).getSelectedNodes()[0];
                                    FSPM.showEntryAuth(null, null, treeNode);
                                }, 50);
                            }
                        },
                        function () {
                            if (FSPM.VIEW.tabPane) {
                                setTimeout(function () {
                                    var treeNode = FSPM.VIEW.tabPane.getWidgetByName(Constants.entryTableTreeNoCheckInPanelWD).getSelectedNodes()[0];
                                    FSPM.showEntryAuth(null, null, treeNode);
                                }, 50);
                            }
                        }
                    ]
                }
            };
        },

        createDepAndCRolePane: function () {
            var self = this;
            var pane = $("<div/>").addClass(Constants.depAndCRolePaneCls);
            $("<div/>").addClass(Constants.depAndCRolePaneTitleCls).text(FR.i18nText("FS-Privilege-Department_or_Roles")).appendTo(pane);
            var filter = function (parentNode, node, newNodes, result) {
                if (!newNodes) {
                    return null;
                }

                if (!result) {
                    result = [];
                }
                for (var i = 0, l = newNodes.length; i < l; i++) {
                    var item = newNodes[i];
                    var zItem = {};
                    zItem.id = item.id;
                    zItem.pId = item.parentID;
                    zItem.name = item.text;
                    zItem.sortindex = item.sortindex;
                    zItem.open = false;
                    if (item.ChildNodes && item.ChildNodes.length > 0) {
                        filter(parentNode, node, item.ChildNodes, result);
                    }
                    if (FSPM.CONTROL._alreadyExists(zItem.id, result)) {
                        continue;
                    }
                    result.push(zItem);
                }
                return result;
            };
            FSPM.VIEW.departRoleTableTree = new FS.TableTree({
                treeID: 'departRoleTableTree',
                widgetName: Constants.depAndCRoleTableTreeWD,
                renderEl: pane,
                setting: {
                    view: {
                        showIcon: false,  //不显示每个节点前的ICON
                        selectedMulti: true
                    },
                    data: {
                        simpleData: {
                            enable: true,
                            idKey: "id",
                            pidKey: "pId",
                            rootPId: -2
                        }
                    },
                    async: {
                        enable: true,
                        url: FR.servletURL + "?op=fs_set&cmd=auth_getdepandcusrole",
                        dataFilter: filter,
                        data: {
                            serverID: FS.serverID
                        }
                    },
                    callback: {
                        onAsyncSuccess: function () {
                            var roleId = self.getCurrentRoleId();
                            if (!roleId) {
                                return;
                            }
                            FSPM.VIEW._showDepAndCRolePrivilege(roleId, self.getCurrentSpace());
                        },
                        beforeClick: function () {
                            return false;
                        }
                    }
                },
                height: '100%',
                width: '100%',
                fit: true,
                tooltype: 'check',
                titleMaxWidth: '230',
                tools: [
                    {
                        onToolClick: function (e) {
                            e.stopEvent();
                        }
                    }
                ],
                onItemToolClick: function () {
                    var roleId = self.getCurrentRoleId();
                    if (!roleId) {
                        return;
                    }
                    FSPM.CACHE.setDepAndCRolePrivilege(roleId, FSPM.VIEW.departRoleTableTree.getFullSelectedNodes(), self.getCurrentSpace());
                }
            });
            return pane;
        },

        _getAllLeafNodesFromTreedata: function (treedata, result) {
            if (!result) {
                result = [];
            }
            for (var i = 0, len = treedata.length; i < len; i++) {
                var item = treedata[i];
                if (item.ChildNodes) {
                    result.push(item);
                    this._getAllLeafNodesFromTreedata(item.ChildNodes, result);
                } else {
                    result.push(item);
                }
            }
            return result;
        },

        _needShowDepAndCRolePane: function () {
            //REPORT-2053 始终显示可管理角色权限面板
            return true;
        },

        showSpaceAuth: function (selectRole, space) {
            space = space || Constants.space.SP;//默认是自定义角色
            if (!selectRole) {
                return;
            }

            var rolePrivilegeCache = FSPM.CACHE.getRolePrivilege(selectRole.id, space);
            if (!rolePrivilegeCache) {
                var normalPrivilege;
                switch (space) {
                    case Constants.space.SP:
                        normalPrivilege = FS.Trans.getCustomRoleAuth(selectRole);
                        break;
                    case Constants.space.UP:
                        normalPrivilege = FS.Trans.getForgedUserAuth(selectRole);
                        break;
                }
                FSPM.CACHE.cachePrivilege(selectRole.id, normalPrivilege, space);
            }
            //授予的权限项是报表还是平台管理。
            var entryAndModuleTab = FSPM.VIEW.tabPane.getWidgetByName(Constants.entryAndModuleInsideTabWD);

            var privilegeTypes = {
                Entry: 0,
                Module: 1
            };
            var privilegeType;
            var self = this;
            if (entryAndModuleTab.getActiveIndex() === 0) {
                privilegeType = privilegeTypes.Entry;
            } else if (entryAndModuleTab.getActiveIndex() === 1) {
                privilegeType = privilegeTypes.Module;
            }

            if (privilegeType === privilegeTypes.Entry) {
                FSPM.VIEW._showEntryPrivilege(selectRole.id, space);
            } else if (privilegeType === privilegeTypes.Module) {
                FSPM.VIEW._showModulePrivilege(selectRole.id, space);
            } else if (space === Constants.space.SP) {
                $.each(FS.Plugin.PrivilegeManageTabProvider.items, function (index, item) {
                    if (entryAndModuleTab.getActiveIndex() - FS.Plugin.PrivilegeManageTabProvider.indexOffset === index && $.isFunction(item.positionAndCustomRoleAction)) {
                        item.positionAndCustomRoleAction.call(self, selectRole);
                    }
                });
            }

            // FS.Plugin.MultiLevelReport.showPrivilege(customRole.id);

            if (FS.config.templatePrivilegeType == Constants.templatePrivileges.ROLE_VERIFY_NEEDED) {
                if (FS.isDataConnectionAuthorityOpen()) {
                    var templateAndDataConnectionTab = FSPM.VIEW.tabPane.getWidgetByName(Constants.templateAndDataConnectionInsideTabWD);
                    if (templateAndDataConnectionTab.getActiveIndex() === 0) {
                        //模板
                        FSPM.VIEW._showTemplatePrivilege(selectRole.id, space);
                    } else {
                        //数据连接
                        FSPM.VIEW._showDataConnectionPrivilege(selectRole.id, space);
                    }
                } else {
                    FSPM.VIEW._showTemplatePrivilege(selectRole.id, space);
                }
            }
        },

        _showEntryPrivilege: function (roleId, space) {
            var cacheEntryPrivileges = FSPM.CACHE.getEntryPrivilege(roleId, space);
            FSPM.VIEW.reportTableTree.clearState();
            var reportsForTree = [];
            for (var i = 0; i < cacheEntryPrivileges.length; i++) {
                //cache里的没type，要加上
                var temp = $.extend({}, cacheEntryPrivileges[i]);
                if (temp.id && !("" + temp.id).startWith("0")) {
                    temp.id = temp.type + "" + temp.id;
                }
                reportsForTree.push(temp);
            }
            FSPM.VIEW.reportTableTree.selectNodesByData(reportsForTree);
        },

        _showModulePrivilege: function (roleId, space) {
            var cacheCompanyModulePrivilege = FSPM.CACHE.getModulePrivilege(roleId, space);
            var entryAndModuleTab = FSPM.VIEW.tabPane.getWidgetByName(Constants.entryAndModuleInsideTabWD);
            var moduleList = entryAndModuleTab.getWidgetByName(Constants.moduleListWD);

            //REPORT-3168 yaoh.wu:前端组件列表内容没有加载完成就进行选中操作，导致第一次查看显示异常
            if (moduleList.options.items.length === 0 && moduleList.options.listItems.length === 0) {
                setTimeout(function () {
                    FSPM.VIEW._showModulePrivilege(roleId);
                }, 50);
                return;
            }
            moduleList.clearState();
            if (FS.isGradeAuthorityOpen()) {
                FSPM.VIEW._showDepAndCRolePrivilege(roleId, space);
            }
            moduleList.selectByData(cacheCompanyModulePrivilege);
        },

        _showDepAndCRolePrivilege: function (roleId, space) {
            if (!roleId) {
                return;
            }
            var cacheDepAndCRolePrivilege = FSPM.CACHE.getDepAndCRolePrivilege(roleId, space);
            if (!this._needShowDepAndCRolePane(roleId)) {
                FSPM.VIEW.depAndCRolePane.hide();
                return;
            }
            FSPM.VIEW.departRoleTableTree.clearState();
            FSPM.VIEW.depAndCRolePane.show();
            var nodes = FSPM.VIEW.departRoleTableTree.transformToArray(FSPM.VIEW.departRoleTableTree.getNodes());
            for (var m = 0; m < cacheDepAndCRolePrivilege.length; m++) {
                for (var i = 0; i < nodes.length; i++) {
                    if (cacheDepAndCRolePrivilege[m] + "" === nodes[i].id + "") {
                        FSPM.VIEW.departRoleTableTree.selectNodeWithCascade(nodes[i], true, 0);
                        break;
                    }
                }
            }
        },

        _showTemplatePrivilege: function (roleId, space) {
            if (FSPM.VIEW.templateTableTree) {
                var templatePrivilege = FSPM.CACHE.getTemplatePrivilege(roleId, space);
                FSPM.VIEW.templateTableTree.clearState();
                //pop
                FSPM.VIEW.templateTableTree.selectNodesByPath(templatePrivilege);
            }
        },

        _showDataConnectionPrivilege: function (roleId, space) {
            var templateAndDataConnectionTab = FSPM.VIEW.tabPane.getWidgetByName(Constants.templateAndDataConnectionInsideTabWD);
            var dataConnectionList = templateAndDataConnectionTab.getWidgetByName(Constants.dataConnectionListWD);
            var dataConnectionPrivilege = FSPM.CACHE.getDataConnectionPrivilege(roleId, space);
            var listdata = [];
            for (var i = 0, len = dataConnectionPrivilege.length; i < len; i++) {
                listdata.push({
                    text: dataConnectionPrivilege[i],
                    view: 1
                });
            }
            dataConnectionList.clearState();
            dataConnectionList.selectByText(listdata);
        },

        showCompanyRoleAuth: function (treeNode) {
            if (!treeNode) {
                return;
            }
            //授予的权限项是报表还是平台管理。
            var entryAndModuleTab = FSPM.VIEW.tabPane.getWidgetByName(Constants.entryAndModuleInsideTabWD);

            var privilegeTypes = {
                Entry: 0,
                Module: 1
            };
            var privilegeType;
            var self = this;
            if (entryAndModuleTab.getActiveIndex() === 0) {
                privilegeType = privilegeTypes.Entry;
            } else if (entryAndModuleTab.getActiveIndex() === 1) {
                privilegeType = privilegeTypes.Module;
            }
            var rolePrivilegeCache = FSPM.CACHE.getRolePrivilege(treeNode.id, Constants.space.JP);
            if (!rolePrivilegeCache) {
                var departmentId, postId;
                if (treeNode.isParent) {
                    //选的是部门，那职位Id就是所有职位
                    departmentId = treeNode.id.substring(0, treeNode.id.indexOf(Constants.postIdPrefix));
                } else {
                    //选的是职位，部门ID就是ParentNode的ID
                    departmentId = treeNode.id.substring(0, treeNode.id.indexOf(Constants.postIdPrefix));
                    postId = treeNode.id.substr(Constants.postIdPrefix.length + treeNode.id.indexOf(Constants.postIdPrefix));
                }
                var companyRolePrivilege = FS.Trans.getCompanyRoleAuth(departmentId, postId);
                FSPM.CACHE.cachePrivilege(treeNode.id, companyRolePrivilege, Constants.space.JP);
            }

            if (privilegeType === privilegeTypes.Entry) {
                FSPM.VIEW._showEntryPrivilege(treeNode.id, Constants.space.JP);
            } else if (privilegeType === privilegeTypes.Module) {
                FSPM.VIEW._showModulePrivilege(treeNode.id, Constants.space.JP);
            } else {
                $.each(FS.Plugin.PrivilegeManageTabProvider.items, function (index, item) {
                    if (entryAndModuleTab.getActiveIndex() - FS.Plugin.PrivilegeManageTabProvider.indexOffset === index && $.isFunction(item.positionAndCustomRoleAction)) {
                        item.positionAndCustomRoleAction.call(self, treeNode);
                    }
                });
            }
            if (FS.config.templatePrivilegeType == Constants.templatePrivileges.ROLE_VERIFY_NEEDED) {
                if (FS.isDataConnectionAuthorityOpen()) {
                    var templateAndDataConnectionTab = FSPM.VIEW.tabPane.getWidgetByName(Constants.templateAndDataConnectionInsideTabWD);
                    if (templateAndDataConnectionTab.getActiveIndex() === 0) {
                        //模板
                        FSPM.VIEW._showTemplatePrivilege(treeNode.id, Constants.space.JP);
                    } else {
                        //数据连接
                        FSPM.VIEW._showDataConnectionPrivilege(treeNode.id, Constants.space.JP);
                    }
                } else {
                    FSPM.VIEW._showTemplatePrivilege(treeNode.id, Constants.space.JP);
                }
            }

        },

        TABS: {
            //职位列表的Tab
            _departmentAndPositionTab: function (contentWidth, contentHeight, treeID, hasTool, clickFunc) {
                function filter(parentNode, node, newNodes, result) {
                    if (!newNodes) {
                        return null;
                    }

                    if (!result) {
                        result = [];
                    }
                    var postAllArray = [];
                    for (var i = 0, l = newNodes.length; i < l; i++) {
                        var item = newNodes[i];
                        if (item.postId) {
                            var postItem = {};
                            postItem.id = item.departmentId + Constants.postIdPrefix + item.postId;
                            postItem.pId = item.departmentId + Constants.postIdPrefix;
                            postItem.open = false;
                            postItem.name = item.postName;
                            if (FSPM.CONTROL._alreadyExists(postItem.id, result)) {
                                continue;
                            }
                            //职位名称为空不显示
                            if (postItem.name) {
                                result.push(postItem);
                            }
                            // 所有部门中的职位，职位名称为空不显示在所有部门中
                            if (FSPM.CONTROL._hasDepartmentAll()) {
                                var postInDepartAll = {};
                                postInDepartAll.id = Constants.departmentAllID + Constants.postIdPrefix + item.postId;
                                postInDepartAll.pId = Constants.departmentAllID + Constants.postIdPrefix;
                                postInDepartAll.open = false;
                                postInDepartAll.name = item.postName;
                                if (!FSPM.CONTROL._alreadyExists(postInDepartAll.id, result) && postInDepartAll.name) {
                                    result.push(postInDepartAll);
                                }
                            }
                        }
                        //department/entry
                        var zItem = {};
                        zItem.id = item.departmentId + Constants.postIdPrefix;
                        zItem.pId = item.departmentPId + Constants.postIdPrefix;
                        zItem.name = item.departmentName;
                        zItem.open = false;
                        zItem.description = item.description;
                        if (hasTool && FSPM.CONTROL._hasDepartmentAll()) {
                            //把所有职务加上
                            var postAllInDepartment = {};
                            postAllInDepartment.id = item.departmentId + Constants.postIdPrefix + Constants.postAllID;
                            postAllInDepartment.pId = item.departmentId + Constants.postIdPrefix;
                            postAllInDepartment.name = FR.i18nText("FS-Privilege-Post_All");
                            postAllInDepartment.open = false;
                            if (!FSPM.CONTROL._alreadyExists(postAllInDepartment.id, postAllArray)) {
                                postAllArray.push(postAllInDepartment);
                            }
                        }
                        if (item.ChildNodes && item.ChildNodes.length > 0) {
                            filter(parentNode, node, item.ChildNodes, result);
                        }
                        if (!FSPM.CONTROL._alreadyExists(zItem.id, result)) {
                            result.push(zItem);
                        }
                    }
                    //把所有部门，职务的节点加上
                    if (FSPM.CONTROL._hasDepartmentAll()) {
                        var departmentAll = {
                            id: Constants.departmentAllID + Constants.postIdPrefix,
                            pId: "-1",
                            name: FR.i18nText("FS-Privilege-Department_All"),
                            open: false
                        };
                        result.unshift(departmentAll);
                        if (hasTool) {
                            result = postAllArray.concat(result);
                            //把所有职务加上
                            var postAll = {};
                            postAll.id = Constants.departmentAllID + Constants.postIdPrefix + Constants.postAllID;
                            postAll.pId = Constants.departmentAllID + Constants.postIdPrefix;
                            postAll.name = FR.i18nText("FS-Privilege-Post_All");
                            postAll.open = false;
                            result.unshift(postAll);
                        }
                    }
                    return result;
                }

                var departmentAndPostTreeSetting = {
                    view: {
                        showIcon: false,  //不显示每个节点前的ICON
                        selectedMulti: hasTool
                    },
                    data: {
                        simpleData: {
                            enable: true,
                            idKey: "id",
                            pidKey: "pId",
                            rootPId: "-1"
                        }
                    },
                    callback: {
                        onClick: function (e, treeId, treeNode) {
                            clickFunc.call(this, treeNode);
                        },
                        beforeClick: function () {
                            if (hasTool) {
                                return false;
                            }
                        }
                    },
                    async: {
                        enable: true,
                        url: FR.servletURL + "?op=fs_set&cmd=auth_getcompanyrole",
                        dataFilter: filter,
                        data: {
                            serverID: FS.serverID
                        }
                    }
                };
                var widgetName = hasTool ? Constants.departmentTableTreeWD : Constants.departmentTableTreeNoCheckWD;
                var tabletree = {
                    title: FR.i18nText("FS-Privilege-Department_And_Post"),
                    content: {
                        type: 'fstabletree',
                        treeID: treeID,
                        height: contentHeight - 28,
                        setting: departmentAndPostTreeSetting,
                        alwaysShowTools: hasTool,
                        toolMargin: 10,
                        width: contentWidth - 2,
                        itemHoverCls: 'fs-sys-tabletree-item-hover',
                        widgetName: widgetName,
                        fit: false,
                        tools: hasTool ? [] : [
                                {
                                    rootToolHide: false,
                                    iconCls: 'fs-module-copy-white',
                                    hoverCls: 'fs-module-copy-white-over',
                                    //编辑按钮事件
                                    onToolClick: function (e) {
                                        var nodeID = $(this).data('nodeID');
                                        var tableTree = FSPM.VIEW.tabPane.getWidgetByName(widgetName);
                                        var node = tableTree.getNodeById(nodeID);
                                        tableTree.selectNode(node);
                                        FSPM.VIEW._createReuseDialog({
                                            space: Constants.space.JP,
                                            conf: {
                                                url: FR.servletURL + "?op=fs_set&cmd=auth_getcompanyrole",
                                                data: {
                                                    serverID: FS.serverID
                                                },
                                                type: 'POST'
                                            },
                                            id: node.id
                                        });
                                        e.stopEvent();
                                    }
                                }
                            ]
                    },
                    width: 110
                };

                if (hasTool) {
                    var extraPrivileges = FS.Plugin.PrivilegeManageExtraPrivilegeProvider.items;
                    var tools = [{
                        name: 'view',
                        //编辑按钮事件
                        onToolClick: function (e, treeNode, isSelect) {
                            for (var i = 0; i < extraPrivileges.length; i++) {
                                if (!isSelect && (treeNode[extraPrivileges[i].value]) !== 0) {
                                    FSPM.VIEW.departmentTableTree.cancelSelectedNodeWithCascade(treeNode, i + 1);
                                }
                            }
                            if (FS.isGradeAuthorityOpen()) {
                                //有授权
                                if (!isSelect && (treeNode["design"] !== 0)) {
                                    FSPM.VIEW.departmentTableTree.cancelSelectedNodeWithCascade(treeNode, FS.isEditReportAuthorityOpen() ? (tools.length - 2) : (tools.length - 1));
                                }
                            }
                            if (FS.isEditReportAuthorityOpen()) {
                                //有编辑
                                if (!isSelect && (treeNode["edit"] !== 0)) {
                                    FSPM.VIEW.departmentTableTree.cancelSelectedNodeWithCascade(treeNode, tools.length - 1);
                                }
                            }
                            e.stopEvent();
                        }
                    }];
                    for (var i = 0; i < extraPrivileges.length; i++) {
                        tools.push({
                            name: extraPrivileges[i].value,
                            onToolClick: function (e, treeNode, isSelect) {
                                if (isSelect && (treeNode["view"] !== 1)) {
                                    FSPM.VIEW.departmentTableTree.selectNodeWithCascade(treeNode, true, 0);
                                }
                                if (FS.isGradeAuthorityOpen()) {
                                    //有授权
                                    if (!isSelect && (treeNode["design"] !== 0)) {
                                        FSPM.VIEW.departmentTableTree.cancelSelectedNodeWithCascade(treeNode, FS.isEditReportAuthorityOpen() ? (tools.length - 2) : (tools.length - 1));
                                    }
                                }
                                if (FS.isEditReportAuthorityOpen()) {
                                    //有编辑
                                    if (!isSelect && (treeNode["edit"] !== 0)) {
                                        FSPM.VIEW.departmentTableTree.cancelSelectedNodeWithCascade(treeNode, tools.length - 1);
                                    }
                                }
                                e.stopEvent();
                            }
                        });
                    }
                    if (FS.isGradeAuthorityOpen()) {
                        //开启了分级授权才有授权工具
                        tools.push({
                            name: 'design',
                            //编辑按钮事件
                            onToolClick: function (e, treeNode, isSelect) {
                                if (isSelect && (treeNode["view"] !== 1)) {
                                    FSPM.VIEW.departmentTableTree.selectNodeWithCascade(treeNode, true, 0);
                                }
                                for (var i = 0; i < extraPrivileges.length; i++) {
                                    if (isSelect && (treeNode[extraPrivileges[i].value]) !== 1) {
                                        FSPM.VIEW.departmentTableTree.selectNodeWithCascade(treeNode, true, i + 1);
                                    }
                                }
                                if (FS.isEditReportAuthorityOpen()) {
                                    if (!isSelect && (treeNode["edit"] !== 0)) {
                                        FSPM.VIEW.departmentTableTree.cancelSelectedNodeWithCascade(treeNode, tools.length - 1);
                                    }
                                }
                                e.stopEvent();
                            }
                        });
                    }
                    if (FS.isEditReportAuthorityOpen()) {
                        tools.push({
                            name: 'edit',
                            onToolClick: function (e, treeNode, isSelect) {
                                if (isSelect) {
                                    if (treeNode["view"] !== 1) {
                                        FSPM.VIEW.departmentTableTree.selectNodeWithCascade(treeNode, true, 0);
                                    }
                                    for (var i = 0; i < extraPrivileges.length; i++) {
                                        if (isSelect && (treeNode[extraPrivileges[i].value]) !== 1) {
                                            FSPM.VIEW.departmentTableTree.selectNodeWithCascade(treeNode, true, i + 1);
                                        }
                                    }
                                    if (FS.isGradeAuthorityOpen() && treeNode["design"] !== 1) {
                                        FSPM.VIEW.departmentTableTree.selectNodeWithCascade(treeNode, true, tools.length - 2);
                                    }
                                }
                                e.stopEvent();
                            }
                        });
                    }
                    $.extend(tabletree.content, {
                        tools: tools,
                        tooltype: 'check',
                        onItemToolClick: function (currentTreeNode) {
                            FSPM.VIEW.saveEntryDepartmentCache(currentTreeNode);
                        }
                    });
                }

                var items = [];
                var keyupFunction = function (e) {
                    (function () {
                        if (!FR.isNavKeyPress(e)) {
                            var val = this.getValue();
                            var departmentNode;
                            if (this.options.resultWidgets.departmentTableTreeNoCheckWD) {
                                departmentNode = FSPM.VIEW.tabPane.getWidgetByName(Constants.departmentTableTreeNoCheckWD);
                            }
                            if (this.options.resultWidgets.departmentTableTreeWD) {
                                departmentNode = FSPM.VIEW.tabPane.getWidgetByName(Constants.departmentTableTreeWD);
                            }
                            var result = FS.Sync.ajax({
                                url: FR.servletURL + "?op=fs_set&cmd=auth_getcompanyrole",
                                data: {
                                    searchKeyword: val,
                                    serverID: FS.serverID
                                },
                                type: 'POST'
                            });
                            var newTreeNodes = departmentNode.options.setting.async.dataFilter("departmentTableTree", result, result, []);
                            var allOldNodes = departmentNode.getNodes();
                            var allOldNodesNum = allOldNodes.length;
                            //刷新Tree，（1）清空所有Node（2）添加新的Nodes
                            for (var i = 0; i < allOldNodesNum; i++) {
                                departmentNode.removeNode(allOldNodes[0]);
                            }
                            departmentNode.addNodes(null, newTreeNodes, true);
                            //搜索过后的tree不显示所有部门，删掉
                            var allNodes = departmentNode.getNodes();
                            for (i = 0; i < allNodes.length; i++) {
                                if (val.length > 0 && allNodes[i].name === FR.i18nText("FS-Privilege-Department_All")) {
                                    departmentNode.removeNode(allNodes[i]);
                                }
                            }
                            if (this.options.resultWidgets.departmentTableTreeWD &&
                                FSPM.VIEW.tabPane.getWidgetByName(Constants.entryTableTreeNoCheckInPanelWD)) {
                                FSPM.showEntryAuth(e, "", FSPM.VIEW.tabPane.getWidgetByName(Constants.entryTableTreeNoCheckInPanelWD).getSelectedNodes()[0]);
                            }
                        }
                    }).createDelegate(this).defer(500);
                };
                items.push({
                    el: {
                        type: 'search',
                        width: contentWidth,
                        autoSearch: true,
                        onKeyup: keyupFunction
                    }
                });
                items.push({
                    el: tabletree.content
                });
                return {
                    title: FR.i18nText("FS-Privilege-Department_And_Post"),
                    content: {
                        type: 'vertical',
                        items: items,
                        width: contentWidth - 2
                    },
                    width: 110
                };
            },

            createUnRepeatName: function (name) {
                if (name === null || name === undefined) {
                    name = FR.i18nText("FS-Privilege-Normal_Role");
                }
                var customRoleList = FSPM.VIEW._getCustomRoleList();
                var allRoles = customRoleList.getAllItemText();
                if (allRoles.length === 0) {
                    return name + "1";
                }
                for (var i = 1; i < 10000; i++) {
                    var newName = name + i;
                    for (var m = 0; m < allRoles.length; m++) {
                        if (allRoles[m] == newName) {
                            break;
                        }
                        if (m == allRoles.length - 1) {
                            return newName;
                        }
                    }
                }
            },
            /**
             * 设置自定义列表可排序
             * @private
             */
            _makeCustomRoleListSortable: function () {
                var self = this;
                var beforeDrag = 0;
                var afterDrag = 0;
                var sortID;
                var itemCls = "div." + Constants.customRoleListItemCls;
                var sRoleList = FSPM.VIEW.tabPane.getWidgetByName(Constants.positionAndCustomRoleInsideTabNoCheckWD).getWidgetByName(Constants.customRoleListNoCheckWD);
                var list = sRoleList.element;
                list.sortable({
                    nested: false,
                    delay: 200,
                    itemSelector: itemCls,
                    handler: itemCls,
                    containerSelector: "fr-core-list",
                    placeholder: "<div style = 'height: 24px'/>",
                    onDrag: function ($item, position, _super, event) {
                        position.left = 0;
                        _super($item, position);
                        beforeDrag = $(itemCls, list).index($item[0]);
                        sortID = parseInt($item.attr('id'));
                    },
                    onDrop: function ($item, container, _super, event) {
                        afterDrag = $(itemCls, list).index($item[0]);
                        if ((beforeDrag != afterDrag) && (beforeDrag >= 0) && (afterDrag >= 0)) {
                            var sortIndex = sRoleList.getItemLength() - afterDrag;
                            //拖拽后同时修改后台顺序
                            var config = {
                                url: FR.servletURL + "?op=fs_manager&cmd=fs_modify_srole_sort",
                                type: 'POST',
                                data: {
                                    sortId: sortID,
                                    sortIndex: sortIndex,
                                    serverID: FS.serverID
                                }
                            };
                            var completeFn = function (res, status) {
                                if (status !== 'success') {
                                    FR.Msg.toast(FR.i18nText("FS-Generic-Simple_Failed"));
                                }
                            };
                            FS.Async.ajax(config, completeFn);
                        }
                        _super($item);
                    }
                });
            },

            //自定义角色Tab
            _customRoleTab: function (contentWidth, contentHeight, operation, tools) {
                //自定义角色按钮
                var keyupFunction = function (e) {
                    (function () {
                        if (!FR.isNavKeyPress(e)) {
                            var val = this.getValue();
                            var roleList;
                            if (this.options.resultWidgets.positionAndCustomRoleInsideTabNoCheckWD) {
                                roleList = FSPM.VIEW.tabPane.getWidgetByName(Constants.positionAndCustomRoleInsideTabNoCheckWD).getWidgetByName(Constants.customRoleListNoCheckWD);
                                roleList.refresh({
                                    async: {
                                        url: FR.servletURL + "?op=fs_set&cmd=auth_getcustomrole",
                                        data: {
                                            dataFilter: val,
                                            serverID: FS.serverID
                                        }
                                    }
                                });
                            }
                            if (this.options.resultWidgets.positionAndCustomRoleInsideTabWD) {
                                roleList = FSPM.VIEW.tabPane.getWidgetByName(Constants.positionAndCustomRoleInsideTabWD).getWidgetByName(Constants.customRoleListWD);
                                FS.Tools.refreshSyncList(roleList, {
                                    sync: {
                                        url: FR.servletURL + "?op=fs_set&cmd=auth_getcustomrole",
                                        data: {
                                            dataFilter: val,
                                            serverID: FS.serverID
                                        }
                                    }
                                });
                            }

                        }
                    }).createDelegate(this).defer(500);
                };
                var items = [];

                items.push({
                    el: {
                        type: 'search',
                        width: contentWidth,
                        autoSearch: true,
                        onKeyup: keyupFunction
                    }
                });

                var customRoleList = {
                    type: 'quicklist',
                    scrollLoading: true,
                    async: {
                        url: FR.servletURL + '?op=fs_set&cmd=auth_getcustomrole',
                        data: {
                            serverID: FS.serverID
                        }
                    },
                    onBeforeItemCreate: function (element, opts) {
                        if (opts.id < 0 || opts.isSync) {
                            element.addClass(Constants.customRoleListSyncItemCls);
                        } else {
                            element.addClass(Constants.customRoleListItemCls);
                        }
                        element.attr("id", opts.id);
                    },
                    valueField: 'id',
                    width: contentWidth - 2,
                    height: contentHeight,
                    itemCanBeSelect: true
                };


                if (tools && tools.item && $.isFunction(tools.item.action) && FR.Plugin.validLevel(FS.Plugin.GradeAuthority.Tools, tools.item)) {
                    tools.item.action.call(this, customRoleList);
                    customRoleList.widgetName = Constants.customRoleListWD;
                } else {
                    customRoleList.widgetName = Constants.customRoleListNoCheckWD;
                    //复用按钮
                    $.extend(customRoleList, {
                        tools: [
                            {
                                iconCls: 'fs-module-copy-white',
                                iconCls4Hover: 'fs-module-copy-white-hover'
                            }
                        ],
                        alwaysShowTools: false,
                        onItemToolClick: function (toolindex, index, e) {
                            e.stopEvent();
                            var customRoleList = FSPM.VIEW._getCustomRoleList();
                            var customRoleId = customRoleList.getValueAtIndex(index);
                            var isSync = customRoleList.getItemById(customRoleId).options.isSync;
                            var customRoleName = customRoleList.getTextAtIndex(index);
                            if (toolindex === 0) {
                                //权限复用
                                FSPM.VIEW._createReuseDialog({
                                    space: Constants.space.SP,
                                    conf: {
                                        sync: {
                                            url: FR.servletURL + "?op=fs_set&cmd=auth_getcustomrole",
                                            data: {
                                                serverID: FS.serverID
                                            }
                                        }
                                    },
                                    id: customRoleId,
                                    name: customRoleName
                                });
                            }
                            customRoleList.options.listItems[index].element.mouseup();
                        },
                        onCustomItemSelect: function () {
                            var roleId = this.getValue();
                            var roleName = this.getText();
                            FSPM.VIEW.showSpaceAuth({
                                id: roleId,
                                name: roleName
                            });
                        },

                        dataFilter: function (item) {
                            return {
                                text: item.text,
                                value: item.id,
                                id: item.id,
                                isSync: item.isSync
                            };
                        }
                    });
                }
                items.push({
                    el: customRoleList
                });
                return {
                    title: FR.i18nText("FS-Generic-Simple_Role"),
                    content: {
                        type: 'vertical',
                        items: items,
                        width: contentWidth
                    },
                    width: 120
                };
            },
            //用户Tab
            _userTab: function (contentWidth, contentHeight, operation, tools) {
                var keyupFunction = function (e) {
                    (function () {
                        if (!FR.isNavKeyPress(e)) {
                            var val = this.getValue();
                            var userList;
                            if (this.options.resultWidgets.positionAndCustomRoleInsideTabNoCheckWD) {
                                userList = FSPM.VIEW.tabPane.getWidgetByName(Constants.positionAndCustomRoleInsideTabNoCheckWD).getWidgetByName(Constants.forgedUserListNoCheckWD);
                                userList.refresh({
                                    async: {
                                        url: FR.servletURL + "?op=fs_set&cmd=auth_getForgedUser",
                                        data: {
                                            dataFilter: val,
                                            serverID: FS.serverID
                                        }
                                    }
                                });
                            }
                            if (this.options.resultWidgets.positionAndCustomRoleInsideTabWD) {
                                userList = FSPM.VIEW.tabPane.getWidgetByName(Constants.positionAndCustomRoleInsideTabWD).getWidgetByName(Constants.forgedUserListWD);
                                FS.Tools.refreshSyncList(userList, {
                                    sync: {
                                        url: FR.servletURL + "?op=fs_set&cmd=auth_getForgedUser",
                                        data: {
                                            dataFilter: val,
                                            serverID: FS.serverID
                                        }
                                    }
                                });
                                if (FSPM.VIEW.tabPane.getWidgetByName(Constants.entryTableTreeNoCheckInPanelWD)) {
                                    FSPM.showEntryAuth(e, "", FSPM.VIEW.tabPane.getWidgetByName(Constants.entryTableTreeNoCheckInPanelWD).getSelectedNodes()[0]);
                                }
                            }

                        }
                    }).createDelegate(this).defer(500);
                };
                var items = [];

                items.push({
                    el: {
                        type: 'search',
                        width: contentWidth,
                        autoSearch: true,
                        onKeyup: keyupFunction
                    }
                });

                var userList = {
                    type: 'quicklist',
                    scrollLoading: true,
                    async: {
                        url: FR.servletURL + '?op=fs_set&cmd=auth_getForgedUser',
                        data: {
                            serverID: FS.serverID
                        }
                    },
                    onBeforeItemCreate: function (element, opts) {
                        element.attr("id", opts.id);
                    },
                    valueField: 'id',
                    width: contentWidth - 2,
                    height: contentHeight,
                    itemCanBeSelect: true
                };


                if (tools && tools.item && $.isFunction(tools.item.action) && FR.Plugin.validLevel(FS.Plugin.GradeAuthority.Tools, tools.item)) {
                    tools.item.action.call(this, userList, Constants.space.UP);
                    userList.widgetName = Constants.forgedUserListWD;
                } else {
                    userList.widgetName = Constants.forgedUserListNoCheckWD;
                    //编辑按钮
                    $.extend(userList, {
                        tools: [
                            {
                                iconCls: 'fs-module-delete-white',
                                iconCls4Hover: 'fs-module-delete-white-hover'
                            },
                            {
                                iconCls: 'fs-module-copy-white',
                                iconCls4Hover: 'fs-module-copy-white-hover'
                            }
                        ],
                        alwaysShowTools: false,
                        onItemToolClick: function (toolindex, index, e) {
                            e.stopEvent();
                            var forgedUserList = FSPM.VIEW._getForgedUserList();
                            var userid = forgedUserList.getValueAtIndex(index);
                            var text = forgedUserList.getTextAtIndex(index);
                            if (toolindex === 1) {
                                //权限复用
                                FSPM.VIEW._createReuseDialog({
                                    space: Constants.space.UP,
                                    conf: {
                                        sync: {
                                            url: FR.servletURL + "?op=fs_set&cmd=auth_getForgedUser",
                                            data: {
                                                serverID: FS.serverID
                                            }
                                        }
                                    },
                                    id: userid,
                                    name: text
                                });
                            } else {
                                //删除
                                FR.Msg.confirm(FR.i18nText("Fine-Engine_FS_Frame_Delete_Data"), FR.i18nText("FS-Generic-Sure_To_Delete") + '?', function (result) {
                                    if (result) {
                                        //先向后台请求删除数据，请求成功再在web端删除
                                        FS.Trans.updateForgedUsers({
                                            delids: userid
                                        });
                                        //缓存中也要清空
                                        FSPM.CACHE.delecteCache(userid, Constants.space.UP);
                                        forgedUserList.remove(index);
                                        if (forgedUserList.getItemLength() > 0) {
                                            forgedUserList.selectItemByIndex(0, true);
                                        } else {
                                            //最后一个了
                                        }
                                    }
                                });
                            }
                            forgedUserList.options.listItems[index].element.mouseup();
                        },
                        onCustomItemSelect: function () {
                            var userId = this.getValue();
                            FSPM.VIEW.showSpaceAuth({
                                id: userId
                            }, Constants.space.UP);
                        },

                        dataFilter: function (item) {
                            return {
                                text: item.text,
                                value: item.id,
                                id: item.id
                            };
                        }
                    });
                }
                items.push({
                    el: userList
                });
                var oriLen = items.length;
                //只有管理员才能使用增加伪用户按钮
                if (operation && operation.item && $.isFunction(operation.item.action) && FR.Plugin.validLevel(FS.Plugin.GradeAuthority.Operation, operation.item)) {
                    operation.item.action.call(this, items, Constants.space.UP);
                    if (items.length === oriLen + 1) {
                        userList.height = contentHeight - 32;
                    }
                }
                return {
                    title: FR.i18nText("FS-Generic-Simple_User"),
                    title_hover: FR.i18nText("FS-Privilege_ForgedUser_Tip_Tab"),
                    content: {
                        type: 'vertical',
                        items: items,
                        width: contentWidth
                    },
                    width: 110
                };
            },
            //报表Tab
            _entryTab: function (widgetName, tabWidth, contentWidth, contentHeight, treeID, viewOnly, hasTool, clickFunc) {
                var extraPrivileges = FS.Plugin.PrivilegeManageExtraPrivilegeProvider.items;
                var tools = [{
                    name: 'view',
                    //编辑按钮事件
                    onToolClick: function (e, treeNode, isSelect) {
                        for (var i = 0; i < extraPrivileges.length; i++) {
                            if (!isSelect && (treeNode[extraPrivileges[i].value]) !== 0) {
                                FSPM.VIEW.reportTableTree.cancelSelectedNodeWithCascade(treeNode, i + 1);
                            }
                        }
                        if (FS.isGradeAuthorityOpen()) {
                            //有授权
                            if (!isSelect && (treeNode["design"] !== 0)) {
                                FSPM.VIEW.reportTableTree.cancelSelectedNodeWithCascade(treeNode, FS.isEditReportAuthorityOpen() ? (tools.length - 2) : (tools.length - 1));
                            }
                        }
                        if (FS.isEditReportAuthorityOpen()) {
                            //有编辑
                            if (!isSelect && (treeNode["edit"] !== 0)) {
                                FSPM.VIEW.reportTableTree.cancelSelectedNodeWithCascade(treeNode, tools.length - 1);
                            }
                        }
                        e.stopEvent();
                    }
                }];

                for (var i = 0; i < extraPrivileges.length; i++) {
                    tools.push({
                        name: extraPrivileges[i].value,
                        //编辑按钮事件
                        onToolClick: function (e, treeNode, isSelect) {
                            if (isSelect && (treeNode["view"] !== 1)) {
                                FSPM.VIEW.reportTableTree.selectNodeWithCascade(treeNode, true, 0);
                            }
                            if (FS.isGradeAuthorityOpen()) {
                                //有授权
                                if (!isSelect && (treeNode["design"] !== 0)) {
                                    FSPM.VIEW.reportTableTree.cancelSelectedNodeWithCascade(treeNode, FS.isEditReportAuthorityOpen() ? (tools.length - 2) : (tools.length - 1));
                                }
                            }
                            if (FS.isEditReportAuthorityOpen()) {
                                //有编辑
                                if (!isSelect && (treeNode["edit"] !== 0)) {
                                    FSPM.VIEW.reportTableTree.cancelSelectedNodeWithCascade(treeNode, tools.length - 1);
                                }
                            }
                        }
                    });
                }

                if (FS.isGradeAuthorityOpen()) {
                    //开启了分级授权才有授权工具
                    tools.push({
                        name: 'design',
                        //编辑按钮事件
                        onToolClick: function (e, treeNode, isSelect) {
                            if (isSelect && (treeNode["view"] !== 1)) {
                                FSPM.VIEW.reportTableTree.selectNodeWithCascade(treeNode, true, 0);
                            }
                            for (var i = 0; i < extraPrivileges.length; i++) {
                                if (isSelect && (treeNode[extraPrivileges[i].value]) !== 1) {
                                    FSPM.VIEW.reportTableTree.selectNodeWithCascade(treeNode, true, i + 1);
                                }
                            }
                            if (FS.isEditReportAuthorityOpen()) {
                                if (!isSelect && (treeNode["edit"] !== 0)) {
                                    FSPM.VIEW.reportTableTree.cancelSelectedNodeWithCascade(treeNode, tools.length - 1);
                                }
                            }
                            e.stopEvent();
                        }
                    });
                }
                if (FS.isEditReportAuthorityOpen()) {
                    tools.push({
                        name: 'edit',
                        onToolClick: function (e, treeNode, isSelect) {
                            if (isSelect) {
                                if (treeNode["view"] !== 1) {
                                    FSPM.VIEW.reportTableTree.selectNodeWithCascade(treeNode, true, 0);
                                }
                                for (var i = 0; i < extraPrivileges.length; i++) {
                                    if (isSelect && (treeNode[extraPrivileges[i].value]) !== 1) {
                                        FSPM.VIEW.reportTableTree.selectNodeWithCascade(treeNode, true, i + 1);
                                    }
                                }
                                if (FS.isGradeAuthorityOpen() && treeNode["design"] !== 1) {
                                    FSPM.VIEW.reportTableTree.selectNodeWithCascade(treeNode, true, tools.length - 2);
                                }
                            }
                            e.stopEvent();
                        }
                    });
                }
                var reportSetting = FSPM.TABLETREESETTINGS.getEntryTableTreeSetting(clickFunc, hasTool ? tools.length : 0);
                var toolConfig = {
                    tooltype: 'check',
                    toolMargin: Number(FR.i18nText("FS-Privilege_Report_Tool_Margin")),
                    alwaysShowTools: true,
                    tools: tools,
                    onItemToolClick: function () {
                        FSPM.VIEW.saveEntryCache();
                    }
                };
                if (viewOnly) {
                    toolConfig.toolUnEditAble = true;
                }
                var result = {
                    title: FR.i18nText("FS-Generic-Simple_Report"),
                    content: {
                        type: 'fstabletree',
                        height: contentHeight,
                        width: contentWidth,
                        treeID: treeID,
                        setting: reportSetting,
                        widgetName: widgetName
                    },
                    width: tabWidth
                };
                if (hasTool) {
                    $.extend(result.content, toolConfig);
                }
                return result;
            },

            //平台管理Tab
            _moduleTab: function (widgetName, tabWidth, contentWidth, contentHeight, viewOnly, hasTool, onCustomSelect) {
                var tools = [{
                    name: "view",
                    width: 20
                }];
                if (FS.isGradeAuthorityOpen()) {
                    tools.unshift({
                        name: "design",
                        width: 20
                    });
                }
                var toolConfig = {
                    tooltype: 'check',
                    alwaysShowTools: true,
                    toolMargin: Number(FR.i18nText("FS-Privilege_Template_Tool_Margin")),
                    tools: tools,
                    beforeSelect: function (toolindex, index, isSelected, e) {
                        var entryAndModuleTab = FSPM.VIEW.tabPane.getWidgetByName(Constants.entryAndModuleInsideTabWD);
                        var moduleList = entryAndModuleTab.getWidgetByName(Constants.moduleListWD);
                        var selectedModule = moduleList.getValueAtIndex(index).value;
                        if (FS.isGradeAuthorityOpen()) {
                            FSPM.VIEW.depAndCRolePane.show();
                        }
                    },
                    onItemToolClick: function (toolindex, index, isSelected, e) {
                        var entryAndModuleTab = FSPM.VIEW.tabPane.getWidgetByName(Constants.entryAndModuleInsideTabWD);
                        var moduleList = entryAndModuleTab.getWidgetByName(Constants.moduleListWD);
                        if ((toolindex === 1) && !isSelected) {
                            //查看取消选中时，授权也要取消选中
                            moduleList.options.listItems[index].doUnselect(0);
                        }
                        if (toolindex === 0 && isSelected && tools.length > 1) {
                            moduleList.options.listItems[index].doSelect(1);
                        }

                        FSPM.VIEW.saveModuleCache();
                    }
                };
                if (viewOnly) {
                    toolConfig.toolUnEditAble = true;
                }
                var result = {
                    title: FR.i18nText("FS-Module-Platform_Manager"),
                    content: {
                        type: 'quicklist',
                        height: contentHeight,
                        width: contentWidth,
                        paddingRight: 0,
                        async: {
                            url: FR.servletURL + "?op=fs_set&cmd=auth_getallmodules",
                            data: {
                                serverID: FS.serverID
                            }
                        },
                        widgetName: widgetName,
                        onAsyncSuccess: function () {
                            if (hasTool && viewOnly) {
                                FSPM.showUserAuth(FSPM.VIEW.userAuth);
                            }
                        }
                    },
                    width: tabWidth
                };
                if (hasTool) {
                    $.extend(result.content, toolConfig);
                }
                if ($.isFunction(onCustomSelect)) {
                    result.content.onCustomItemSelect = onCustomSelect;
                }
                if (!hasTool && !viewOnly) {
                    result.content.itemCanBeSelect = true;
                }
                return result;
            },

            //模板Tab
            _templateTab: function () {
                var self = this;
                var templateTree = {
                    title: FR.i18nText("FS-Privilege-Simple_Template"),
                    content: {
                        type: 'fstabletree',
                        height: 374,
                        width: FSPM.templateTableContentWidth,
                        fit: false,
                        treeID: 'templateTableTree',
                        setting: FSPM.TABLETREESETTINGS.getTemplateTableTreeSetting(),
                        tooltype: 'check',
                        toolMargin: Number(FR.i18nText("FS-Privilege_Template_Tool_Margin")),
                        widgetName: Constants.templateTableTreeWD,
                        tools: [
                            {
                                name: 'page',
                                //编辑按钮事件
                                onToolClick: function (e, treeNode, isSelect) {
                                    if (!isSelect && (treeNode["design"] !== 0)) {
                                        FSPM.VIEW.templateTableTree.cancelSelectedNodeWithCascade(treeNode, 2);
                                    }
                                    e.stopEvent();
                                }
                            },
                            {
                                name: 'write',
                                //编辑按钮事件
                                onToolClick: function (e, treeNode, isSelect) {
                                    if (!isSelect && (treeNode["design"] !== 0)) {
                                        FSPM.VIEW.templateTableTree.cancelSelectedNodeWithCascade(treeNode, 2);
                                    }
                                    e.stopEvent();
                                }
                            },
                            {
                                name: 'design',
                                //编辑按钮事件
                                onToolClick: function (e, treeNode, isSelect) {
                                    if (isSelect) {
                                        if (treeNode["page"] !== 1) {
                                            FSPM.VIEW.templateTableTree.selectNodeWithCascade(treeNode, true, 0);
                                        }
                                        if (treeNode["write"] !== 1) {
                                            FSPM.VIEW.templateTableTree.selectNodeWithCascade(treeNode, true, 1);
                                        }
                                    }
                                    e.stopEvent();
                                }
                            }
                        ],
                        onItemToolClick: function (currentNode) {
                            FSPM.CACHE.setTemplateCache(currentNode);
                        }
                    },
                    width: FSPM.templateWidth
                };
                var keyupFunction = function (e) {
                    (function () {
                        if (!FR.isNavKeyPress(e)) {
                            var val = this.getValue();
                            var entryNode = FSPM.VIEW.tabPane.getWidgetByName(Constants.templateTableTreeWD);
                            var result = FS.Sync.ajax({
                                url: FR.servletURL + "?op=fs_entry&cmd=get_user_reports",
                                data: {
                                    searchKeyword: val,
                                    serverID: FS.serverID
                                },
                                type: 'POST'
                            });
                            var newTreeNodes = entryNode.options.setting.async.dataFilter("templateTableTree", result, result);
                            var allOldNodes = entryNode.getNodes();
                            var allOldNodesNum = allOldNodes.length;
                            //刷新Tree，（1）清空所有Node（2）添加新的Nodes
                            for (var i = 0; i < allOldNodesNum; i++) {
                                entryNode.removeNode(allOldNodes[0]);
                            }
                            entryNode.addNodes(null, newTreeNodes, true);
                            var treeNode;
                            if (FSPM.VIEW.tabPane.getWidgetByName(Constants.departmentTableTreeNoCheckWD)) {
                                treeNode = FSPM.VIEW.tabPane.getWidgetByName(Constants.departmentTableTreeNoCheckWD).getSelectedNodes()[0];
                            }
                            else {
                                return;
                            }
                            FSPM.VIEW.showCompanyRoleAuth(treeNode);
                            var roleList = FSPM.VIEW.customRoleTab.content.resultWidgets.customRoleListNoCheckWD;
                            var roleId = roleList.getValue();
                            var roleName = roleList.getText();
                            if (roleId !== null) {
                                FSPM.VIEW.showSpaceAuth({
                                    id: roleId,
                                    name: roleName
                                });
                            }
                        }
                    }).createDelegate(this).defer(500);
                };
                var items = [
                    {
                        el: {
                            type: 'search',
                            width: FSPM.templateTableContentWidth,
                            autoSearch: true,
                            onKeyup: keyupFunction
                        },
                        height: 28
                    },
                    {
                        el: templateTree.content
                    }
                ];

                return {
                    title: FR.i18nText("FS-Privilege-Simple_Template"),
                    content: {
                        type: 'vertical',
                        items: items,
                        width: FSPM.templateTableContentWidth
                    },
                    width: FSPM.templateWidth
                };
            },

            _dataConnectionTab: function () {
                return {
                    title: FR.i18nText("FS-System-Connection_List"),
                    content: {
                        type: 'quicklist',
                        scrollLoading: true,
                        height: 374,
                        width: FSPM.templateTableContentWidth,
                        widgetName: Constants.dataConnectionListWD,
                        fit: false,
                        tooltype: 'check',
                        tools: [
                            {
                                name: 'view',
                                width: 20
                            }
                        ],
                        onItemToolClick: function () {
                            FSPM.VIEW.saveDataConnectionCache();
                        },
                        async: {
                            url: FR.servletURL + "?op=fs_set&cmd=sc_getconnectioninfo",
                            data: {
                                all: true,
                                data: {
                                    serverID: FS.serverID
                                }
                            }
                        },
                        dataFilter: function (item) {
                            return {
                                text: item.name,
                                value: item.name
                            };
                        }
                    },
                    width: FSPM.connectionWidth
                };
            }
        },

        saveEntryCache: function () {
            var roleId = this.getCurrentRoleId();
            if (roleId) {
                FSPM.CACHE.setEntryPrivilege(roleId, FSPM.VIEW.reportTableTree.getSelectedNodes(), true, this.getCurrentSpace());
            }
        },

        saveModuleCache: function () {
            var entryAndModuleTab = FSPM.VIEW.tabPane.getWidgetByName(Constants.entryAndModuleInsideTabWD);
            var moduleList = entryAndModuleTab.getWidgetByName(Constants.moduleListWD);
            var roleId = this.getCurrentRoleId();

            if (roleId) {
                FSPM.CACHE.setModulePrivilege(roleId, moduleList.getValue(), this.getCurrentSpace());
            }
        },

        saveTemplateCache: function () {

            var roleId = this.getCurrentRoleId();

            if (roleId) {
                FSPM.CACHE.setTemplatePrivilege(roleId, FSPM.VIEW.templateTableTree.getSelectedNodes(), this.getCurrentSpace());
            }
        },
        getCurrentRoleId: function () {
            var positionAndCustomRoleInsideTab = FSPM.VIEW.tabPane.getWidgetByName(Constants.positionAndCustomRoleInsideTabNoCheckWD);

            if (positionAndCustomRoleInsideTab.getActiveIndex() === 0) {
                var treeNode = FSPM.VIEW.tabPane.getWidgetByName(Constants.departmentTableTreeNoCheckWD).getSelectedNodes()[0];
                if (!treeNode) {
                    return;
                }
                return treeNode.id;
            } else if (positionAndCustomRoleInsideTab.getActiveIndex() === 1) {
                return positionAndCustomRoleInsideTab.getWidgetByName(Constants.customRoleListNoCheckWD).getValue();
            } else {
                return positionAndCustomRoleInsideTab.getWidgetByName(Constants.forgedUserListNoCheckWD).getValue();
            }
        },
        getCurrentSpace: function () {
            return Constants.index_space[FSPM.VIEW.tabPane.getWidgetByName(Constants.positionAndCustomRoleInsideTabNoCheckWD).getActiveIndex()];
        },

        saveDataConnectionCache: function () {
            var templateAndDataConnectionTab = FSPM.VIEW.tabPane.getWidgetByName(Constants.templateAndDataConnectionInsideTabWD);
            var dataConnectionList = templateAndDataConnectionTab.getWidgetByName(Constants.dataConnectionListWD);
            var roleId = this.getCurrentRoleId();
            if (roleId) {
                FSPM.CACHE.setDataConnectionPrivilege(roleId, dataConnectionList.getValue(), this.getCurrentSpace());
            }
        },

        saveEntryDepartmentCache: function (currentTreeNode) {
            var treeNode = FSPM.VIEW.tabPane.getWidgetByName(Constants.entryTableTreeNoCheckInPanelWD).getSelectedNodes()[0];
            if (!treeNode) {
                return;
            }
            var entryId = treeNode.id;
            if (entryId) {
                //DEC-129 用getAllSelectedLeafNodes，不用getSelectedNodes，防止报表快捷设置->所有职位的报表权限不生效
                FSPM.CACHE.setEntryCache(entryId, FSPM.VIEW.tabPane.getWidgetByName(Constants.departmentTableTreeWD).getAllSelectedLeafNodes(), Constants.space.JP, currentTreeNode);
            }
        },

        saveEntryListRoleCache: function (currentNode, space) {
            space = space || Constants.space.SP;
            var treeNode = FSPM.VIEW.tabPane.getWidgetByName(Constants.entryTableTreeNoCheckInPanelWD).getSelectedNodes()[0];
            if (!treeNode) {
                return;
            }
            var entryId = treeNode.id;
            if (entryId) {
                var positionAndCustomRoleTab = FSPM.VIEW.tabPane.getWidgetByName(Constants.positionAndCustomRoleInsideTabWD);
                var listRoleName;
                switch (space) {
                    case Constants.space.SP:
                        listRoleName = Constants.customRoleListWD;
                        break;
                    case Constants.space.UP:
                        listRoleName = Constants.forgedUserListWD;
                        break;
                }
                var roleList = positionAndCustomRoleTab.getWidgetByName(listRoleName);
                FSPM.CACHE.setEntryCache(entryId, roleList.getValue(), space, currentNode);
            }
        },
        //部门树
        createDepartTreePane: function (config) {
            function filter(parentNode, node, newNodes, result) {
                if (!newNodes) {
                    return null;
                }

                if (!result) {
                    result = [];
                }
                var postAllArray = [];
                for (var i = 0, l = newNodes.length; i < l; i++) {
                    var item = newNodes[i];
                    if (item.postId) {
                        var postItem = {};
                        postItem.id = item.departmentId + Constants.postIdPrefix + item.postId;
                        postItem.pId = item.departmentId + Constants.postIdPrefix;
                        postItem.open = false;
                        postItem.name = item.postName;
                        if (FSPM.CONTROL._alreadyExists(postItem.id, result)) {
                            continue;
                        }
                        //职位名称为空不显示
                        if (postItem.name) {
                            result.push(postItem);
                        }
                        // 所有部门中的职位，职位名称为空不显示在所有部门中
                        if (FSPM.CONTROL._hasDepartmentAll()) {
                            var postInDepartAll = {};
                            postInDepartAll.id = Constants.departmentAllID + Constants.postIdPrefix + item.postId;
                            postInDepartAll.pId = Constants.departmentAllID + Constants.postIdPrefix;
                            postInDepartAll.open = false;
                            postInDepartAll.name = item.postName;
                            if (!FSPM.CONTROL._alreadyExists(postInDepartAll.id, result) && postInDepartAll.name) {
                                result.push(postInDepartAll);
                            }
                        }
                    }
                    var zItem = {};
                    zItem.id = item.departmentId + Constants.postIdPrefix;
                    zItem.pId = item.departmentPId + Constants.postIdPrefix;
                    zItem.name = item.departmentName;
                    zItem.open = false;
                    zItem.description = item.description;
                    if (item.ChildNodes && item.ChildNodes.length > 0) {
                        filter(parentNode, node, item.ChildNodes, result);
                    }
                    if (!FSPM.CONTROL._alreadyExists(zItem.id, result)) {
                        result.push(zItem);
                    }
                }
                //把所有部门，职务的节点加上
                if (FSPM.CONTROL._hasDepartmentAll()) {
                    var departmentAll = {
                        id: Constants.departmentAllID + Constants.postIdPrefix,
                        pId: "-1",
                        name: FR.i18nText("FS-Privilege-Department_All"),
                        open: false
                    };
                    result.unshift(departmentAll);
                    result = postAllArray.concat(result);
                    //把所有职务加上
                    var postAll = {};
                    postAll.id = Constants.departmentAllID + Constants.postIdPrefix + Constants.postAllID;
                    postAll.pId = Constants.departmentAllID + Constants.postIdPrefix;
                    postAll.name = FR.i18nText("FS-Privilege-Post_All");
                    postAll.open = false;
                    result.unshift(postAll);
                }
                return result;
            }

            var departmentAndPostTreeSetting = {
                view: {
                    showIcon: false,  //不显示每个节点前的ICON
                    selectedMulti: true,
                    itemCheckable: true //加载节点前的复选框
                },
                data: {
                    simpleData: {
                        enable: true,
                        idKey: "id",
                        pidKey: "pId",
                        rootPId: "-1"
                    }
                },
                callback: {
                    onClickCheck: function (e, treeId, treeNode) {
                        if (config && config.clickCheckFunc && $.isFunction(config.clickCheckFunc)) {
                            config.clickCheckFunc.call(this, e, treeId, treeNode);
                        }
                    },
                    onAsyncSuccess: function () {
                        var node = departTree.selectNodeByDataNoCascade({
                            id: config.id
                        }, 0);
                        departTree.halfBubble(node, true, 0);
                    }
                },
                async: {
                    enable: true,
                    url: FR.servletURL + "?op=fs_set&cmd=auth_getcompanyrole",
                    dataFilter: filter,
                    data: {
                        serverID: FS.serverID
                    }
                }
            };
            var departTree = new FS.TableTree({
                treeID: "departTree_reuse",
                height: 300,
                setting: departmentAndPostTreeSetting,
                alwaysShowTools: true,
                toolMargin: 10,
                width: 430,
                widgetName: "departTree_reuse",
                fit: false
            });
            var refreshFunc = function (data) {
                var result = FS.Sync.ajax(data.conf);
                var newTreeNodes = departTree.options.setting.async.dataFilter("departmentTableTree", result, result, []);
                var allOldNodes = departTree.getNodes();
                var allOldNodesNum = allOldNodes.length;
                //刷新Tree，（1）清空所有Node（2）添加新的Nodes
                for (var i = 0; i < allOldNodesNum; i++) {
                    departTree.removeNode(allOldNodes[0]);
                }
                departTree.addNodes(null, newTreeNodes, true);
                //搜索过后的tree不显示所有部门，删掉
                var allNodes = departTree.getNodes();
                for (i = 0; i < allNodes.length; i++) {
                    if (data.dataFilter && data.dataFilter.length > 0 && allNodes[i].name === FR.i18nText("FS-Privilege-Department_All")) {
                        departTree.removeNode(allNodes[i]);
                    }
                }

            };
            departTree.refresh = refreshFunc;
            return departTree;
        },

        //普通角色列表
        createSRoleListPane: function (curItemArr, onItemToolClick) {
            var conf = {
                url: FR.servletURL + '?op=fs_set&cmd=auth_getcustomrole',
                onBeforeItemCreate: function (element, opts) {
                    if (opts.id < 0 || opts.isSync) {
                        element.addClass(Constants.customRoleListSyncItemCls);
                    } else {
                        element.addClass(Constants.customRoleListItemCls);
                    }
                    element.attr("id", opts.id);
                },
                onItemToolClick: onItemToolClick,
                curItemArr: curItemArr
            };
            return this.createCheckListPane(conf);
        },
        createForgedUserListPane: function (curItemArr, onItemToolClick) {
            var conf = {
                url: FR.servletURL + '?op=fs_set&cmd=auth_getForgedUser',
                onBeforeItemCreate: function (element, opts) {
                    element.attr("id", opts.id);
                },
                onItemToolClick: onItemToolClick,
                curItemArr: curItemArr
            };
            return this.createCheckListPane(conf);
        },
        //列表
        createCheckListPane: function (conf) {
            var list = new FR.QuickList({
                type: 'quicklist',
                scrollLoading: true,
                async: {
                    url: conf.url,
                    data: {
                        serverID: FS.serverID
                    }
                },
                onBeforeItemCreate: function (element, opts) {
                    if (conf.onBeforeItemCreate && $.isFunction(conf.onBeforeItemCreate)) {
                        conf.onBeforeItemCreate.call(this, element, opts);
                    }
                },
                onItemToolClick: function (toolindex, index, isSelected, e) {
                    if (conf.onItemToolClick && $.isFunction(conf.onItemToolClick)) {
                        conf.onItemToolClick.call(this, toolindex, index, isSelected, e);
                    }
                },
                valueField: 'id',
                width: 430,
                height: 300,
                itemCanBeSelect: false,
                tooltype: 'check',
                tools: [
                    {
                        name: 'sel',
                        width: 20
                    }
                ],
                toolPadding: 5,
                paddingLeft: 25,
                toolAlign: 'left',
                onAsyncSuccess: function () {
                    if (conf.curItemArr) {
                        this.selectByData(conf.curItemArr);
                    }
                }
            });
            return list;
        },
        _createReuseDialog: function (config) {
            config = config || {};
            var reuserPane, spaceTip;
            var space = this.getCurrentSpace();
            var id = config.id;
            var addIds = [id];
            var curItemArr = [{
                id: id,
                sel: 1
            }];
            var onItemToolClick = function (toolindex, index, isSelected, e) {
                var selectId = reuserPane.getValueAtIndex(index).id;
                if (isSelected) {
                    addIds.push(selectId);
                } else {
                    addIds = _.filter(addIds, function (id) {
                        return id !== selectId;
                    });
                }
            };
            var clickCheckFunc = function (e, treeId, treeNode) {
                var $target = $(e.target);
                var isSelected;
                if ($target.hasClass('fs_tool_checkon')) {
                    if (treeNode[treeNode.toolName[0]] === 2) {
                        $target.addClass('fs_tool_checkhalf');
                    }
                    isSelected = false;
                    $target.removeClass('fs_tool_checkon');
                    if (!$target.hasClass('fs_tool_checkhalf')) {
                        reuserPane.cancelSelectedNode(treeNode, 0);
                    }
                    addIds = _.filter(addIds, function (id) {
                        return id !== treeNode.id;
                    });
                    treeNode.toolName[0] = 0;
                } else if ($target.hasClass('fs_tool_checkhalf')) {
                    $target.removeClass('fs_tool_checkhalf');
                    isSelected = false;
                    $target.addClass('fs_tool_checkon');
                    reuserPane.selectNode(treeNode, true);
                    addIds.push(treeNode.id);
                    treeNode.toolName[0] = 1;
                } else {
                    isSelected = true;
                    $target.addClass('fs_tool_checkon');
                    reuserPane.selectNode(treeNode, true);
                    addIds.push(treeNode.id);
                    treeNode.toolName[0] = 1;
                }
                reuserPane.halfBubble(treeNode, isSelected, 0);
            };
            switch (space) {
                case Constants.space.JP:
                    spaceTip = FR.i18nText("FS-Privilege-Department_And_Post");
                    reuserPane = this.createDepartTreePane({
                        clickCheckFunc: clickCheckFunc,
                        id: id
                    });
                    break;
                case Constants.space.SP:
                    reuserPane = this.createSRoleListPane(curItemArr, onItemToolClick);
                    spaceTip = FR.i18nText("FS-Generic-Simple_Role");
                    break;
                case Constants.space.UP:
                    reuserPane = this.createForgedUserListPane(curItemArr, onItemToolClick);
                    spaceTip = FR.i18nText("FS-Generic-Simple_User");
                    break;
            }
            var reuseDialog = new FR.Dialog({
                confirm: true,
                title: FR.i18nText("FS-Privilege_Reuse"),
                width: 450,
                height: 510,
                doSize: true,
                destroyOnClose: true,
                text4OK: FR.i18nText("FS-Generic-Simple_OK"),
                contentWidget: {
                    type: 'absolute',
                    items: [
                        {
                            el: {
                                type: 'label',
                                width: 430,
                                wrap: true,
                                value: FR.i18nText("FS-Privilege_Reuse_Warnning_Tip", spaceTip, spaceTip),
                                height: 56
                            }, x: 10, y: 5
                        },
                        {
                            el: {
                                type: 'search',
                                width: 430,
                                autoSearch: true,
                                onKeyup: function (e) {
                                    if (!FR.isNavKeyPress(e)) {
                                        var val = this.getValue();
                                        if (space === Constants.space.JP) {
                                            config.conf.data.searchKeyword = val;
                                        } else {
                                            config.conf.sync.data.dataFilter = val;
                                        }
                                        setTimeout(function () {
                                            if (space === Constants.space.JP) {
                                                reuserPane.refresh(config);
                                            } else {
                                                FS.Tools.refreshSyncList(reuserPane, config.conf);
                                            }
                                        }, 100);
                                    }
                                }
                            }, x: 10, y: 58
                        },
                        {el: reuserPane.element, x: 10, y: 100}
                    ]
                },
                onOK: function () {
                    if (!id) {
                        return true;
                    }
                    if (addIds.length === 1 && addIds[0] === id) {
                        return true;
                    }
                    FS.Trans.reuseAndUpdatePrivilege({
                        id: id,
                        space: space,
                        src: addIds
                    });
                    FSPM.CACHE.delecteCache(id, space);//刷新缓存
                    if (space === Constants.space.JP) {
                        FSPM.VIEW.showCompanyRoleAuth({
                            id: id
                        });
                    } else {
                        FSPM.VIEW.showSpaceAuth({
                            id: id,
                            name: config.name
                        }, space);
                    }
                    return true;
                }
            });
            reuseDialog.setVisible(true);
        },

        /**
         * 生成添加和删除用户的对话框
         * @param data 初始化数据
         * @private
         */
        _createCustomRoleDialog: function (role, index) {
            var isViewOnly = false;
            if ((role.id && role.id < 0) || role.isSync) {
                //同步过来的角色
                isViewOnly = true;
            }
            var roleName = role.name;
            var $userOptPane = FS.Tools.createUserOptPane({
                roleName: roleName,
                viewOnly: isViewOnly
            });
            var userDialog = new FR.Dialog({
                confirm: true,
                title: FR.i18nText("FS-User-Personnel_Management"),
                width: 550,
                height: 445,
                doSize: true,
                destroyOnClose: true,
                text4OK: (isViewOnly ? null : FR.i18nText("FS-Generic-Simple_OK")),
                contentWidget: {
                    type: 'absolute',
                    items: [
                        {
                            el: {
                                type: 'text',
                                widgetName: Constants.customRoleNameTextWD,
                                wrap: false,
                                width: 230,
                                allowBlank: false,
                                value: roleName,
                                height: 28
                            }, x: 15, y: 12
                        },
                        {
                            el: {
                                type: 'search',
                                width: 230,
                                autoSearch: true,
                                onKeyup: function (e) {
                                    if (!FR.isNavKeyPress(e)) {
                                        var val = this.getValue();
                                        var dp = {
                                            roleName: roleName
                                        };
                                        if (val) {
                                            dp.keyword = val;
                                        }
                                        setTimeout(function () {
                                            $userOptPane.refresh(dp, $userOptPane.seluser, $userOptPane.alluser, function () {
                                                $userOptPane.seluser.empty();
                                                $userOptPane.alluser.empty();
                                            });
                                        }, 100);
                                    }
                                }
                            }, x: 300, y: 10
                        },
                        {el: $userOptPane, x: 15, y: 50}
                    ]
                },
                onOK: function () {
                    var customRoleList = FSPM.VIEW._getCustomRoleList();
                    var roleWD = userDialog.getWidgetByName(Constants.customRoleNameTextWD);
                    if (!roleWD.checkValid()) {
                        return false;
                    }
                    role.name = roleWD.getValue();
                    var addids = $userOptPane.getAddlist, delids = $userOptPane.getDellist;
                    var customRole = FS.Trans.updateRoleUsers({
                        role: role,
                        addids: addids.join(','),
                        delids: delids.join(',')
                    });
                    if (customRole.illegal) {
                        FR.Msg.alert(FR.i18nText('Fine-Engine_FS_Generic_Simple_Wrong'), FR.i18nText("FS-Privilege-Role_Name_Exists"));
                        return false;
                    }
                    if (!role.id) {
                        if (customRole.id) {
                            //添加角色
                            customRoleList.addItem(customRole, true);
                        }
                        else {
                            FR.Msg.alert(FR.i18nText('Fine-Engine_FS_Generic_Simple_Wrong'), FR.i18nText("FS-Privilege-No_Privilege"));
                            return false;
                        }
                    } else {
                        //编辑角色
                        customRoleList.setTextAtIndex(index, role.name);
                    }
                }
            });
            userDialog.setVisible(true);
        },
        /**
         * 生成添加和删除用户的对话框
         * @param data 初始化数据
         * @private
         */
        _createForgedUserConfigDialog: function () {
            var conf = {
                url: FR.servletURL + "?op=fs_set&cmd=auth_getfilterforgedusers"
            };
            var $userOptPane = FS.Tools.createPublicUserOptPane(conf);
            var depLabelWidth = FR.i18nTextWidth("FS-User-Simple_Department", 7.5);
            var staffLabelWidth = FR.i18nTextWidth("FS-User-Simple_Staff", 7.5);
            var userDialog = new FR.Dialog({
                confirm: true,
                title: FR.i18nText("FS-User-Personnel_Management"),
                width: 550,
                height: 445,
                doSize: true,
                destroyOnClose: true,
                text4OK: FR.i18nText("FS-Generic-Simple_OK"),
                contentWidget: {
                    type: 'absolute',
                    items: [
                        {
                            el: {
                                type: 'label',
                                width: depLabelWidth,
                                value: FR.i18nText("FS-User-Simple_Department"),
                                fontsize: 14
                            }, x: 15, y: 14
                        },
                        {
                            el: {
                                type: 'treecombobox',
                                mutiSelection: true,
                                widgetName: Constants.departMultiTreeWD,
                                width: 210,
                                height: 21,
                                fontSize: 12,
                                watermark: FR.i18nText("Fine-Engine_Search"),
                                widgetUrl: FR.servletURL + "?op=fs_set&cmd=auth_dpu_tree&type=3",
                                returnFullPath: true,
                                selectLeafOnly: true,
                                listeners: [{
                                    eventName: 'afteredit',
                                    action: function () {
                                        var department = this.getValue();
                                        var keyword = userDialog.getWidgetByName(Constants.userSearchWD);
                                        var dp = {
                                            depart: department,
                                            keyword: keyword.getValue()
                                        };
                                        $userOptPane.refresh(dp, $userOptPane.seluser, $userOptPane.alluser, function () {
                                            $userOptPane.seluser.empty();
                                            $userOptPane.alluser.empty();
                                        });

                                    }
                                }]
                            }, x: depLabelWidth + 20, y: 14
                        },
                        {
                            el: {
                                type: 'label',
                                width: staffLabelWidth,
                                value: FR.i18nText("FS-User-Simple_Staff"),
                                fontsize: 14
                            }, x: 315 - staffLabelWidth, y: 14
                        },
                        {
                            el: {
                                type: 'search',
                                width: 210,
                                autoSearch: true,
                                widgetName: Constants.userSearchWD,
                                watermark: FR.i18nText("Fine-Engine_Search"),
                                height: 21,
                                onKeyup: function (e) {
                                    if (!FR.isNavKeyPress(e)) {
                                        var departTree = userDialog.getWidgetByName(Constants.departMultiTreeWD);
                                        var keyword = this.getValue();
                                        var dp = {
                                            depart: departTree.getValue(),
                                            keyword: keyword
                                        };
                                        setTimeout(function () {
                                            $userOptPane.refresh(dp, $userOptPane.seluser, $userOptPane.alluser, function () {
                                                $userOptPane.seluser.empty();
                                                $userOptPane.alluser.empty();
                                            });
                                        }, 100);
                                    }
                                }
                            }, x: 320, y: 14
                        },
                        {el: $userOptPane, x: 15, y: 50}
                    ]
                },
                onOK: function () {
                    var forgedUserList = FSPM.VIEW._getForgedUserList();
                    var addids = $userOptPane.getAddlist, delids = $userOptPane.getDellist;
                    var res = FS.Trans.updateForgedUsers({
                        addids: addids.join(','),
                        delids: delids.join(',')
                    });
                    if (res.isSucceed) {
                        forgedUserList.refresh({
                            async: {
                                url: FR.servletURL + '?op=fs_set&cmd=auth_getForgedUser',
                                data: {
                                    serverID: FS.serverID
                                }
                            }
                        });

                    } else {
                        FR.Msg.alert(FR.i18nText('Fine-Engine_FS_Generic_Simple_Wrong'), res.detail);
                    }
                },
                onBeforeClose: function () {
                    var departTree = userDialog.getWidgetByName(Constants.departMultiTreeWD);
                    departTree._showView = FR.emptyFn;//REPORT-4627

                }
            });
            userDialog.setVisible(true);
        },

        _getCustomRoleList: function () {
            var customRoleList = FSPM.VIEW.tabPane.getWidgetByName(Constants.positionAndCustomRoleInsideTabNoCheckWD).getWidgetByName(Constants.customRoleListNoCheckWD);
            return customRoleList;
        },
        _getForgedUserList: function () {
            var forgedUserList = FSPM.VIEW.tabPane.getWidgetByName(Constants.positionAndCustomRoleInsideTabNoCheckWD).getWidgetByName(Constants.forgedUserListNoCheckWD);
            return forgedUserList;
        }
    },

    CONTROL: {

        comparateNumber: function (a, b) {
            return a - b;
        },

        comparateString: function (a, b) {
            if (a == b) {
                return 0;
            } else if (a > b) {
                return 1;
            } else {
                return -1;
            }
        },

        comparateEntry: function (a, b) {
            var aid = a.id, bid = b.id;
            var atype = a.type, btype = b.type;

            var r = atype - btype;
            if (r === 0) {
                var a_design = (a.design ? a.design : 0), b_design = (b.design ? b.design : 0);
                var dr = a_design - b_design;
                if (dr === 0) {
                    var a_view = (a.view ? a.view : 0), b_view = (b.view ? b.view : 0);
                    var vr = a_view - b_view;
                    if (vr === 0) {
                        var a_edit = (a.edit ? a.edit : 0), b_edit = (b.edit ? b.edit : 0);
                        var ve = a_edit - b_edit;
                        if (ve === 0) {
                            var extraPrivileges = FS.Plugin.PrivilegeManageExtraPrivilegeProvider.items;
                            for (var i = 0;i < extraPrivileges.length;i++) {
                                var a_extra_diff = (a[extraPrivileges[i].value] ? a[extraPrivileges[i].value] : 0), b_extra_diff = (b[extraPrivileges[i].value] ? b[extraPrivileges[i].value] : 0);
                                var extra_diff = a_extra_diff - b_extra_diff;
                                if (extra_diff !== 0) {
                                    return extra_diff;
                                }
                            }
                            return aid - bid;
                        } else {
                            return ve;
                        }
                    } else {
                        return vr;
                    }
                } else {
                    return dr;
                }
            } else {
                return r;
            }
        },

        comparateTemplate: function (a, b) {
            var aPath = a.path, bPath = b.path;
            if (aPath === bPath) {
                var aPage = (a.page ? a.page : 0), bPage = (b.page ? b.page : 0);
                var vr = aPage - bPage;
                if (vr === 0) {
                    var aWrite = (a.write ? a.write : 0), bWrite = (b.write ? b.write : 0);
                    var wr = aWrite - bWrite;
                    if (wr === 0) {
                        var aDesign = (a.design ? a.design : 0), bDesign = (b.design ? b.design : 0);
                        return a.design - b.design;
                    } else {
                        return wr;
                    }
                } else {
                    return vr;
                }
            } else {
                return (aPath > bPath) ? 1 : -1;
            }
        },

        comparateModule: function (a, b) {
            var aid = a.id, bid = b.id;
            var r = aid - bid;
            if (r === 0) {
                var a_design = (a.design ? a.design : 0), b_design = (b.design ? b.design : 0);
                var dr = a_design - b_design;
                if (dr === 0) {
                    var a_view = (a.view ? a.view : 0), b_view = (b.view ? b.view : 0);
                    var vr = a_view - b_view;
                    if (vr === 0) {
                        var a_edit = (a.edit ? a.edit : 0), b_edit = (b.edit ? b.edit : 0);
                        return a_edit - b_edit;
                    } else {
                        return vr;
                    }
                } else {
                    return dr;
                }
            } else {
                return r;
            }
        },

        checkPrivilegeArray: function (baseArray, newArray, isEntry) {
            var result = {};
            if (baseArray && newArray) {
                var add = result.add = [];
                var remove = result.remove = [];
                var comparatorFn = isEntry ? ((isEntry === "module") ? this.comparateModule :
                        ((isEntry === "template") ? this.comparateTemplate : ((isEntry === "string") ? this.comparateString : this.comparateEntry))) : this.comparateNumber;
                baseArray = baseArray.sort(comparatorFn);
                newArray = newArray.sort(comparatorFn);

                var bi = 0, ni = 0;
                var cr = 0;
                for (; bi < baseArray.length && ni < newArray.length; bi++) {
                    cr = comparatorFn.call(this, baseArray[bi], newArray[ni]);

                    while (cr > 0) {
                        add[add.length] = newArray[ni];
                        ni++;
                        if (ni >= newArray.length) {
                            break;
                        }
                        cr = comparatorFn.call(this, baseArray[bi], newArray[ni]);
                    }

                    if (ni >= newArray.length) {
                        break;
                    }

                    if (cr === 0) {
                        ni++;
                    } else {
                        remove[remove.length] = baseArray[bi];
                    }
                }

                for (; bi < baseArray.length; bi++) {
                    remove[remove.length] = baseArray[bi];
                }
                for (; ni < newArray.length; ni++) {
                    add[add.length] = newArray[ni];
                }
                // 检验一下
                if ((add.length - remove.length) != (newArray.length - baseArray.length)) {
                    throw "checkPrivilegeArray error!";
                }
            }

            return result;
        },

        //privilegeChanges格式是
        // {
        //      roleId:
        //          {
        //              entries:
        //                  {
        //                      add : [],
        //                      remove : []
        //                  },
        //              modules:
        //                  {
        //                      add:[],
        //                      remove:[]
        //                  }
        //          },
        //      roleId2....
        // };
        // 改成 ：
        // {
        //      customRole:[{id:,entries:modules:},...],
        //      companyRole:[{departmentId:,postId:,entries:,modules:}]
        // }

        saveAuth: function () {
            //只需要比较Cache里存在的数据和原始权限有没有区别即可
            var cachePrivileges = FSPM.CACHE.getRoleCache();
            var originalPrivileges = FSPM.CACHE.getOriginalPrivilege();

            //记录修改部分
            var privilegeChanges = {};

            var self = this;

            $.each(FS.Plugin.PrivilegeManageTabProvider.items, function (index, item) {
                if (item && $.isFunction(item.save)) {
                    item.save.call(self);
                }
            });
            $.each(Constants.space, function (spaceKey, space) {
                var originalPri = originalPrivileges[space];
                privilegeChanges[space] = [];
                $.each(originalPri, function (key, value) {
                    var id = key;
                    var originalEntry = value['entries'];
                    var newEntry = cachePrivileges[space][id]['entries'];
                    var originalModule = value['modules'];
                    var newModule = cachePrivileges[space][id]['modules'];
                    var originalTemplate = value['templates'];
                    var newTemplate = cachePrivileges[space][id]['templates'];
                    var originalDepAndCRole = value['depandcroles'];
                    var newDepAndCRole = cachePrivileges[space][id]['depandcroles'];
                    var originalDataConnection = value['dataconnections'];
                    var newDataConnection = cachePrivileges[space][id]['dataconnections'];
                    var item = {};
                    if (space == Constants.space.JP) {
                        var departAndPostId = id.split(Constants.postIdPrefix);
                        item.departmentId = departAndPostId[0];
                        if (departAndPostId[1]) {
                            item.postId = departAndPostId[1];
                        }
                    } else {
                        item.id = id;
                    }
                    item.entries = self.checkPrivilegeArray(originalEntry, newEntry, true);
                    item.modules = self.checkPrivilegeArray(originalModule, newModule, "module");
                    item.templates = self.checkPrivilegeArray(originalTemplate, newTemplate, "template");
                    item.depandcroles = self.checkPrivilegeArray(originalDepAndCRole, newDepAndCRole, "string");
                    item.dataconnections = self.checkPrivilegeArray(originalDataConnection, newDataConnection, "string");
                    privilegeChanges[space].push(item);
                });
            });
            if (privilegeChanges[Constants.space.JP].length === 0
                && privilegeChanges[Constants.space.SP].length === 0
                && privilegeChanges[Constants.space.UP].length === 0) {
                return;
            }
            var result = FS.Trans.savePrivileges(privilegeChanges);
            if (result == "error") {
                FR.Msg.toast(FR.i18nText("FS-Privilege-Already_Set"));
            } else {
                FR.Msg.toast(FR.i18nText("FS-Generic-Simple_Successfully"));
                //更新originalPrivilege
                FSPM.CACHE.refreshOriginalPrivilege(FR.clone(cachePrivileges));
                FSPM.CACHE.clearEntryCache();
            }
        },

        saveEntryAuth: function () {
            var self = this;

            var cacheEntryPrivileges = FSPM.CACHE.getEntryCache();
            var originalEntryPrivileges = FSPM.CACHE.getOriginalEntryCache();

            //记录修改部分
            var entryPrivilegeChanges = {};
            entryPrivilegeChanges[Constants.space.JP] = [];
            entryPrivilegeChanges[Constants.space.SP] = [];
            entryPrivilegeChanges[Constants.space.UP] = [];

            var getPrivilegeJSON = function (addEntry, removeEntry, roleId, space) {
                if (!addEntry && !removeEntry || !roleId) {
                    return null;
                }
                var result = {
                    entries: {
                        add: addEntry ? [addEntry] : [],
                        remove: removeEntry ? [removeEntry] : []
                    },
                    modules: {
                        add: [],
                        remove: []
                    },
                    templates: {
                        add: [],
                        remove: []
                    },
                    depandcroles: {
                        add: [],
                        remove: []
                    },
                    dataconnections: {
                        add: [],
                        remove: []
                    }
                };
                if (space === Constants.space.JP) {
                    if (roleId.indexOf(Constants.postIdPrefix) >= 0) {
                        //部门角色
                        var departAndPostId = roleId.split(Constants.postIdPrefix);
                        result.departmentId = departAndPostId[0];
                        if (departAndPostId[1]) {
                            result.postId = departAndPostId[1];
                        }
                    } else {
                        result.departmentId = roleId;
                    }
                } else {
                    result.id = roleId;
                }
                return result;
            };

            var dealWithRoleChanges = function (key, originalRoles, newRoles, space) {
                var role = self.checkPrivilegeArray(
                    originalRoles[space], newRoles[space], "module"
                );
                var addEntryDict = {};
                var extraPrivileges = FS.Plugin.PrivilegeManageExtraPrivilegeProvider.items;
                if (role.add && role.add.length > 0) {
                    for (var m = 0, len = role.add.length; m < len; m++) {
                        var addEntry = {
                            "id": key.substr(1),
                            "type": key.charAt(0)
                        };
                        addEntry.view = role.add[m].view;
                        for (var i = 0;i < extraPrivileges.length;i++){
                            addEntry[extraPrivileges[i].value] = role.add[m][extraPrivileges[i].value];
                        }
                        addEntry.design = role.add[m].design;
                        addEntry.edit = role.add[m].edit;
                        addEntryDict[role.add[m].id] = addEntry;
                    }
                }
                var removeEntryDict = {};
                if (role.remove && role.remove.length > 0) {
                    for (var m = 0, len = role.remove.length; m < len; m++) {
                        var removeEntry = {
                            "id": key.substr(1),
                            "type": key.charAt(0)
                        };
                        removeEntry.view = role.remove[m].view;
                        for (var i = 0;i < extraPrivileges.length;i++){
                            removeEntry[extraPrivileges[i].value] = role.remove[m][extraPrivileges[i].value];
                        }
                        removeEntry.design = role.remove[m].design;
                        removeEntry.edit = role.remove[m].edit;
                        removeEntryDict[role.remove[m].id] = removeEntry;
                    }
                }
                $.each(addEntryDict, function (id, addEntry) {
                    var removeEntry = null;
                    if (addEntryDict.hasOwnProperty(id)) {
                        removeEntry = removeEntryDict[id];
                        delete removeEntryDict[id];
                    }
                    var RoleChange = getPrivilegeJSON(addEntry, removeEntry, id, space);
                    if (RoleChange) {
                        entryPrivilegeChanges[space].push(RoleChange);
                    }
                });
                $.each(removeEntryDict, function (id, removeEntry) {
                    var RoleChange = getPrivilegeJSON(null, removeEntry, id, space);
                    if (RoleChange) {
                        entryPrivilegeChanges[space].push(RoleChange);
                    }
                });
            };

            $.each(originalEntryPrivileges, function (key, value) {
                var originalRoles = value;
                var newRoles = cacheEntryPrivileges[key];
                dealWithRoleChanges(key, originalRoles, newRoles, Constants.space.JP);
                dealWithRoleChanges(key, originalRoles, newRoles, Constants.space.SP);
                dealWithRoleChanges(key, originalRoles, newRoles, Constants.space.UP);
            });
            var result = FS.Trans.savePrivileges(entryPrivilegeChanges);
            if (result == "error") {
                FR.Msg.toast(FR.i18nText("FS-Privilege-Already_Set"));
            } else {
                FR.Msg.toast(FR.i18nText("FS-Generic-Simple_Successfully"));
                FSPM.CACHE.refreshOriginalEntryCache(FR.clone(cacheEntryPrivileges));
                FSPM.CACHE.clearRoleCache();
            }

        },

        _alreadyExists: function (id, result) {
            for (var i = 0; i < result.length; i++) {
                if (result[i].id === id) {
                    return true;
                }
            }
            return false;
        },

        /**
         * 是否支持所有部门节点操作
         *
         * kyle: 暂时限制开启分级授权时，仅允许超级管理员操作所有部门节点
         *
         * @returns {boolean} 是否支持所有部门
         * @since 7.1.1
         * @private
         */
        _hasDepartmentAll: function () {
            return FS.config.gradeAuthority !== "true" || FS.config.isAdmin === true;
        },

        popSettingData: function (floatPane) {
            var settings = FS.Trans.getPrivilegeSetting();
            var radioGroup = floatPane.getWidgetByName(Constants.settingRadioGroupWD);
            radioGroup.setValue(settings["rType"], true);
            if (settings["rType"] == Constants.templatePrivileges.DIGITAL_URL) {
                floatPane.getWidgetByName(Constants.templateControlCardWD).getWidgetByName(Constants.keyURLTextEditorWD).setValue(settings.keyUrl);
            }
            var gradeAuthority = FS.isGradeAuthorityOpen();
            var editReportAuthority = FS.isEditReportAuthorityOpen();
            floatPane.getWidgetByName(Constants.gradeAuthoritySwitchWD).setValue(gradeAuthority, false);
            floatPane.getWidgetByName(Constants.editReportSwitchWD).setValue(editReportAuthority, false);
        },

        setData: function (floatPane) {
            var radioGroup = floatPane.getWidgetByName(Constants.settingRadioGroupWD);
            var jo = {};
            jo.rType = radioGroup.getValue();
            if (jo.rType == Constants.templatePrivileges.DIGITAL_URL) {
                jo.keyUrl = floatPane.getWidgetByName(Constants.templateControlCardWD)
                    .getWidgetByName(Constants.keyURLTextEditorWD).getValue();
                if (!jo.keyUrl) {
                    FR.Msg.alert(FR.i18nText("Fine-Engine_FS_Generic_Simple_Wrong"), FR.i18nText("FS-Privilege-Need_Input_Url_Key"));
                    return;
                }
            } else if (jo.rType == Constants.templatePrivileges.ROLE_VERIFY_NEEDED) {
                jo.isDataConnectionPrivilegeOpen = floatPane.getWidgetByName(Constants.templateControlCardWD)
                    .getWidgetByName(Constants.dataConnectionSwitchWD).getValue();
            }
            jo.gradeAuthority = floatPane.getWidgetByName(Constants.gradeAuthoritySwitchWD).getValue();
            jo.editReport = floatPane.getWidgetByName(Constants.editReportSwitchWD).getValue();
            var result = FS.Trans.savePrivilegeSetting(jo);
            if (result == "success") {
                floatPane.doSlide();
                FR.Msg.toast(FR.i18nText("FS-Generic-Simple_Successfully"));
                //做了变动，就重新刷新下权限管理标签页
                FSPM.CACHE.clearCache();
                FS.setGradeAuthorityOpen(jo.gradeAuthority + "");
                FS.setEditReportAuthority(jo.editReport + "");
                FS.setTemplatePrivilegeType(jo.rType + "");
                if (jo.rType == Constants.templatePrivileges.ROLE_VERIFY_NEEDED) {
                    FS.setDataConnectionAuthorityOpen(jo.isDataConnectionPrivilegeOpen + "");
                }
                var privilegeModule = {
                    text: FR.i18nText("FS-Module-Privilege_Manager"),
                    id: 18,
                    isModule: true
                };
                FS.Design.showDesign(privilegeModule);
            } else {
                FR.Msg.toast(FR.i18nText("FS-Generic-Simple_Failed"));
            }
        }
    },

    MODEL: {
        TabTitle: {
            createTitle: function (text, clickFunc, index) {
                return $("<span/>").text(text).addClass("fs_privilege_manager_tabTitle")
                    .click(function () {
                        if ($.isFunction(clickFunc)) {
                            clickFunc.call(this, index);
                        }
                    });
            }
        }
    }
};
