FS.REGISTER = {
    baseClass: "register-page",
    init: function (renderer) {
        FR.$defaultImport('/com/fr/fs/web/css/manager/fs_register.css', 'css');
        this.initData(renderer);
    },
    initContainer: function (renderer) {
        var self = this;
        var registerType = this.getRegisterType();
        var items = [self.createVersionInfoPane(registerType), self.createFunctionList()];
        self.registerTabPane = new FS.LTabPane({
            width: '100%',
            height: "auto",
            items: items,
            style: 'blue',
            vgap: 21,
            widgetName: 'visitorManagerTabPane',
            renderEl: renderer,
            initAfterActions: [
                function () {
                    this.getWidgetByName("versionInfoTable").element.css({
                        '-webkit-user-select': 'initial',
                        '-moz-user-select': 'initial',
                        'width': '900px'
                    });
                    if (registerType === 0) {
                        this.getWidgetByName("registerInfoTable").setRowVisible([1, 2, 3, 4, 5, 6, 7], false);
                        this.getWidgetByName("authRadioGroup").setValue('local');
                        this.getWidgetByName("registerInfoTable").doLayout();
                    } else {
                        if (!self.serverType) {
                            this.getWidgetByName("versionSuccessTable").setRowVisible([1, 6, 2, 3, 4, 5, 8, 16], false);
                            this.getWidgetByName("showDetail").setVisible(false);
                            this.getWidgetByName("showDetail2").setVisible(false);
                            this.getWidgetByName("showDetail3").setVisible(false);
                            this.getWidgetByName("showDetail4").setVisible(false);
                            this.getWidgetByName("versionSuccessTable").doLayout();
                            if (registerType === 1) {
                                $(".registerHelpMsg").hide();
                                this.getWidgetByName("registerHelpMsg1").setVisible(false);
                                this.getWidgetByName("pluginInfoListGrid").setVisible(true);
                            } else {
                                this.getWidgetByName("versionSuccessTable").setRowVisible([ 7, 15, 16], false);
                                this.getWidgetByName("pluginInfoListGrid").setVisible(false);
                                if (!self.data.appinfo["Re-mac-match"]) {
                                    this.getWidgetByName("showDetail").setVisible(true);
                                }
                                if (!self.data.appinfo["Re-uuid-match"]) {
                                    this.getWidgetByName("showDetail2").setVisible(true);
                                }
                                if (!self.data.appinfo["Re-appname-match"]) {
                                    this.getWidgetByName("showDetail3").setVisible(true);
                                }
                                if (!self.data.appinfo["Re-version-match"]) {
                                    this.getWidgetByName("showDetail4").setVisible(true);
                                }
                                this.getWidgetByName("versionSuccessTable").doLayout();
                            }
                        } else {
                            this.getWidgetByName("versionSuccessTable").setRowVisible([2, 3, 4, 5, 6, 9, 10, 11, 14, 15, 17, 16], false);
                            if (self.privateCloud_type == 2 && !self.message) {
                                this.getWidgetByName("versionSuccessTable").setRowVisible([1], true);
                            } else {
                                if (registerType === 1) {
                                    $(".registerHelpMsg").hide();
                                    this.getWidgetByName("registerHelpMsg1").setVisible(false);
                                    this.getWidgetByName("pluginInfoListGrid").setVisible(true);
                                    this.getWidgetByName("versionSuccessTable").setRowVisible([16, 1], false);
                                    this.getWidgetByName("versionSuccessTable").setRowVisible([15], true);
                                } else {
                                    this.getWidgetByName("versionSuccessTable").setRowVisible([15, 1, 16], false);
                                }
                            }
                            this.getWidgetByName("versionSuccessTable").doLayout();
                        }
                    }
                },
                function () {
                }
            ]
        });
    },
    getRegisterType: function () {
        var registerType = 0;
        var self = this;
        FR.ajax({
            url: FR.servletURL,
            type: 'POST',
            async: false,
            data: {
                op: 'fr_server',
                cmd: 'check_regist_configured'
            },
            timeout: 5000,
            complete: function (res, status) {
                var result = FR.jsonDecode(res.responseText);
                FS.config.isLicExist = result.isConfigured;
            }
        });
        //未注册
        if (FS.config.isLicExist != 'true' && !self.serverType) {
            registerType = 0;
        } else {
            //已注册
            if (this.isRegisterSuccess()) {
                //注册成功
                registerType = 1;
            } else {
                //注册失败
                registerType = 2;
            }
        }
        return registerType;
    },
    _getRegisterAuthorityMsg: function () {
        var authorityMsg = "";
        var self = this;
        if (!self.serverType) {
            authorityMsg = FR.i18nText("FS-Reg-Local");
        } else {
            authorityMsg = FR.i18nText("FS-Reg-Cloud");
        }
        return authorityMsg;
    },
    //判断是否注册成功
    isRegisterSuccess: function () {
        var info = this.data.appinfo;
        var self = this;
        if (info && !self.serverType) {
            if (this.isOnlineCheck) {
                return info["Re-online-match"];
            }
            return info["Re-appname-match"] && info["Re-version-match"]
                && info["Re-uuid-match"] && info["Re-mac-match"]
                && !info['Re-lic-out-date'] && info["Re-appcontent-match"]
        } else if (self.serverType) {
            return (self.privateCloud_type === 1);
        }
        return false;
    },
    createVersionInfoPane: function (registerType) {
        var self = this;
        var panelHeight = this.macinfo.length * 25 + 675;
        var widget;
        if (registerType === 1) {
            panelHeight += 125;
        } else {
            panelHeight -= 240;
        }
        var versionInfoConfig = {
            title: FR.i18nText("FS-Reg-Version_Info"),
            content: {
                widgetName: 'versionInfoPanel',
                type: 'panel',
                width: 850,
                height: panelHeight,
                doSize: true,
                contentWidget: this._createVersionInfoTable(registerType)
            }
        }
        return versionInfoConfig;
    },

    _createVersionInfoTable: function (registerType) {
        var rowSize;
        var items = [
            [
                {el: $('<div/>')},
                {el: {type: 'llabel', levelStyle: 1, value: FR.i18nText("FS-Reg-Version_Info")}},
                {el: $('<div/>')}
            ],
            [
                {el: $('<div/>')},
                {el: this._createNormalInfoTable()},
                {el: $('<div/>')}
            ],
            [
                {el: $('<div/>')},
                {el: {type: 'llabel', levelStyle: 1, value: FR.i18nText("FS-Module-Simple_Register")}},
                {el: $('<div/>')}
            ],
            [
                {el: $('<div/>')},
                {el: this._createInfoTable(registerType)},
                {el: $('<div/>')}
            ]
        ];
        rowSize = [28, 95, 28, "auto"];
        var visitorViewConfig = {
            widgetName: 'versionNormalTable',
            type: 'tablelayout',
            items: items,
            columnSize: [17, 731, 50],
            rowSize: rowSize,
            width: 830,
            vgap: 12
        }
        return visitorViewConfig;
    },

    refreshTab: function () {

        FS.tabPane._refreshTab(FS.tabPane._getSelectedTab());
    },
    _createUnbindOrSubmitButton: function (registerType) {
        var self = this;
        return {
            x: 0,
            y: 0,
            type: 'absolute',
            items: [
                {
                    type: 'quickbutton',
                    style: 'blue',
                    widgetName: "submitButton",
                    baseClass: "is_register_button_span",
                    text: FR.i18nText('FS-Submit-Authority'),
                    width: FR.i18nTextWidth('FS-Submit-Authority') + 60,
                    height: 33,
                    handler: function () {
                        var serverURL = self.registerTabPane.getWidgetByName("inputMsg").getValue();
                        var submitButton = self.registerTabPane.getWidgetByName("submitButton");
                        var authority = submitButton.getText();
                        var regex = new RegExp("(https):\/\/*");
                        var regErrorMsg = "";
                        var reg = new RegExp("[\\u4E00-\\u9FFF]+", "g");
                        if (serverURL === "") {
                            regErrorMsg = FR.i18nText("FS-Error-Null-Msg");
                            FR.Msg.alert(FR.i18nText("FS-System-Dialog_Title"), regErrorMsg);
                        } else if (serverURL !== "" && reg.test(serverURL)) {
                            regErrorMsg = FR.i18nText("FS-Chinese-Not-Null");
                            FR.Msg.alert(FR.i18nText("FS-System-Dialog_Title"), regErrorMsg);
                        } else if (!regex.test(serverURL)) {
                            regErrorMsg = FR.i18nText("FS-Error-URL-Msg");
                            FR.Msg.alert(FR.i18nText("FS-System-Dialog_Title"), regErrorMsg);
                        } else {
                            if (authority !== FR.i18nText("FS-Cloud-Unbind")) {
                                FR.showLoadingDialog({
                                    title: FR.i18nText("FS-System-Dialog_Title"),
                                    text: FR.i18nText("FS-Before-Authority"),
                                    width: 310,
                                    height: 120
                                });
                                FR.ajax({
                                    url: FR.servletURL,
                                    type: 'POST',
                                    async: true,
                                    data: {
                                        op: 'fr_server',
                                        cmd: 'sc_post_cloud_url',
                                        serverURL: serverURL
                                    },
                                    complete: function (res, status) {  //云授权情况
                                        FR.hideLoadingDialog();
                                        var self1 = this;
                                        var flag = false;
                                        self1.data = FR.jsonDecode(res.responseText);
                                        var cloudStatus = self1.data.status;
                                        var cloudConfig = self1.data.serverConfig;
                                        self.serverType = cloudConfig.type;
                                        if (status == 'success') {
                                            var state = cloudStatus["status"];
                                            self.registerTabPane.getWidgetByName("inputMsg").setValue(serverURL);
                                            switch (state) {
                                                case "SUCCESS":
                                                    self.registerTabPane.getWidgetByName("inputMsg").setEnable(false);
                                                    FR.Msg.alert(FR.i18nText('FS-System-Dialog_Title'), FR.i18nText('FS-Authority-Successfully'),
                                                        function (value) {
                                                            self.refreshTab();
                                                        });
                                                    break;

                                                case "NONE":
                                                    FR.Msg.alert(FR.i18nText('Fine-Engine_FS_Generic_Simple_Wrong'), FR.i18nText('FS-Server-Error-Msg'),
                                                        function (value) {
                                                            self.refreshTab();
                                                        });
                                                    break;

                                                case "FAILED":
                                                    if (cloudStatus["message"]) {
                                                        FR.Msg.alert(FR.i18nText('Fine-Engine_FS_Generic_Simple_Wrong'), cloudStatus["message"], function (value) {
                                                            self.refreshTab();
                                                        });
                                                    } else {
                                                        FR.Msg.alert(FR.i18nText('Fine-Engine_FS_Generic_Simple_Wrong'), FR.i18nText('FS-Connect-Failed'), function (value) {
                                                            self.refreshTab();
                                                        });
                                                    }
                                                    break;
                                            }
                                            self.registerTabPane.getWidgetByName("versionSuccessTable").doLayout();
                                        }
                                    }
                                })
                            } else {
                                var $content = $('<div"/>').text(FR.i18nText("FS-Is-Unbind-URL")).css({
                                    paddingLeft: 20,
                                    paddingTop: 30
                                });

                                FR.Msg.confirm(FR.i18nText("FS-System-Dialog_Title"), FR.i18nText("FS-Is-Unbind-URL"), function(value) {
                                    if (value) {
                                    FR.showLoadingDialog({
                                        title: FR.i18nText("FS-System-Dialog_Title"),
                                        text: FR.i18nText("FS-Before-Unbind-Authority"),
                                        width: 310,
                                        height: 120
                                    });
                                    FR.ajax({
                                        url: FR.servletURL,
                                        async: true,
                                        type: "POST",
                                        data: {
                                            op: 'fr_server',
                                            cmd: 'sc_clean_cloud_url'
                                        },
                                        timeout: 5000,
                                        complete: function (res, status) {  //云授权情况
                                            //解除绑定
                                            FR.hideLoadingDialog();
                                            self.refreshTab();
                                        }
                                    })
                                }
                                });

                            }
                        }

                    }
                }
            ]
        }
    },
    _createCancelInfo: function (registerType) {
        var self = this;
        return {
            x: 0,
            y: 10,
            type: 'absolute',
            items: [
                {
                    type: 'quickbutton',
                    style: 'gray',
                    baseClass: "is_register_button_span",
                    text: FR.i18nText('Fine-Engine_FS_Generic_Simple_Cancel'),
                    width: FR.i18nTextWidth('Fine-Engine_FS_Generic_Simple_Cancel') + 84,
                    height: 33,
                    handler: function () {
                        switch (registerType) {
                            case 0: //未注册
                            {
                                self.registerTabPane.getWidgetByName("registerInfoTable").setRowVisible([1, 2, 3, 4, 5, 6, 7], false);
                                self.registerTabPane.getWidgetByName('registerImmediately').setVisible(true);
                                this.getWidgetByName("authRadioGroup").setValue('local');
                                this.getWidgetByName("registerInfoTable").doLayout();
                                break;
                            }

                            case 1: //注册成功
                            {
                                if (!self.serverType) {
                                    self.registerTabPane.getWidgetByName("versionSuccessTable").setRowVisible([7, 9, 10, 11, 12, 13, 14, 15, 17], true);
                                    self.registerTabPane.getWidgetByName("versionSuccessTable").setRowVisible([1, 2, 3, 4, 5, 6, 8, 16], false);
                                } else {
                                    self.registerTabPane.getWidgetByName("versionSuccessTable").setRowVisible([7, 8, 12, 13, 15, 17], true);
                                    self.registerTabPane.getWidgetByName("versionSuccessTable").setRowVisible([1, 2, 3, 4, 5, 6, 9, 10, 11, 14, 16], false);
                                }
                                self.registerTabPane.getWidgetByName('registerSecond').setVisible(true);
                                this.getWidgetByName("authRadioGroup").setValue('local');
                                this.getWidgetByName("versionSuccessTable").doLayout();
                                break;
                            }

                            default: //注册失败
                            {
                                if (!self.serverType) {
                                    self.registerTabPane.getWidgetByName("versionSuccessTable").setRowVisible([7, 9, 10, 11, 12, 13, 14], true);
                                    self.registerTabPane.getWidgetByName("versionSuccessTable").setRowVisible([1, 2, 3, 4, 5, 6, 8, 15, 17, 16], false);
                                } else {
                                    self.registerTabPane.getWidgetByName("versionSuccessTable").setRowVisible([2, 3, 4, 5, 6, 9, 10, 11, 14, 15, 17, 16], false);
                                    self.registerTabPane.getWidgetByName("versionSuccessTable").setRowVisible([1, 7, 8, 12, 13], true);
                                }
                                self.registerTabPane.getWidgetByName('registerSecond').setVisible(true);
                                this.getWidgetByName("authRadioGroup").setValue('local');
                                this.getWidgetByName("versionSuccessTable").doLayout();
                            }

                        }
                    }
                }
            ]
        }
    },
    _createExportInfo: function () {
        var self = this;
        return {
            type: 'absolute',
            items: [
                {
                    x: 0,
                    y: 5,
                    type: 'quickbutton',
                    baseClass: "is_register_button_span",
                    text: FR.i18nText('FS-Reg-Export_Info'),
                    width: FR.i18nTextWidth('FS-Reg-Export_Info') + 30,
                    height: 33,
                    handler: function () {
                        window.location = FR.servletURL + "?op=fs_manager&cmd=export_registrationinformation";
                    }
                },
                {
                    x: FR.i18nTextWidth('FS-Reg-Export_Info') + 50,
                    y: 13,
                    el: self._createEmailLink()
                }
            ]
        }
    },
    _createEmailLink: function () {
        var email_link = $('<div/>').attr('id', 'email_link');
        var link_a = $('<a/>').addClass('email_link').appendTo(email_link);
        link_a.attr('href', FS.config.registerUrl);
        $('<span/>').addClass('email_link').text(FR.i18nText("FS-Reg-Register_email") + " " + FS.config.registerMail).appendTo(link_a);
        return email_link;
    },
    _createVersionInfoLabel: function (registerType) {
        var value = registerType;
        var wrapDiv = $('<div/>').addClass('is_register_success_span');
        switch (value) {
            case 0:
                value = FR.i18nText("FS-Reg-Simple_Unregistered");
                wrapDiv.css('color', '#F30000');
                break;
            case 1:
                value = FR.i18nText("FS-Reg_Registration_Successfully");
                wrapDiv.css('color', '#2DAC00');
                break;
            case 2:
                value = FR.i18nText("FS-Reg-Simple_Register_Failed");
                wrapDiv.css('color', '#F30000');
                break;
        }
        $('<span/>').text(value).appendTo(wrapDiv);
        return wrapDiv;
    },
    _getFileLoad: function (registerType) {
        var self = this;
        var filePanel = {
            widgetName: 'filePanel',
            type: 'panel',
            height: 35,
            doSize: true,
            contentWidget: {
                type: "tablepane",
                rowSize: [35],
                colSize: [110],
                items: [[
                    {
                        type: "absolute",
                        items: [
                            {
                                x: 0, y: 0, width: 106, height: 33,
                                type: "multifile",
                                maxlength: 1,
                                accept: ".lic",
                                hideFileList: true,
                                showViewImage: false,
                                listeners: [{
                                    eventName: "afterinit",
                                    action: function () {
                                        this.$preview.remove();
                                    }
                                }, {
                                    eventName: "afteredit",
                                    action: function () {
                                        var attach = this.wrap.attach_array[0];
                                        var id = attach.attach_id;
                                        var isSuccess = false;
                                        $(function () {
                                            FR.ajax({
                                                url: FR.servletURL,
                                                data: {
                                                    op: 'reg',
                                                    cmd: 'lic_upload',
                                                    id: id
                                                },
                                                async: false,
                                                complete: function (res, status) {
                                                    if (status == 'success') {
                                                        isSuccess = res.responseText == 'true';
                                                        self.refreshTab();
                                                    }
                                                }
                                            })
                                        });
                                        if (isSuccess) {
                                            FR.Msg.toast(FR.i18nText("FS-Reg-Lic_Upload_Success"));
                                        } else {
                                            FR.Msg.toast(FR.i18nText("FS-Reg-Lic_Upload_Failed"));
                                        }
                                    }
                                }]
                            },
                            {
                                x: 0, y: 0,
                                width: 106, height: 31,
                                style: "blue",
                                type: "quickbutton",
                                text: FR.i18nText("FS-Upload-Lic-File")
                            }
                        ]
                    }
                ]]
            }
        }
        return filePanel;
    },
    _createInfoTable: function (registerType) {
        if (registerType === 0) {
            return this._createUnregisterVersionTable(registerType);
        } else {
            return this._createRegisterSuccessInfoTable(registerType);
        }
    },
    _createNormalInfoTable: function () {
        var self = this;
        var appinfo = self.data.appinfo;
        var items = [
            [
                {el: this._createRegisterSpan(FR.i18nText("FS-Reg-App_Name"))},
                {el: this._createRegisterSpan(appinfo['Re-AppName'])},
                {el: $('<div/>')}
            ],
            [
                {el: this._createRegisterSpan(FR.i18nText("FS-Reg-FR-Version"))},
                {
                    el: {
                        type: "tablelayout",
                        items: [
                            [
                                {el: this._createRegisterSpan(FR.i18nText("FS-Reg-Version"))},
                                {el: this._createRegisterSpan(appinfo['Re-system-version'])}
                            ]
                        ],
                        columnSize: [54, 553],
                        rowSize: [17]
                    }
                },
                {el: $('<div/>')}
            ],
            [
                {el: $('<div/>')},
                {
                    el: {
                        type: "tablelayout",
                        items: [
                            [
                                {el: this._createRegisterSpan(FR.i18nText("FS-Reg-FR-JAR"))},
                                {el: this._createRegisterSpan(appinfo['Re-Jar'])}
                            ]
                        ],
                        columnSize: [35, 572],
                        rowSize: [17]
                    }
                },
                {el: $('<div/>')}
            ]
        ];
        var visitorViewConfig = {
            widgetName: 'versionInfoTable',
            type: 'tablelayout',
            items: items,
            columnSize: [180, 607, 50],
            rowSize: [17, 17, 17],
            vgap: 15
        }
        return visitorViewConfig;
    },
    _createUnregisterVersionTable: function (registerType) {   //未注册版本的注册信息
        var self = this;
        var appinfo = self.data.appinfo;
        var macinfo = this.macinfo;
        var mac_items = [];
        mac_items.push(this._createRegisterSpan(macinfo[0]));
        for (var m = 1, len = macinfo.length; m < len; m++) {
            var mac_item = this._createRegisterUnableSpan(macinfo[m]);
            mac_items.push([
                {el: mac_item}, {el: $('<div/>')}
            ]);
        }
        var macHeight = macinfo.length * 25 - 8;
        var macItems = [
            {
                x: 0,
                y: 0,
                type: 'label',
                height: 15,
                width: 300,
                fontsize: '13px',
                color: '#202020',
                value: macinfo[0]
            }
        ];
        for (var i = 1, len = macinfo.length; i < len; i++) {
            macItems.push(
                {
                    x: 0,
                    y: 25 * i,
                    type: 'label',
                    height: 15,
                    width: 300,
                    fontsize: '13px',
                    color: 'grey',
                    value: macinfo[i]
                }
            );
        }
        var wrapDiv = $('<div/>').addClass('is_register_warning_span');
        var regex = "((https)://)(([a-zA-Z0-9\._-]+\.[a-zA-Z]{2,6})|([0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}))(:[0-9]{1,4})+(/[a-zA-Z0-9\&%_\./-~-]*)?";
        var items = [
            [
                {el: this._createRegisterSpan(FR.i18nText("FS-Reg_Version_Registration"))},
                {
                    el: {
                        type: "tablelayout",
                        items: [
                            [
                                {el: this._createVersionInfoLabel(registerType)},
                                {
                                    el: {
                                        widgetName: "registerImmediately",
                                        x: 0,
                                        y: 0,
                                        type: 'iconbutton',
                                        text: '[' + FR.i18nText("FS-Reg-Immediately") + ']',
                                        baseClass: 'is_register_button_span',
                                        handler: function () {

                                            this.getWidgetByName('registerImmediately').setVisible(false);
                                            self.registerTabPane.getWidgetByName('registerInfoTable').setRowVisible([2, 3, 4], true);
                                            self.registerTabPane.getWidgetByName('registerInfoTable').setRowVisible([5, 6, 7], false);
                                            this.getWidgetByName("registerInfoTable").doLayout();
                                        }
                                    }
                                },
                                {el: $('<span class="is_register_warning_span"/>').text(FR.i18nText("FS-Reg-Warn-Msg")).appendTo(wrapDiv)},
                                {
                                    el: {
                                        type: 'iconbutton',
                                        text: FR.i18nText("FS-Reg-How"),
                                        baseClass: 'is_register_button_span',
                                        handler: function () {
                                            window.open(FS.config.registerUrl);
                                        }
                                    }
                                }
                            ]
                        ],
                        columnSize: [48, 100, 300, 159],
                        rowSize: [15]
                    }
                },
                {el: $('<div/>')}
            ],
            [
                {el: this._createRegisterSpan(FR.i18nText("FS-User-Simple_Authentication"))},  //修改过
                {
                    el: {
                        type: "llabel",
                        widgetName: "authorityWay",
                        value: this._getRegisterAuthorityMsg()
                    }
                },
                {el: $('<div/>')}
            ],
            [
                {el: this._createRegisterSpan(FR.i18nText("FS-User-Simple_Authentication"))},
                {
                    el: {
                        x: 0, y: 0,
                        type: 'radiogroup',
                        assureSelect: true,
                        columnsInRow: 1,
                        widgetName: 'authRadioGroup',
                        value: 0,
                        items: [
                            {text: FR.i18nText("FS-Reg-Local"), value: 'local', vgap: 15},
                            {text: FR.i18nText("FS-Reg-Cloud"), value: 'cloud'}
                        ],
                        listeners: [
                            {
                                eventName: FR.Events.AFTEREDIT,
                                action: function () {
                                    var value = this.getValue();
                                    if (value === 'local') {
                                        self.registerTabPane.getWidgetByName("registerInfoTable").setRowVisible([2, 3, 4], true);
                                        self.registerTabPane.getWidgetByName("registerInfoTable").setRowVisible([1, 5, 6, 7], false);
                                    } else {
                                        self.registerTabPane.getWidgetByName("registerInfoTable").setRowVisible([1, 3, 4, 7], false);
                                        self.registerTabPane.getWidgetByName("registerInfoTable").setRowVisible([2, 5, 6], true);
                                    }
                                    self.registerTabPane.getWidgetByName("registerInfoTable").doLayout();
                                }
                            }
                        ]
                    }
                },
                {el: $('<div/>')}
            ],
            [
                {el: this._createRegisterSpan(FR.i18nText("FS-Reg-Machine-Info"))},
                {
                    el: {
                        type: "tablelayout",
                        items: [
                            [
                                {el: this._createRegisterSpan(FR.i18nText("FS-Reg-Mac_Address"))},
                                {
                                    el: {
                                        type: 'panel',
                                        height: macHeight,
                                        doSize: true,
                                        contentWidget: {
                                            type: 'absolute',
                                            items: macItems
                                        }
                                    }
                                }
                            ],
                            [
                                {el: this._createRegisterSpan(FR.i18nText("FS-Reg-Machine_Code"))},
                                {el: this._createRegisterSpan(appinfo['Re-uuid-in-system'], 'uuid')}
                            ],
                            [
                                {
                                    el: {
                                        type: 'iconbutton',
                                        text: FR.i18nText("FS-Reg-Export_Info"),
                                        baseClass: 'is_register_button_span',
                                        handler: function () {
                                            window.location = FR.servletURL + "?op=fs_manager&cmd=export_registrationinformation";
                                        }
                                    }
                                },
                                {el: $('<div/>')}
                            ]
                        ],
                        columnSize: [80, 527],
                        rowSize: [macHeight, 14, 17],
                        vgap: 15
                    }
                },
                {el: $('<div/>')}
            ],
            [
                {el: $('<div/>')},
                {
                    el: {
                        type: "tablelayout",
                        items: [
                            [
                                {el: this._getFileLoad(registerType)},   //修改文件上传渲染
                                {el: this._createCancelInfo(registerType)}
                            ]
                        ],
                        columnSize: [124, 150],
                        rowSize: [35]
                    }
                },
                {el: $('<div/>')}
            ],
            [
                {el: this._createRegisterSpan(FR.i18nText("FS-Generic-Server_Address"))},
                {
                    el: {
                        type: "text",
                        width: 400,
                        widgetName: "inputMsg",
                        autoVerify: true,
                        allowBlank: false,
                        watermark: FR.i18nText("FS-Cloud-Address-Msg"),
                        regex: regex
                    }
                },
                {el: $('<div/>')}
            ],
            [
                {el: $('<div/>')},
                {
                    el: {
                        type: "tablelayout",
                        items: [
                            [
                                {el: this._createUnbindOrSubmitButton(registerType)},
                                {el: this._createCancelInfo(registerType)}
                            ]
                        ],
                        columnSize: [124, 150],
                        rowSize: [35]
                    }
                },
                {el: $('<div/>')}
            ],
            [
                {el: this._createRegisterSpan(FR.i18nText("FS-Module-Plugin-Register"))},
                {el: this._createVersionInfoLabel(1)},
                {el: $('<div/>')}
            ]
        ];
        var visitorViewConfig = {
            widgetName: 'registerInfoTable',
            type: 'tablelayout',
            items: items,
            columnSize: [180, 607, 50],
            rowSize: [20, 20, 60, macHeight + 70, 50, 25, 35, 20],
            vgap: 15
        }
        return visitorViewConfig;
    },
    choseRegisterType: function (registerType, typeSelector) {
        var value = typeSelector.getValue();
        if (registerType === 1) {
            if (value === 'local') {
                typeSelector.getWidgetByName('versionSuccessTable').setRowVisible([1, 14, 5, 6, 7, 8, 9, 10, 11, 12, 13, 16], false);
                typeSelector.getWidgetByName('versionSuccessTable').setRowVisible([4, 2, 3, 15, 17], true);
            } else {
                this.registerTabPane.getWidgetByName("versionSuccessTable").setRowVisible([1, 4, 2, 3, 16], false);
                this.registerTabPane.getWidgetByName("versionSuccessTable").setRowVisible([2, 6, 5, 15, 17], true);
            }
        } else {
            if (value === 'local') {
                typeSelector.getWidgetByName('versionSuccessTable').setRowVisible([1, 15, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 17, 16], false);
                typeSelector.getWidgetByName('versionSuccessTable').setRowVisible([4, 2, 3], true);
            } else {
                this.registerTabPane.getWidgetByName("versionSuccessTable").setRowVisible([1, 4, 2, 3, 15, 17, 16], false);
                this.registerTabPane.getWidgetByName("versionSuccessTable").setRowVisible([2, 6, 5], true);
            }
        }
        this.registerTabPane.getWidgetByName("versionSuccessTable").doLayout();
    },
    _createRegisterSuccessInfoTable: function (registerType) {
        var self = this;
        var appinfo = self.data.appinfo;
        var macinfo = this.macinfo;
        var mac_items = [];
        mac_items.push(this._createRegisterSpan(macinfo[0]));
        for (var m = 1, len = macinfo.length; m < len; m++) {
            var mac_item = this._createRegisterUnableSpan(macinfo[m]);
            mac_items.push([
                {el: mac_item}, {el: $('<div/>')}
            ]);
        }
        var macHeight = macinfo.length * 25 - 8;
        var macItems = [
            {
                x: 0,
                y: 0,
                type: 'label',
                height: 15,
                width: 300,
                fontsize: '13px',
                color: '#202020',
                value: macinfo[0]
            }
        ];
        for (var i = 1, len = macinfo.length; i < len; i++) {
            macItems.push(
                {
                    x: 0,
                    y: 25 * i,
                    type: 'label',
                    height: 15,
                    width: 300,
                    fontsize: '13px',
                    color: 'grey',
                    value: macinfo[i]
                }
            );
        }
        var wrapDiv = $('<div/>').addClass('is_register_success_span');
        var wrapDiv2 = $('<div/>').addClass('is_register_tips_span');
        var tdHeight = 0;
        if (!self.isOnlineCheck) {
            tdHeight = 15;
        }
        var regex = "((https)://)(([a-zA-Z0-9\._-]+\.[a-zA-Z]{2,6})|([0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}))(:[0-9]{1,4})+(/[a-zA-Z0-9\&%_\./-~-]*)?";

        var visitorViewConfig = {
            widgetName: 'versionSuccessTable',
            type: 'tablelayout',
            items: [
                [
                    {el: this._createRegisterSpan(FR.i18nText("FS-Reg_Version_Registration"))},
                    {
                        el: {
                            type: "tablelayout",
                            items: [
                                [
                                    {el: this._createVersionInfoLabel(registerType)},
                                    {
                                        el: {
                                            widgetName: "registerSecond",
                                            x: 0,
                                            y: 0,
                                            type: 'iconbutton',
                                            text: '[' + FR.i18nText("FS-Reg-Second") + ']',
                                            baseClass: 'is_register_button_span',
                                            handler: function () {
                                                if (registerType === 1) {
                                                    this.getWidgetByName('registerSecond').setVisible(false);
                                                    this.getWidgetByName('versionSuccessTable').setRowVisible([14, 5, 6, 7, 8, 9, 10, 11, 12, 13, 16, 1], false);
                                                    this.getWidgetByName('versionSuccessTable').setRowVisible([4, 2, 3, 15, 17], true);
                                                    if (self.serverType) {
                                                        self.registerTabPane.getWidgetByName("inputMsg").setEnable(false);
                                                        self.registerTabPane.getWidgetByName("inputMsg").setValue(self.serverAdress);
                                                        self.registerTabPane.getWidgetByName("submitButton").setText(FR.i18nText("FS-Cloud-Unbind"));
                                                    }
                                                } else {
                                                    this.getWidgetByName('registerSecond').setVisible(false);
                                                    this.getWidgetByName('versionSuccessTable').setRowVisible([13, 1, 5, 6, 7, 8, 9, 10, 11, 12, 15, 17, 14, 16], false);
                                                    this.getWidgetByName('versionSuccessTable').setRowVisible([4, 2, 3], true);
                                                }
                                                if (self.serverType) {
                                                    this.getWidgetByName("authRadioGroup").setValue('cloud');
                                                } else {
                                                    this.getWidgetByName("authRadioGroup").setValue('local');
                                                }
                                                this.getWidgetByName('versionSuccessTable').doLayout();
                                                self.choseRegisterType(registerType, this.getWidgetByName("authRadioGroup"));
                                            }
                                        }
                                    },
                                    {el: $('<span class="is_register_warning_span registerHelpMsg"/>').text(FR.i18nText("FS-Reg-Warn-Msg")).appendTo(wrapDiv)},
                                    {
                                        el: {
                                            type: 'iconbutton',
                                            text: FR.i18nText("FS-Reg-How"),
                                            widgetName: "registerHelpMsg1",
                                            baseClass: 'is_register_button_span',
                                            handler: function () {
                                                window.open(FS.config.registerUrl);
                                            }
                                        }
                                    }
                                ]
                            ],
                            columnSize: [60, 100, 300, 140],
                            rowSize: [17]
                        }
                    },
                    {el: $('<div/>')}
                ],
                [
                    {el: this._createRegisterSpan(FR.i18nText("FS-Failed-Connect-Reason"))},
                    {el: this._createRegisterSpan(self.message)},
                    {el: $('<div/>')}
                ],
                [
                    {el: this._createRegisterSpan(FR.i18nText("FS-User-Simple_Authentication"))},
                    {
                        el: {
                            x: 0, y: 0,
                            type: 'radiogroup',
                            assureSelect: true,
                            columnsInRow: 1,
                            widgetName: 'authRadioGroup',
                            value: 0,
                            items: [
                                {text: FR.i18nText("FS-Reg-Local"), value: 'local', vgap: 15},
                                {text: FR.i18nText("FS-Reg-Cloud"), value: 'cloud'}
                            ],
                            listeners: [
                                {
                                    eventName: FR.Events.AFTEREDIT,
                                    action: function () {
                                        self.choseRegisterType(registerType, this);
                                    }
                                }
                            ]
                        }
                    },
                    {el: $('<div/>')}
                ],
                [
                    {el: this._createRegisterSpan(FR.i18nText("FS-Reg-Machine-Info"))},
                    {
                        el: {
                            type: "tablelayout",
                            items: [
                                [
                                    {el: this._createRegisterSpan(FR.i18nText("FS-Reg-Mac_Address"))},
                                    {
                                        el: {
                                            type: 'panel',
                                            height: macHeight,
                                            doSize: true,
                                            contentWidget: {
                                                type: 'absolute',
                                                items: macItems
                                            }
                                        }
                                    }
                                ],
                                [
                                    {el: this._createRegisterSpan(FR.i18nText("FS-Reg-Machine_Code"))},
                                    {el: this._createRegisterSpan(appinfo['Re-uuid-in-system'], 'uuid')}
                                ],
                                [
                                    {
                                        el: {
                                            type: 'iconbutton',
                                            text: FR.i18nText("FS-Reg-Export_Info"),
                                            baseClass: 'is_register_button_span',
                                            handler: function () {
                                                window.location = FR.servletURL + "?op=fs_manager&cmd=export_registrationinformation";
                                            }
                                        }
                                    },
                                    {el: $('<div/>')}
                                ]
                            ],
                            columnSize: [80, 527],
                            rowSize: [macHeight, 14, 17],
                            vgap: 15
                        }
                    },
                    {el: $('<div/>')}
                ],
                [
                    {el: $('<div/>')},
                    {
                        el: {
                            type: "tablelayout",
                            items: [
                                [
                                    {el: this._getFileLoad(registerType)},   //修改文件上传渲染
                                    {el: this._createCancelInfo(registerType)}
                                ]
                            ],
                            columnSize: [124, 150],
                            rowSize: [35]
                        }
                    },
                    {el: $('<div/>')}
                ],
                [
                    {el: this._createRegisterSpan(FR.i18nText("FS-Generic-Server_Address"))},
                    {
                        el: {
                            type: "text",
                            widgetName: "inputMsg",
                            width: 400,
                            autoVerify: true,
                            allowBlank: false,
                            watermark: FR.i18nText("FS-Cloud-Address-Msg"),
                            regex: regex
                        }
                    },
                    {el: $('<div/>')}
                ],
                [
                    {el: $('<div/>')},
                    {
                        el: {
                            type: "tablelayout",
                            items: [
                                [
                                    {el: this._createUnbindOrSubmitButton(registerType)},
                                    {el: this._createCancelInfo(registerType)}
                                ]
                            ],
                            columnSize: [124, 150],
                            rowSize: [35]
                        }
                    },
                    {el: $('<div/>')}
                ],
                [
                    {el: this._createRegisterSpan(FR.i18nText("FS-User-Simple_Authentication"))},
                    {
                        el: {
                            type: "llabel",
                            widgetName: "authorityWay",
                            value: this._getRegisterAuthorityMsg()
                        }
                    },
                    {el: $('<div/>')}
                ],
                [
                    {el: this._createRegisterSpan(FR.i18nText("FS-Generic-Server_Address"))},
                    {
                        el: {
                            type: "llabel",
                            widgetName: "authorityWay",
                            value: self.serverAdress
                        }
                    },
                    {el: $('<div/>')}
                ],
                [
                    {el: this._createRegisterSpan(FR.i18nText("FS-Reg-Machine-Info"))},
                    {
                        el: {
                            type: "tablelayout",
                            items: [
                                [
                                    {el: this._createRegisterSpan(FR.i18nText("FS-Reg-Mac_Address"))},
                                    {el: this._createRegisterFailSpan(appinfo['Re-binding-mac'])},
                                    {
                                        el: {
                                            widgetName: "showDetail",
                                            type: 'iconbutton',
                                            text: FR.i18nText("FS-Generic-Face_View"),
                                            baseClass: 'is_register_button_span',
                                            handler: function () {
                                                if (!appinfo["Re-mac-match"]) {
                                                    var widgetName = self.registerTabPane.getWidgetByName("showDetail");
                                                    var text = self.data.appinfo;
                                                    var $tipPre = $('<pre/>').append($('<span class="hello1"/>').text(FR.i18nText("FS-Failed-MAC-Reason")));
                                                    var $tipPre2 = $('<pre/>').append($('<span/>').text(FR.i18nText("FS-Local-MAC-Address") + text["Re-first-mac"]))
                                                    var $tipContext = $('<div class="fs-sys-macmsg"/>')
                                                        .append($tipPre).append($tipPre2);
                                                    $tipContext.appendTo($('body')).css({
                                                        position: 'absolute',
                                                        left: $(".hello1").offset().left + this.element.offset().left,
                                                        top: $(".hello1").offset().top + this.element.offset().top,
                                                        'z-index': FR.widget.opts.zIndex++
                                                    });
                                                    $(document).bind('mousedown.tip', function (e) {
                                                        var target = e.target;
                                                        if (!$(target).isChildAndSelfOf('.fs-sys-macmsg')) {
                                                            $tipContext.remove();
                                                            $(document).unbind('mousedown.tip');
                                                        }
                                                    });
                                                }
                                            }
                                        }
                                    }
                                ],
                                [
                                    {el: this._createRegisterSpan(FR.i18nText("FS-Reg-Machine_Code"))},
                                    {el: this._createRegisterFailSpan(appinfo['Re-uuid-in-lic'], 'uuid')},
                                    {
                                        el: {
                                            widgetName: "showDetail2",
                                            type: 'iconbutton',
                                            text: FR.i18nText("FS-Generic-Face_View"),
                                            baseClass: 'is_register_button_span',
                                            handler: function () {
                                                if (!appinfo["Re-uuid-match"]) {
                                                    var text = self.data.appinfo;
                                                    var $tipPre = $('<pre class = "hello"/>').append($('<span/>').text(FR.i18nText("FS-Failed-Reason")));
                                                    var $tipPre2 = $('<pre class = "hello"/>').append($('<span/>').text(FR.i18nText("FS-Local-Machine-Code") + text["Re-uuid-in-system"]));
                                                    var $tipContext = $('<div class="fs-sys-macmsg"/>')
                                                        .append($tipPre).append($tipPre2);
                                                    $tipContext.appendTo($('body')).css({
                                                        position: 'absolute',
                                                        left: $(".hello").offset().left + this.element.offset().left,
                                                        top: $(".hello").offset().top + this.element.offset().top,
                                                        'z-index': FR.widget.opts.zIndex++
                                                    });
                                                    $(document).bind('mousedown.tip', function (e) {
                                                        var target = e.target;
                                                        if (!$(target).isChildAndSelfOf('.fs-sys-macmsg')) {
                                                            $tipContext.remove();
                                                            $(document).unbind('mousedown.tip');
                                                        }
                                                    });
                                                }
                                            }
                                        }
                                    }
                                ]
                            ],
                            columnSize: [80, 400, 30],
                            rowSize: [14, 17],
                            vgap: 15
                        }
                    },
                    {el: $('<div/>')}
                ],
                [
                    {el: this._createRegisterSpan(FR.i18nText("FS-Reg-Version_Number"))},
                    {
                        el: {
                            type: "tablelayout",
                            items: [
                                [
                                    {el: this._createRegisterFailSpan(appinfo['Re-version-in-lic'], 'uuid')},
                                    {
                                        el: {
                                            widgetName: "showDetail4",
                                            type: 'iconbutton',
                                            text: FR.i18nText("FS-Generic-Face_View"),
                                            baseClass: 'is_register_button_span',
                                            handler: function () {
                                                if (!appinfo["Re-version-match"]) {
                                                    var text = self.data.appinfo;
                                                    var $tipPre = $('<pre class = "hello"/>').append($('<span/>').text(FR.i18nText("FS-Failed-Version-Reason")));
                                                    var $tipPre2 = $('<pre"/>').append($('<span/>').text(FR.i18nText("FS-Local-Version-Number") + text["Re-system-version"]));
                                                    var $tipContext = $('<div class="fs-sys-macmsg"/>')
                                                        .append($tipPre).append($tipPre2);
                                                    $tipContext.appendTo($('body')).css({
                                                        position: 'absolute',
                                                        left: $(".hello").offset().left + this.element.offset().left,
                                                        top: $(".hello").offset().top + this.element.offset().top,
                                                        'z-index': FR.widget.opts.zIndex++
                                                    });
                                                    $(document).bind('mousedown.tip', function (e) {
                                                        var target = e.target;
                                                        if (!$(target).isChildAndSelfOf('.fs-sys-macmsg')) {
                                                            $tipContext.remove();
                                                            $(document).unbind('mousedown.tip');
                                                        }
                                                    });
                                                }
                                            }
                                        }
                                    }
                                ]
                            ],
                            columnSize: [170, 30],
                            rowSize: [17],
                            vgap: 15
                        }
                    },
                    {el: $('<div/>')}
                ],
                [
                    {el: this._createRegisterSpan(FR.i18nText("FS-Reg-App_Name"))},
                    {
                        el: {
                            type: "tablelayout",
                            items: [
                                [
                                    {el: this._createRegisterFailSpan(appinfo['Re-appname-in-lic'], 'uuid')},
                                    {
                                        el: {
                                            widgetName: "showDetail3",
                                            type: 'iconbutton',
                                            text: FR.i18nText("FS-Generic-Face_View"),
                                            baseClass: 'is_register_button_span',
                                            handler: function () {
                                                if (!appinfo["Re-appname-match"]) {
                                                    var text = self.data.appinfo;
                                                    var $tipPre = $('<pre class = "hello"/>').append($('<span/>').text(FR.i18nText("FS-Failed-AppName-Reason")));
                                                    var $tipPre2 = $('<pre"/>').append($('<span/>').text(FR.i18nText("FS-Local-AppName") + text["Re-AppName"]));
                                                    var $tipContext = $('<div class="fs-sys-macmsg"/>')
                                                        .append($tipPre).append($tipPre2);
                                                    $tipContext.appendTo($('body')).css({
                                                        position: 'absolute',
                                                        left: this.element.offset().left + 20,
                                                        top: this.element.offset().top + 10,
                                                        'z-index': FR.widget.opts.zIndex++
                                                    });
                                                    $(document).bind('mousedown.tip', function (e) {
                                                        var target = e.target;
                                                        if (!$(target).isChildAndSelfOf('.fs-sys-macmsg')) {
                                                            $tipContext.remove();
                                                            $(document).unbind('mousedown.tip');
                                                        }
                                                    });
                                                }
                                            }
                                        }
                                    }
                                ]
                            ],
                            columnSize: [170, 30],
                            rowSize: [17],
                            vgap: 15
                        }
                    },
                    {el: $('<div/>')}
                ],
                [
                    {el: this._createRegisterSpan(FR.i18nText("FS-Reg-Simple_Deadline"))},
                    {el: this._createRegisterSpan(appinfo['Re-deadline'])},
                    {el: $('<div/>')}
                ],
                [
                    {el: this._createRegisterSpan(FR.i18nText("FS-Reg-Concurrent_Ip"))},
                    {el: this._createRegisterSpan(FR.i18nText(appinfo['Re-sametime-ip']))},
                    {el: $('<div/>')}
                ],
                [
                    {el: $('<div/>')},
                    {
                        el: {
                            type: "tablelayout",
                            items: [
                                [
                                    {
                                        el: {
                                            type: 'iconbutton',
                                            text: FR.i18nText("FS-Reg-Export_Info"),
                                            baseClass: 'is_register_button_span',
                                            handler: function () {
                                                window.location = FR.servletURL + "?op=fs_manager&cmd=export_registrationinformation";
                                            }
                                        }
                                    },
                                    {el: $('<div/>')}
                                ]
                            ],
                            columnSize: [80, 465],
                            rowSize: [17]
                        }
                    },
                    {el: $('<div/>')}
                ],
                [
                    {el: this._createRegisterSpan(FR.i18nText("FS-Module-Plugin-Register"))},
                    {
                        el: {
                            type: "tablelayout",
                            items: [
                                [
                                    {el: this._createPluginInfoLable()},
                                    {el: this._createRegisterSpan(FR.i18nText("FS-Reg-Plugin-Count"))},  //显示插件注册情况
                                    {
                                        el: {
                                            type: 'iconbutton',
                                            text: FR.i18nText("FS-Reg-How"),
                                            baseClass: 'is_register_button_span',
                                            handler: function () {
                                                window.open(FS.config.pluginRegisterUrl);
                                            }
                                        }
                                    }
                                ]
                            ],
                            columnSize: [26, 465, 70],
                            rowSize: [20]
                        }
                    },
                    {el: $('<div/>')}
                ],
                [
                    {el: this._createRegisterSpan(FR.i18nText("FS-Module-Plugin-Register"))},
                    {el: this._createVersionInfoLabel(1)},
                    {el: $('<div/>')}
                ],
                [
                    {el: $('<div/>')},
                    {el: this._createPluginInfoListTable()},
                    {el: $('<div/>')}

                ]
            ],
            columnSize: [
                FR.i18nTextWidth("FS-Reg-Concurrent_Ip", 6.5) + 63,
                724 - FR.i18nTextWidth("FS-Reg-Concurrent_Ip", 6.5),
                50],
            rowSize: [17, 17, 60, macHeight + 70, 50, 25, 35, tdHeight, 17, tdHeight + 30, 17, 17, 17, 17, 17, 17, 17, "auto"],
            vgap: 15
        };
        return visitorViewConfig;
    },
    getPluginPurchasedNotInstalledLocaled: function () {
        var purchased;
        FR.ajax({
            url: FR.servletURL,
            type: 'POST',
            async: false,
            data: {
                op: 'plugin',
                cmd: 'purchased_not_install'
            },
            complete: function (res, status) {
                if (status == 'success') {
                    var self1 = this;
                    self1.data = FR.jsonDecode(res.responseText);
                    purchased = self1.data.chargeUnistallPluginInfo;
                }
            }
        });
        if (purchased !== undefined) {
            for (var i = 0, len = purchased.length; i < len; i++) {
                var plugin = purchased[i];
                if (plugin.name) {
                    plugin.name = FR.i18nText(plugin.name);
                }
            }
            return purchased;
        } else {
            return null;
        }
    },
    getPluginInstalledInfoLocaled: function () {
        var plugininfo;
        FR.ajax({
            url: FR.servletURL,
            data: {
                op: 'plugin',
                cmd: 'installed_on_charge'
            },
            type: 'POST',
            async: false,
            complete: function (res, status) {

                if (status == 'success') {
                    var self2 = this;
                    self2.data = FR.jsonDecode(res.responseText);
                    plugininfo = self2.data.chargePluginInfo;
                }
            }
        });
        var state = "";
        for (var i = 0, len = plugininfo.length; i < len; i++) {
            var plugin = plugininfo[i];
            if (plugininfo[i]["is_trial"] && !plugininfo[i]["register_failed"]) {
                state = FR.i18nText("FS-Reg-Simple_Unregistered");
            } else {
                if (plugininfo[i]["register_failed"]) {
                    state = FR.i18nText("FS-Reg-Simple_Register_Failed");
                } else {
                    state = FR.i18nText("FS-Registered-Done");
                }
            }
            if (plugin.name) {
                plugin.name = FR.i18nText(plugin.name);
                plugin.status = state;
            }
        }
        return plugininfo;
    },
    _createCommonFunctionList: function () {
        var functionList = this.getFuncListLocaled();
        var pluginCharges = this.getPluginInstalledInfoLocaled();
        var pluginUnistalls = this.getPluginPurchasedNotInstalledLocaled();
        if (pluginUnistalls !== null) {
            for (var i = 0, length = pluginUnistalls.length; i < length; i++) {
                var pluginUnistall = pluginUnistalls[i];
                var hello = {"name": pluginUnistall["NAME"]};
                functionList.push(hello);
            }
        }
        if (pluginCharges !== null) {
            for (var i = 0, len = pluginCharges.length; i < len; i++) {
                var pluginCharge = pluginCharges[i];
                if (pluginCharge["status"] == FR.i18nText("FS-Registered-Done")) {
                    var hello = {"name": pluginCharge["name"]};
                    functionList.push(hello);
                }
            }
        }
        return functionList;
    },
    _createPluginInfoListTable: function () {
        var self = this;
        var pluginInfoListPane = {
            type: 'quickgrid',
            widgetName: 'pluginInfoListGrid',
            marginLeft: 30,
            page: true,
            intervalColor: true,
            pageCount: 10,
            items: self.getPluginInstalledInfoLocaled(),
            columnsConfig: [
                {
                    key: 'name',
                    value: FR.i18nText("FS-Plugin-Name"),
                    width: 280
                },
                {
                    key: 'status',
                    value: FR.i18nText("FS-Register-Status"),
                    width: 160
                },
                {
                    onCellCreate: function (rowIdx, colIdx, item, colCfg) {
                        if (!item.is_trial && !item.register_failed) {
                            var wrapDiv = $('<div class= "viewRegisterDetail"/>').css({
                                'color': '#1483FF',
                                'cursor': 'pointer'
                            }).html(FR.i18nText("FS-Generic-Face_View"));
                            wrapDiv.click(function () {
                                var text = self.data.appinfo;
                                var deadline = item.deadline;
                                var $tipPre = $('<pre/>').append($('<span/>').text(FR.i18nText("FS-Reg-Simple_Deadline-Plugin") + deadline));
                                var $tipContext = $('<div class="fs-sys-viewmsg"/>')
                                    .append($tipPre);
                                $tipContext.appendTo($('body')).css({
                                    position: 'absolute',
                                    left: $(this).offset().left + 43,
                                    top: $(this).offset().top + 5,
                                    'z-index': FR.widget.opts.zIndex++
                                });
                                $(document).bind('mousedown.tip', function (e) {
                                    var target = e.target;
                                    if (!$(target).isChildAndSelfOf('.fs-sys-viewmsg')) {
                                        $tipContext.remove();
                                        $(document).unbind('mousedown.tip');
                                    }
                                });
                            });
                            return wrapDiv;
                        }
                    },
                    width: 120
                }
            ]
        };
        return pluginInfoListPane;
    },
    _createPluginInfoLable: function () {
        var self = this;
        var count = 0;
        var wrap = $('<div/>');
        var plugininfos = self.getPluginInstalledInfoLocaled();
        var len = self.getPluginInstalledInfoLocaled().length;
        for (var i = 0; i < len; i++) {
            var plugininfo = plugininfos[i];
            if (plugininfo["status"] === FR.i18nText("FS-Reg-Simple_Unregistered")) {
                count++;
            }
        }
        $('<span/>').text(count).addClass('uuid_failed').appendTo(wrap);
        return wrap;
    },
    _createRegisterSpan: function (info, uuid) {
        var wrap = $('<div/>');
        var changeColor = uuid && info === FR.i18nText("FS-Generic-Get_Uuid_Failed");
        $('<span/>').text(info).addClass(changeColor ? 'uuid_failed' : 'register_info').appendTo(wrap);
        return wrap;
    },
    _createRegisterFailSpan: function (info, uuid) {
        var wrap = $('<div class= "REGISTER-style-title" />');
        var self = this;
        var appinfo = self.data.appinfo;
        var changeColor = uuid && info === FR.i18nText("FS-Generic-Get_Uuid_Failed");
        wrap.attr('title',info);
        if (info) {
            if (!appinfo["Re-mac-match"] && info === appinfo["Re-binding-mac"]) {
                wrap.text(info).addClass('uuid_failed');
            } else if (!appinfo["Re-uuid-match"] && info === appinfo["Re-uuid-in-lic"]) {
                wrap.text(info).addClass('uuid_failed');
            } else if (!appinfo["Re-version-match"] && info === appinfo["Re-version-in-lic"]) {
                wrap.text(info).addClass('uuid_failed');
            } else if (!appinfo["Re-appname-match"] && info === appinfo["Re-appname-in-lic"]) {
                wrap.text(info).addClass('uuid_failed');
            }
            else {
                if (info === appinfo["Re-binding-mac"]) {
                    wrap.text(appinfo["Re-first-mac"]).addClass('register_info');
                } else {
                    wrap.text(info).addClass('register_info');
                }
            }
        }
        return wrap;
    },
    _createRegisterUnableSpan: function (info) {
        var wrap = $('<div/>');
        $('<span/>').text(info).addClass('register_unable_info').appendTo(wrap);
        return wrap;
    },
    createFunctionList: function () {
        var functionList = this._createCommonFunctionList();
        var len = functionList.length;
        var self = this;
        var functionListPane = {
            type: 'quickgrid',
            widgetName: 'functionListGrid',
            items: functionList,
            columnsConfig: [
                {
                    key: 'name',
                    value: FR.i18nText("FS-Reg_Function_Name_List"),
                    width: 580
                }, {
                    key: 'support',
                    value: FR.i18nText("FS-Reg-Support_Or_Not"),
                    width: 140,
                    onCellCreate: function () {
                        return $("<div/>").addClass("fs-register-ok");
                    }
                }
            ]
        };
        var versionInfoConfig = {
            title: FR.i18nText("FS-Reg-Function_List"),
            content: {
                widgetName: 'functionListPanel',
                type: 'panel',
                left: 20,
                width: 950,
                height: 27 * (len + 1) + 25,
                doSize: true,
                contentWidget: functionListPane
            }
        }
        return versionInfoConfig;
    },
    getFuncListLocaled: function () {
        var funcList = this.data.functionlist;
        for (var i = 0, len = funcList.length; i < len; i++) {
            var func = funcList[i];
            if (func.name) {
                func.name = FR.i18nText(func.name);
            }
        }
        return funcList;
    },
    initData: function (renderer) {
        var self = this;
        FR.ajax({
            url: FR.servletURL,
            type: 'POST',
            async: false,
            data: {
                op: 'fr_server',
                cmd: 'sc_post_cloud_init_url'
            },
            complete: function (res, status) {
                var self1 = this;
                self1.data = FR.jsonDecode(res.responseText);
                var state = self1.data.status;
                var cloudConfig = self1.data.serverConfig;
                if (state.status === "SUCCESS") {
                    self.privateCloud_type = 1;
                } else if (state.status === "FAILED") {
                    self.privateCloud_type = 2;
                    if (!state.message || state.message === "") {
                        self.message = FR.i18nText("FS-Connect-Failed");
                    } else {
                        self.message = state.message;
                    }
                } else {
                    self.privateCloud_type = 0;
                }
                self.serverType = cloudConfig['type'];
                self.serverAdress = cloudConfig['adress'];
            }
        });
        var config = {
            url: FR.servletURL + '?op=fr_server&cmd=sc_get_registerinfo',
            type: 'POST'
        };
        var completefun = function (res, status) {
            self.data = FR.jsonDecode(res.responseText);
            var appinfo = self.data.appinfo;
            self.macinfo = [];
            if (appinfo['Re-all-server-mac']) {
                self.macinfo = appinfo['Re-all-server-mac'].split("\n");
            }
            self.isOnlineCheck = appinfo['Re-isonline-check'];
            self.initContainer(renderer);
        };
        FS.Async.ajax(config, completefun);
    }
};