FS.REGISTER = {
    baseClass: "register-page",
    init: function (renderer) {
        FR.$defaultImport('/com/fr/fs/web/css/manager/fs_register.css', 'css');
        this.initData(renderer);
    },
    initContainer: function (renderer) {
        var self = this;
        var appinfo = self.registerStatus;
        var registerType = this.getRegisterType();
        var items = [self.createVersionInfoPane(registerType), self.createFunctionList()];
        self.registerTabPane = new FS.LTabPane({
            width: '100%',
            height: "auto",
            items: items,
            style: 'blue',
            vgap: 21,
            widgetName: 'visitorManagerTabPane',
            renderEl: renderer,
            initAfterActions: [
                function () {
                    this.getWidgetByName("versionInfoTable").element.css({
                        '-webkit-user-select': 'initial',
                        '-moz-user-select': 'initial',
                        'width': '900px'
                    });
                    self._createDifferentPage(registerType, this.getWidgetByName("registerInfoTable"));
                    if (registerType === 2) {
                        $('.is_register_warning_span').hide();
                    }
                    if (registerType === 1) {
                        this.getWidgetByName('failDetailTable').setRowVisible([0, 1, 2, 3, 4, 5, 6, 7], false);
                        if (self.type) {
                            if (appinfo['isAppNameNotMatch']) {
                                this.getWidgetByName('failDetailTable').setRowVisible([6, 7], true);
                            }
                            if (appinfo['isVersionNumberNotMatch']) {
                                this.getWidgetByName('failDetailTable').setRowVisible([4, 5], true);
                            }
                            if (appinfo['isMacAddressNotMatch']) {
                                this.getWidgetByName('failDetailTable').setRowVisible([0, 1], true);
                            }
                            if (appinfo['isMachineCodeNotMatch']) {
                                this.getWidgetByName('failDetailTable').setRowVisible([2, 3], true);
                            }
                        }

                    }
                    if (self.type) {
                        this.getWidgetByName("authRadioGroup").setValue('local');
                    } else {
                        this.getWidgetByName("authRadioGroup").setValue('cloud');
                    }
                    this.getWidgetByName("registerInfoTable").doLayout();
                },
                function () {
                }
            ]
        });
    },
    getRegisterType: function () {
        var self = this;
        var registerType = 0;
        if (self.status) {
            registerType = self.status;
        }
        return registerType;
    },
    _createDifferentPage: function (registerType, widgetSelector) {
        var self = this;
        widgetSelector.setRowVisible([0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19],false);
        switch (registerType) {
            case 0:
                widgetSelector.setRowVisible([0], true);
                break;
            default:    //注册后状态
                if (self.type) {
                    widgetSelector.setRowVisible([0, 7, 8, 9, 10, 11, 14, 15, 16, 17],true);
                } else {
                    widgetSelector.setRowVisible([0, 7, 12, 13, 14, 15, 16, 17], true);
                }
        }
        if (registerType == 1) {
            widgetSelector.getWidgetByName('registerInfoTable').setRowVisible([8, 9, 10, 11, 12, 13, 14, 15, 16, 17], false);
            widgetSelector.getWidgetByName('registerInfoTable').setRowVisible([18, 19], true);
        }
        widgetSelector.getWidgetByName("registerInfoTable").doLayout();
    },
    _getRegisterAuthorityMsg: function () {
        var authorityMsg = "";
        var self = this;
        if (self.type) {
            authorityMsg = FR.i18nText("FS-Reg-Local");
        } else {
            authorityMsg = FR.i18nText("FS-Reg-Cloud");
        }
        return authorityMsg;
    },
    createVersionInfoPane: function (registerType) {
        var self = this;
        var panelHeight = this.macinfo.length * 25;
        var widget;
        if (registerType != 2) {
            panelHeight = 530;
        } else {
            panelHeight = 900;
        }
        var versionInfoConfig = {
            title: FR.i18nText("FS-Reg-Version_Info"),
            content: {
                widgetName: 'versionInfoPanel',
                type: 'panel',
                width: 850,
                height: panelHeight,
                doSize: true,
                contentWidget: this._createVersionInfoTable(registerType)
            }
        }
        return versionInfoConfig;
    },
    _createVersionInfoTable: function (registerType) {
        var rowSize;
        var items = [
            [
                {el: $('<div/>')},
                {el: {type: 'llabel', levelStyle: 1, value: FR.i18nText("FS-Reg-Version_Info")}},
                {el: $('<div/>')}
            ],
            [
                {el: $('<div/>')},
                {el: this._createNormalInfoTable()},
                {el: $('<div/>')}
            ],
            [
                {el: $('<div/>')},
                {el: {type: 'llabel', levelStyle: 1, value: FR.i18nText("FS-Module-Simple_Register")}},
                {el: $('<div/>')}
            ],
            [
                {el: $('<div/>')},
                {el: this._createRegisterVersionTable(registerType)},
                {el: $('<div/>')}
            ]
        ];
        rowSize = [28, 95, 28, "auto"];
        var visitorViewConfig = {
            widgetName: 'versionNormalTable',
            type: 'tablelayout',
            items: items,
            columnSize: [17, 731, 50],
            rowSize: rowSize,
            width: 830,
            vgap: 12
        };
        return visitorViewConfig;
    },
    _createNormalInfoTable: function () {
        var self = this;
        var appinfo = self.data.registerStatus;
        var versionInfo = self.data.versionInfo;
        var items = [
            [
                {el: this._createRegisterSpan(FR.i18nText("FS-Reg-App_Name"))},
                {el: this._createRegisterSpan(versionInfo['appName'])},
                {el: $('<div/>')}
            ],
            [
                {el: this._createRegisterSpan(FR.i18nText("FS-Reg-FR-Version"))},
                {
                    el: {
                        type: "tablelayout",
                        items: [
                            [
                                {el: this._createRegisterSpan(FR.i18nText("FS-Reg-Version"))},
                                {el: this._createRegisterSpan(versionInfo['frVersion'])}
                            ]
                        ],
                        columnSize: [54, 553],
                        rowSize: [17]
                    }
                },
                {el: $('<div/>')}
            ],
            [
                {el: $('<div/>')},
                {
                    el: {
                        type: "tablelayout",
                        items: [
                            [
                                {el: this._createRegisterSpan(FR.i18nText("FS-Reg-FR-JAR"))},
                                {el: this._createRegisterSpan(versionInfo['jarVersion'])}
                            ]
                        ],
                        columnSize: [35, 572],
                        rowSize: [17]
                    }
                },
                {el: $('<div/>')}
            ]
        ];
        var visitorViewConfig = {
            widgetName: 'versionInfoTable',
            type: 'tablelayout',
            items: items,
            columnSize: [180, 607, 50],
            rowSize: [17, 17, 17],
            vgap: 15
        };
        return visitorViewConfig;
    },
    _createRegisterVersionTable: function (registerType) {   //版本的注册信息
        var appinfo = this.data.registerStatus;
        var localConfig = this.data.registerConfigInfo;
        var wrapDiv = $('<div/>').addClass('is_register_warning_span');
        var macItems = this._getMacItemsInfo();
        var macHeight = macItems.length * 25 - 8;
        var items = [
            [
                {el: this._createRegisterSpan(FR.i18nText("FS-Reg_Version_Registration"))},
                {el: this._createRegisterImmediately(registerType)},
                {el: $('<div/>')}
            ],
            [
                {el: this._createRegisterSpan(FR.i18nText("FS-User-Simple_Authentication"))},
                {el: this._createRadioGroup(registerType)},
                {el: $('<div/>')}
            ],
            [
                {el: this._createRegisterSpan(FR.i18nText("FS-Reg-Machine-Info"))},
                {
                    el: {
                        type: "tablelayout",
                        items: [
                            [
                                {el: this._createRegisterSpan(FR.i18nText("FS-Reg-Mac_Address"))},
                                {
                                    el: {
                                        type: 'panel',
                                        height: macHeight,
                                        doSize: true,
                                        contentWidget: {
                                            type: 'absolute',
                                            items: macItems
                                        }
                                    }
                                }
                            ],
                            [
                                {el: this._createRegisterSpan(FR.i18nText("FS-Reg-Machine_Code"))},
                                {el: this._createRegisterSpan(localConfig['localMachineCode'])}
                            ]
                        ],
                        columnSize: [70, 527],
                        rowSize: [macHeight, 20],
                        vgap: 15
                    }
                },
                {el: $('<div/>')}
            ],
            [
                {el: $('<div/>')},
                {el: this._createExportInfo()},
                {el: $('<div/>')}
            ],
            [
                {el: $('<div/>')},
                {
                    el: {
                        type: "tablelayout",
                        items: [
                            [
                                {el: this._getFileLoad(registerType)},   //修改文件上传渲染
                                {el: this._createCancelInfo(registerType)}
                            ]
                        ],
                        columnSize: [124, 150],
                        rowSize: [35]
                    }
                },
                {el: $('<div/>')}
            ],
            //私有云注册（5，6）
            [
                {el: this._createRegisterSpan(FR.i18nText("FS-Generic-Server_Address"))},
                {el: this._createInputMsg()},
                {el: $('<div/>')}
            ],
            [
                {el: $('<div/>')},
                {
                    el: {
                        type: "tablelayout",
                        items: [
                            [
                                {el: this._createUnbindOrSubmitButton(registerType)},
                                {el: this._createCancelInfo(registerType)}
                            ]
                        ],
                        columnSize: [150, 150],
                        rowSize: [35]
                    }
                },
                {el: $('<div/>')}
            ],                                                      //0……6  未注册

            [
                {el: this._createRegisterSpan(FR.i18nText("FS-User-Simple_Authentication"))},
                {el: this._createRegisterSpan(this._getRegisterAuthorityMsg())},    //注册成功认证成功界面
                {el: $('<div/>')}
            ],
            [
                {el: this._createRegisterSpan(FR.i18nText("FS-Reg-Machine-Info"))},
                {
                    el: {
                        type: "tablelayout",
                        items: [
                            [
                                {el: this._createRegisterSpan(FR.i18nText("FS-Reg-Mac_Address"))},
                                {el: this._createRegisterSpan(appinfo['macAddress'])}
                            ],
                            [
                                {el: this._createRegisterSpan(FR.i18nText("FS-Reg-Machine_Code"))},
                                {el: this._createRegisterSpan(appinfo['machineCode'])}    //注册成功或失败
                            ]
                        ],
                        columnSize: [80, 400],
                        rowSize: [14, 17],
                        vgap: 15
                    }
                },
                {el: $('<div/>')}
            ],
            [
                {el: this._createRegisterSpan(FR.i18nText("FS-Reg-Version_Number"))},
                {el: this._createRegisterSpan(appinfo['version'])},
                {el: $('<div/>')}
            ],
            [
                {el: this._createRegisterSpan(FR.i18nText("FS-Reg-App_Name"))},
                {el: this._createRegisterSpan(appinfo['appName'])},
                {el: $('<div/>')}
            ],
            [
                {el: this._createRegisterSpan(FR.i18nText("FS-Reg-Simple_Deadline"))},
                {el: this._createRegisterSpan(appinfo['deadline'])},
                {el: $('<div/>')}
            ],

            [
                {el: this._createRegisterSpan(FR.i18nText("FS-Generic-Server_Address"))},  //私有云服务器地址
                {el: this._createRegisterSpan(this.serverAddress)},
                {el: $('<div/>')}
            ],
            [
                {el: this._createRegisterSpan(FR.i18nText("FS-Max-Connect"))},  //最大连接数
                {el: this._createRegisterSpan(appinfo['cloudCapacity'])},
                {el: $('<div/>')}
            ],


            [
                {el: this._createRegisterSpan(FR.i18nText("FS-Reg-Concurrent_Ip"))},
                {el: this._createRegisterSpan(FR.i18nText(appinfo['concurrency']))},
                {el: $('<div/>')}
            ],
            [
                {el: $('<div/>')},
                {el: this._createExportInfo()},
                {el: $('<div/>')}
            ],
            [
                {el: this._createRegisterSpan(FR.i18nText("FS-Module-Plugin-Register"))},
                {
                    el: {
                        type: "tablelayout",
                        items: [
                            [
                                {el: this._createRegisterSpan(this._createPluginUnregisterLength())},
                                {el: this._createRegisterSpan(FR.i18nText("FS-Reg-Plugin-Count"))},  //显示插件注册情况
                                {
                                    el: {
                                        type: 'iconbutton',
                                        text: FR.i18nText("FS-Reg-How"),
                                        baseClass: 'is_register_button_span',
                                        handler: function () {
                                            window.open(FS.config.pluginRegisterUrl);
                                        }
                                    }
                                }
                            ]
                        ],
                        columnSize: [20, 465, 70],
                        rowSize: [20]
                    }
                },
                {el: $('<div/>')}
            ],
            [
                {el: $('<div/>')},
                {el: this._createPluginInfoListTable()},
                {el: $('<div/>')}
            ],                                             //7……17本地注册成功

            [
                {el: this._createRegisterSpan(FR.i18nText("FS-Failed-Connect-Reason"))},
                {el: this._createRegisterSpan(appinfo['reason'])},
                {el: $('<div/>')}
            ],                                  //失敗原因表格
            [
                {el: $('<div/>')},
                {
                    el: {
                        type: "tablelayout",
                        widgetName: 'failDetailTable',
                        items: [
                            [
                                {el: this._createRegisterSpan(FR.i18nText("FS-Auth-MAC-Address"))},
                                {el: this._createRegisterSpan(appinfo['macAddress'])}
                            ],
                            [
                                {el: this._createRegisterSpan(FR.i18nText("FS-Local-MAC-Address"))},
                                {
                                    el: {
                                        type: 'panel',
                                        height: macHeight,
                                        doSize: true,
                                        contentWidget: {
                                            type: 'absolute',
                                            items: macItems
                                        }
                                    }
                                }
                            ],
                            [
                                {el: this._createRegisterSpan(FR.i18nText("FS-Auth-Machine-Code"))},
                                {el: this._createRegisterSpan(appinfo['machineCode'])}
                            ],
                            [
                                {el: this._createRegisterSpan(FR.i18nText("FS-Local-Machine-Code"))},
                                {el: this._createRegisterSpan(appinfo['localMachineCode'])}
                            ],
                            [
                                {el: this._createRegisterSpan(FR.i18nText("FS-Auth-Version-Number"))},
                                {el: this._createRegisterSpan(appinfo['version'])}
                            ],
                            [
                                {el: this._createRegisterSpan(FR.i18nText("FS-Local-Version-Number"))},
                                {el: this._createRegisterSpan(appinfo['localVersionNumber'])}
                            ],
                            [
                                {el: this._createRegisterSpan(FR.i18nText("FS-Auth-AppName"))},
                                {el: this._createRegisterSpan(appinfo['appName'])}
                            ],
                            [
                                {el: this._createRegisterSpan(FR.i18nText("FS-Local-AppName"))},
                                {el: this._createRegisterSpan(appinfo['localAppName'])}
                            ]
                        ],
                        columnSize: [90, 'fill'],
                        rowSize: [20, macHeight, 20, 20, 20, 20, 20, 20],
                        vgap: 15
                    }
                },
                {el: $('<div/>')}
            ]
        ];
        var visitorViewConfig = {
            widgetName: 'registerInfoTable',
            type: 'tablelayout',
            items: items,
            columnSize: [180, 607, 50],
            rowSize: [20, 60, macHeight + 40, 20, 35, 35, 35, 20, 50, 20, 20, 20, 20, 20, 20, 20, 20, 300, 20, 400],
            vgap: 15
        };
        return visitorViewConfig;
    },
    _getMacItemsInfo: function() {
        var macinfo = this.macinfo;
        var mac_items = [];
        mac_items.push(this._createRegisterSpan(macinfo[0]));
        for (var m = 1, len = macinfo.length; m < len; m++) {
            var mac_item = this._createRegisterUnableSpan(macinfo[m]);
            mac_items.push([
                {el: mac_item}, {el: $('<div/>')}
            ]);
        }
        var macHeight = macinfo.length * 25 - 8;
        var macItems = [
            {
                x: 0,
                y: 0,
                type: 'label',
                height: 15,
                width: 300,
                fontsize: '13px',
                color: '#202020',
                value: macinfo[0]
            }
        ];
        for (var i = 1, len = macinfo.length; i < len; i++) {
            macItems.push(
                {
                    x: 0,
                    y: 25 * i,
                    type: 'label',
                    height: 15,
                    width: 300,
                    fontsize: '13px',
                    color: 'grey',
                    value: macinfo[i]
                }
            );
        }

        return macItems;
    },
    _createRegisterImmediately: function(registerType) {
        var self = this;
        var wrapDiv = $('<div/>').addClass('is_register_warning_span');
        var text = self._createShowInFirstLine(registerType);
        var registerImmediate = {
            widgetName: 'registerWayButton',
            type: 'tablelayout',
            items: [
                [
                    {el: this._createVersionInfoLabel(registerType)},
                    {
                        el: {
                            widgetName: "registerHelp",
                            x: 0,
                            y: 0,
                            type: 'iconbutton',
                            text: '[' + text + ']',
                            baseClass: 'is_register_button_span',
                            handler: function () {
                                this.getWidgetByName('registerHelp').setVisible(false);
                                self.choseRegisterType(registerType, this.getWidgetByName("authRadioGroup"));
                            }
                        }
                    },
                    {el: $('<span class="is_register_warning_span"/>').text(FR.i18nText("FS-Reg-Warn-Msg")).appendTo(wrapDiv)},
                    {
                        el: {
                            type: 'iconbutton',
                            text: FR.i18nText("FS-Reg-How"),
                            baseClass: 'is_register_button_span',
                            handler: function () {
                                window.open(FS.config.registerUrl);
                            }
                        }
                    }
                ]
            ],
            columnSize: [55, 100, 300, 159],
            rowSize: [15]
        };
        return registerImmediate;
    },
    _createShowInFirstLine: function (registerType) {
        var text = "";
        if (registerType === 0) {
            text = FR.i18nText("FS-Reg-Immediately");
        } else {
            text = FR.i18nText("FS-Reg-Second");
        }
        return text;
    },
    _createShowInSubmitButton: function (registerType) {
        var text = "";
        var self = this;
        if (registerType === 2 && !self.type) {
            text = FR.i18nText("FS-Cloud-Unbind");
        } else {
            text = FR.i18nText("FS-Submit-Authority");
        }
        return text;
    },
    _createVersionInfoLabel: function (registerType) {
        var value = registerType;
        var wrapDiv = $('<div/>').addClass('is_register_success_span');
        switch (value) {
            case 0:
                value = FR.i18nText("FS-Reg-Simple_Unregistered");
                wrapDiv.css('color', '#F30000');
                break;
            case 1:
                value = FR.i18nText("FS-Reg-Simple_Register_Failed");
                wrapDiv.css('color', '#F30000');
                break;
            case 2:
                value = FR.i18nText("FS-Reg_Registration_Successfully");
                wrapDiv.css('color', '#2DAC00');
                break;

        }
        $('<span/>').text(value).appendTo(wrapDiv);
        return wrapDiv;
    },
    _createRegisterSpan: function (info) {
        var wrap = $('<div/>');
        var appinfo = this.registerStatus;
        var changeColor = "";
        if (info === this.pluginRegisterInfo.length || info === appinfo['reason']) {
            changeColor = 'uuid_failed';
        } else {
            changeColor = 'register_info';
        }
        $('<span/>').text(info).addClass(changeColor).appendTo(wrap);
        return wrap;
    },
    _createRegisterUnableSpan: function (info) {
        var wrap = $('<div/>');
        $('<span/>').text(info).addClass('register_unable_info').appendTo(wrap);
        return wrap;
    },
    _createRadioGroup: function(registerType) {
        var self = this;
        var choseAuthority = {
            x: 0, y: 0,
            type: 'radiogroup',
            assureSelect: true,
            columnsInRow: 1,
            widgetName: 'authRadioGroup',
            value: 0,
            items: [
                {text: FR.i18nText("FS-Reg-Local"), value: 'local', vgap: 20},
                {text: FR.i18nText("FS-Reg-Cloud"), value: 'cloud'}
            ],
            listeners: [
                {
                    eventName: FR.Events.AFTEREDIT,
                    action: function () {
                        self.choseRegisterType(registerType, this);
                    }
                }
            ]
        };
        return choseAuthority;
    },
    _getSelectorType: function (registerType, typeSelector) {
        if (this.type) {
            typeSelector.setValue('local');
        } else {
            typeSelector.setValue('cloud');
        }
    },
    choseRegisterType: function (registerType, typeSelector) {
        var self = this;
        var value = typeSelector.getValue();
        if (value === 'local') {
            self.registerTabPane.getWidgetByName('registerInfoTable').setRowVisible([1, 2, 3, 4], true);
            self.registerTabPane.getWidgetByName('registerInfoTable').setRowVisible([5, 6, 7, 8, 9 ,10, 11, 12, 13, 14, 15, 18, 19], false);
        } else {
            self.registerTabPane.getWidgetByName('registerInfoTable').setRowVisible([1, 5, 6], true);
            self.registerTabPane.getWidgetByName('registerInfoTable').setRowVisible([2, 3, 4, 7, 8, 9 ,10, 11, 12, 13, 14, 15, 18, 19], false);
        }
        if (registerType == 2) {
            if (!self.type) {
                self.registerTabPane.getWidgetByName("inputMsg").setEnable(false);
                self.registerTabPane.getWidgetByName('inputMsg').setValue(self.serverAddress);
            }
        }
        self.registerTabPane.getWidgetByName("registerInfoTable").doLayout();
    },
    _createExportInfo:function() {
        var exportIcon = {
            type: 'iconbutton',
            text: FR.i18nText("FS-Reg-Export_Info"),
            width: 80,
            baseClass: 'is_register_button_span',
            handler: function () {
                window.location = FR.servletURL + "?op=fr_regist&cmd=export_registration_information";
            }
        };
        return exportIcon;
    },
    _createInputMsg: function () {
        var self = this;
        var regex = "((https)://)(([a-zA-Z0-9\._-]+\.[a-zA-Z]{2,6})|([0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}))(:[0-9]{1,4})+(/[a-zA-Z0-9\&%_\./-~-]*)?";
        var input = {
            type: "text",
            width: 400,
            widgetName: "inputMsg",
            autoVerify: true,
            allowBlank: false,
            watermark: FR.i18nText("FS-Cloud-Address-Msg"),
            regex: regex
        }
        return input;
    },
    _createRegularExpression: function(value) {
        var regex = new RegExp("(https):\/\/+");
        var regErrorMsg = "";
        var reg = new RegExp("[\\u4E00-\\u9FFF]+", "g");
        if (value === "") {
            regErrorMsg = FR.i18nText("FS-Error-Null-Msg");
        } else if (value !== "" && reg.test(value)) {
            regErrorMsg = FR.i18nText("FS-Chinese-Not-Null");
        } else if (!regex.test(value)) {
            regErrorMsg = FR.i18nText("FS-Error-URL-Msg");
        }
        return regErrorMsg;
    },
    refreshTab: function () {
        FS.tabPane._refreshTab(FS.tabPane._getSelectedTab());
    },
    _getFileLoad: function (registerType) {
        var self = this;
        var filePanel = {
            widgetName: 'filePanel',
            type: 'panel',
            height: 35,
            doSize: true,
            contentWidget: {
                type: "tablepane",
                rowSize: [35],
                colSize: [110],
                items: [[
                    {
                        type: "absolute",
                        items: [
                            {
                                x: 0, y: 0, width: 106, height: 35,
                                type: "multifile",
                                maxlength: 1,
                                accept: ".lic",
                                hideFileList: true,
                                showViewImage: false,
                                listeners: [{
                                    eventName: "afterinit",
                                    action: function () {
                                        this.$preview.remove();
                                    }
                                }, {
                                    eventName: "afteredit",
                                    action: function () {
                                        var attach = this.wrap.attach_array[0];
                                        var id = attach.attach_id;
                                        var isSuccess = false;
                                        $(function () {
                                            FR.ajax({
                                                url: FR.servletURL,
                                                data: {
                                                    op: 'fr_regist',
                                                    cmd: 'lic_upload',
                                                    id: id
                                                },
                                                async: false,
                                                complete: function (res, status) {
                                                    var self1 = this;
                                                    self1.data = FR.jsonDecode(res.responseText);
                                                    var reason = self1.data.reason;
                                                    var state = self1.data.status;
                                                    if (status == 'success' && state == 'success') {
                                                        FR.Msg.alert(FR.i18nText("FS-System-Dialog_Title"),FR.i18nText("FS-Reg_Registration_Successfully"),
                                                            function(value) {
                                                                self.refreshTab();
                                                            });
                                                    } else {
                                                        FR.Msg.alert(FR.i18nText("FS-System-Dialog_Title"),reason + FR.i18nText('FS-Error-Msg'),
                                                            function(value) {
                                                                self.refreshTab();
                                                            });
                                                    }
                                                }
                                            });
                                        });
                                    }
                                }]
                            },
                            {
                                x: 0, y: 0,
                                width: 106, height: 31,
                                style: "blue",
                                type: "quickbutton",
                                text: FR.i18nText("FS-Upload-Lic-File")
                            }
                        ]
                    }
                ]]
            }
        }
        return filePanel;
    },
    _createCancelInfo: function (registerType) {
        var self = this;
        return {
            x: 0,
            y: 10,
            type: 'absolute',
            items: [
                {
                    type: 'quickbutton',
                    style: 'gray',
                    baseClass: "is_register_button_span",
                    text: FR.i18nText('Fine-Engine_FS_Generic_Simple_Cancel'),
                    width: FR.i18nTextWidth('Fine-Engine_FS_Generic_Simple_Cancel') + 84,
                    height: 33,
                    handler: function () {
                        self.registerTabPane.getWidgetByName('registerWayButton').setVisible(true);
                        self._createDifferentPage(registerType, self.registerTabPane.getWidgetByName('registerInfoTable'));
                        self.registerTabPane.getWidgetByName('registerHelp').setVisible(true);
                        self._getSelectorType(registerType, self.registerTabPane.getWidgetByName('authRadioGroup'));
                    }
                }
            ]
        };
    },
    _createUnbindOrSubmitButton: function (registerType) {
        var self = this;
        return {
            type: 'absolute',
            items: [
                {
                    type: 'quickbutton',
                    style: 'blue',
                    widgetName: "submitButton",
                    baseClass: "is_register_button_span",
                    text: self._createShowInSubmitButton(registerType),
                    width: FR.i18nTextWidth('FS-Submit-Authority') + 60,
                    height: 33,
                    handler: function () {
                        var serverURL = self.registerTabPane.getWidgetByName("inputMsg").getValue();
                        var regErrorMsg = self._createRegularExpression(serverURL);
                        if (regErrorMsg) {
                            FR.Msg.alert(FR.i18nText("FS-System-Dialog_Title"), regErrorMsg);
                        } else {
                            if (!self.type && self.status === 2) {
                                FR.Msg.confirm(FR.i18nText("FS-System-Dialog_Title"), FR.i18nText("FS-Is-Unbind-URL"), function(value) {
                                    FR.showLoadingDialog({
                                        title: FR.i18nText("FS-System-Dialog_Title"),
                                        text: FR.i18nText("FS-Before-Unbind-Authority"),
                                        width: 310,
                                        height: 120
                                    });
                                    FR.ajax({
                                        url: FR.servletURL,
                                        async: true,
                                        type: "POST",
                                        data: {
                                            op: 'fr_regist',
                                            cmd: 'disconnect_cloud_server'
                                        },
                                        complete: function (res, status) {
                                            var self1 = this;
                                            self1.data = FR.jsonDecode(res.responseText);
                                            var reason = self1.data.reason;
                                            FR.hideLoadingDialog();
                                            if (status == "success" && !reason) {
                                                FR.Msg.alert(FR.i18nText('FS-System-Dialog_Title'), FR.i18nText('FS-Authority-Successfully'),
                                                    function (value) {
                                                        self.refreshTab();
                                                    });
                                            } else {
                                                FR.Msg.alert(FR.i18nText('Fine-Engine_FS_Generic_Simple_Wrong'), reason,
                                                    function (value) {
                                                        self.refreshTab();
                                                    });
                                            }
                                        }
                                    });
                                });
                            } else {
                                FR.showLoadingDialog({
                                    title: FR.i18nText("FS-System-Dialog_Title"),
                                    text: FR.i18nText("FS-Before-Authority"),
                                    width: 310,
                                    height: 120
                                });
                                FR.ajax({
                                    url: FR.servletURL,
                                    type: 'POST',
                                    async: true,
                                    data: {
                                        op: 'fr_regist',
                                        cmd: 'connect_cloud_server',
                                        serverURL: serverURL
                                    },
                                    complete: function (res, status) {
                                        FR.hideLoadingDialog();
                                        var self1 = this;
                                        self1.data = FR.jsonDecode(res.responseText);
                                        var reason = self1.data.reason;
                                        if (status == "success" && !reason) {
                                            FR.Msg.alert(FR.i18nText('FS-System-Dialog_Title'), FR.i18nText('FS-Authority-Successfully'),
                                                function (value) {
                                                    self.refreshTab();
                                                });
                                        } else {
                                            FR.Msg.alert(FR.i18nText('Fine-Engine_FS_Generic_Simple_Wrong'), reason,
                                                function (value) {
                                                    self.refreshTab();
                                                });
                                        }
                                    }
                                });
                            }
                        }
                    }
                }
            ]
        }
    },
    _createPluginUnregisterLength: function () {
        var self = this;
        var plugininfo = self.pluginRegisterInfo;
        var count = 0;
        for (var i = 0, len = plugininfo.length; i < len; i ++) {
            var plugin = plugininfo[i];
            if (plugin.registerStatus === 0) {
                count ++;
            }
        }
        return count;

    },
    _createPluginInfoListTable: function () {
        var self = this;
        var pluginInfoListPane = {
            type: 'quickgrid',
            widgetName: 'pluginInfoListGrid',
            marginLeft: 30,
            page: true,
            intervalColor: true,
            pageCount: 10,
            items: this.getPluginInstalledInfoLocaled(),
            columnsConfig: [
                {
                    key: 'name',
                    value: FR.i18nText("FS-Plugin-Name"),
                    width: 230
                },
                {
                    key: 'status',
                    value: FR.i18nText("FS-Register-Status"),
                    width: 120,
                    onCellCreate: function (rowIdx, colIdx, item, colCfg) {
                        var wrapDiv = $('<div/>');
                        $('<span/>').text(item.status).appendTo(wrapDiv);
                        if (item.status != FR.i18nText('FS-Registered-Done')) {
                            wrapDiv.addClass('uuid_failed');
                        }
                        return wrapDiv;
                    }
                },
                {
                    key: 'operation',
                    value: FR.i18nText('FS-Monitor-Form_Action'),
                    width: 120,
                    onCellCreate: function () {
                        var wrapDiv = $('<div/>').css({
                            'color': '#1483FF'
                        });
                        $('<span style="position: absolute; z-index: 0;"/>').text(FR.i18nText("FS-Lic-Upload")).appendTo(wrapDiv);
                        new FR.MultiFileEditor({
                            renderEl: wrapDiv,
                            maxlength: 1,
                            accept: '.lic',
                            height: 16,
                            width: 40,
                            hideFileList: true,
                            showViewImage: false,
                            listeners: [{
                                eventName: "afterinit",
                                action: function () {
                                    this.$preview.remove();
                                }
                            }, {
                                eventName: "afteredit",
                                action: function () {
                                    var self1 = this;
                                    self1.data = FR.jsonDecode(res.responseText);
                                    var attach = this.wrap.attach_array[0];
                                    var id = attach.attach_id;
                                    var isSuccess = false;
                                    var reason = self1.data.reason;
                                    $(function () {
                                        FR.ajax({
                                            url: FR.servletURL,
                                            data: {
                                                op: 'fr_regist',
                                                cmd: 'plugin_lic_upload',
                                                id: id
                                            },
                                            async: false,
                                            complete: function (res, status) {
                                                if (status == 'success') {
                                                    //待完善
                                                }
                                            }
                                        });
                                    });
                                }
                            }]

                        });
                        $('img', wrapDiv).remove();
                        return wrapDiv;
                    }
                },
                {
                    onCellCreate: function (rowIdx, colIdx, item, colCfg) {
                        var deadline = item.deadline;
                        var message = item.message;
                        var text = "";
                        if (message) {
                            var wrapDiv = $('<div/>').css({
                                'color': '#1483FF',
                                'cursor': 'pointer'
                            }).html(FR.i18nText("FS-Generic-Face_View"));
                            wrapDiv.click(function () {
                                if (item.registerStatus == 2) {
                                    text = FR.i18nText("FS-Reg-Simple_Deadline-Plugin");
                                } else {
                                    text = FR.i18nText("FS-Failed-Connect-Reason") + "：";
                                }
                                var $tipPre = $('<pre/>').append($('<span/>')).text(text + message);
                                var $tipContext = $('<div class="fs-sys-pluginmsg"/>').append($tipPre);
                                $tipContext.appendTo($('body')).css({
                                    position: 'absolute',
                                    left: $(this).offset().left + 43,
                                    top: $(this).offset().top + 5,
                                    'z-index': FR.widget.opts.zIndex++
                                });
                                $(document).bind('mousedown.tip', function (e) {
                                    var target = e.target;
                                    if (!$(target).isChildAndSelfOf('.fs-sys-pluginmsg')) {
                                        $tipContext.remove();
                                        $(document).unbind('mousedown.tip');
                                    }
                                });
                            });
                            return wrapDiv;
                        }
                    },
                    width: 80
                }
            ]
        };
        return pluginInfoListPane;
    },
    getPluginInstalledInfoLocaled: function () {
        var plugininfo = this.pluginRegisterInfo;
        var state = "";
        for (var i = 0, len = plugininfo.length; i < len; i++) {
            var plugin = plugininfo[i];
            switch (plugin.registerStatus) {
                case 0:
                    state = FR.i18nText("FS-Reg-Simple_Unregistered");
                    break;
                case 1:
                    state = FR.i18nText("FS-Reg-Simple_Register_Failed");
                    break;
                case 2:
                    state = FR.i18nText("FS-Registered-Done");
                    break;
            }

            if (plugin.name) {
                plugin.name = FR.i18nText(plugin.name);
                plugin.status = state;
            }
        }
        return plugininfo;
    },
    createFunctionList: function () {
        var self = this;
        var functionList = self.data.functionList;
        var len = functionList.length;
        var functionListPane = {
            type: 'quickgrid',
            widgetName: 'functionListGrid',
            items: functionList,
            columnsConfig: [
                {
                    key: 'name',
                    value: FR.i18nText("FS-Reg_Function_Name_List"),
                    width: 580,
                    onCellCreate: function (rowIdx, colIdx, item, colCfg) {
                        var wrapDiv = $('<div class= "viewRegisterDetail"/>');
                        wrapDiv.html(FR.i18nText(item));
                        return wrapDiv;
                    }
                }, {
                    key: 'support',
                    value: FR.i18nText("FS-Reg-Support_Or_Not"),
                    width: 140,
                    onCellCreate: function () {
                        return $("<div/>").addClass("fs-register-ok");
                    }
                }
            ]
        };
        var versionInfoConfig = {
            title: FR.i18nText("FS-Reg-Function_List"),
            content: {
                widgetName: 'functionListPanel',
                type: 'panel',
                left: 20,
                width: 950,
                height: 27 * (len + 1) + 25,
                doSize: true,
                contentWidget: functionListPane
            }
        }
        return versionInfoConfig;
    },
    initData: function (renderer) {
        var self = this;
        var config = {
            url: FR.servletURL + '?op=fr_regist&cmd=get_register_summary',
            type: 'POST'
        };
        var completefun = function (res, status) {
            self.data = FR.jsonDecode(res.responseText);
            self.macinfo = [];
            self.versionInfo = self.data.versionInfo;
            self.registerStatus = self.data.registerStatus;
            self.registerConfigInfo = self.data.registerConfigInfo;
            self.functionList = self.data.functionList;
            self.pluginRegisterInfo = self.data.pluginRegisterInfo;

            if (self.registerConfigInfo.localMacAddress) {
                self.macinfo = self.registerConfigInfo.localMacAddress;
            }
            if (self.registerConfigInfo.serverAddress) {
                self.serverAddress = self.registerConfigInfo.serverAddress;
            }
            if (self.registerConfigInfo.type == "File") {
                self.type = true;
            } else {
                self.type = false;
            }
            if (self.registerStatus.status) {
                self.status = self.registerStatus.status;
            }
            self.initContainer(renderer);
        };
        FS.Async.ajax(config, completefun);
    }
};