FS.ReportManagerAddon = FS.Plugin.ReportManagerAddon;

/**
 * Coder: yaoh.wu
 * Date: 2017-5-25
 * Time: 13:44:24
 */
FS.REPORTMGR = FSRM = {
    //widget name domain
    _WD: {
        reportCoverConfigPanelWD: "reportCoverConfigPanel"
    },
    CONSTS: {
        //对应EntryConstants.java
        FOLDER: '0',
        FILE: '1',
        REPORTLET: '2',
        URL: '3',
        ANALYSIS: '4',
        PROCESS: '5',
        FASTQUERY: '6',
        REPORTPROCESS: '8',
        PROCESSTYPE: {
            1: FR.i18nText("FS-Report-RP_TaskMgr"),
            2: FR.i18nText("FS-Report-RP_ProcessMgr"),
            3: FR.i18nText("Fine-Engine_FS_Report_RP_MyTask")
        },
        ENTRYTYPEDESC: {
            FILE: FR.i18nText('FS-Generic-Simple_Position'),
            URL: FR.i18nText('FS-Generic-Simple_URL'),
            PROCESS: FR.i18nText('FS-Generic-Simple_Label'),
            REPORTLET: FR.i18nText('FS-Generic-Simple_Template')
        },
        NODEICONS: {
            CPT: 'cpt',
            FRM: 'frm'
        },
        TNAME: 'report',
        CATALOGWIDTHS: [150, 150, 65, 65, 60],
        HYPERLINKINDEX: 1
    },
    //finereport 报表混排支持类型
    TNAME_DESC: {
        FILE: 'file',
        URL: 'link',
        REPORT: 'report',
        RP: 'rp'
    },

    INIT_COUNT: 4,
    DEFAULT_SHOWTYPE: '2',
    DEFAULT_MOBILE: 7,

    init: function (renderer) {
        FR.$defaultImport('/com/fr/fs/web/css/manager/fs_reportmgr.css', 'css');
        this.createTabPane(renderer);
        FSRM.Control.initData();
    },

    createTabPane: function (render) {
        var self = this;
        this.renderEl = render;
        var resizeFns = [
            function (container, width, height) {

            }, function (container, width, height) {
                //限制最小缩放尺寸
                width = width < 500 ? 500 : width;
                height = height < 300 ? 300 : height;
                //调整封面设置面板尺寸
                container.getWidgetByName(FSRM._WD.reportCoverConfigPanelWD).doResize({
                    width: width,
                    height: height - 70
                });
                var right_panel_width = width - 245;
                var panel_height = height - 120;
                $("#fs-mobile-dir-cover-container").height(panel_height);
                self.mobileDirCoverPane.doResize({
                    width: 245,
                    height: panel_height
                });
                self.mobileEntryCoverPane.doResize({
                    width: right_panel_width,
                    height: panel_height
                });
                $("#fs-mobile-cover-upload-tip").width(width - 280);
            }
        ];
        this.tabPane = new FS.LTabPane({
            width: '100%',
            height: '100%',
            style: 'blue',
            marginLeft: 0,
            renderEl: render,
            items: [
                this.reportTab(),
                this.reportCoverTabConfig()
            ],
            initAfterActions: [
                function () {
                    self.dirMgrInit();
                    $('.fs_reportmgr_cpt_icon').attr('title', FR.i18nText("FS-Report-Add_Cpt"));
                    $('.fs_reportmgr_link_icon').attr('title', FR.i18nText("FS-Report-Add_Link"));
                    $('.fs_reportmgr_rp_icon').attr('title', FR.i18nText("Fine-Engine_FS_Report_RP_AddLabel"));
                    $('.fs_reportmgr_remove_icon').attr('title', FR.i18nText("FS-Report_Batch_Remove"));
                    this.getWidgetByName("cptMgrPane").panelBody.css('overflow', 'auto');
                }, function () {
                    FSRM.Control.getFolderData();
                    self.createMobileDirCoverPane();
                    if (self.dirCovers.length > 0) {
                        self.dirCovers[0].click();
                    } else {
                        self.createMobileEntryCoverPane();
                    }
                }
            ],
            opAfterActions: [
                function () {

                }, function () {
                    resizeFns[1](this, render.width(), render.height());
                }
            ]
        });
        this.renderEl.data("onResize", function (width, height) {
            var tabIdx = self.tabPane.getSelectedIndex();
            if (tabIdx !== null) {
                resizeFns[tabIdx](self.tabPane, width, height);
            }
        });
    },

    /**
     * 目录管理面板
     */
    reportTab: function () {
        var self = this;
        var dirMgrPane = {
            type: 'panel',
            doSize: true,
            y: 75,
            x: 40,
            width: 236,
            height: 450,
            title: FR.i18nText("FS-Report-Directory_Management"),
            border: true,
            contentHtml: $('<div/>').addClass('fs_reportmgr_dir_panel_content'),
            tools: [{
                //添加目录按钮及其事件
                iconCls: 'fs-module-add-white',
                width: 24,
                height: 24,
                handler: function () {
                    if (!FSRM.DIR.dirTabletree.getSelectedNodes()[0]) {
                        FR.Msg.alert(FR.i18nText("Fine-Engine_FS_Generic_Simple_Alert"), FR.i18nText("Fine-Engine_FS_Report_Do_Select_Dir"));
                        return;
                    }
                    $(this).removeClass('fs_reportmgr_add_icon_white_click');
                    var title = FR.i18nText("FS-Report-Add_Directory");
                    var onOK = function () {
                        var dirname = addDirDialog.getWidgetByName("nameText").getValue();
                        var description = addDirDialog.getWidgetByName("descriptionText").getValue();
                        var mobileDeviceConfig = FSRM._makeMobileDeviceConfig(
                            addDirDialog.getWidgetByName("deviceCheckboxGroup").getValue()
                        );
                        if (!self.DIR._checkValid(dirname, true)) {
                            return;
                        }
                        self.DIR._addFolder(dirname, description, mobileDeviceConfig);
                    };
                    var onCancel = function () {
                    };
                    var data = {};
                    data.parentMobileConfig = self.DIR.getParentMobileConfig();
                    var addDirDialog = self.createDirDialog(title, onOK, onCancel, data);
                    addDirDialog.setVisible(true);
                    addDirDialog.getWidgetByName("deviceCheckboxGroup").setValue(
                        FSRM._makeMobileConfigCheckboxValue(data.parentMobileConfig)
                    );
                }
            }
            ]
        };
        //右侧节点管理工具栏
        var tools = [
            {
                //模板批量添加ICON及其事件
                iconCls: 'fs_reportmgr_cpt_icon',
                width: 21,
                height: 21,
                hover: [function () {
                    $(this).addClass('fs_reportmgr_cpt_icon_hover');
                }, function () {
                    $(this).removeClass('fs_reportmgr_cpt_icon_hover');
                }],
                handler: {
                    mousedown: function () {
                        $(this).addClass('fs_reportmgr_cpt_icon_click');
                    },
                    mouseleave: function () {
                        $(this).removeClass('fs_reportmgr_cpt_icon_hover');
                        $(this).removeClass('fs_reportmgr_cpt_icon_click');
                    },
                    mouseup: function () {
                        $(this).removeClass('fs_reportmgr_cpt_icon_click');
                        if (!FSRM.DIR.dirTabletree.getSelectedNodes()[0] || FSRM.DIR.dirTabletree.getSelectedNodes()[0].pId === "0-2") {
                            FR.Msg.alert(FR.i18nText("Fine-Engine_FS_Generic_Simple_Alert"), FR.i18nText("Fine-Engine_FS_Report_No_Dir_Selected"));
                            return;
                        }
                        //清空缓存的数据
                        FSRM.Cache.clearDetailConfigCache();
                        FSRM.Cache.clearSelectedNodesCache();
                        self.View.createBatchCptDialog(0);
                    }
                }
            },
            {
                //链接添加ICON及其事件
                iconCls: 'fs_reportmgr_link_icon',
                width: 21,
                height: 21,
                hover: [function () {
                    $(this).addClass('fs_reportmgr_link_icon_hover');
                }, function () {
                    $(this).removeClass('fs_reportmgr_link_icon_hover');
                }],
                handler: {
                    mousedown: function () {
                        $(this).addClass('fs_reportmgr_link_icon_click');
                    },
                    mouseleave: function () {
                        $(this).removeClass('fs_reportmgr_link_icon_hover');
                        $(this).removeClass('fs_reportmgr_link_icon_click');
                    },
                    mouseup: function () {
                        $(this).removeClass('fs_reportmgr_link_icon_click');
                        if (!FSRM.DIR.dirTabletree.getSelectedNodes()[0] || FSRM.DIR.dirTabletree.getSelectedNodes()[0].pId === "0-2") {
                            FR.Msg.alert(FR.i18nText("Fine-Engine_FS_Generic_Simple_Alert"), FR.i18nText("Fine-Engine_FS_Report_No_Dir_Selected"));
                            return;
                        }
                        var title = FR.i18nText("FS-Report-Add_Link");
                        var onOK = function () {
                            return self.DIR._addOrEditLink(null, null, true);
                        };
                        var onCancel = function () {
                        };
                        var data = {};
                        //编辑dialog的初始数据
                        data.parentMobileConfig = self.DIR.getParentMobileConfig();
                        self.linkDialog = self.createLinkDialog(title, onOK, onCancel, data);
                        self.linkDialog.setVisible(true);
                        self.linkDialog.getWidgetByName("deviceCheckboxGroup").setValue(
                            FSRM._makeMobileConfigCheckboxValue(data.parentMobileConfig)
                        );
                    }
                }
            }
        ];
        var reportMgrAddon = FS.Plugin.ReportManagerAddon;
        if (reportMgrAddon) {
            $.each(reportMgrAddon, function (i, m) {
                if ($.isFunction(m)) {
                    m.apply(self, [tools]);
                }
            });
        }

        //批量删除按钮（位于最右边）
        tools.push({
            //批量删除ICON其事件
            iconCls: 'fs_reportmgr_remove_icon',
            width: 21,
            height: 21,
            hover: [function () {
                $(this).addClass('fs_reportmgr_remove_icon_hover');
            }, function () {
                $(this).removeClass('fs_reportmgr_remove_icon_hover');
            }],
            handler: {
                mousedown: function () {
                    $(this).addClass('fs_reportmgr_remove_icon_click');
                },
                mouseleave: function () {
                    $(this).removeClass('fs_reportmgr_remove_icon_hover');
                    $(this).removeClass('fs_reportmgr_remove_icon_click');
                },
                mouseup: function () {
                    $(this).removeClass('fs_reportmgr_remove_icon_click');
                    var ids = [];
                    var $checkBoxes = $('input[id^=CheckBox]');
                    for (var i = 0; i < $checkBoxes.length; i++) {
                        var $currentEntryCheckBox = $($checkBoxes[i]);
                        if ($currentEntryCheckBox.is(':checked')) {
                            ids.push($currentEntryCheckBox.parent().attr('entrytypeid'));
                        }
                    }
                    if (ids.length === 0) {
                        FR.Msg.alert(FR.i18nText("Fine-Engine_FS_Generic_Simple_Alert"), FR.i18nText("FS-Report_Choose_Remove_Item"));
                        return;
                    }

                    var completeFn = function (res, status) {
                        if (status === 'success') {
                            if (res.responseText === "-1") {
                                //没有权限
                                FR.Msg.alert(FR.i18nText("Fine-Engine_FS_Generic_Simple_Alert"), FR.i18nText("FS-Report-No_Folder_Edit_Privilege"));
                                return;
                            }

                            //删除之后全选框设置为false
                            $('input[id^=CheckBoxAll]').attr('checked', false);

                            //触发当前目录树的点击事件，重新获取当前目录下的节点来显示
                            var selectedNodetID = FSRM.DIR.dirTabletree.getSelectedNodes()[0].tId;
                            FSRM.DIR.dirTabletree.$tbody.find('tr#' + selectedNodetID).click()

                        }
                    };
                    var config = {
                        url: FR.servletURL + "?op=fs_entry&cmd=removereport",
                        type: 'POST',
                        data: {entryIDs: ids}
                    };

                    FR.Msg.confirm(FR.i18nText("Fine-Engine_FS_Frame_Delete_Data"), FR.i18nText("FS-Generic-Sure_To_Delete") + '?', function (result) {
                        if (result) {
                            //确认删除
                            FS.Async.ajax(config, completeFn);
                        }
                    });
                }
            }
        });


        //节点管理面板
        var cptMgrPane = {
            type: 'panel',
            widgetName: 'cptMgrPane',
            doSize: true,
            border: true,
            title: FR.i18nText("FS-Module-Node_Manager"),
            x: 301,
            y: 75,
            width: 602,
            height: 450,
            tools: tools,
            contentHtml: this.cptMgrInit()
        };
        return {
            title: FR.i18nText("FS-Module-Report_Manager"),
            content: {
                type: 'absolute',
                scrollable: true,
                width: '100%',
                height: '100%',
                top: 15,
                left: 20,
                items: [dirMgrPane, cptMgrPane]
            }
        }
    },

    /**
     * 报表封面
     */
    reportCoverTabConfig: function () {
        return {
            title: FR.i18nText('FS-Mobile-Report_Cover'),
            content: {
                type: 'panel',
                widgetName: FSRM._WD.reportCoverConfigPanelWD,
                doSize: true,
                width: this.renderEl.width(),
                height: this.renderEl.height() - 70,
                closeAfterAction: false,
                contentWidget: {
                    type: 'tablepane',
                    vgap: 8,
                    colSize: [40, 80, 245, 245],
                    rowSize: ['fill', 28],
                    items: [
                        [
                            null, null,
                            $('<div/>').attr("id", "fs-mobile-dir-cover-container").height(
                                this.renderEl.height() - 120
                            ).append(
                                $('<div/>').attr("id", "fs-mobile-dir-cover-pane")
                                    .addClass("fs-mobile-cover-pane")
                            ),
                            $('<div/>').append(
                                $('<div/>').attr("id", "fs-mobile-entry-cover-pane")
                                    .addClass("fs-mobile-cover-pane")
                            )
                        ], [
                            {}, {
                                type: 'quickbutton',
                                style: 'blue',
                                text: FR.i18nText("FS-Frame-Simple_Save"),
                                handler: function () {
                                    if (!FSRM.Control.coverData) {
                                        return;
                                    }
                                    var completeFn = function (res, status) {
                                        if (status === 'success') {
                                            FR.Msg.toast(FR.i18nText("FS-Generic-Simple_Successfully"));
                                            FSRM.Control.initEntryCoverId();
                                        }
                                    };
                                    var config = {
                                        url: FR.servletURL + '?op=fs_main&cmd=set_report_cover',
                                        type: 'POST',
                                        data: FSRM.Control.coverData
                                    };
                                    //保存封面设置
                                    FS.Async.ajax(config, completeFn);
                                }
                            }, null,
                            $('<div/>').addClass("fr-fileupload-tooltip").height(21).append(
                                $('<span/>').attr(
                                    "id", "fs-mobile-cover-upload-tip"
                                ).addClass("fr-fileupload-tooltipspan").width(
                                    this.renderEl.width() - 280
                                ).css("text-align", "center").text(
                                    FR.i18nText("FS-Mobile-Report_Cover_Upload_ToolTip")
                                )
                            )
                        ]
                    ]
                }
            }
        }
    },

    /**
     * 移动端一级目录封面设置
     */
    createMobileDirCoverPane: function () {
        this.mobileDirCoverPane = FR.createWidget({
            renderEl: $("#fs-mobile-dir-cover-pane"),
            type: 'panel',
            width: 245,
            height: this.renderEl.height() - 120,
            doSize: true,
            contentWidget: {
                type: 'tablepane',
                colSize: ['fill'],
                rowSize: [5, 'auto'],
                scrollable: true,
                items: [
                    $('<div/>').height(5),
                    this._createMobileDirCoverItems()
                ]
            }
        })
    },

    /**
     * 移动端报表及链接封面设置
     */
    createMobileEntryCoverPane: function (idx, folderId) {
        var rows = this._createMobileEntryCoverRows(idx, folderId);
        this.mobileEntryCoverPane = FR.createWidget({
            renderEl: $("#fs-mobile-entry-cover-pane"),
            type: 'panel',
            width: this.renderEl.width() - 245,
            height: this.renderEl.height() - 120,
            doSize: true,
            contentWidget: {
                type: 'tablepane',
                colSize: ['fill'],
                rowSize: rows[0],
                scrollable: true,
                items: rows[1]
            }
        })
    },

    _createMobileDirCoverItems: function () {
        var self = this;
        var dirs = [];
        if (FSRM.Control.folderData.length > 0) {
            dirs = FSRM.Control.folderData[0].ChildNodes;
        }
        this.dirCovers = [];
        $.each(dirs, function (idx, dir) {
            var cover = self._createCoverItem(idx, dir, true);
            if (cover) {
                self.dirCovers.push(cover);
            }
        });
        return [this.dirCovers]
    },

    _createMobileEntryCoverRows: function (idx, folderId) {
        var coverRows = [$('<div/>').height(5)];
        var coverRowSize = [5];
        if (folderId === null || folderId === undefined) {
            return [coverRowSize, coverRows]
        }
        var self = this;
        //先读取缓存数据
        var folders = FSRM.Control.folderEntries[idx];
        if (!folders) {
            folders = FS.Sync.ajax({
                url: FR.servletURL + '?op=fs_main&cmd=get_cover_sub_entries',
                type: 'POST',
                data: {folderID: folderId}
            });
            FSRM.Control.folderEntries[idx] = folders;
        }
        $.each(folders, function (i, folder) {
            var subDir = folder.folder;
            var entries = folder.entry;
            if (!subDir || subDir.mobileDeviceConfig > 1) {
                if (subDir) {
                    coverRows.push(self._createMobileCoverSubDirTitle(subDir.text));
                    coverRowSize.push('auto');
                }
                if (entries !== null) {
                    coverRows.push(self._createMobileEntryCoverItems(entries));
                    coverRowSize.push('auto');
                }
            }
        });
        return [coverRowSize, coverRows];
    },

    _createMobileEntryCoverItems: function (entries) {
        var self = this;
        var rowCovers = [];
        $.each(entries, function (idx, entry) {
            var cover = self._createCoverItem(idx, entry, false);
            if (cover !== null) {
                rowCovers.push(cover);
            }
        });
        return [rowCovers]
    },

    _createCoverItem: function (idx, entry, isDirCover) {
        var self = this;
        var $cover = $('<div class="fs-mobile-report-cover"/>');
        $cover = isDirCover ? $cover : $cover.addClass('fs-mobile-custom-cover');
        var coverId = entry.mobileCoverId;
        //缓存中entry对应的封面id
        var isFromCache = false;
        if (FSRM.Control.coverData && entry.nodeicon) {
            var cacheCoverId;
            if (entry.nodeicon === "cpt") {
                cacheCoverId = FSRM.Control.coverData.report[entry.id];
                if (cacheCoverId) {
                    coverId = cacheCoverId;
                    isFromCache = true;
                }
            } else if (entry.nodeicon === "url") {
                cacheCoverId = FSRM.Control.coverData.link[entry.id];
                if (cacheCoverId) {
                    coverId = cacheCoverId;
                    isFromCache = true;
                }
            }
        }
        if (!coverId) {
            coverId = String.fromCharCode(Math.floor(Math.random() * 26) + "a".charCodeAt(0));
            isFromCache = true;
        }
        var attachUrl = isFromCache ? "?op=fr_attach&cmd=ah_image&isAdjust=false&id=" : "?op=fs_main&cmd=get_report_cover&id=";
        var coverUrl = FR.servletURL + (coverId.length < 2 ?
            "?op=resource&resource=/com/fr/fs/resources/images/mobile/cover/" + coverId + ".png" : attachUrl + coverId);
        var coverImg = $('<img class="fs-mobile-report-cover-img"/>').attr("src", coverUrl).appendTo($cover),
            toolMask;
        $cover.append(
            $('<div class="fs-mobile-report-cover-title"/>').append($('<span/>').text(entry.text))
        );
        $cover.mouseover(function () {
            if (!toolMask) {
                var uploadBtn = $('<div/>').addClass("fs-mobile-cover-upload-icon");
                new FR.MultiFileEditor({
                    renderEl: uploadBtn,
                    maxlength: 1,
                    accept: '.png.jpg.gif',
                    height: 24,
                    width: 24,
                    hideFileList: true,
                    showViewImage: false,
                    listeners: [{
                        eventName: FR.Events.AFTEREDIT,
                        action: function () {
                            var attachId = this.getValue().attach_id;
                            var url = FR.servletURL + ('?op=fr_attach&cmd=ah_image&id=' + attachId + '&isAdjust=false');
                            coverImg.attr('src', url);
                            $('td', this.element).remove();
                            //设置缓存配置
                            FSRM.Control.setEntryCoverId(entry, attachId, isDirCover);
                        }
                    }]
                });
                $('img', uploadBtn).remove();

                var resetBtn = $('<div/>').addClass("fs-mobile-cover-reset-icon").attr("title", FR.i18nText("FS-Mobile-Report_Cover_Reset"))
                    .click(function () {
                        //生成随机封面图ID
                        var newImgId = entry.mobileCoverId;
                        while (newImgId === entry.mobileCoverId) {
                            //ID: a-z
                            newImgId = String.fromCharCode(Math.floor(Math.random() * 26) + "a".charCodeAt(0));
                        }
                        coverImg.attr("src", FR.servletURL + "?op=resource&resource=/com/fr/fs/resources/images/mobile/cover/" + newImgId + ".png");
                        FSRM.Control.setEntryCoverId(entry, newImgId, isDirCover);
                    });
                toolMask = $('<div/>').addClass("fs-mobile-report-cover-tool-mask")
                    .append(uploadBtn).append(resetBtn).click(function (e) {
                        //屏蔽目录切换
                        if (e && e.stopPropagation) {
                            e.stopPropagation();
                        } else if (window.event) {
                            window.event.cancelBubble = true;
                        }
                    }).appendTo($cover);
            }
            toolMask.show();
        }).mouseout(function () {
            if (toolMask) {
                toolMask.hide();
            }
        });
        if (isDirCover) {
            var dirCover = $('<div/>').addClass("fs-mobile-dir-cover-container")
                .click(function () {
                    if (self.selectedCover) {
                        self.selectedCover.removeClass("fs-mobile-dir-cover-container-selected");
                    }
                    dirCover.addClass("fs-mobile-dir-cover-container-selected");
                    self.selectedCover = dirCover;
                    $("#fs-mobile-entry-cover-pane").empty();
                    self.createMobileEntryCoverPane(idx, entry.id);
                }).append($cover);
            return dirCover;
        } else {
            return $cover;
        }
    },

    _createMobileCoverSubDirTitle: function (title) {
        return $('<div/>').addClass("fs-mobile-report-sub-dir-title").append($('<span/>').text(title));
    },

    DIR: {

        /**
         * 编辑文件
         * ps：好像没有用到过
         * @param id
         * @param sortindex
         * @returns {boolean}
         * @private
         */
        _editFile: function (id, sortindex) {
            if (!this._isFileValid()) {
                return false;
            }
            var file = this._getFileDialogValue(id);
            if (!file) {
                return false;
            }
            if (sortindex) {
                file.sortindex = sortindex;
            }

            var completeFn = function () {
                //触发当前目录树的点击事件，重新获取当前目录下的节点来显示
                var selectedNodetID = FSRM.DIR.dirTabletree.getSelectedNodes()[0].tId;
                FSRM.DIR.dirTabletree.$tbody.find('tr#' + selectedNodetID).click();
            };
            var config = {
                url: FR.servletURL + '?op=fr_schedule&cmd=se_setfilename',
                data: {
                    setScheduleFileName: file
                },
                type: 'POST'
            };
            FS.Async.ajax(config, completeFn);
        },

        /**
         * 校验添加文件对话框必填项
         * @returns {boolean}
         * @private
         */
        _isFileValid: function () {
            var name = FSRM.fileDialog.getWidgetByName("nameText").getValue();
            if (!name) {
                FR.Msg.alert(FR.i18nText("Fine-Engine_FS_Generic_Simple_Alert"), FR.i18nText("FS-Report-Enter_File_Name"));
                return false;
            }
            return true;
        },

        /**
         * 获取添加文件对话框中数据
         * @param id
         * @returns {{parentId: string, description, path, text}}
         * @private
         */
        _getFileDialogValue: function (id) {
            var name = FSRM.fileDialog.getWidgetByName("nameText").getValue();
            var path = FSRM.fileDialog.getWidgetByName("fileposition").getValue();
            var description = FSRM.fileDialog.getWidgetByName("descriptionText").getValue();
            var pd = this.dirTabletree.getSelectedNodes()[0].id.substr(1);

            var file = {parentId: pd, description: description, path: path, text: name};
            if (id !== null && id !== undefined) {
                file.id = id;
            }
            return file;
        },

        /**
         * 添加或编辑链接
         * @param id
         * @param sortindex
         * @param isAdd
         * @param coverId
         * @returns {boolean}
         * @private
         */
        _addOrEditLink: function (id, sortindex, isAdd, coverId) {
            var self = this;
            if (!this._isLinkValid()) {
                return false;
            }
            var url = this._getLinkDialogValue(id);
            if (!url) {
                return false;
            }
            if (sortindex) {
                url.sortindex = sortindex;
            }
            url.mobileCoverId = isAdd === true ? FSRM._makeMobileCoverRandomId() : coverId;
            url.parentDeviceConfig = self.getParentMobileConfig();
            var completeFn = function (res) {
                if (res.responseText === "-1") {
                    //没有权限
                    FR.Msg.alert(FR.i18nText("Fine-Engine_FS_Generic_Simple_Alert"), FR.i18nText("FS-Report-No_Folder_Edit_Privilege"));
                    return;
                }
                //触发当前目录树的点击事件，重新获取当前目录下的节点来显示
                var selectedNodetID = FSRM.DIR.dirTabletree.getSelectedNodes()[0].tId;
                FSRM.DIR.dirTabletree.$tbody.find('tr#' + selectedNodetID).click();
            };
            var config = {
                url: FR.servletURL + '?op=fs_entry&cmd=addurl',
                data: {
                    urlJason: url
                },
                type: 'POST'
            };
            FS.Async.ajax(config, completeFn);
        },

        /**
         * 校验添加链接对话框中必填项
         * @returns {boolean}
         * @private
         */
        _isLinkValid: function () {
            var path = FSRM.linkDialog.getWidgetByName("pathText").getValue();
            var name = FSRM.linkDialog.getWidgetByName("nameText").getValue();
            if (!path) {
                FR.Msg.alert(FR.i18nText("Fine-Engine_FS_Generic_Simple_Alert"), FR.i18nText("FS-Report-Input_Link_URL"));
                return false;
            }
            if (!name) {
                FR.Msg.alert(FR.i18nText("Fine-Engine_FS_Generic_Simple_Alert"), FR.i18nText("FS-Report-Input_Link_Name"));
                return false;
            }
            return true;
        },

        /**
         * 获取添加链接对话框中填写的信息
         * @param id
         * @returns {{parentId: string, description, url, text, mobileDeviceConfig: (*|number)}}
         * @private
         */
        _getLinkDialogValue: function (id) {
            var path = FSRM.linkDialog.getWidgetByName("pathText").getValue();
            var name = FSRM.linkDialog.getWidgetByName("nameText").getValue();
            var description = FSRM.linkDialog.getWidgetByName("descriptionText").getValue();
            var pd = this.dirTabletree.getSelectedNodes()[0].id.substr(1);
            var mobileDeviceConfig = FSRM._makeMobileDeviceConfig(
                FSRM.linkDialog.getWidgetByName("deviceCheckboxGroup").getValue()
            );

            var url = {
                parentId: pd,
                description: description,
                url: path,
                text: name,
                mobileDeviceConfig: mobileDeviceConfig
            };
            if (id !== null && id !== undefined) {
                url.id = id;
            }
            return url;
        },


        /**
         * 编辑报表
         * @param id
         * @param sortindex 目录内排序索引
         * @param isAdd 是否新添加的，新添加的封面id需要重新生成
         * @param coverId 封面id
         * @returns {boolean}
         * @private
         */
        _editCpt: function (id, sortindex, isAdd, coverId) {
            var self = this;
            if (!this._isCptValid()) {
                return false;
            }
            var report = this._getCptDialogValue(id);
            if (!report) {
                return false;
            }
            if (sortindex) {
                report.sortindex = sortindex;
            }
            report.mobileCoverId = isAdd === true ? FSRM._makeMobileCoverRandomId() : coverId;
            report.parentDeviceConfig = self.getParentMobileConfig();
            var completeFn = function (res) {
                if (res.responseText === "-1") {
                    //没有权限
                    FR.Msg.alert(FR.i18nText("Fine-Engine_FS_Generic_Simple_Alert"), FR.i18nText("FS-Report-No_Folder_Edit_Privilege"));
                    return;
                }
                //触发当前目录树的点击事件，重新获取当前目录下的节点来显示
                var selectedNodetID = FSRM.DIR.dirTabletree.getSelectedNodes()[0].tId;
                FSRM.DIR.dirTabletree.$tbody.find('tr#' + selectedNodetID).click();
            };
            var config = {
                url: FR.servletURL + '?op=fs_entry&cmd=addreport',
                data: {
                    reportJason: [report]
                },
                type: 'POST'
            };
            FS.Async.ajax(config, completeFn);
        },

        /**
         * 目录内添加报表，支持批量添加
         * @param reports 报表对象
         * @private
         */
        _addCpt: function (reports) {
            var self = this;
            for (var i = 0; i < reports.length; i++) {
                reports[i].mobileCoverId = FSRM._makeMobileCoverRandomId();
                reports[i].parentDeviceConfig = self.getParentMobileConfig();
            }

            var completeFn = function (res) {
                if (res.responseText === "-1") {
                    //没有权限
                    FR.Msg.alert(FR.i18nText("Fine-Engine_FS_Generic_Simple_Alert"), FR.i18nText("FS-Report-No_Folder_Edit_Privilege"));
                    return;
                }
                var items = FR.jsonDecode(res.responseText);
                var tName = 'report';
                //DOM操作
                for (var i = 0; i < items.length; i++) {
                    var item = FR.jsonDecode(items[i]);
                    var showType = (item.showType === "2" ? FR.i18nText("FS-Generic-Simple_Preview") : (item.showType === "0" ? FR.i18nText("FS-Generic-Face_Write") : FR.i18nText("FS-Report-Simple_Analysis")));
                    var hasParameters = (item.transmitParameters ? FR.i18nText("FS-Report-Has_Parameter") : FR.i18nText("FS-Generic-Simple_None"));
                    var data = [item.text, item, FSRM.CONSTS.REPORTLET, showType, hasParameters, item.id];
                    var originaldata = item;
                    if ($('.fs_reportmgr_table_content_' + tName).children().length <= 0) {
                        $('.fs_reportmgr_table_' + tName).show();
                    }
                    FSRM.addTableData(tName, FSRM.CONSTS.CATALOGWIDTHS, FSRM.CONSTS.HYPERLINKINDEX, data, originaldata);
                }
            };
            var config = {
                url: FR.servletURL + '?op=fs_entry&cmd=addreport',
                data: {
                    reportJason: reports
                },
                type: 'POST'
            };
            FS.Async.ajax(config, completeFn);
        },


        /**
         * 添加单个报表对话框中必填的信息项是否都有值
         * @returns {boolean}
         * @private
         */
        _isCptValid: function () {
            var path = FSRM.cptDialog.getWidgetByName("pathCombo").getValue().join('/');
            var name = FSRM.cptDialog.getWidgetByName("nameText").getValue();
            var showtype = FSRM.cptDialog.getWidgetByName("typeRadioGroup").getValue();
            if (!path) {
                FR.Msg.alert(FR.i18nText("Fine-Engine_FS_Generic_Simple_Alert"), FR.i18nText("FS-Report-Input_Cpt_Path"));
                return false;
            }
            if (!name) {
                FR.Msg.alert(FR.i18nText("Fine-Engine_FS_Generic_Simple_Alert"), FR.i18nText("FS-Report-Input_Cpt_Name"));
                return false;
            }
            if (showtype === "") {
                FR.Msg.alert(FR.i18nText("FS-Report-Choose_ViewType"));
                return false;
            }
            return true;
        },

        /**
         * 获取报表编辑对话框中用户输入的信息
         * @param id
         * @returns {{parentId: string, description, path: string, text, showType, mobileDeviceConfig: *, transmitParameters: (*|string)}}
         * @private
         */
        _getCptDialogValue: function (id) {
            var path = FSRM.cptDialog.getWidgetByName("pathCombo").getValue().join('/');
            var name = FSRM.cptDialog.getWidgetByName("nameText").getValue();
            var description = FSRM.cptDialog.getWidgetByName("descriptionText").getValue();
            var showType = FSRM.cptDialog.getWidgetByName("typeRadioGroup").getValue();
            var pd = this.dirTabletree.getSelectedNodes()[0].id.substr(1);
            var mobileDeviceConfig = FSRM._makeMobileDeviceConfig(
                FSRM.cptDialog.getWidgetByName("deviceCheckboxGroup").getValue()
            );
            var transmitParameters = FSRM.cptDialog.getWidgetByName("paraSetGrid").getData();
            var report = {
                parentId: pd,
                description: description,
                path: path,
                text: name,
                showType: showType,
                mobileDeviceConfig: mobileDeviceConfig,
                transmitParameters: transmitParameters
            };
            if (id !== null && id !== undefined) {
                report.id = id;
            }
            return report;
        },


        /**
         * 添加上报流程
         * @param id
         * @param sortindex
         * @returns {boolean}
         * @private
         */
        _addOrEditRP: function (id, sortindex) {
            if (!this._isRPValid()) {
                return false;
            }
            var rp = this._getRPDialogValue(id);
            if (!rp) {
                return false;
            }
            if (sortindex) {
                rp.sortindex = sortindex;
            }
            var completeFn = function (res) {
                if (res.responseText === "-1") {
                    //没有权限
                    FR.Msg.alert(FR.i18nText("Fine-Engine_FS_Generic_Simple_Alert"), FR.i18nText("FS-Report-No_Folder_Edit_Privilege"));
                    return;
                }
                //触发当前目录树的点击事件，重新获取当前目录下的节点来显示
                var selectedNodetID = FSRM.DIR.dirTabletree.getSelectedNodes()[0].tId;
                FSRM.DIR.dirTabletree.$tbody.find('tr#' + selectedNodetID).click();
            };
            var config = {
                url: FR.servletURL + "?op=fs_entry&cmd=addreportprocess",
                data: {
                    processJason: rp
                },
                type: 'POST'
            };
            FS.Async.ajax(config, completeFn);
        },

        /**
         * 校验上报流程对话框中必填项是否都合法
         * @returns {boolean}
         * @private
         */
        _isRPValid: function () {
            var label = FSRM.rpDialog.getWidgetByName("LABELCOMBO").getValue();
            var name = FSRM.rpDialog.getWidgetByName("RPNAME").getValue();
            if (!label) {
                FR.Msg.alert(FR.i18nText("Fine-Engine_FS_Generic_Simple_Alert"), FR.i18nText("FS-Report-RP_SelectLabel"));
                return false;
            }
            if (!name) {
                FR.Msg.alert(FR.i18nText("Fine-Engine_FS_Generic_Simple_Alert"), FR.i18nText("FS-Report-RP_InputName"));
                return false;
            }
            return true;
        },

        /**
         * 获取添加上报流程对话框中填写的内容
         * @param id
         * @returns {{parentId: string, processType, text, description}}
         * @private
         */
        _getRPDialogValue: function (id) {
            var label = FSRM.rpDialog.getWidgetByName("LABELCOMBO").getValue();
            var text = FSRM.rpDialog.getWidgetByName("RPNAME").getValue();
            var description = FSRM.rpDialog.getWidgetByName("RPDESCRIPTION").getValue();
            var pd = this.dirTabletree.getSelectedNodes()[0].id.substr(1);
            var rp = {
                parentId: pd,
                processType: label,
                text: text,
                description: description
            };
            if (id !== null && id !== undefined) {
                rp.id = id;
            }
            return rp;
        },

        _makeZTreeData: function (treedata, result, parentMobileConfig) {
            if (!result) {
                result = [];
            }
            if (parentMobileConfig === null || parentMobileConfig === undefined) {
                parentMobileConfig = 7;
            }
            for (var i = 0, len = treedata.length; i < len; i++) {
                var item = treedata[i];
                var zitem = {};
                zitem.name = item.localeKey ? FR.i18nText(item.localeKey) : item.text;
                zitem.parentMobileConfig = parentMobileConfig;
                zitem.mobileDeviceConfig = item.mobileDeviceConfig;
                zitem.mobileCoverId = item.mobileCoverId ? item.mobileCoverId : FSRM._makeMobileCoverRandomId();
                if (item.ChildNodes && item.ChildNodes.length > 0) {
                    this._makeZTreeData(item.ChildNodes, result, item.mobileDeviceConfig & parentMobileConfig);
                }
                zitem.id = item.id;
                zitem.pId = item.parentId;
                zitem.open = true;
                zitem.description = item.description;
                zitem.sortindex = item.sortindex;
                result.push(zitem);
            }
            return result;
        },


        /**
         * 转换待添加到右侧列表中的数据结构
         * @param reports
         * @returns {Array}
         * @private
         */
        _getData: function (reports) {
            var result = [];
            for (var i = 0, len = reports.length; i < len; i++) {
                var report = reports[i];
                if (report.type === FSRM.CONSTS.REPORTLET) {
                    result.push(this._getReportData(report));
                } else if (report.type === FSRM.CONSTS.URL) {
                    result.push(this._getLinkData(report));
                } else if (report.type === FSRM.CONSTS.REPORTPROCESS) {
                    result.push(this._getRPData(report));
                } else if (report.type === FSRM.CONSTS.FILE) {
                    result.push(this._getFileData(report));
                } else {
                    // fine bi
                    $.each(FS.Plugin.EntrySupporter, function (index, value) {
                        if (value.acceptTypeByNumber(report.type)) {
                            value.update(report);
                        }
                    });
                }
            }
            return result;
        },
        /**
         * 报表
         * @param report
         * @returns {[*,*,string,*,*,*]}
         * @private
         */
        _getReportData: function (report) {
            var showType = (report.showType === "2" ? FR.i18nText("FS-Generic-Simple_Preview") : (report.showType === "0" ? FR.i18nText("FS-Generic-Face_Write") : FR.i18nText("FS-Report-Simple_Analysis")));
            var hasParameters = (report.transmitParameters ? FR.i18nText("FS-Report-Has_Parameter") : FR.i18nText("FS-Generic-Simple_None"));
            return [report.text, report, FSRM.CONSTS.REPORTLET, showType, hasParameters, report.id];
        },

        /**
         * 文件
         * @param item
         * @returns {[*,*,string,string,string,*]}
         * @private
         */
        _getFileData: function (item) {
            return [item.text, item.path, FSRM.CONSTS.FILE, '--', '--', item.id];
        },

        /**
         * 链接
         * @param item
         * @returns {[*,*,string,string,string,*]}
         * @private
         */
        _getLinkData: function (item) {
            return [item.text, item.url, FSRM.CONSTS.URL, '--', '--', item.id];
        },


        /**
         * 上报
         * @param item
         * @returns {[*,*,string,string,string,*]}
         * @private
         */
        _getRPData: function (item) {
            return [item.text, item, FSRM.CONSTS.PROCESS, '--', '--', item.id];
        },

        _initFileData: function (files) {
            if (!files) {
                files = [];
            }
            var reportsData = this._getData(files);
            FSRM.reportTable.popTableData(reportsData, files);

            // fine bi
            $.each(FS.Plugin.EntrySupporter, function (index, value) {
                value.populate();
            });
        },

        /**
         * 在右侧显示目录下的报表条目
         * @param e
         * @param treeId
         * @param treeNode
         * @private
         */
        _showFiles: function (e, treeId, treeNode) {
            //如果是根目录，直接return
            if (!treeNode.getParentNode()) {
                FSRM.DIR._initFileData();
                return;
            }
            var nodeID = treeNode.id;
            var completeFn = function (res) {
                if (!res.responseText) {
                    return;
                }
                var files = FR.jsonDecode(res.responseText);
                FSRM.DIR._initFileData(files);
            };
            var config = {
                url: FR.servletURL + '?op=fs_entry&cmd=getfiles',
                type: 'POST',
                data: {folderID: nodeID}
            };
            FS.Async.ajax(config, completeFn);
        },

        _checkValid: function (dirName, isAdd) {
            if (!dirName) {
                FR.Msg.alert(FR.i18nText("Fine-Engine_FS_Generic_Simple_Alert"), FR.i18nText("FS-Report-Input_Folder_Name"));
                return false;
            }
            var dirTabletree = FSRM.DIR.dirTabletree;
            var selectedNode = dirTabletree.getSelectedNodes()[0];
            var siblings;
            if (isAdd === true) {
                siblings = selectedNode.children || [];
            } else {
                //修改
                siblings = selectedNode.getParentNode() ? (selectedNode.getParentNode().children || []) : [];
            }
            for (var i = 0, len = siblings.length; i < len; i++) {
                var node = siblings[i];
                if (node.name === dirName && node !== selectedNode) {
                    FR.Msg.alert(FR.i18nText("Fine-Engine_FS_Generic_Simple_Alert"), FR.i18nText("FS-Report-Simple_Named") + dirName + FR.i18nText("FS-Report-Folder_Already_Exist"));
                    return false;
                }
            }
            return true;
        },

        getParentMobileConfig: function () {
            var self = this;
            var selectedNode = self.dirTabletree.getSelectedNodes()[0];
            return selectedNode.mobileDeviceConfig & selectedNode.parentMobileConfig;
        },

        /**
         * 左侧目录树编辑目录
         * @private
         */
        _editFolder: function () {
            var dirTabletree = FSRM.DIR.dirTabletree;
            var selectedNode = dirTabletree.getSelectedNodes()[0];
            var dirName = this.getWidgetByName("nameText").getValue();
            var description = this.getWidgetByName("descriptionText").getValue();
            var mobileDeviceConfig = FSRM._makeMobileDeviceConfig(
                this.getWidgetByName("deviceCheckboxGroup").getValue()
            );
            if (!FSRM.DIR._checkValid(dirName, false)) {
                return;
            }
            var folder = {};
            var parentId = selectedNode.pId.substr(1);
            if (parentId === null && parentId === undefined) {
                parentId = -1;
            }
            if (selectedNode.id !== null && selectedNode.id !== undefined) {
                folder.id = selectedNode.id;
            }
            folder.parentId = parentId;
            folder.text = dirName;
            folder.hasChildren = true;
            folder.isexpand = true;
            folder.complete = true;
            folder.description = description;
            folder.sortindex = selectedNode.sortindex;
            folder.mobileDeviceConfig = mobileDeviceConfig;
            folder.parentDeviceConfig = selectedNode.getParentNode().parentMobileConfig;
            folder.mobileCoverId = selectedNode.mobileCoverId;
            var completeFn = function (res) {
                if (res.responseText === "-1") {
                    //没有权限
                    FR.Msg.alert(FR.i18nText("Fine-Engine_FS_Generic_Simple_Alert"), FR.i18nText("FS-Report-No_Folder_Edit_Privilege"));
                    return;
                }
                selectedNode.name = dirName;
                selectedNode.description = description;
                selectedNode.mobileDeviceConfig = mobileDeviceConfig;
                dirTabletree.updateNode(selectedNode);
                if (selectedNode.isParent) {
                    $.each(selectedNode.children, function (idx, childNode) {
                        FSRM.DIR._editChildNodeMobileConfig(childNode, selectedNode);
                    })
                }
            };
            var config = {
                url: FR.servletURL + "?op=fs_entry&cmd=editfolder",
                data: {
                    folderJason: folder
                },
                type: 'POST'
            };
            FS.Async.ajax(config, completeFn);
        },

        _editChildNodeMobileConfig: function (node, parent) {
            var self = this;
            node.parentMobileConfig = parent.mobileDeviceConfig & parent.parentMobileConfig;
            if (node.isParent) {
                $.each(node.children, function (idx, childNode) {
                    self._editChildNodeMobileConfig(childNode, node);
                })
            }
        },

        /**
         * 左侧目录树添加目录
         * @param dirname
         * @param description
         * @param mobileDeviceConfig
         * @private
         */
        _addFolder: function (dirname, description, mobileDeviceConfig) {
            var self = this;
            var selectedNode = this.dirTabletree.getSelectedNodes()[0];
            var folder = {};
            folder.parentId = selectedNode.id.substr(1);
            folder.text = dirname;
            folder.description = description;
            folder.mobileDeviceConfig = mobileDeviceConfig;
            if (selectedNode.getParentNode() !== null && selectedNode.getParentNode() !== undefined) {
                folder.parentDeviceConfig = selectedNode.getParentNode().parentMobileConfig;
            } else {
                var rootNode = FSRM.DIR.dirTabletree.getTreeObj().getNodes()[0];
                folder.parentDeviceConfig = rootNode.parentMobileConfig;
            }
            folder.mobileCoverId = FSRM._makeMobileCoverRandomId();
            var completeFn = function (res) {
                if (res.responseText === "-1") {
                    //没有权限
                    FR.Msg.alert(FR.i18nText("Fine-Engine_FS_Generic_Simple_Alert"), FR.i18nText("FS-Report-No_Folder_Edit_Privilege"));
                    return;
                }
                var newnode = FR.jsonDecode(res.responseText);
                var node = {};
                node.id = newnode.id;
                node.name = dirname;
                node.pId = selectedNode.id;
                node.description = description;
                node.mobileDeviceConfig = mobileDeviceConfig;
                node.parentMobileConfig = selectedNode.mobileDeviceConfig;
                node.mobileCoverId = folder.mobileCoverId;
                node.open = true;
                self.dirTabletree.addSingleNode(selectedNode, node, selectedNode.open);
            };
            var config = {
                url: FR.servletURL + "?op=fs_entry&cmd=addfolder",
                data: {
                    folderJason: folder
                },
                type: 'POST'
            };
            FS.Async.ajax(config, completeFn);
        },

        /**
         * 创建左侧目录管理tabletree
         * @param zTreedata
         * @private
         */
        _createTableTree: function (zTreedata) {
            var self = this;
            var dirMgrSetting = {
                view: {
                    showIcon: false  //不显示每个节点前的ICON
                },
                data: {
                    simpleData: {
                        enable: true,
                        idKey: "id",
                        pidKey: "pId",
                        rootPId: "0-2"
                    }
                },
                callback: {
                    onClick: this._showFiles
                }
            };
            //左侧目录管理tabletree
            this.dirTabletree = new FS.TableTree({
                treeID: 'dirmgrTableTree',
                renderEl: $('.fs_reportmgr_dir_panel_content'),
                setting: dirMgrSetting,
                height: '100%',
                width: '100%',
                fit: true,
                alwaysShowTools: false,
                Nodes: zTreedata,
                itemHoverCls: 'fs_reportmgr_tabletree_item_hover',
                tools: [
                    {
                        iconCls: 'fs-module-edit-white',
                        hoverCls: 'fs-module-edit-white-over',
                        rootToolHide: true,
                        //编辑按钮事件
                        onToolClick: function (e) {
                            var title = FR.i18nText("FS-Report-Edit_Directory");
                            var onOK = self._editFolder;
                            var onCancel = function () {
                            };
                            var nodeID = $(this).data('nodeID'); //编辑dialog的初始数据
                            var preEditNode = self.dirTabletree.getNodeById(nodeID);
                            var parentNode = preEditNode.getParentNode();
                            self.dirTabletree.selectNode(preEditNode);
                            var data = {
                                parentMobileConfig: parentNode.mobileDeviceConfig & parentNode.parentMobileConfig
                            };
                            var editDirDialog = FSRM.createDirDialog(title, onOK, onCancel, data);
                            editDirDialog.setVisible(true);
                            editDirDialog.getWidgetByName("nameText").setValue(preEditNode.name);
                            editDirDialog.getWidgetByName("descriptionText").setValue(preEditNode.description);
                            editDirDialog.getWidgetByName("deviceCheckboxGroup").setValue(
                                FSRM._makeMobileConfigCheckboxValue(preEditNode.mobileDeviceConfig & data.parentMobileConfig)
                            );
                            e.stopEvent();
                        }
                    },
                    {
                        rootToolHide: true,
                        iconCls: 'fs-module-delete-white',
                        hoverCls: 'fs-module-delete-white-over',
                        //删除按钮事件
                        onToolClick: function (e) {
                            var nodeID = $(this).data('nodeID');
                            var preDeleteNode = self.dirTabletree.getNodeById(nodeID);
                            self.dirTabletree.selectNode(preDeleteNode);
                            FR.Msg.confirm(FR.i18nText("Fine-Engine_FS_Frame_Delete_Data"), FR.i18nText("FS-Generic-Sure_To_Delete") + '?', function (result) {
                                if (result) {
                                    //先向后台请求删除数据，请求成功再在web端删除
                                    var folderId = self.dirTabletree.getSelectedNodes()[0].id;
                                    var completeFn = function (res) {
                                        if (res.responseText === "-1") {
                                            //没有权限
                                            FR.Msg.alert(FR.i18nText("Fine-Engine_FS_Generic_Simple_Alert"), FR.i18nText("FS-Report-No_Folder_Edit_Privilege"));
                                            return;
                                        }
                                        self.dirTabletree.removeSelectedNodes();
                                        var root = self.dirTabletree.getTreeObj().getNodes()[0];
                                        self.dirTabletree.selectNode(root);
                                        FSRM.tabPane.getWidgetByName("cptMgrPane").panelBody.children().hide();
                                    };
                                    var config = {
                                        url: FR.servletURL + "?op=fs_entry&cmd=removefolder",
                                        type: 'POST',
                                        data: {
                                            folderId: folderId
                                        }
                                    };
                                    FS.Async.ajax(config, completeFn);
                                }
                            });
                            e.stopEvent();
                        }
                    }
                ]
            });
            this.dirTabletree.changeable(this.changeDir);
        },

        /**
         * 左侧目录父子关系变化及排序保存到后端
         * @param dragNode 拖拽的节点
         * @param dropInfo 释放信息
         */
        changeDir: function (dragNode, dropInfo) {
            //修改根目录的id
            if (dropInfo.pid === '0-1') {
                dropInfo.pid = '-1';
            }
            if (dropInfo.prevNodeID === '0-1') {
                dropInfo.prevNodeID = '-1';
            }
            if (dropInfo.err === 'err') {
                //清空当前页面并重新加载
                FSRM.renderEl.empty();
                FSRM.init(FSRM.renderEl);
                return;
            }
            FS.Async.ajax({
                url: FR.servletURL + "?op=fs_entry&cmd=update_tree",
                type: 'POST',
                data: {
                    dragID: dragNode.id,
                    dropPID: dropInfo.pid,
                    prevID: dropInfo.prevNodeID,
                    nextID: dropInfo.nextNodeID
                }
            }, function (res, status) {
                if (status === 'success' && res.responseText === 'success') {
                    //清空当前树并重新加载
                    var dirTree = FSRM.DIR.dirTabletree;
                    dirTree.$table.empty();
                    var node = dirTree.getSelectedNodes()[0];
                    FSRM.DIR.initData(node);
                }
            });
        },

        initData: function (node) {
            var self = this;
            var completeFn = function (res, status) {
                if (status === 'success') {
                    var treedata = FR.jsonDecode(res.responseText);
                    var zTreedata = self._makeZTreeData(treedata);
                    self._createTableTree(zTreedata);
                    var selectNode = node ? self.dirTabletree.getNodeByNodeID(node.id) : self.dirTabletree.getTreeObj().getNodes()[0];
                    $('tr#' + selectNode.tId)[0].scrollIntoView();
                    self.dirTabletree.selectNode(selectNode);
                }
            };
            var config = {
                url: FR.servletURL + '?op=fs_entry&cmd=getfolder',
                type: 'POST'
            };
            FS.Async.ajax(config, completeFn);
        }
    },


    /**
     * 目录管理面板内容初始化
     */
    dirMgrInit: function () {
        this.DIR.initData();
    },


    /**
     * 目录管理面板内容初始化
     * @returns {[*]}
     */
    cptMgrInit: function () {

        var catalogs = [FR.i18nText("FS-Generic-WF_Name"),
            FR.i18nText("FS-Report-Simple_Path"),
            FR.i18nText("FS-Generic-Report_Type"),
            FR.i18nText("FS-Report-Simple_Way"),
            FR.i18nText("FS-Report-Parameter_Binding")
        ];
        var hyperLinkIndex = FSRM.CONSTS.HYPERLINKINDEX;
        this.reportTable = this.createTable(catalogs, FSRM.CONSTS.CATALOGWIDTHS, FSRM.CONSTS.TNAME, hyperLinkIndex).hide();
        var children = [this.reportTable];
        var self = this;
        // fine bi
        $.each(FS.Plugin.EntrySupporter, function (index, value) {
            var el = value.ui.apply(self, [hyperLinkIndex]);
            children.push(el);
        });

        return children;
    },


    /**
     * 创建右侧报表混排数据表格，没有数据时隐藏起来
     * @param catalogs
     * @param catalogWidths
     * @returns {* | jQuery}
     * @param tName
     * @param hyperLinkIndex
     */
    createTable: function (catalogs, catalogWidths, tName, hyperLinkIndex) {
        var self = this;
        var tableCls = 'fs_reportmgr_table_' + tName;
        var catalogCls = 'fs_reportmgr_table_catalog';
        var contentCls = 'fs_reportmgr_table_content_' + tName;
        var table = $('<div/>').addClass(tableCls);
        //菜单DIV
        var catalogDiv = $('<div/>').addClass(catalogCls);

        $('<input type="checkbox" id="CheckBoxAll' + tName + '" style="float:left; margin: 6px">')
            .change(function () {
                $('input[id^="CheckBox' + tName + '"]').attr('checked', $(this).is(":checked"));
            })
            .appendTo(catalogDiv);
        for (var i = 0; i < catalogs.length; i++) {
            $('<div/>').text(FS.getShowText(catalogs[i], catalogWidths[i], 14, "\"Open Sans\", \"Tahoma\", \"Hiragino Sans GB\", \"Microsoft YaHei\""))
                .css({width: catalogWidths[i], 'float': 'left'})
                .appendTo(catalogDiv);
        }
        catalogDiv.appendTo(table);

        //内容
        var contentDiv = $('<div/>').addClass(contentCls);
        //数据载入
        contentDiv.appendTo(table);
        var popTableData = function (data, originaldata) {
            contentDiv.empty();
            if (data.length > 0) {
                table.show();
            } else {
                table.hide();
            }
            for (var i = 0; i < data.length; i++) {
                self.addTableData(tName, catalogWidths, hyperLinkIndex, data[i], originaldata[i]);
            }
            self.makeTableSortable(contentDiv, contentCls, tName);
        };

        $.extend(table, {
            popTableData: popTableData
        });

        this.makeTableSortable(contentDiv, contentCls, tName);
        return table;
    },


    /**
     * 使右侧列表可以排序
     * @param table
     * @param contentCls
     */
    makeTableSortable: function (table, contentCls) {
        var beforeDrag = 0, afterDrag = 0, beforeDragID, isSort, contentLeft;
        var itemcls = "div.fs_reportmgr_table_content_line", dragTipHandle = function (event) {
            var offsetX = 30;
            var p = $('p#drag-tip');
            p[0].style.left = event.clientX + offsetX + "px";
            p[0].style.top = event.clientY + "px";
        };
        var $dragTip = $('p#drag-tip');
        if ($dragTip.length === 0) {
            $('<p id="drag-tip" class="drag-tip"></p>').appendTo('body');
        }

        var modifyLeft = 40, modifyRight = 275, sortLeft = 300, sortRight = 900;

        table.sortable({
            nested: false,
            handler: itemcls,
            delay: 200,
            itemSelector: itemcls,
            placeholder: '<div id="table_drag_mark" style="height:2px;background:#3397cb"/>',
            containerSelector: contentCls,
            onDragStart: function ($item, position, _super, event) {
                $item.hide();
                //侧边导航栏宽度 fine report 或者 fine bi
                contentLeft = $('div.bi-platform-border-right').width() || $('div#fs-frame-content').offset().left;
            },
            onDrag: function ($item, position, _super, event) {

                $dragTip = $('p#drag-tip');
                $dragTip.text($item.find('div:first').text()).addClass('drag-tip-content');
                $(document).on({'mousemove': dragTipHandle});
                table.children().unbind('mouseenter');
                if (sortLeft + contentLeft < position.left && position.left < sortRight + contentLeft) {
                    isSort = true;
                    document.body.style.cursor = 'auto';
                    table.find('div#table_drag_mark').show();
                } else if (modifyLeft + contentLeft < position.left && position.left < modifyRight + contentLeft) {
                    isSort = false;
                    document.body.style.cursor = 'auto';
                    table.find('div#table_drag_mark').hide();
                } else {
                    document.body.style.cursor = 'no-drop';
                    table.find('div#table_drag_mark').hide();
                    return;
                }
                _super($item, position);
                beforeDrag = $(itemcls, table).index($item[0]);
                beforeDragID = $item.attr('entrytypeid');
            },
            onDrop: function ($item, container, _super, event) {
                document.body.style.cursor = 'auto';
                $dragTip.text('').removeClass('drag-tip-content');
                $(document).off({'mousemove': dragTipHandle});
                var completeFn = function () {
                    //选中当前的目录节点，更新下页面的显示
                    var selectedNodetID = FSRM.DIR.dirTabletree.getSelectedNodes()[0].tId;
                    FSRM.DIR.dirTabletree.$tbody.find('tr#' + selectedNodetID).click();
                };
                afterDrag = $(itemcls, table).index($item[0]);
                if (isSort === true && (beforeDrag !== afterDrag) && (beforeDrag >= 0) && (afterDrag >= 0)) {
                    var sortConfig = {
                        url: FR.servletURL + "?op=fs_entry&cmd=modifyforsort",
                        type: 'POST',
                        data: {sortid: beforeDragID, sortindex: afterDrag}
                    };
                    FS.Async.ajax(sortConfig, completeFn);
                } else if (isSort === false) {
                    //修改报表所在目录
                    var $parent = FSRM.DIR.dirTabletree.$tbody.find('.fs_reportmgr_tabletree_item_hover');
                    if ($parent.length === 1) {
                        var targetID = $parent.attr("id");
                        var parentID = FSRM.DIR.dirTabletree.getNodeById(targetID).id;
                        var modifyConfig = {
                            url: FR.servletURL + "?op=fs_entry&cmd=modify_entry_parent",
                            type: 'POST',
                            data: {sortID: beforeDragID, parentID: parentID}
                        };
                        FS.Async.ajax(modifyConfig, completeFn);
                    }
                } else {
                    completeFn();
                }
                _super($item);
            }
        });
    },


    /**
     * 向右侧列表中添加一行数据,如果插入数据与之前具有相同id则修改之前那条数据
     * @param data 整理的数据，最后一位放id
     * @param originaldata 原始数据
     * @param catalogWidths 表格宽度
     * @param hyperLinkIndex 超链所在data的索引位置
     * @param type tName类型
     */
    addTableData: function (type, catalogWidths, hyperLinkIndex, data, originaldata) {
        var self = this;
        var tableCls = 'fs_reportmgr_table_' + type;
        var contentCls = 'fs_reportmgr_table_content_' + type;
        var lineCls = 'fs_reportmgr_table_content_line';
        var contentDiv = $('.' + contentCls);
        var lineDiv = $('<div/>').addClass(lineCls).data('tCls', tableCls);
        $('input#CheckBoxAll' + type).attr('checked', false);
        var j = 0;
        $('<input type="checkbox" id="CheckBox' + type + data[data.length - 1] + '" style="float:left; margin: 6px">')
            .change(function () {
                var chooseAll = true;
                $('input[id^="CheckBox' + type + '"]').each(function (index, value) {
                    if (!$(this).is(':checked')) {
                        chooseAll = false;
                        return false;
                    }
                });
                $('input#CheckBoxAll' + type).attr('checked', chooseAll);
            })
            .appendTo(lineDiv);

        //finereport 报表支持混排的类型
        var tNameDesc = '', desc = '';
        if (data[2] === FSRM.CONSTS.REPORTLET) {
            tNameDesc = FSRM.TNAME_DESC.REPORT;
            desc = FSRM.CONSTS.ENTRYTYPEDESC.REPORTLET;
        } else if (data[2] === FSRM.CONSTS.URL) {
            tNameDesc = FSRM.TNAME_DESC.URL;
            desc = FSRM.CONSTS.ENTRYTYPEDESC.URL;
        } else if (data[2] === FSRM.CONSTS.PROCESS) {
            tNameDesc = FSRM.TNAME_DESC.RP;
            desc = FSRM.CONSTS.ENTRYTYPEDESC.PROCESS;
        } else if (data[2] === FSRM.CONSTS.FILE) {
            tNameDesc = FSRM.TNAME_DESC.FILE;
            desc = FSRM.CONSTS.ENTRYTYPEDESC.FILE;
        } else {
            tNameDesc = type;
            desc = '--';
        }
        for (var len = catalogWidths.length; j < len; j++) {
            var $oneDataDiv = $('<div/>').css({
                width: catalogWidths[j],
                'float': 'left'
            }).appendTo(lineDiv);
            if (j === hyperLinkIndex) {
                this.addHyperLink(tNameDesc, data[j], $oneDataDiv, originaldata);
            } else if (j === 2) {
                $oneDataDiv.text(FS.getShowText(desc, 132, 12, 'SimSun')).attr('title', desc);
            } else {
                $oneDataDiv.text(FS.getShowText(data[j], 132, 12, 'SimSun')).attr('title', data[j]);
            }
        }
        //根据ID判断是否已经插入过该条数据，如果已存在，则为编辑事件
        var id = data[j];
        if (id) {
            //add type to VIEW
            lineDiv.attr('entrytype', tNameDesc);
            lineDiv.attr('entrytypeid', id);
            //这边编辑事件可以解决编辑之后前端新添加的假象
            var $find = $('.' + lineCls + '[entrytype=' + tNameDesc + '][entrytypeid=' + id + ']');
            if ($find && $find.length > 0) {
                $find.after(lineDiv);
                $find.remove();
            } else {
                lineDiv.appendTo(contentDiv);
            }
        }//删除按钮
        var deleteDiv = $('<div/>').addClass('fs-module-delete-white')
            .attr('title', FR.i18nText("FS-Generic-Simple_Remove")).css({'display': 'none', float: 'right'})
            .hover(function () {
                $(this).addClass('fs-module-delete-white-hover');
            }, function () {
                $(this).removeClass('fs-module-delete-white-hover');
            }).click(function () {
                //删除按钮的点击事件
                var preDeleteDiv = $(this);
                FR.Msg.confirm(FR.i18nText("Fine-Engine_FS_Frame_Delete_Data"), FR.i18nText("FS-Generic-Sure_To_Delete") + '?', function (result) {
                    if (result) {
                        var entryID = preDeleteDiv.parent().attr('entrytypeid');
                        var completeFn = function (res, status) {
                            if (status === 'success') {
                                if (res.responseText === "-1") {
                                    //没有权限
                                    FR.Msg.alert(FR.i18nText("Fine-Engine_FS_Generic_Simple_Alert"), FR.i18nText("FS-Report-No_Folder_Edit_Privilege"));
                                    return;
                                }
                                //DOM上的删除操作
                                var $table = $('.' + preDeleteDiv.parent().data('tCls'));
                                preDeleteDiv.parent().remove();
                                if ($table.find('.' + contentCls).children().length <= 0) {
                                    $table.hide();
                                }
                            }
                        };
                        var config = {
                            url: FR.servletURL + "?op=fs_entry&cmd=removereport",
                            type: 'POST',
                            data: {entryIDs: [entryID]}
                        };
                        FS.Async.ajax(config, completeFn);
                    }
                });
            });
        //编辑按钮
        var editDiv = $('<div/>').addClass('fs-module-edit-white')
            .attr('title', FR.i18nText("FS-Generic-Simple_Edit")).css({'display': 'none', float: 'right'})
            .data('type', tNameDesc)
            .hover(function () {
                $(this).addClass('fs-module-edit-white-hover');
            }, function () {
                $(this).removeClass('fs-module-edit-white-hover');
            }).click(function () {
                //编辑按钮的点击事件
                var type = $(this).data('type');
                if (type === FSRM.TNAME_DESC.URL) {
                    //链接编辑事件
                    var title = FR.i18nText("FS-Report-Edit_Link");
                    var data = FR.clone(originaldata);
                    data.parentMobileConfig = self.DIR.getParentMobileConfig();
                    var onOK = function () {
                        return self.DIR._addOrEditLink(data.id.substr(1), data.sortindex, false, data.mobileCoverId);
                    };
                    var onCancel = function () {
                    };
                    self.linkDialog = self.createLinkDialog(title, onOK, onCancel, data);
                    self.linkDialog.setVisible(true);
                    self.linkDialog.getWidgetByName("deviceCheckboxGroup").setValue(
                        FSRM._makeMobileConfigCheckboxValue(data.parentMobileConfig & data.mobileDeviceConfig)
                    );
                } else if (type === FSRM.TNAME_DESC.REPORT) {
                    //模板编辑事件
                    var title = FR.i18nText("FS-Report-Edit_Cpt");
                    var data = FR.clone(originaldata);
                    data.parentMobileConfig = self.DIR.getParentMobileConfig();
                    var onOK = function () {
                        return self.DIR._editCpt(data.id.substr(1), data.sortindex, false, data.mobileCoverId);
                    };
                    var onCancel = function () {
                    };
                    self.cptDialog = self.createCptDialog(title, onOK, onCancel, data);
                    self.cptDialog.setVisible(true);
                    self.cptDialog.getWidgetByName("deviceCheckboxGroup").setValue(
                        FSRM._makeMobileConfigCheckboxValue(data.parentMobileConfig & data.mobileDeviceConfig)
                    );
                } else if (type === FSRM.TNAME_DESC.FILE) {
                    var title = FR.i18nText("FS-Report-Edit_File");
                    var data = FR.clone(originaldata);
                    var onOK = function () {
                        return self.DIR._editFile(data.id.substr(1), data.sortindex);
                    };
                    var onCancel = function () {

                    };
                    self.fileDialog = self.createFileDialog(title, onOK, onCancel, data);
                    self.fileDialog.setVisible(true);
                } else if (type === FSRM.TNAME_DESC.RP) {
                    var title = FR.i18nText("FS-Report-RP_EditLabel");
                    var data = FR.clone(originaldata);
                    var onOK = function () {
                        return self.DIR._addOrEditRP(data.id.substr(1), data.sortindex);
                    };
                    var onCancel = function () {

                    };
                    self.rpDialog = self.createRPDialog(title, onOK, onCancel, data);
                    self.rpDialog.setVisible(true);
                } else {
                    var editors = FS.Plugin.DirectoryContentEditor;
                    for (var i = 0, len = editors.length; i < len; i++) {
                        var editor = editors[i];
                        if (editor.acceptTypeByString(type)) {
                            editor.action.apply(self, [originaldata]);
                        }
                    }
                }
            });
        lineDiv.hover(function () {
            $(this).addClass('fs_reportmgr_table_content_line_hover');
            editDiv.show();
            deleteDiv.show();
        }, function () {
            $(this).removeClass('fs_reportmgr_table_content_line_hover');
            editDiv.hide();
            deleteDiv.hide();
        });
        deleteDiv.appendTo(lineDiv);
        editDiv.appendTo(lineDiv);
    },

    /**
     * 添加超链接
     * @param type
     * @param data
     * @param $oneDataDiv
     * @param originData
     */
    addHyperLink: function (type, data, $oneDataDiv, originData) {
        var url = '#';
        //模板链接
        if (type === FSRM.TNAME_DESC.REPORT) {
            var report = data;
            var ps = report.path.split("/");
            var reportName = ps[ps.length - 1];
            var parameters = {}, tps = report.transmitParameters;
            //模板类型，好像只有这个属性能用来判断是.cpt还是.frm。老版本这里没考虑。
            if (report.nodeicon === FSRM.CONSTS.NODEICONS.CPT) {
                $.extend(parameters, {reportlet: report.path});
            } else if (report.nodeicon === FSRM.CONSTS.NODEICONS.FRM) {
                $.extend(parameters, {formlet: report.path});
            }
            //预览方式op
            if (report.showType === '0') {
                $.extend(parameters, {op: 'write'});
            } else if (report.showType === '1') {
                parameters.op = 'view';
            }
            //url参数
            for (var index = 0, len = tps ? tps.length : 0; index < len; index++) {
                parameters[tps[index].name] = tps[index].value;
            }
            url = FR.buildServletUrl(parameters);
            $('<a target="_blank" href=' + url + '></a>')
                .text(FS.getShowText(reportName, 130, 12, 'SimSun'))
                .attr('title', reportName)
                .appendTo($oneDataDiv);
        }
        //地址链接
        else if (type === FSRM.TNAME_DESC.URL) {
            var address = data;
            //地址解析
            if (address.match(/[a-zA-Z]+:\/\/[^\s]*/)) {
                url = address;
            } else {
                url = FR.server + '/' + address;
            }
            $('<a target="_blank" href=' + encodeURI(url) + '></a>')
                .text(FS.getShowText(address, 130, 12, 'SimSun'))
                .attr('title', address)
                .appendTo($oneDataDiv);
        }
        //数据上报
        else if (type === FSRM.TNAME_DESC.RP) {
            var tdname = FSRM.CONSTS.PROCESSTYPE[data.processType];
            url = FR.buildServletUrl({op: "fs_main", cmd: "entry_report", id: data.id});
            $('<a target="_blank" href=' + url + '></a>')
                .text(FS.getShowText(tdname, 130, 12, 'SimSun'))
                .attr('title', tdname)
                .appendTo($oneDataDiv);
        }
        //8.0挂载的结果报表
        else if (type === FSRM.TNAME_DESC.FILE) {
            var position = data;
            url = FR.buildServletUrl({op: 'fs_main', cmd: 'entry_report', id: originData.id});
            $('<a target="_blank" href=' + url + '></a>')
                .text(FS.getShowText(position, 130, 12, 'SimSun'))
                .attr('title', position)
                .appendTo($oneDataDiv);
        }
        else {
            var editors = FS.Plugin.DirectoryContentEditor;
            for (var i = 0, len = editors.length; i < len; i++) {
                var editor = editors[i];
                if (editor.acceptTypeByString(type)) {
                    editor.hyperlink.apply(this, [$oneDataDiv, data]);
                }
            }
        }
    },

    _getMobileCheckBoxWidth: function () {
        return Math.max(200, 3 * (42 + Math.max(FR.i18nTextWidth("FS-Report-Devices_PC"),
            Math.max(FR.i18nTextWidth("FS-Report-Devices_Tablet"),
                FR.i18nTextWidth("FS-Report-Devices_Phone")))));
    },

    _createMobileCheckBoxItems: function (parentConfig) {
        var items = [
            {value: "1", text: FR.i18nText("FS-Report-Devices_PC")},
            {value: "2", text: FR.i18nText("FS-Report-Devices_Tablet")},
            {value: "4", text: FR.i18nText("FS-Report-Devices_Phone")}
        ];
        if (parentConfig === null) {
            return;
        }
        var config = FSRM._makeMobileConfigCheckboxValue(parentConfig).split(',');
        $.each(items, function (idx, item) {
            if (config.indexOf(item.value) < 0) {
                item.disabled = true;
            }
        });
        return items;
    },

    /**
     * 目录添加对话框
     * @param title
     * @param okCallback
     * @param cancelCallback
     * @param data
     * @returns {*}
     */
    createDirDialog: function (title, okCallback, cancelCallback, data) {
        var self = this;
        var hGap = 10;//标签和文本框之间的间隙
        var labelWidth = parseInt(FR.i18nText("FS-Report-Create_Dir_Dialog_Label_width") || 58);
        return new FR.Dialog({
            title: title,
            text4OK: FR.i18nText("FS-Generic-Simple_OK"),
            text4Cancel: FR.i18nText("Fine-Engine_FS_Generic_Simple_Cancel"),
            onOK: function () {
                okCallback.apply(this);
            },
            onCancel: function () {
                cancelCallback.apply(this);
            },
            destroyOnClose: true,
            animate: false,
            width: self._getMobileCheckBoxWidth() + 100,
            height: 251,
            confirm: true,
            border: true,
            closable: true,
            contentWidget: {
                type: 'absolute',
                items: [
                    {
                        type: 'llabel',
                        value: FR.i18nText("FS-Generic-WF_Name"),
                        height: 21,
                        width: labelWidth,
                        textalign: 'right',
                        x: 0,
                        y: 16
                    },
                    {
                        type: 'text',
                        height: 21,
                        width: 130,
                        widgetName: 'nameText',
                        x: hGap + labelWidth,
                        y: 16
                    },
                    {
                        type: 'llabel',
                        value: FR.i18nText("FS-Generic-Simple_Description"),
                        height: 21,
                        width: labelWidth,
                        textalign: 'right',
                        x: 0,
                        y: 47
                    },
                    {
                        type: 'textarea',
                        height: 85,
                        width: 185,
                        widgetName: 'descriptionText',
                        x: hGap + labelWidth,
                        y: 47
                    },
                    {
                        type: 'llabel',
                        value: FR.i18nText("FS-Report-Simple_Device"),
                        textalign: 'right',
                        widgetName: 'reportDevice',
                        height: 21,
                        width: labelWidth,
                        x: 0,
                        y: 142
                    },
                    {
                        type: 'fscheckboxgroup',
                        columnsInRow: 3,
                        items: self._createMobileCheckBoxItems(data.parentMobileConfig),
                        height: 21,
                        width: self._getMobileCheckBoxWidth(),
                        value: "1,2,4",
                        widgetName: 'deviceCheckboxGroup',
                        x: hGap + labelWidth - 5,
                        y: 141
                    }
                ]
            }
        });
    },

    /**
     * 链接添加对话框
     * @param title
     * @param okCallback
     * @param cancelCallback
     * @param data
     * @returns {*}
     */
    createLinkDialog: function (title, okCallback, cancelCallback, data) {
        var self = this;
        var hGap = 10, labelWidth = parseInt(FR.i18nText("FS-Report-Add_Template_Width") || 58);
        var linkDialog = new FR.Dialog({
            title: title,
            text4OK: FR.i18nText("FS-Generic-Simple_OK"),
            text4Cancel: FR.i18nText("Fine-Engine_FS_Generic_Simple_Cancel"),
            onOK: function () {
                return okCallback.apply(this);
            },
            onCancel: function () {
                cancelCallback.apply(this);
            },
            destroyOnClose: true,
            animate: false,
            width: self._getMobileCheckBoxWidth() + 100,
            height: 291,
            confirm: true,
            border: true,
            closable: true,
            contentWidget: {
                type: 'absolute',
                items: [
                    {
                        type: 'llabel',
                        value: FR.i18nText("FS-Report-Link_Path"),
                        height: 21,
                        width: labelWidth,
                        textalign: 'right',
                        x: 0,
                        y: 16
                    },
                    {
                        type: 'text',
                        height: 21,
                        width: 185,
                        widgetName: 'pathText',
                        x: hGap + labelWidth,
                        y: 16
                    },
                    {
                        type: 'llabel',
                        value: FR.i18nText("FS-Generic-WF_Name"),
                        height: 21,
                        width: labelWidth,
                        textalign: 'right',
                        x: 0,
                        y: 47
                    },
                    {
                        type: 'text',
                        height: 21,
                        width: 185,
                        widgetName: 'nameText',
                        x: hGap + labelWidth,
                        y: 47
                    },
                    {
                        type: 'llabel',
                        value: FR.i18nText("FS-Generic-Simple_Description"),
                        height: 21,
                        width: labelWidth,
                        textalign: 'right',
                        x: 0,
                        y: 78
                    },
                    {
                        type: 'textarea',
                        height: 85,
                        width: 185,
                        widgetName: 'descriptionText',
                        x: hGap + labelWidth,
                        y: 78
                    },
                    {
                        type: 'llabel',
                        value: FR.i18nText("FS-Report-Simple_Device"),
                        textalign: 'right',
                        widgetName: 'reportDevice',
                        height: 21,
                        width: labelWidth,
                        x: 0,
                        y: 173
                    },
                    {
                        type: 'fscheckboxgroup',
                        columnsInRow: 3,
                        items: self._createMobileCheckBoxItems(data.parentMobileConfig),
                        height: 21,
                        width: self._getMobileCheckBoxWidth(),
                        value: "1,2,4",
                        widgetName: 'deviceCheckboxGroup',
                        x: hGap + labelWidth - 5,
                        y: 172
                    }
                ]
            }
        });
        if (data.url) {
            linkDialog.getWidgetByName("pathText").setValue(data.url);
            linkDialog.getWidgetByName("nameText").setValue(data.text);
            linkDialog.getWidgetByName("descriptionText").setValue(data.description);
            linkDialog.getWidgetByName("deviceCheckboxGroup").setValue(
                FSRM._makeMobileConfigCheckboxValue(data.mobileDeviceConfig)
            );
        }
        return linkDialog;
    },


    /**
     * 文件对话框
     * @param title
     * @param okCallback
     * @param cancelCallback
     * @param data
     * @returns {*}
     */
    createFileDialog: function (title, okCallback, cancelCallback, data) {
        var fileDialog = new FR.Dialog({
            title: title,
            text4OK: FR.i18nText("FS-Generic-Simple_OK"),
            text4Cancel: FR.i18nText("Fine-Engine_FS_Generic_Simple_Cancel"),
            onOK: function () {
                return okCallback.apply(this);
            },
            onCancel: function () {
                cancelCallback.apply(this);
            },
            destroyOnClose: true,
            width: 320,
            height: 300,
            confirm: true,
            border: true,
            closable: true,
            contentWidget: {
                type: 'absolute',
                items: [
                    {
                        type: 'llabel',
                        value: FR.i18nText("FS-Report-File_Name"),
                        height: 21,
                        width: FR.i18nTextWidth("FS-Report-File_Name", 6.5) + 6,
                        textalign: 'right',
                        x: 0,
                        y: 16
                    },
                    {
                        type: 'text',
                        height: 21,
                        width: 185,
                        widgetName: 'nameText',
                        x: Math.max(68, FR.i18nTextWidth("FS-Generic-Simple_Layout", 6.5) + 16),
                        y: 16
                    },
                    {
                        type: 'llabel',
                        value: FR.i18nText("FS-Generic-Simple_Description"),
                        height: 21,
                        width: 58,
                        textalign: 'right',
                        x: 0,
                        y: 47
                    },
                    {
                        type: 'textarea',
                        height: 85,
                        width: 185,
                        widgetName: 'descriptionText',
                        x: Math.max(68, FR.i18nTextWidth("FS-Generic-Simple_Layout", 6.5) + 16),
                        y: 47
                    },
                    {
                        type: 'llabel',
                        value: FR.i18nText("FS-Generic-Simple_Layout"),
                        height: 21,
                        width: Math.max(58, FR.i18nTextWidth("FS-Generic-Simple_Layout", 6.5) + 6),
                        textalign: 'right',
                        x: 0,
                        y: 141
                    },
                    {
                        type: 'textarea',
                        height: 85,
                        width: 185,
                        widgetName: 'fileposition',
                        x: Math.max(68, FR.i18nTextWidth("FS-Generic-Simple_Layout", 6.5) + 16),
                        disabled: true,
                        y: 141
                    }
                ]
            }
        });
        if (data) {
            fileDialog.getWidgetByName("nameText").setValue(data.text);
            fileDialog.getWidgetByName("fileposition").setValue(data.path);
            fileDialog.getWidgetByName("descriptionText").setValue(data.description);
        }
        return fileDialog;
    },


    /**
     * 报表添加或编辑对话框
     * @param title
     * @param okCallback
     * @param cancelCallback
     * @param data
     * @returns {*}
     */
    createCptDialog: function (title, okCallback, cancelCallback, data) {
        var self = this;
        var hGap = 10, labelWidth = parseInt(FR.i18nText("FS-Report-Add_Template_Width") || 58);
        var cptDialog = new FR.Dialog({
            title: title,
            text4OK: FR.i18nText("FS-Generic-Simple_OK"),
            text4Cancel: FR.i18nText("Fine-Engine_FS_Generic_Simple_Cancel"),
            onOK: function () {
                return okCallback.apply(this);
            },
            onCancel: function () {
                cancelCallback.apply(this);
            },
            destroyOnClose: true,
            width: 500,
            height: 400,
            confirm: true,
            border: true,
            closable: true,
            contentWidget: {
                type: 'absolute',
                widgetName: 'cptAbsolute',
                scrollable: true,
                items: [
                    {
                        type: 'llabel',
                        value: FR.i18nText("FS-Report-Simple_Path"),
                        height: 21,
                        width: labelWidth,
                        textalign: 'right',
                        x: 0,
                        y: 16
                    },
                    {
                        width: 280,
                        height: 21,
                        widgetUrl: FR.servletURL + "?op=fs_entry&cmd=get_user_reports&form=true&file=cpt,frm&serverID=" + FS.serverID,
                        type: 'treecombobox',
                        returnFullPath: true,
                        allowBlank: false,
                        x: hGap + labelWidth,
                        widgetName: 'pathCombo',
                        selectLeafOnly: true,
                        y: 16,
                        listeners: [{
                            eventName: FR.Events.AFTEREDIT,
                            action: function () {
                                var path = this.getValue();
                                var reportName = path[path.length - 1];
                                if (reportName) {
                                    //Sean: 若是表单，则只能选择预览一种类型
                                    if (reportName.endWith('.frm')) {
                                        cptDialog.getWidgetByName("typeRadioGroup").setValue('2');
                                        cptDialog.getWidgetByName("typeRadioGroup").setEnable(false);
                                        cptDialog.getWidgetByName("reportType").setEnable(false);
                                    } else {
                                        cptDialog.getWidgetByName("typeRadioGroup").setEnable(true);
                                        cptDialog.getWidgetByName("reportType").setEnable(true);
                                    }
                                    //截去文件扩展名
                                    var nameWidget = cptDialog.getWidgetByName("nameText");
                                    nameWidget.validateCss();
                                    nameWidget.setValue(reportName.substr(0, reportName.length - 4));
                                    cptDialog.getWidgetByName("paraSetGrid").reportletPath = path.join('/');
                                }
                            }
                        }]
                    },
                    {
                        type: 'llabel',
                        value: FR.i18nText("FS-Generic-WF_Name"),
                        height: 21,
                        width: labelWidth,
                        textalign: 'right',
                        x: 0,
                        y: 47
                    },
                    {
                        type: 'text',
                        height: 21,
                        width: 280,
                        widgetName: 'nameText',
                        allowBlank: false,
                        autoVerify: true,
                        x: hGap + labelWidth,
                        y: 47
                    },
                    {
                        type: 'llabel',
                        value: FR.i18nText("FS-Generic-Simple_Description"),
                        height: 21,
                        width: labelWidth,
                        textalign: 'right',
                        x: 0,
                        y: 78
                    },
                    {
                        type: 'textarea',
                        height: 85,
                        width: 280,
                        widgetName: 'descriptionText',
                        x: hGap + labelWidth,
                        y: 78
                    },
                    {
                        type: 'llabel',
                        value: FR.i18nText("FS-Report-Simple_Way"),
                        textalign: 'right',
                        widgetName: 'reportType',
                        height: 21,
                        width: labelWidth,
                        x: 0,
                        y: 173
                    },
                    {
                        type: 'radiogroup',
                        assureSelect: true,
                        columnsInRow: 3,
                        items: [
                            {value: '0', text: FR.i18nText("FS-Generic-Face_Write")},
                            {value: '1', text: FR.i18nText("FS-Report-Simple_Analysis")},
                            {value: '2', text: FR.i18nText("FS-Generic-Simple_Preview")}
                        ],
                        height: 21,
                        width: 200,
                        value: '2',
                        widgetName: 'typeRadioGroup',
                        x: hGap + labelWidth,
                        y: 173
                    },
                    {
                        type: 'llabel',
                        value: FR.i18nText("FS-Report-Simple_Device"),
                        textalign: 'right',
                        widgetName: 'reportDevice',
                        height: 21,
                        width: labelWidth,
                        x: 0,
                        y: 204
                    },
                    {
                        type: 'fscheckboxgroup',
                        columnsInRow: 3,
                        items: self._createMobileCheckBoxItems(data.parentMobileConfig),
                        height: 21,
                        width: 200,
                        value: "1,2,4",
                        widgetName: 'deviceCheckboxGroup',
                        x: hGap + labelWidth - 5,
                        y: 203
                    },
                    {
                        type: 'llabel',
                        value: FR.i18nText("FS-Generic-Parameter_Setting"),
                        textalign: 'right',
                        height: 30,
                        width: labelWidth,
                        x: 0,
                        y: 235
                    },
                    {
                        type: "parametergrid",
                        widgetName: "paraSetGrid",
                        width: 385,
                        x: hGap + labelWidth,
                        y: 235
                    }
                ]
            }
        });
        cptDialog.getWidgetByName('cptAbsolute').doLayout();
        //编辑目录时有初始数据
        if (data.path) {
            cptDialog.getWidgetByName("pathCombo").setValue(data.path);
            cptDialog.getWidgetByName("nameText").setValue(data.text);
            cptDialog.getWidgetByName("descriptionText").setValue(data.description);
            cptDialog.getWidgetByName("typeRadioGroup").setValue(data.showType);
            cptDialog.getWidgetByName("deviceCheckboxGroup").setValue(
                FSRM._makeMobileConfigCheckboxValue(data.mobileDeviceConfig)
            );
            cptDialog.getWidgetByName("paraSetGrid").popData(data.transmitParameters);
        }
        // 调整部分组件的宽度
        this.fixBtnGroupWidth(cptDialog.getWidgetByName("typeRadioGroup"));
        this.fixBtnGroupWidth(cptDialog.getWidgetByName("deviceCheckboxGroup"));
        return cptDialog;
    },

    View: {

        /**
         * 总步数：选择路径和配置两步
         */
        setTotalStep: 2,

        /**
         * 报表批量添加对话框
         * @param step
         */
        createBatchCptDialog: function (step) {
            FSRM.View.batAddReportDialog = new FR.Dialog({
                title: FR.i18nText("FS-Report_Batch_Add_Cpt"),               // 对话框的标题
                widgetName: 'batAddReportDialog',
                width: 500,                 // 对话框的宽度
                height: 500,                // 对话框的高度
                modal: true,                // 是否是模态对话框（模态对话框将只有最上层的对话框可以被选中）
                border: true,               // 对话框是否需要包含边框
                closable: true,             // 对话框是否可以被关闭，某些情况下需要通过API进行关闭此选项可以为false
                style: "blue",
                //关闭即销毁 防止遗留的dom影响下一次隐藏或者显示时选择器的工作。
                destroyOnClose: true,
                resizeable: false,
                needSeparate: 8,
                otherButton: true,
                button4Other: [{
                    bT: FR.i18nText("FS-Generic-Simple_Next"),
                    bW: 80,
                    baseCls: 'nextButton',
                    bF: function () {
                        FSRM.View._move2NextStep();
                    }
                }, {
                    bT: FR.i18nText("FS-Generic-Simple_Previous"),
                    bW: 80,
                    invisible: true,
                    baseCls: 'preButton',
                    bF: function () {
                        FSRM.View._move2PreStep();
                    }
                }],
                onCancel: function () {
                    FSRM.Cache.clearSelectedNodesCache();
                    FSRM.Cache.clearDetailConfigCache();
                },
                contentWidget: {
                    width: 500,
                    type: 'card',
                    items: [
                        FSRM.View.createFirstMultiSelectTreeConfig(),
                        FSRM.View.createSecondPathDetailConfig()
                    ],
                    widgetName: 'batAddReportDialogCard',
                    defaultShowIndex: step
                },
                onBeforeClose: function () {
                    $.each(FSRM.View.ajaxHolder, function (index, itemName) {
                        var comboTree = FSRM.View.batAddReportDialog.getWidgetByName(itemName);
                        comboTree._showView = FR.emptyFn;//REPORT-5265
                    });
                    FSRM.View.ajaxHolder = [];
                }
            });
            //batAddReportDialog拿不到cardLayout showCardByIndex(index) index 步上的组件。
            FSRM.View.cardLayout = FSRM.View.batAddReportDialog.getWidgetByName('batAddReportDialogCard');

            FSRM.View.batAddReportDialog.element.css({'color': '#000000'});
            FSRM.View.batAddReportDialog.setVisible(true);

            //样式调整
            var $title = $('div.dialog_title:visible');
            $title.css('top', '15px');
            if (FSRM.View.cardLayout.showIndex === 1) {
                $title.next().css({'overflow-y': 'scroll', 'overflow-x': 'hidden'});
            }

            if (step === 0) {
                //cache all nodes
                var treeComboboxWidget = FSRM.View.cardLayout.getWidgetByName('fsTableTreeReportletWithCheckBox');
                var allNodes = FS.Sync.ajax({
                    url: FR.servletURL + "?op=fs_entry&cmd=get_user_reports&form=true&file=cpt,frm",
                    data: {
                        serverID: FS.serverID
                    },
                    type: 'POST'
                });
                FSRM.Cache.AllNodes = treeComboboxWidget.options.setting.async.dataFilter("fsTableTreeReportlet", allNodes, allNodes, []);
            }
        },

        /**
         * 创建/编辑定时任务弹出对话框的标题
         */
        createMultiStepsTitle: function (step) {
            //标题栏
            var titleClass = "dialog_title";
            var titleSelectedClass = "dialog_title_selected";
            var first_div = $('<div/>').text(FR.i18nText("FS-Report-Select_Path"));
            var first_title_point_div = $('<div class="fs_reportmgr_next_step"/>').html('&rsaquo;');
            var marginLeft = 15 + "px";
            var second_div = $('<div/>').text(FR.i18nText("FS-Report-Add_Set_Config")).css({
                'margin-left': marginLeft
            });
            var second_title_point_div = $('<div class="fs_reportmgr_next_step"/>');
            var title_div = $('<div/>').addClass(titleClass);
            first_div.appendTo(title_div);
            first_title_point_div.appendTo(title_div);
            second_div.appendTo(title_div);
            second_title_point_div.appendTo(title_div);
            switch (step) {
                case 1:
                    first_div.addClass(titleSelectedClass);
                    break;
                case 2:
                    second_div.addClass(titleSelectedClass);
                    break;
            }
            first_div.css({
                'margin-left': '165px'
            });
            return title_div;
        },


        /**
         * 第一步路径选择
         * @returns {{type: string, columnSize: [string], scrolly: boolean, rowSize: [number,number,number,number], vgap: number, widgetName: string, items: [*,*,*,*]}|*}
         */
        createFirstMultiSelectTreeConfig: function () {
            var self = this;
            FSRM.View.FirstStepPanel = {
                type: 'border',
                widgetName: 'firstMultiSelectedTree',
                items: [
                    {
                        region: 'north',
                        height: 50,
                        el: self.createMultiStepsTitle(1)
                    },
                    {
                        region: 'center',
                        //这边高度设置是没有用的，具体可以看 BorderLayout 源码 当前值是计算出来的371
                        height: 371,
                        el: self.createSearchReportletTreePanel()
                    }
                ]
            };
            return FSRM.View.FirstStepPanel;
        },

        /**
         *创建第一步多选树
         * @returns {{el: {type: string, fit: boolean, width: number, height: number, border: boolean, contentWidget: {type: string, items: [*,*], width: number}}}}
         */
        createSearchReportletTreePanel: function () {

            var self = this;
            var reportTableTreeSetting = self.createReportletTableTreeSetting(FR.emptyFn());
            var searchKeyupFunction = function (e) {
                (function () {
                    var val = this.getValue();
                    var entryNode = self.batAddReportDialog.getWidgetByName('fsTableTreeReportletWithCheckBox');
                    var result = FS.Sync.ajax({
                        url: FR.servletURL + "?op=fs_entry&cmd=get_user_reports&form=true&file=cpt,frm",
                        data: {
                            searchKeyword: val,
                            serverID: FS.serverID
                        },
                        type: 'POST'
                    });
                    var newTreeNodes = entryNode.options.setting.async.dataFilter("fsTableTreeReportlet", result, result, []);
                    var allOldNodes = entryNode.getNodes();
                    var allOldNodesNum = allOldNodes.length;
                    //刷新Tree 清空旧的添加新的
                    for (var i = 0; i < allOldNodesNum; i++) {
                        entryNode.removeNode(allOldNodes[0]);
                    }
                    entryNode.addNodes(null, newTreeNodes, true);
                }).createDelegate(this).defer(500);
            };
            var tools = [{
                name: 'check',
                onToolClick: function (e, treeNode, isSelect) {
                    var selectedNodes =
                        FSRM.View.cardLayout.getWidgetByName('fsTableTreeReportletWithCheckBox').getAllSelectedLeafNodes();
                    FSRM.Cache.updateSelectedNodesCache(selectedNodes);
                    e.stopEvent();
                }
            }];
            var items = [
                {
                    region: 'north',
                    el: {
                        type: 'search',
                        width: 498,
                        autoSearch: true,
                        onKeyup: searchKeyupFunction
                    },
                    height: 28
                },
                {
                    region: 'center',
                    el: {
                        type: 'panel',
                        width: 498,
                        height: 343,
                        border: false,
                        contentWidget: {
                            type: 'fstabletree',
                            width: 498,
                            height: 343,
                            treeID: 'fsTableTreeReportletWithCheckBox',
                            widgetName: 'fsTableTreeReportletWithCheckBox',
                            setting: reportTableTreeSetting,
                            alwaysShowTools: true,
                            toolMargin: 10,
                            tools: tools,
                            tooltype: 'check',
                            onItemToolClick: function (currentTreeNode) {
                                //在onToolClick执行后才执行
                            }
                        }
                    }
                }
            ];

            return {
                type: 'panel',
                width: 498,
                height: 371,
                border: false,
                contentWidget: {
                    type: 'border',
                    items: items,
                    width: 400
                }
            };
        },

        /**
         * 第二步路径配置
         * @returns {{type: string, columnSize: [number,number,string], scrolly: boolean, rowSize: [number,number,number], vgap: number, widgetName: string, items: [*,*,*]}|*}
         */
        createSecondPathDetailConfig: function () {
            var self = this;
            var initCount = FSRM.INIT_COUNT;
            var cachedData = FSRM.Cache.getSelectedNodesCache();
            var realItems = [];
            FSRM.View.ajaxHolder = [];
            var initializedCount = 0;
            for (; initializedCount < Math.min(cachedData.length, initCount); initializedCount++) {
                realItems = realItems.concat(FSRM.View.createReportletDetailConfig(cachedData[initializedCount], initializedCount));
            }

            var lazyLoadItem = function () {
                if (initializedCount < cachedData.length) {
                    var items = FSRM.View.createReportletDetailConfig(cachedData[initializedCount], initializedCount);
                    initializedCount++;
                    //增加最后一个组件的高度，防止被对话框按钮组遮挡
                    if (initializedCount === cachedData.length) {
                        items[items.length - 1].height = 120;
                    }
                    return items;
                }
            };

            FSRM.View.SecondStepPanel = {
                type: 'border',
                items: [
                    {
                        region: 'north',
                        height: 50,
                        el: self.createMultiStepsTitle(2)
                    }, {
                        region: 'center',
                        //这边高度设置是没有用的，具体可以看 BorderLayout 源码 当前值是计算出来的371
                        height: 371,
                        el: {
                            type: 'lazyabsolute',
                            scrollable: true,
                            widgetName: 'secondMultiConfigPanel',
                            items: realItems,
                            listeners: [{
                                eventName: FR.Events.AFTERINIT,
                                action: function () {
                                    var self = this;
                                    this.element.on('scroll', _.debounce(function () {
                                            var item = lazyLoadItem();
                                            if (item !== undefined) {
                                                var data = cachedData[initializedCount - 1];
                                                var fsView = FSRM.View;
                                                self.lazyAddItem(item);
                                                fsView.setSelectedValue(data, fsView.cardLayout);
                                            }
                                        }, 100)
                                    );
                                }
                            }]
                        }
                    }
                ]
            };
            return FSRM.View.SecondStepPanel;
        },


        /**
         * 报表路径详细信息配置
         * TODO 批量添加选择的报表非常多的时候前端页面生成的性能问题
         * @param cacheData
         * @param index
         * @return {[*,*,*,*,*,*,*,*,*,*,*,*,*]}
         */
        createReportletDetailConfig: function (cacheData, index) {
            FSRM.View.ajaxHolder.push('pathCombo_' + cacheData.id + "widgetName");
            var title_offset = 40;
            var index_offset = 320 * index;
            var parentMobileConfig = FSRM.DIR.getParentMobileConfig();
            var id = cacheData.id;
            var configTitle = FS.getShowText(cacheData.name.replace(/.\w+$/, ''), 300, 15, '"Microsoft YaHei",' +
                ' STXihei, SimSun, sans-serif');
            var hGap = 10, labelWidth = parseInt(FR.i18nText("FS-Report-Add_Template_Width") || 58);
            //标记一下已经被展示出来了
            cacheData.inited = true;

            return [
                //text
                {
                    type: 'label',
                    widgetName: "-title_" + id + "widgetName",
                    width: 498,
                    height: 40,
                    value: configTitle,
                    textalign: 'left',     //对齐方式
                    border: false,     //是否有边框
                    cls: 'fs_config_title',
                    x: 0,
                    y: index_offset,
                    listeners: [{
                        eventName: FR.Events.AFTERINIT,
                        action: function () {
                            this.element.css('cursor', 'pointer');
                            this.element.on({
                                mouseenter: function () {
                                    $('div[widgetName="-delete_' + id + 'widgetName"]').mouseenter();
                                },
                                mouseleave: function () {
                                    $('div[widgetName="-delete_' + id + 'widgetName"]').mouseleave();
                                },
                                click: function () {
                                    $('div[widgetName="-hide_' + id + 'widgetName"]').click();
                                }
                            });
                        }
                    }]
                },
                //tips
                {
                    type: 'iconbutton',
                    widgetName: "-tips_" + id + "widgetName",
                    width: 16,
                    height: 16,
                    baseClass: 'fs-report-title-tips',
                    title: FR.i18nText('FS-Report_Has_Invalid_Value_To_Fill'),
                    x: 435,
                    y: index_offset + 20,
                    listeners: [{
                        eventName: FR.Events.AFTERINIT,
                        action: function () {
                            this.element.hide();
                        }
                    }]
                },
                //hide 虽然不显示这个按钮了，留着用于标记状态，而且复用代码
                {
                    type: 'iconbutton',
                    widgetName: "-hide_" + id + "widgetName",
                    width: 16,
                    height: 16,
                    baseClass: 'fs-report-title-hide',
                    handler: function () {
                        var $this = $(this.element);
                        var $container = $('div[widgetName="secondMultiConfigPanel"]');
                        //当前（要隐藏的）不包括title的其他组件
                        var $currents = $container.find('div[widgetName$="_' + id + 'widgetName"]')
                            .not('div[widgetName^="-"]');
                        //当前的参数控件
                        var $param = $('div[widgetName="paraSetGrid_' + id + 'widgetName"]');
                        //之后的所有组件
                        var $nextAll = $param.nextAll('div[widgetName$="widgetName"]');
                        //借用iconbutton对象保存 首尾距离
                        var distance = this.headTailDistance;
                        if ($this.hasClass('fs-report-title-hide')) {
                            //当前'pathLabel_' + id + "widgetName" top
                            var $currentPath = $('div[widgetName="pathLabel_' + id + 'widgetName"]');
                            var head = $currentPath.css('top');
                            //下一个"-title_" + id + "widgetName" top
                            var $nextTitle = $param.next('div');
                            //首尾距离
                            distance = parseInt($nextTitle.css('top')) - parseInt(head);
                            this.headTailDistance = distance;
                            //隐藏当前
                            $currents.hide();
                            //把后面的位置都往上挪 distance px 加上 自定义的20 px 让两个标题距离更近一点
                            $nextAll.css('top', '-=' + (distance + 20));
                            $this.removeClass('fs-report-title-hide').addClass('fs-report-title-more');

                            //不显示这个按钮了，隐藏起来
                            $this.css('display', 'none');
                        } else {
                            //把后面的位置都往下挪 distance px
                            $nextAll.css('top', '+=' + (distance + 20));
                            //显示当前
                            $currents.show();
                            $this.removeClass('fs-report-title-more').addClass('fs-report-title-hide');
                            //不显示这个按钮了，隐藏起来
                            $this.css('display', 'none');
                        }
                    },
                    x: 415,
                    y: index_offset + 20,
                    listeners: [{
                        //创建后隐藏该按钮
                        eventName: FR.Events.AFTERINIT,
                        action: function () {
                            this.element.hide();
                        }
                    }]
                },
                //delete
                {
                    type: 'iconbutton',
                    widgetName: "-delete_" + id + "widgetName",
                    width: 16,
                    height: 16,
                    baseClass: 'fs-report-title-delete',
                    handler: function () {
                        FR.Msg.confirm(FR.i18nText("Fine-Engine_FS_Frame_Delete_Data"), FR.i18nText("FS-Generic-Sure_To_Delete") + '?', function (result) {
                            if (result) {
                                //当前parameter grid widget
                                var $currentParam = $('div[widgetName="paraSetGrid_' + id + 'widgetName"]');
                                //当前title的top
                                var current = $('div[widgetName="-title_' + id + 'widgetName"]').css('top');
                                //下一个title按钮的top
                                var next = $currentParam.next().css('top');
                                //距离
                                var distance = parseInt(next) - parseInt(current);
                                //删除dom后上移的内容
                                var $allBellow = $currentParam.nextAll('div[widgetName$="widgetName"]');
                                //删除dom
                                $('div[widgetName$="_' + id + 'widgetName"]').remove();
                                //借助pathComboboxTree 组件来标记已经被删除，提交数据的时候跳过
                                FSRM.View.cardLayout.getWidgetByName('pathCombo_' + id + "widgetName")['deleted' + id] = true;
                                FSRM.View.ajaxHolder = _.filter(FSRM.View.ajaxHolder, function (name) {
                                    return name !== 'pathCombo_' + id + "widgetName";
                                });
                                //上移
                                $allBellow.css('top', '-=' + distance);
                                //删除缓存的第一步选中节点
                                FSRM.Cache.deleteSelectedNodeCacheByID(id);
                                //如果都删完了那么就返回第一步
                                if (FSRM.Cache.getSelectedNodesCache().length === 0) {
                                    FSRM.View._move2PreStep();
                                }
                            }
                        });
                    },
                    x: 455,
                    y: index_offset + 20
                },
                //path
                {
                    type: 'llabel',
                    value: FR.i18nText("FS-Report-Simple_Path"),
                    widgetName: 'pathLabel_' + id + "widgetName",
                    height: 21,
                    width: labelWidth,
                    textalign: 'right',
                    x: 0,
                    y: index_offset + 16 + title_offset
                },
                {
                    width: 280,
                    height: 21,
                    widgetUrl: FR.servletURL + "?op=fs_entry&cmd=get_user_reports&form=true&file=cpt,frm&serverID=" + FS.serverID,
                    type: 'treecombobox',
                    allowBlank: false,
                    returnFullPath: true,
                    x: hGap + labelWidth,
                    widgetName: 'pathCombo_' + id + "widgetName",
                    selectLeafOnly: true,
                    y: index_offset + 16 + title_offset,
                    listeners: [
                        {
                            eventName: FR.Events.AFTEREDIT,
                            action: function () {
                                var cardLayout = FSRM.View.cardLayout;
                                var path = this.getValue();
                                var reportName = path[path.length - 1];
                                if (reportName) {
                                    if (reportName.endWith('.frm')) {
                                        cardLayout.getWidgetByName('typeRadioGroup_' + id + 'widgetName').setValue('2');
                                        cardLayout.getWidgetByName('typeRadioGroup_' + id + 'widgetName').setEnable(false);
                                        cardLayout.getWidgetByName('reportType_' + id + 'widgetName').setEnable(false);
                                    } else {
                                        cardLayout.getWidgetByName('typeRadioGroup_' + id + 'widgetName').setEnable(true);
                                        cardLayout.getWidgetByName('reportType_' + id + 'widgetName').setEnable(true);
                                    }
                                    //获取文件名，不含扩展名
                                    var titleName = reportName.substring(reportName.lastIndexOf('/') + 1, reportName.length - 4);
                                    //赋值给name
                                    var nameTextWidget = cardLayout.getWidgetByName('nameText_' + id + 'widgetName');
                                    nameTextWidget.validateCss();
                                    nameTextWidget.setValue(titleName);
                                    cardLayout.getWidgetByName('paraSetGrid_' + id + 'widgetName').reportletPath = path.join('/');
                                    //赋值给title
                                    var title = FS.getShowText(titleName, 300, 15, '"Microsoft YaHei",' +
                                        ' STXihei, SimSun, sans-serif');
                                    cardLayout.getWidgetByName("-title_" + id + "widgetName").setValue(title);
                                }
                                FSRM.Cache.updateSelectedNodeCacheByID(id, path.join('/'));
                            }
                        },
                        {
                            eventName: FR.Events.STOPEDIT,
                            action: function () {
                                //名字是否非法
                                var invalidName = $('div[widgetName="nameText_' + id + 'widgetName"]').find('input').hasClass('fr-invalid');
                                //路径是否合法
                                var invalidPath = this.element.find('input').hasClass('fr-invalid');
                                //显示或隐藏提示
                                if (invalidName || invalidPath) {
                                    $('div[widgetName="-tips_' + id + 'widgetName"]').show();
                                } else {
                                    $('div[widgetName="-tips_' + id + 'widgetName"]').hide();
                                }
                            }
                        }]
                },
                {
                    type: 'llabel',
                    value: FR.i18nText("FS-Generic-WF_Name"),
                    widgetName: 'nameLabel_' + id + "widgetName",
                    height: 21,
                    width: labelWidth,
                    textalign: 'right',
                    x: 0,
                    y: index_offset + 47 + title_offset
                },
                {
                    type: 'text',
                    height: 21,
                    width: 280,
                    widgetName: 'nameText_' + id + "widgetName",
                    allowBlank: false,
                    autoVerify: true,
                    x: hGap + labelWidth,
                    y: index_offset + 47 + title_offset,
                    listeners: [
                        {
                            eventName: FR.Events.AFTEREDIT,
                            action: function () {
                                var cardLayout = FSRM.View.cardLayout;
                                var title = FS.getShowText(this.getValue(), 300, 15, '"Microsoft YaHei",' +
                                    ' STXihei, SimSun, sans-serif');
                                cardLayout.getWidgetByName("-title_" + id + "widgetName").setValue(title);
                            }
                        }, {
                            eventName: FR.Events.STOPEDIT,
                            action: function () {
                                //路径是否非法
                                var invalidPath = $('div[widgetName="pathCombo_' + id + 'widgetName"]').find('input').hasClass('fr-invalid');
                                //名字是否合法
                                var invalidName = this.element.find('input').hasClass('fr-invalid');
                                //显示或隐藏提示
                                if (invalidName || invalidPath) {
                                    $('div[widgetName="-tips_' + id + 'widgetName"]').show();
                                } else {
                                    $('div[widgetName="-tips_' + id + 'widgetName"]').hide();
                                }
                            }
                        }]
                },
                //desc
                {
                    type: 'llabel',
                    value: FR.i18nText("FS-Generic-Simple_Description"),
                    widgetName: 'descLabel_' + id + "widgetName",
                    height: 21,
                    width: labelWidth,
                    textalign: 'right',
                    x: 0,
                    y: index_offset + 78 + title_offset
                },
                {
                    type: 'textarea',
                    height: 85,
                    width: 280,
                    widgetName: 'descriptionText_' + id + "widgetName",
                    x: hGap + labelWidth,
                    y: index_offset + 78 + title_offset
                },
                //type
                {
                    type: 'llabel',
                    value: FR.i18nText("FS-Report-Simple_Way"),
                    textalign: 'right',
                    widgetName: 'reportType_' + id + "widgetName",
                    height: 21,
                    width: labelWidth,
                    x: 0,
                    y: index_offset + 173 + title_offset
                },
                {
                    type: 'radiogroup',
                    assureSelect: true,
                    columnsInRow: 3,
                    items: [
                        {value: '0', text: FR.i18nText("FS-Generic-Face_Write")},
                        {value: '1', text: FR.i18nText("FS-Report-Simple_Analysis")},
                        {value: '2', text: FR.i18nText("FS-Generic-Simple_Preview")}
                    ],
                    height: 21,
                    width: 200,
                    value: '2',
                    widgetName: 'typeRadioGroup_' + id + "widgetName",
                    x: hGap + labelWidth,
                    y: index_offset + 173 + title_offset
                },
                //showtype
                {
                    type: 'llabel',
                    value: FR.i18nText("FS-Report-Simple_Device"),
                    textalign: 'right',
                    widgetName: 'reportDevice_' + id + "widgetName",
                    height: 21,
                    width: labelWidth,
                    x: 0,
                    y: index_offset + 204 + title_offset
                },
                {
                    type: 'fscheckboxgroup',
                    columnsInRow: 3,
                    items: FSRM._createMobileCheckBoxItems(parentMobileConfig),
                    height: 21,
                    width: 200,
                    value: "1,2,4",
                    widgetName: 'deviceCheckboxGroup_' + id + "widgetName",
                    x: hGap + labelWidth - 5,
                    y: index_offset + 204 + title_offset
                },
                //parameter
                {
                    type: 'llabel',
                    value: FR.i18nText("FS-Generic-Parameter_Setting"),
                    widgetName: 'paramLabel_' + id + "widgetName",
                    textalign: 'right',
                    height: 30,
                    width: labelWidth,
                    x: 0,
                    y: index_offset + 235 + title_offset
                },
                {
                    type: 'parametergrid',
                    widgetName: 'paraSetGrid_' + id + "widgetName",
                    width: 300,
                    onRowClick: function () {
                        if (!this.currentHeight) {
                            this.currentHeight = 32;
                        }
                        var distance = this.el.el.height() - this.currentHeight;
                        //当前的参数控件之后的所有组件位置挪 distance px
                        $('div[widgetName="paraSetGrid_' + id + 'widgetName"]')
                            .nextAll('div[widgetName$="widgetName"]')
                            .css('top', '+=' + distance);
                        this.currentHeight = this.el.el.height();
                    },
                    x: hGap + labelWidth,
                    y: index_offset + 235 + title_offset
                }
            ];
        },

        /**
         *
         * @param cacheData
         * @returns {{parentId: string, description, path: string, text, showType, mobileDeviceConfig: (* | number), transmitParameters: (string | *), hasDeleted: boolean}}
         */
        getReportDialogValue: function (cacheData) {
            var id = cacheData.id;
            //获取要添加进的目录id
            var pd = FSRM.DIR.dirTabletree.getSelectedNodes()[0].id.substr(1);
            if (cacheData.inited === true) {
                // 由于页面上的内容可能经过用户修改 id只是用来获取页面上的内容
                var cardLayout = FSRM.View.cardLayout;
                var hasDeleted = false;
                if (cardLayout.getWidgetByName('pathCombo_' + id + 'widgetName')['deleted' + id]) {
                    //在第二步时该数据被删除了
                    hasDeleted = true;
                }
                var pathWidget = cardLayout.getWidgetByName('pathCombo_' + id + 'widgetName');
                //如果路径被修改且正在搜索，那么路径就不取值，在校验时当作非法值处理
                var path = pathWidget.editComp.val() === '' ? undefined : pathWidget.getValue().join('/');
                var name = cardLayout.getWidgetByName('nameText_' + id + 'widgetName').getValue();
                var description = cardLayout.getWidgetByName('descriptionText_' + id + 'widgetName').getValue();
                var showType = cardLayout.getWidgetByName('typeRadioGroup_' + id + 'widgetName').getValue();
                var mobileDeviceConfig = FSRM._makeMobileDeviceConfig(
                    cardLayout.getWidgetByName('deviceCheckboxGroup_' + id + 'widgetName').getValue()
                );
                var transmitParameters = cardLayout.getWidgetByName('paraSetGrid_' + id + 'widgetName').getData();
                return {
                    parentId: pd,
                    description: description,
                    path: path,
                    text: name,
                    showType: showType,
                    mobileDeviceConfig: mobileDeviceConfig,
                    transmitParameters: transmitParameters,
                    hasDeleted: hasDeleted,
                    inited: true
                };
            } else {
                return {
                    parentId: pd,
                    description: "",
                    path: cacheData.path,
                    text: cacheData.name.split('.')[0],
                    showType: FSRM.DEFAULT_SHOWTYPE,
                    mobileDeviceConfig: FSRM.DEFAULT_MOBILE,
                    transmitParameters: [],
                    hasDeleted: false,
                    inited: false
                };
            }
        },

        createReportletTableTreeSetting: function (clickFunc) {
            //result filter
            function filter(parentNodeID, node, items, results) {
                if (!items) {
                    return null;
                }
                if (!results) {
                    results = [];
                }

                //data refactor
                function dataRefactor(items, parentID, results) {
                    for (var i = 0, l = items.length; i < l; i++) {
                        var item = items[i];
                        //不含有reportlet文件的文件夹跳过
                        if (item.ChildNodes && item.hasChildren === true && item.ChildNodes.length === 0) {
                            continue;
                        }
                        var result = {};
                        result.id = item.id;
                        result.pId = parentID;
                        result.name = item.text;
                        result.open = false;
                        result.type = 2;
                        result.description = item.value;
                        result.path = item.path;
                        if (item.ChildNodes && item.ChildNodes.length > 0) {
                            dataRefactor(item.ChildNodes, item.id, results);
                        }
                        if (isAlreadyExists(result.id, results)) {
                            continue;
                        }
                        results.push(result);
                    }
                }

                // all nodes are root's[0-1] children
                dataRefactor(items, '0-1', results);
                return results;
            }

            //Determine whether id included in results or not
            function isAlreadyExists(id, results) {
                for (var i = 0; i < results.length; i++) {
                    if (results[i].id === id) {
                        return true;
                    }
                }
                return false;
            }

            return {
                async: {
                    enable: true,
                    url: FR.servletURL + "?op=fs_entry&cmd=get_user_reports&form=true&file=cpt,frm",
                    dataFilter: filter,
                    data: {
                        serverID: FS.serverID
                    }
                },
                view: {
                    showIcon: false,
                    selectedMulti: true
                },
                data: {
                    simpleData: {
                        enable: true,
                        idKey: "id",
                        pidKey: "pId",
                        rootPId: "0-1"
                    }
                },
                callback: {
                    onClick: clickFunc,
                    beforeClick: function () {
                        return false;
                    }
                }
            };
        },
        /**
         * 点击下一步或者完成按钮 执行跳转到下一步
         * @private
         */
        _move2NextStep: function () {
            var cardLayout = FSRM.View.cardLayout;
            var currentStep = cardLayout.showIndex;
            if (currentStep === this.setTotalStep - 1) {
                // submit and save data
                var cacheData = FSRM.Cache.getSelectedNodesCache();
                var reports = [];
                for (var i = 0; i < cacheData.length; i++) {
                    var report = FSRM.View.getReportDialogValue(cacheData[i]);
                    if (!FSRM.View._isReportValid(report)) {
                        return;
                    }
                    reports.push(report)
                }
                FSRM.DIR._addCpt(reports);

                FSRM.View.batAddReportDialog.doClose();
                return;
            }
            if (FSRM.Cache.getSelectedNodesCache().length === 0) {
                FR.Msg.alert(FR.i18nText("Fine-Engine_FS_Generic_Simple_Alert"), FR.i18nText("FS-Report_Choose_Add_Item"));
                return;
            }

            //动态更新下一步
            cardLayout.options.items[currentStep + 1] = FSRM.View.createSecondPathDetailConfig();
            cardLayout.cardsHasCreated = [currentStep];

            //显示第二步
            cardLayout.showCardByIndex(currentStep + 1);
            //set default path value and cached configs
            this.setSelectedValues(cardLayout);

            //样式调整
            var $title = $('div.dialog_title:visible');
            $title.css('top', '15px');
            if (cardLayout.showIndex === 1) {
                $title.next().css({'overflow-y': 'scroll', 'overflow-x': 'hidden'});
            }

            $(".preButton").show();
            //modify next step button to submit button
            if (currentStep + 1 === this.setTotalStep - 1) {
                $('.nextButton').find('span').text(FR.i18nText("FS-Generic-Simple_Submit"));
            }
        },

        /**
         * 绑定第一步选中路径的值到第二步页面
         * @private
         */
        setSelectedValues: function (cardLayout) {
            var data = FSRM.Cache.getSelectedNodesCache();
            var initCount = FSRM.INIT_COUNT;
            for (var i = 0; i < Math.min(data.length, initCount); i++) {
                this.setSelectedValue(data[i], cardLayout);
            }
            cardLayout.doLayout();
        },

        setSelectedValue: function (data, cardLayout) {
            //赋初始化值
            cardLayout.getWidgetByName('pathCombo_' + data.id + 'widgetName').setValue(data.path);
            //赋上缓存的旧值
            var configData = FSRM.Cache.getDetailConfigCache();
            for (var j = 0; j < configData.length; j++) {
                if (configData[j].path === data.path) {
                    cardLayout.getWidgetByName('nameText_' + data.id + 'widgetName').setValue(configData[j].text, false);
                    cardLayout.getWidgetByName('descriptionText_' + data.id + 'widgetName').setValue(configData[j].description, false);
                    cardLayout.getWidgetByName("typeRadioGroup_" + data.id + 'widgetName').setValue(configData[j].showType, false);
                    cardLayout.getWidgetByName("deviceCheckboxGroup_" + data.id + 'widgetName').setValue(
                        FSRM._makeMobileConfigCheckboxValue(configData[j].mobileDeviceConfig), false
                    );
                    cardLayout.getWidgetByName("paraSetGrid_" + data.id + 'widgetName').popData(configData[j].transmitParameters);
                    break;
                }
            }
        },

        /**
         *第二步配置所必须信息是否都完成填写，以及是否在第二步时被删除了
         * @param report
         * @returns {boolean}
         */
        _isReportValid: function (report) {
            if (report.hasDeleted) {
                return false;
            }
            var path = report.path;
            var name = report.text;
            var showType = report.showType;
            if (!path && !name) {
                FR.Msg.alert(FR.i18nText("Fine-Engine_FS_Generic_Simple_Alert"), FR.i18nText("FS-Report-Input_Cpt_Path_And_Name"));
                return false;
            }
            if (!path) {
                FR.Msg.alert(FR.i18nText("Fine-Engine_FS_Generic_Simple_Alert"), FR.i18nText("FS-Report-Input_Cpt_Path"));
                return false;
            }
            if (!name) {
                FR.Msg.alert(FR.i18nText("Fine-Engine_FS_Generic_Simple_Alert"), FR.i18nText("FS-Report-Input_Cpt_Name"));
                return false;
            }
            if (showType === "") {
                FR.Msg.alert(FR.i18nText("FS-Report-Choose_ViewType"));
                return false;
            }
            return true;
        },

        /**
         * 点击上一步按钮执行跳转到上一步
         * @private
         */
        _move2PreStep: function () {
            var cardLayout = FSRM.View.cardLayout;
            var cacheData = FSRM.Cache.getSelectedNodesCache();

            //cache second step reportlet path detail configs
            var cacheConfig = [];
            var initCount = FSRM.INIT_COUNT;
            for (var i = 0; i < cacheData.length; i++) {
                var report = FSRM.View.getReportDialogValue(cacheData[i]);
                if (report.hasDeleted === true) {
                    //被删除了，不再cache
                    continue;
                }
                cacheConfig.push(report)
            }
            FSRM.Cache.updateDetailConfigCache(cacheConfig);

            var currentStep = cardLayout.showIndex;
            if (currentStep === this.setTotalStep - 1) {
                //show next button, hide submit button
                $('.nextButton').find('span').text(FR.i18nText("FS-Generic-Simple_Next"));
            }
            if (currentStep === 1) {
                //hide prebutton
                $(".preButton").hide();
            }
            cardLayout.showCardByIndex(currentStep - 1);

            //样式调整
            var $title = $('div.dialog_title:visible');
            $title.css('top', '15px');
            if (cardLayout.showIndex === 1) {
                $title.next().css({'overflow-y': 'scroll', 'overflow-x': 'hidden'});
            }

            //select cache data node
            var checkBoxTree = cardLayout.getWidgetByName('fsTableTreeReportletWithCheckBox');
            //先取消所有勾选
            checkBoxTree.clearState();
            //选中缓存
            //修正id,由于第二步可能修改了路径，缓存的时候id不能改，因为前端组件名称是由id生成的，
            //因此更新缓存的时候添加了一个newid,这一步要修正id
            $.each(cacheData, function (index, value) {
                if (value.newid) {
                    value.oldid = value.id;
                    value.id = value.newid;
                    value[checkBoxTree.options.tools[0].name] = 1;
                }
            });
            checkBoxTree.selectNodesByPath(cacheData);
            //销毁第二步的组件
            cardLayout.getWidgetByName('secondMultiConfigPanel').destroy();
        }
    },

    Cache: {

        /**
         * 保存选中的树节点信息
         * @param selectedNodes
         */
        updateSelectedNodesCache: function (selectedNodes) {
            if (!FSRM.Cache.selectedNodesCache) {
                FSRM.Cache.selectedNodesCache = {};
            }
            FSRM.Cache.selectedNodesCache = selectedNodes;
        },

        /**
         * 清空选中的树节点信息
         */
        clearSelectedNodesCache: function () {
            if (FSRM.Cache.selectedNodesCache) {
                FSRM.Cache.selectedNodesCache = [];
            }
        },
        /**
         * 获取选中的树节点信息
         * @returns {*}
         */
        getSelectedNodesCache: function () {
            if (FSRM.Cache.selectedNodesCache) {
                return FSRM.Cache.selectedNodesCache;
            } else {
                return [];
            }
        },
        /**
         * 修改选中的树节点信息
         * @param oldCacheID
         * @param newCachePath
         */
        updateSelectedNodeCacheByID: function (oldCacheID, newCachePath) {
            var newNode = {};
            var allNodes = FSRM.Cache.AllNodes;
            // search new node detail
            for (var i = 0; i < allNodes.length; i++) {
                if (allNodes[i].path === newCachePath) {
                    newNode = allNodes[i];
                    break;
                }
            }
            if (!newNode.id) {
                return
            }
            var cacheData = FSRM.Cache.selectedNodesCache;
            //update old node to new node
            for (var i = 0; i < cacheData.length; i++) {
                if (cacheData[i].id === oldCacheID) {
                    cacheData[i] = FR.clone(newNode);
                    //id不能换,前端组件名称还是根据id生成的;id也不会发送到后端,不重要
                    cacheData[i].id = oldCacheID;
                    cacheData[i].newid = newNode.id;
                    cacheData[i].inited = true;
                    break;
                }
            }
        },

        /**
         * 通过id删除一条缓存的被选中的节点信息
         * @param id
         */
        deleteSelectedNodeCacheByID: function (id) {
            var cacheData = FSRM.Cache.selectedNodesCache;
            for (var i = 0; i < cacheData.length; i++) {
                if (cacheData[i].id === id) {
                    cacheData.splice(i, 1);
                    break;
                }
            }
        },
        /**
         * 保存报表详细配置信息
         * @param detailConfigData
         */
        updateDetailConfigCache: function (detailConfigData) {
            if (!FSRM.Cache.detailConfigCache) {
                FSRM.Cache.detailConfigCache = {};
            }
            FSRM.Cache.detailConfigCache = detailConfigData;
        },

        /**
         * 清空报表详细配置信息
         */
        clearDetailConfigCache: function () {
            if (FSRM.Cache.detailConfigCache) {
                FSRM.Cache.detailConfigCache = [];
            }
        },
        /**
         * 获取报表详细配置信息
         * @returns {*}
         */
        getDetailConfigCache: function () {
            if (FSRM.Cache.detailConfigCache) {
                return FSRM.Cache.detailConfigCache;
            } else {
                return [];
            }
        }
    },

    /**
     * 根据字符个数调整按钮组的宽度
     * @param widget
     */
    fixBtnGroupWidth: function (widget) {
        var maxWidth = 0;
        var buttonNumber = widget.buttonArray.length;
        for (var i = 0; i < buttonNumber; i++) {
            var buttonTextLength = FR.byteLength(widget.buttonArray[i].element[0].innerText);
            if (buttonTextLength > maxWidth) {
                maxWidth = buttonTextLength;
            }
        }
        widget.element.css("width", (maxWidth * 6 + 34) * buttonNumber + "px");
        // 设置内层 span 的宽度
        for (var i = 0; i < buttonNumber; i++) {
            $(widget.element[0].children[i]).css("left", (maxWidth * 6 + 34) * i + "px");
            $(widget.element[0].children[i]).css("width", (maxWidth * 6 + 34) + "px");
        }
    },


    /**
     * 数据上报Dialog
     * @param title
     * @param okCallback
     * @param cancelCallback
     * @param data
     * @returns {*}
     */
    createRPDialog: function (title, okCallback, cancelCallback, data) {
        var rpDialog = new FR.Dialog({
            title: title,
            text4OK: FR.i18nText("FS-Generic-Simple_OK"),
            text4Cancel: FR.i18nText("Fine-Engine_FS_Generic_Simple_Cancel"),
            onOK: function () {
                return okCallback.apply(this);
            },
            onCancel: function () {
                cancelCallback.apply(this);
            },
            destroyOnClose: true,
            width: 400,
            height: 300,
            confirm: true,
            border: true,
            closable: true,
            contentWidget: {
                type: "tablelayout",
                widgetName: "RPTABLE",
                columnSize: [60, 10, 250],
                rowSize: [10, 21, 21, 85],
                vgap: 10,
                items: [
                    [
                        {el: $('<div/>')}
                    ],
                    [
                        {el: {type: "llabel", value: FR.i18nText("FS-Generic-Simple_Label"), textalign: "right"}},
                        {el: $('<div/>')},
                        {
                            el: {
                                type: "combo", widgetName: "LABELCOMBO", directEdit: false, items: [
                                    {text: FSRM.CONSTS.PROCESSTYPE[1], value: 1},
                                    {text: FSRM.CONSTS.PROCESSTYPE[2], value: 2},
                                    {text: FSRM.CONSTS.PROCESSTYPE[3], value: 3}
                                ], listeners: [{
                                    eventName: FR.Events.AFTEREDIT,
                                    action: function () {
                                        var label = this.getText();
                                        rpDialog.getWidgetByName('RPNAME').setValue(label);
                                    }
                                }], width: 185
                            }
                        }
                    ],
                    [
                        {el: {type: "llabel", value: FR.i18nText("FS-Generic-WF_Name"), textalign: "right"}},
                        {el: $('<div/>')},
                        {el: {type: "text", widgetName: "RPNAME", width: 185}}
                    ],
                    [
                        {
                            el: {
                                type: "vertical", hgap: 0, vgap: 0, items: [
                                    {
                                        el: {
                                            type: 'llabel',
                                            value: FR.i18nText("FS-Generic-Simple_Description"),
                                            textalign: "right"
                                        }, height: 21
                                    }
                                ]
                            }
                        },
                        {el: $('<div/>')},
                        {el: {type: 'textarea', widgetName: "RPDESCRIPTION"}}
                    ]
                ]
            }
        });
        rpDialog.getWidgetByName('RPTABLE').doLayout();
        //编辑目录时有初始数据
        if (data) {
            rpDialog.getWidgetByName("LABELCOMBO").setValue(data.processType);
            rpDialog.getWidgetByName("RPNAME").setValue(data.text);
            rpDialog.getWidgetByName("RPDESCRIPTION").setValue(data.description);
        }
        return rpDialog;
    },

    /**
     *
     * @param checkBoxConfig
     * @returns {number}
     * @private
     */
    _makeMobileDeviceConfig: function (checkBoxConfig) {
        var cfgs = checkBoxConfig.split(',');
        var config = 0;
        $.each(cfgs, function (idx, cfg) {
            config += parseInt(cfg);
        });
        return config;
    },

    /**
     *
     * @param config
     * @returns {string}
     * @private
     */
    _makeMobileConfigCheckboxValue: function (config) {
        var cfgs = config.toString(2).split("");
        var checkBoxConfig = [];
        $.each(cfgs.reverse(), function (idx, cfg) {
            if (cfg === "1") {
                checkBoxConfig.push(1 << idx);
            }
        });
        return checkBoxConfig.join(",")
    },

    /**
     * 生成内置随机报表封面ID
     * @private
     */
    _makeMobileCoverRandomId: function () {
        //ID: a-z
        return String.fromCharCode(Math.floor(Math.random() * 26) + "a".charCodeAt(0));
    },

    Control: {

        /**
         * 初始化数据
         */
        initData: function () {
            //目录信息
            this.folderData = null;
            //目录子节点缓存
            this.folderEntries = [];
        },

        /**
         * 获取目录信息
         */
        getFolderData: function () {
            var self = this;
            self.folderData = FS.Sync.ajax({
                url: FR.servletURL + '?op=fs_entry&cmd=getfolder',
                type: 'POST'
            });
        },

        /**
         * 缓存图片封面设置
         * @param entry   封面设置项
         * @param coverId 封面图片ID
         * @param isDir   是否为目录
         */
        setEntryCoverId: function (entry, coverId, isDir) {
            var self = this;
            if (!self.coverData) {
                self.initEntryCoverId();
            }
            if (coverId === entry.mobileCoverId) {
                return;
            }
            if (entry.mobileCoverId) {
                if (entry.mobileCoverId.length > 1) {
                    self.coverData.del.push(entry.mobileCoverId);
                }
            }
            entry.mobileCoverId = coverId;
            if (isDir) {
                self.coverData.folder[entry.id] = coverId;
            } else if (entry.nodeicon === "cpt" || entry.nodeicon === "frm") {
                self.coverData.report[entry.id] = coverId;
            } else if (entry.nodeicon === "url") {
                self.coverData.link[entry.id] = coverId;
            } else if (entry.type === FSRM.CONSTS.REPORTPROCESS) {//reportprocess
                self.coverData.processType[entry.id] = coverId;
            } else {
                // fine bi
                $.each(FS.Plugin.EntrySupporter, function (index, value) {
                    if (value.acceptTypeByNumber(entry.type)) {
                        var config = value.fillCoverData();
                        if (!self.coverData[config.name]) {
                            self.coverData[config.name] = {};
                        }
                        self.coverData[config.name][entry.id] = coverId;
                    }
                });
            }
        },

        /**
         *
         */
        initEntryCoverId: function () {
            this.coverData = {
                //目录封面变更
                folder: {},
                //报表及表单封面变更
                report: {},
                //链接封面变更
                link: {},
                //处理类型封面变更
                processType: {},
                //变更后需要删除的自定义图片
                del: []
            };
        }
    }
};
