/*
 * Copyright (c) 2001-2014,FineReport Inc, All Rights Reserved.
 */

FS.SystemItems = FS.Plugin.SystemItems;
/**
 * Coder: sean
 * Date: 13-10-19
 * Time: 上午1:38
 */
FS.SYSMGR = {
    init: function (renderer) {
        FR.$defaultImport('/com/fr/fs/web/css/manager/fs_sysmgr.css', 'css');
        var self = this;
        this.initData();
        var items = [
            {
                ui: this.loginSetModule,
                pop: this._popLoginSetData
            },
            {
                ui: this.basicSetModule,
                popAction: this._popBasicSetData
            },
            {
                ui: this.printSetModule,
                popAction: this._popPrintSetData
            },
            {
                ui: this.mailSetModule,
                popAction: this._popEmailData
            },
            {
                ui: this.cacheSetModule,
                popAction: this._popCacheData
            },
            {
                ui: this.connSetModule,
                popAction: function () {

                }
            }
        ];
        $.each(FS.Plugin.SystemItems, function (i, it) {
            var index = it.tabIndex || items.length;
            items.splice(index, 0, it);
        });


        var tabItems = this._createTabItems(items);
        this.serverConfig = new FS.LTabPane({
            width: '100%',
            height: '100%',
            items: tabItems,
            style: 'blue',
            renderEl: renderer,
            marginLeft: 40,
            initAfterAction: function (idx) {
                var popp = items[idx].popAction;
                var pop = items[idx].pop;
                if ($.isFunction(popp)) {
                    self.tabPane = this;
                    popp.apply(self);
                } else if ($.isFunction(pop) && !isNaN(idx)) {
                    self.tabPane = this;
                    pop.apply(self, [parseInt(idx), this]);//兼容老接口
                }
            }
        });
        this.serverConfig.getWidgetByName('singleLoginMode').setEnable(
            this.serverConfig.getWidgetByName('singleLogin').getValue()
        );
        $('#lastLoginPreview').height(190);
    },

    _createTabItems: function (items) {
        var uiItems = [];
        for (var i = 0, len = items.length; i < len; i++) {
            var ui = items[i].ui;
            if ($.isFunction(ui)) {
                uiItems.push(ui.apply(this));
            }
        }
        return uiItems;
    },

    setWidgetValue: function (widgetName, value) {
        if (this.tabPane.getWidgetByName(widgetName)) {
            this.tabPane.getWidgetByName(widgetName).setValue(value);
        }
    },

    getWidgetValue: function (widgetName) {
        if (this.tabPane.getWidgetByName(widgetName)) {
            return this.tabPane.getWidgetByName(widgetName).getValue();
        }
    },

    sendTestMail: function () {
        var self = this;
        var testEmailTablelayout = {
            widgetName: 'testEmailTablelayout',
            type: 'tablelayout',
            items: [
                [
                    {el: $('<div/>')}
                ],
                [
                    {el: $('<div/>')},
                    {el: {type: 'llabel', value: FR.i18nText("FS-System-Email_Receiver") + ":", textalign: 'right'}},
                    {el: $('<div/>')},
                    {el: {type: 'text', widgetName: 'emailReceiver'}}
                ]
            ],
            columnSize: [20, 100, 10, 230],
            rowSize: [30, 21],
            vgap: 20
        };

        var testEmailDialog = new FR.Dialog({
            title: FR.i18nText("FS-System-Send_Test_Mail"),
            onOK: function () {
                var toAddress = this.getWidgetByName('emailReceiver').getValue();
                var serverName = self.serverConfig.getWidgetByName('host').getValue();
                var serverPort = self.serverConfig.getWidgetByName('port').getValue();
                var encryptionMethod = self.serverConfig.getWidgetByName('encryption').getValue();
                var userName = self.serverConfig.getWidgetByName('username').getValue();
                var passWord = self.serverConfig.getWidgetByName('password').getValue();
                var fromAddress = self.serverConfig.getWidgetByName('address').getValue();
                var emailToAttr = {
                    serverName: serverName,
                    serverPort: serverPort,
                    encryptionMethod: encryptionMethod,
                    fromAddress: fromAddress,
                    userName: userName,
                    passWord: passWord,
                    toAddress: toAddress
                };
                FR.showLoadingDialog({
                    width: 310,
                    height: 80,
                    title: FR.i18nText("FS-Generic-Simple_Email"),
                    text: FR.i18nText("FS-System-Simple_Sending")
                });
                var completeFn = function (res, status) {
                    FR.hideLoadingDialog();
                    var result = FR.jsonDecode(res.responseText);
                    if (result.status == "success") {
                        FR.Msg.alert(FR.i18nText("FS-Generic-HJS_Send_Successfully"), FR.i18nText("FS-System-Email_Has_Send_To") + toAddress);
                    } else {
                        FR.Msg.alert(FR.i18nText("FS-Generic-HJS_Send_Failed"), FR.i18nText("FS-System-Email_Send_Failed") + "!\n" + FR.i18nText("FS-System-Please_Check_Email_Attr"));
                    }
                };
                var config = {
                    url: '${servletURL}?op=fr_server&cmd=sc_test_mail',
                    type: 'POST',
                    data: {
                        type: 'POST',
                        __parameters__: emailToAttr
                    }
                };
                FS.Async.ajax(config, completeFn);
            },
            destroyOnClose: true,
            width: 400,
            height: 200,
            doSize: true,
            confirm: true,
            contentWidget: testEmailTablelayout
        });
        testEmailDialog.setVisible(true);
    },

    /*************登录设置*************/
    loginSetModule: function () {
        var self = this;
        return {
            title: FR.i18nText("FS-System-Login_Set"),
            content: {
                widgetName: 'loginSet',
                type: 'confirm',
                firstBtnMargin: 0,
                width: 750,
                height: 620,
                text4OK: FR.i18nText("FS-Frame-Simple_Save"),
                text4Cancel: null,
                btnsAlignment: 'left',
                closeAfterAction: false,
                doSize: true,
                onOK: function () {
                    self.saveSingleLogin();
                },
                contentWidget: {
                    type: 'tablelayout',
                    columnSize: ['fill'],
                    rowSize: [25, 25, 70, 25, 230, 25, 25, 70],
                    vgap: 10,
                    items: [
                        [
                            {el: {type: 'llabel', levelStyle: 1, value: FR.i18nText("FS-System-Single_Login_Set")}}
                        ], [
                            {
                                el: {
                                    type: 'tablelayout',
                                    columnSize: [131, 122],
                                    rowSize: [25],
                                    vgap: 20,
                                    items: [[
                                        {el: {type: 'llabel', value: FR.i18nText("FS-System-Single_Login")}},
                                        {
                                            el: {
                                                type: 'switch',
                                                widgetName: 'singleLogin',
                                                onTurnOff: function () {
                                                    this.getWidgetByName('singleLoginMode').setEnable(false);
                                                },
                                                onTurnOn: function () {
                                                    this.getWidgetByName('singleLoginMode').setEnable(true);
                                                }
                                            }
                                        }
                                    ]]
                                }
                            }
                        ], [
                            {
                                el: {
                                    type: 'radiogroup',
                                    assureSelect: true,
                                    items: [
                                        {
                                            text: FR.i18nText("FS-System-Current_Login_First"),
                                            value: "LATER_FIRST"
                                        },
                                        {
                                            text: FR.i18nText("FS-System-Logined_First"),
                                            value: "FORMER_FIRST"
                                        }
                                    ],
                                    columnsInRow: 1,
                                    widgetName: 'singleLoginMode'
                                }
                            }
                        ], [
                            {el: {type: 'llabel', levelStyle: 1, value: FR.i18nText("FS-System-Last_Logined_Info_Set")}}
                        ], [
                            {
                                el: {
                                    type: 'tablelayout',
                                    columnSize: [131, 400],
                                    rowSize: [25, 25, 230],
                                    vgap: 10,
                                    items: [
                                        [
                                            {el: {type: 'llabel', value: FR.i18nText("FS-System-Last_Logined_Info")}},
                                            {
                                                el: {
                                                    type: 'switch',
                                                    widgetName: 'lastLoginedInfo',
                                                    onTurnOff: function () {
                                                        $('#lastLoginPreview').css('opacity', '0.5');
                                                        this.getWidgetByName('lastLoginInfoText').element.css('opacity', '0.5');

                                                    },
                                                    onTurnOn: function () {
                                                        $('#lastLoginPreview').css('opacity', '1');
                                                        this.getWidgetByName('lastLoginInfoText').element.css('opacity', '1');
                                                    }
                                                }
                                            }

                                        ], [
                                            {
                                                el: {
                                                    type: 'llabel',
                                                    top: 0,
                                                    value: FR.i18nText("FS-System-Last_Logined_Info_Example_Title"),
                                                    widgetName:'lastLoginInfoText'
                                                }
                                            }, {
                                                el: $('<div/>')
                                            }
                                        ], [
                                            {
                                                el: $('<div/>')
                                            }, {
                                                el: $(
                                                    '<div id="lastLoginPreview", style="position:absolute;z-index: 999;width: 400px;height: 190px;left: 0px; top: 0px;background: white;margin-top: -35px;border: 1px solid #DDDDDD;">\n' +
                                                    '    <div style="width: 385px;height: 20px;background: #048BED;font-size: 14px;padding: 5px;padding-left: 10px;color: white;"> ' + FR.i18nText('FS-Msg-New_Message') + '\n' +
                                                    '        <div class="fr-core-panel-tool-close" style="float:right; margin-right:5px; width:20px; height:20px"></div>\n' +
                                                    '    </div>\n' +
                                                    '    <div style="position: absolute;left: 50px;top: 50px;width: 34px;height: 34px; background: url(\'${remoteServletURL}?op=resource&resource=/com/fr/fs/resources/images/time.png\') no-repeat;"></div>\n' +
                                                    '    <div style="font-size: 20px;left: 100px;top: 52px;position: absolute;color: #666666;">' + FR.i18nText('FS-System-Last_Logined_Info_Popup') + '</div>\n' +
                                                    '    <div style="font-size: 15px;left: 100px;top: 90px;position: absolute;color: #999999;">' + FR.i18nText('FS-System-Time') + '：</div>\n' +
                                                    '    <div style="font-size: 15px;left: 200px;top: 90px;position: absolute;color: #999999;">2017-08-01 12:13:14</div>\n' +
                                                    '    <div style="font-size: 15px;left: 100px;top: 111px;position: absolute;color: #999999;">' + FR.i18nText('FS-System-IP_Address') + '：</div>\n' +
                                                    '    <div style="font-size: 15px;left: 200px;top: 111px;position: absolute;color: #999999;"> 255.255.255.0</div>\n' +
                                                    '    <div style="font-size: 15px;left: 100px;top: 132px;position: absolute;color: #999999;">' + FR.i18nText('FS-System-Last_Login_Location') + '：</div>\n' +
                                                    '    <div style="font-size: 15px;left: 200px;top: 132px;position: absolute;color: #999999;">' + FR.i18nText('FS-System-Last_Login_Location_Beijing') + '</div>\n' +
                                                    '</div>'
                                                )
                                            }
                                        ]
                                    ]
                                }
                            }
                        ], [
                            {el: {type: 'llabel', levelStyle: 1, value: FR.i18nText("FS-System-Forget_Password_Set")}}
                        ], [
                            {
                                el: {
                                    type: 'tablelayout',
                                    columnSize: [131, 122],
                                    rowSize: [25],
                                    vgap: 20,
                                    items: [
                                        [
                                            {el: {type: 'llabel', value: FR.i18nText("FS-System-Forget_Password")}},
                                            {el: {type: 'switch', widgetName: 'forgetPassword'}}
                                        ]
                                    ]
                                }
                            }
                        ], [
                            {el: {type: 'label', widgetName:'forgetPasswordText', value: FR.i18nText("FS-System-Forget_Password_Tip")}}
                        ]
                    ]
                }
            }
        };
    },

    /*************基本设置*************/
    basicSetModule: function () {
        var self = this;
        var charsetitems = [];
        for (var i = 0, len = this.data.encodingArray.length; i < len; i++) {
            charsetitems.push({
                value: this.data.encodingArray[i],
                text: this.data.encodingArray[i]
            })
        }
        var items = [
            [
                {el: {type: 'llabel', value: FR.i18nText("FS-System-Reportlets_root_directory_name")}},
                {el: {type: 'text', widgetName: 'reportlets', disabled: true}}
            ],
            [
                {el: {type: 'llabel', value: FR.i18nText("FS-System-Resources_root_directory_name")}},
                {el: {type: 'text', widgetName: 'resources', disabled: true}}
            ],
            [
                {el: {type: 'llabel', value: FR.i18nText("FS-System-Server_character_encoding")}},
                {el: {type: 'combo', widgetName: 'charset', items: charsetitems}}
            ],
            [
                {el: {type: 'llabel', value: FR.i18nText("FS-System-ServletMapping_name")}},
                {el: {type: 'text', widgetName: 'servlet'}}
            ]
        ];
        var rowSize = [21, 21, 21, 21];
        var height = 500;
        items.push([
                {el: {type: 'llabel', value: FR.i18nText("FS-System-Unlock_Gzip")}},
                {el: {type: 'switch', widgetName: 'gzip'}}
            ],
            [
                {el: {type: 'llabel', value: FR.i18nText("FS-System-Sign_Dongle")}},
                {el: {type: 'switch', widgetName: 'dongle'}}
            ]);
        rowSize.push(25, 25);
        items.push(
            [
                {el: {type: 'llabel', value: FR.i18nText("FS-System-Use_Resource_Server")}},
                {el: {type: 'switch', widgetName: 'resserver'}}
            ],
            [
                {el: {type: 'llabel', value: FR.i18nText("FS-System-Resource_Server")}},
                {el: {type: 'text', widgetName: 'serverpath', width: 300}}
            ]
        );
        rowSize.push(25, 21);
        var basicTablelayout = {
            widgetName: 'basicTablelayout',
            type: 'tablelayout',
            items: items,
            columnSize: [
                FR.i18nTextWidth("FS-System-Resources_root_directory_name") > 110 ?
                    FR.i18nTextWidth("FS-System-Resources_root_directory_name") + 50 : 131,
                122
            ],
            rowSize: rowSize,
            vgap: 20
        };
        var basicSetPanel = {
            title: FR.i18nText("FS-System-Basic_Description"),
            content: {
                widgetName: 'basicSetPanel',
                type: 'confirm',
                firstBtnMargin: 0,
                text4OK: FR.i18nText("FS-Frame-Simple_Save"),
                text4Cancel: null,
                width: 500,
                height: height,
                btnsAlignment: 'left',
                closeAfterAction: false,
                doSize: true,
                onOK: function () {
                    self.saveBasicData();
                },
                contentWidget: basicTablelayout
            }
        };
        return basicSetPanel;
    },

    /*************打印设置*************/
    printSetModule: function () {
        var self = this;
        var pintlistitems = [];
        for (var i = 0, len = this.data.serverPrinterList.length; i < len; i++) {
            pintlistitems.push({
                value: this.data.serverPrinterList[i],
                text: this.data.serverPrinterList[i]
            })
        }
        //wei : 为了适应tablelayout布局，下拉框要包在一个div里放进去，不然会拉伸。但是这样，在tabpane里就取不到这个
        //下拉框控件了，所以单独顶一下
        this.printerCombo = FR.createWidget({
            type: 'combocheckbox',
            supportTag: false,
            widgetName: 'printer',
            width: 122,
            height: 21,
            items: pintlistitems
        });
        var printTablelayout = {
            widgetName: 'printTablelayout',
            type: 'tablelayout',
            items: [
                [
                    {el: {type: 'llabel', value: FR.i18nText("FS-Generic-Activated_Printer")}},
                    {el: $('<div/>').append(this.printerCombo.element)}
                ],
                [
                    {el: $('<div/>')}
                ],
                [
                    {el: {type: 'llabel', value: FR.i18nText("FS-Generic-Flash_Print")}},
                    {
                        el: {
                            type: 'checkbox',
                            marginleft: 0,
                            widgetName: 'flash_page',
                            text: FR.i18nText("FS-System-FlashP_Need_Page_Selection")
                        }
                    }
                ],
                [
                    {el: $('<div/>')},
                    {
                        el: {
                            type: 'checkbox',
                            marginleft: 0,
                            widgetName: 'flash_setting',
                            text: FR.i18nText("FS-System-FlashP_Need_Settings"),
                            selected: true,
                            disabled: true
                        }
                    }
                ],
                [
                    {el: $('<div/>')},
                    {
                        el: {
                            type: 'checkbox',
                            marginleft: 0,
                            widgetName: 'flash_size',
                            text: FR.i18nText("FS-System-FlashP_Default_Size")
                        }
                    }
                ],
                [
                    {el: $('<div/>')}
                ],
                [
                    {el: {type: 'llabel', value: FR.i18nText("FS-Generic-PDF_Print")}},
                    {
                        el: {
                            type: 'checkbox',
                            marginleft: 0,
                            widgetName: 'pdf_page',
                            text: FR.i18nText("FS-System-PDFP_Need_Settings")
                        }
                    }
                ],
                [
                    {el: $('<div/>')}
                ],
                [
                    {el: {type: 'llabel', value: FR.i18nText("FS-Generic-Applet_Print")}},
                    {
                        el: {
                            type: 'checkbox',
                            marginleft: 0,
                            widgetName: 'applet_page',
                            text: FR.i18nText("FS-System-Applet_Need_Settings")
                        }
                    }
                ]
            ],
            columnSize: [131, 'fill'],
            rowSize: [21, 0, 16, 16, 16, 0, 16, 0, 16],
            vgap: 10
        };
        var printSetPanel = {
            title: FR.i18nText("FS-Generic-Simple_Print"),
            content: {
                widgetName: 'printSetPanel',
                type: 'confirm',
                firstBtnMargin: 0,
                text4OK: FR.i18nText("FS-Frame-Simple_Save"),
                text4Cancel: null,
                width: FR.i18nTextWidth("FS-System-FlashP_Need_Settings") > 350 ?
                    FR.i18nTextWidth("FS-System-FlashP_Need_Settings") + 200 : 500,
                height: 256,
                btnsAlignment: 'left',
                closeAfterAction: false,
                doSize: true,
                onOK: function () {
                    self.savePrintData();
                },
                contentWidget: printTablelayout
            }
        };
        return printSetPanel;
    },

    /*************邮件设置*************/
    mailSetModule: function () {
        var self = this;
        self.isEmailExpand = false;
        var senderLLabel = {
            type: 'llabel',
            levelStyle: 1,
            value: FR.i18nText("FS-System-Mail_Sender_Account")
        };
        var host_items = [{value: "SMTP.gmail.com", text: "SMTP.gmail.com"}, {
            value: "SMTP.sina.com",
            text: "SMTP.sina.com"
        },
            {value: "SMTP.163.com", text: "SMTP.163.com"}, {value: "SMTP.qq.com", text: "SMTP.qq.com"},
            {value: "SMTP.sohu.com", text: "SMTP.sohu.com"}, {value: "SMTP.live.com", text: "SMTP.live.com"},
            {value: "SMTP.mail.yahoo.com", text: "SMTP.mail.yahoo.com"}, {
                value: "SMTP.netease.com",
                text: "SMTP.netease.com"
            },
            {value: "SMTP.sina.com.cn", text: "SMTP.sina.com.cn"}, {value: "SMTP.263.net", text: "SMTP.263.net"},
            {value: "SMTP.126.com", text: "SMTP.126.com"}];
        var encryption_items = [
            {value: "SSL", text: FR.i18nText("FS-System-Email_Encrypt_SSL")},
            {value: "TLS", text: FR.i18nText("FS-System-Email_Encrypt_TLS")},
            {value: "None", text: FR.i18nText("FS-System-Email_Encrypt_None")}
        ];
        var senderTablePane = {
            widgetName: 'senderTablePane',
            type: 'tablepane',
            colSize: [
                131,
                350,
                FR.i18nTextWidth("FS-System-Send_Test_Mail", 6.5) > 80 ?
                    (FR.i18nTextWidth("FS-System-Send_Test_Mail", 6.5) + 30) : 120
            ],
            rowSize: [21, 21, 21, 21, 21, 21],
            vgap: 20,
            items: [
                [
                    {type: 'llabel', value: FR.i18nText("FS-System-Mail_Host(SMTP)")},
                    {type: 'combo', widgetName: 'host', directEdit: true, items: host_items},
                    {
                        type: 'iconbutton',
                        text: FR.i18nText("FS-System-Email_Ports_and_Encryption"),
                        baseClass: 'fs-servercfg-test',
                        handler: function () {
                            self.isEmailExpand = !self.isEmailExpand;
                            self.serverConfig.getWidgetByName("senderTablePane").setRowVisible([1, 2], self.isEmailExpand);
                        }
                    }
                ],
                [
                    {type: 'llabel', value: FR.i18nText("FS-System-Email_Port")},
                    {type: 'text', widgetName: 'port'}, null
                ],
                [
                    {type: 'llabel', value: FR.i18nText("FS-System-Email_Encryption_Method")},
                    {
                        type: 'combo',
                        widgetName: 'encryption',
                        directEdit: false,
                        allowBlank: false,
                        items: encryption_items
                    }, null
                ],
                [
                    {type: 'llabel', value: FR.i18nText("FS-System-Sender_Address")},
                    {
                        type: 'text', widgetName: 'address', listeners: [{
                        eventName: 'afteredit',
                        action: function () {
                            var showFullName = this.getWidgetByName('username');
                            var mail_address = this.getValue();
                            if (mail_address) {
                                var namePosition = mail_address.indexOf("@");
                                var mail_fullname = namePosition === -1 ? mail_address : mail_address.substring(0, namePosition);
                                showFullName.setValue(mail_fullname);
                            }
                        }
                    }]
                    }, null
                ],
                [
                    {type: 'llabel', value: FR.i18nText("FS-Generic-Simple_Password")},
                    {type: 'password', widgetName: 'password'}, null
                ],
                [
                    {type: 'llabel', value: FR.i18nText("FS-System-Email_Show_Full_Name")},
                    {type: 'text', widgetName: 'username'},
                    {
                        type: 'iconbutton',
                        text: FR.i18nText("FS-System-Send_Test_Mail"),
                        baseClass: 'fs-servercfg-test',
                        handler: function () {
                            self.sendTestMail();
                        }
                    }
                ]
            ]
        };
        var mailSetPanel = {
            title: FR.i18nText("FS-System_Simple_Email"),
            content: {
                widgetName: 'mailSetPanel',
                type: 'tablepane',
                colSize: [80, 750],
                rowSize: [25, 'auto', 30],
                vgap: 25,
                items: [
                    [null, senderLLabel],
                    [null, senderTablePane],
                    [{
                        type: 'quickbutton',
                        style: 'blue',
                        text: FR.i18nText("FS-Frame-Simple_Save"),
                        handler: function () {
                            self.saveEmailData();
                        }
                    }, null]
                ]

            }
        };
        return mailSetPanel;
    },

    /*************缓存设置*************/
    cacheSetModule: function () {
        var self = this;
        var datasetShare = {
            type: 'llabel',
            levelStyle: 1,
            value: FR.i18nText("FS-System-Cache_Dataset_Share")
        };
        var cptCache = {
            type: 'llabel',
            levelStyle: 1,
            value: FR.i18nText("FS-System-Cache_Template_Settings")
        };
        var dsShareTablelayout = {
            type: 'tablelayout',
            columnSize: [
                FR.i18nTextWidth("FS-System-Cache_Reload_Template_Policy", 6.5) > 110 ?
                    (FR.i18nTextWidth("FS-System-Cache_Reload_Template_Policy", 6.5) + 30) : 131,
                150,
                8,
                'fill'
            ],
            rowSize: [21, 15, 82, 15, 21, 20, 21],
            vgap: 0,
            items: [
                [
                    {el: {type: 'llabel', value: FR.i18nText("FS-System-Max_Shared_Datasets")}},
                    {el: {type: 'text', widgetName: 'maximum'}}
                ],
                [
                    {el: $('<div/>')}
                ],
                [
                    {
                        el: {
                            type: 'llabel',
                            verticalcenter: false,
                            lineheight: 26,
                            value: FR.i18nText("FS-System-Cache_Principle")
                        }
                    },
                    {
                        el: {
                            type: 'radiogroup',
                            assureSelect: true,
                            items: [
                                {text: FR.i18nText("FS-System-Simple_LRU"), value: 'LRU'},
                                {text: FR.i18nText("FS-System-Simple_LFU"), value: 'LFU'},
                                {text: FR.i18nText("FS-System-Simple_FIFO"), value: 'FIFO'}
                            ],
                            columnsInRow: 1,
                            adaptive: true,
                            widgetName: 'principle'
                        }
                    }
                ],
                [
                    {el: $('<div/>')}
                ],
                [
                    {el: {type: 'llabel', value: FR.i18nText("FS-System-Time_To_Idle_Seconds")}},
                    {el: {type: 'text', widgetName: 'idle'}},
                    {el: $('<div/>')},
                    {el: {type: 'llabel', value: FR.i18nText("FS-Generic-Sche_Second")}}
                ],
                [
                    {el: $('<div/>')}
                ],
                [
                    {el: {type: 'llabel', value: FR.i18nText("FS-System-Time_To_Live_Seconds")}},
                    {el: {type: 'text', widgetName: 'live'}},
                    {el: $('<div/>')},
                    {el: {type: 'llabel', value: FR.i18nText("FS-Generic-Sche_Second")}}
                ]
            ]
        };
        var cptCacheTablelayout = {
            type: 'tablelayout',
            columnSize: [
                FR.i18nTextWidth("FS-System-Cache_Reload_Template_Policy", 6.5) > 110 ?
                    (FR.i18nTextWidth("FS-System-Cache_Reload_Template_Policy", 6.5) + 30) : 131,
                122
            ],
            rowSize: [25],
            vgap: 20,
            items: [
                [
                    {el: {type: 'llabel', value: FR.i18nText("FS-System-Cache_Reload_Template_Policy")}},
                    {el: {type: 'switch', widgetName: 'reload'}}
                ]
            ]
        };
        var cacheSetPanel = {
            title: FR.i18nText("FS-System-Memory_Cache"),
            content: {
                widgetName: 'cacheSetPanel',
                type: 'confirm',
                firstBtnMargin: 0,
                width: 750,
                height: 393,
                text4OK: FR.i18nText("FS-Frame-Simple_Save"),
                text4Cancel: null,
                btnsAlignment: 'left',
                closeAfterAction: false,
                doSize: true,
                onOK: function () {
                    self.saveCacheData();
                },
                contentWidget: {
                    type: 'tablelayout',
                    columnSize: ['fill'],
                    rowSize: [25, 213, 25, 25],
                    vgap: 10,
                    items: [
                        [
                            {el: datasetShare}
                        ],
                        [
                            {el: dsShareTablelayout}
                        ],
                        [
                            {el: cptCache}
                        ],
                        [
                            {el: cptCacheTablelayout}
                        ]
                    ]
                }
            }
        };
        return cacheSetPanel;
    },
    /*************数据连接*************/
    connSetModule: function () {
        var self = this, items = [];
        var connParas = {};
        var connNames = [];
        var connSize = 0;
        var result = FS.Sync.ajax({
            url: FR.servletURL + "?op=fs_set&cmd=sc_getconnectioninfo",
            type: 'POST'
        });
        connSize = result.length;
        for (var i = 0; i < connSize; i++) {
            var conn = result[i];
            connNames.push(conn.name);
            items.push({
                menu: FR.i18nText("FS-System-Connection_List") + (i + 1) + ": " + conn.name,
                content: {
                    type: 'tablepane',
                    colSize: [130, 380],
                    rowSize: [21, 21, 21, 21],
                    vgap: 8,
                    hgap: 0,
                    items: [
                        [
                            {type: 'llabel', value: FR.i18nText("FS-Generic-Simple_Driver")},
                            {type: 'text', widgetName: 'DRIVER' + i, value: conn.driver}
                        ], [
                            {type: 'llabel', value: 'url'},
                            {type: 'text', widgetName: 'URL' + i, value: conn.url}
                        ], [
                            {type: 'llabel', value: FR.i18nText("FS-Generic-Simple_Username")},
                            {type: 'text', widgetName: 'USERNAME' + i, value: conn.user, width: 190}
                        ], [
                            {type: 'llabel', value: FR.i18nText("FS-Generic-Simple_Password")},
                            {
                                type: 'password',
                                widgetName: 'PASSWORD' + i,
                                encryption: 'output',
                                value: conn.password,
                                width: 190
                            }
                        ]
                    ]
                }
            });
        }
        var connSetPanel = {
            title: FR.i18nText("FS-System-Connection_Description"),
            content: {
                widgetName: 'CONNSETPANE',
                type: 'tablepane',
                colSize: [80, 750],
                rowSize: ['auto', 30],
                vgap: 25,
                items: [
                    [
                        null,
                        {
                            type: 'accordion',
                            items: items
                        }
                    ], [
                        {
                            type: 'quickbutton',
                            style: 'blue',
                            text: FR.i18nText("FS-Frame-Simple_Save"),
                            handler: function () {
                                for (var i = 0; i < connSize; i++) {
                                    connParas[connNames[i]] = {
                                        driver: encodeURIComponent(FR.cjkEncode(this.getWidgetByName('DRIVER' + i).getValue().replace(/\\/g, "/"))),
                                        url: encodeURIComponent(FR.cjkEncode(this.getWidgetByName('URL' + i).getValue().replace(/\\/g, "/"))),
                                        user: encodeURIComponent(FR.cjkEncode(this.getWidgetByName('USERNAME' + i).getValue().replace(/\\/g, "/"))),
                                        password: encodeURIComponent(FR.cjkEncode(this.getWidgetByName('PASSWORD' + i).getValue().replace(/\\/g, "/")))
                                    };
                                }
                                var completeFn = function (res, status) {
                                    var conAttrStatus = res.responseText;
                                    if (conAttrStatus == -1) {
                                        FR.Msg.toast(FR.i18nText("Fine-Engine_FS_System_Event_Submitfailure"));
                                    } else if (conAttrStatus == "success") {
                                        FR.Msg.toast(FR.i18nText("Fine-Engine_FS_System_Event_Submitsuccess"));
                                    } else {
                                        FR.Msg.toast(FR.i18nText("Fine-Engine_FS_System_Event_Submitfailure"));
                                    }
                                };
                                var config = {
                                    url: '${servletURL}?op=fs_set&cmd=sc_connection_attrset',
                                    type: 'POST',
                                    data: {
                                        __parameters__: connParas,
                                        changedConName: connNames
                                    }
                                };
                                FS.Async.ajax(config, completeFn);
                            }
                        },
                        null
                    ]
                ]
            }
        };
        return connSetPanel;
    },
    /****************** 数据部分 *******************/
    initData: function () {
        var self = this;
        self.data = FS.Sync.ajax({
            url: FR.servletURL + '?op=fr_server&cmd=sc_get_configinfo',
            type: 'POST',
            data: {
                serverID: FS.serverID
            }
        });
    },
    _popLoginSetData: function () {
        var basicAttr = this.data;
        this.setWidgetValue("singleLogin", basicAttr.singleLogin);
        this.setWidgetValue("lastLoginedInfo", basicAttr.lastLoginedInfo);
        $('#lastLoginPreview').css('opacity', basicAttr.lastLoginedInfo ? '1' : '0.5');
        this.tabPane.getWidgetByName('lastLoginInfoText').element.css('opacity', basicAttr.lastLoginedInfo ? '1' : '0.5');
        this.setWidgetValue("forgetPassword", basicAttr.forgetPassword);
        if (basicAttr.singleLoginMode === "TURN_OFF_LATER_FIRST") {
            this.setWidgetValue("singleLoginMode", "LATER_FIRST");
            this.tabPane.getWidgetByName('singleLoginMode').setEnable(false);
        } else if (basicAttr.singleLoginMode === "TURN_OFF_FORMER_FIRST") {
            this.setWidgetValue("singleLoginMode", "FORMER_FIRST");
            this.tabPane.getWidgetByName('singleLoginMode').setEnable(false);
        } else {
            this.setWidgetValue("singleLoginMode", basicAttr.singleLoginMode);
            this.tabPane.getWidgetByName('singleLoginMode').setEnable(true);
        }
        this.tabPane.getWidgetByName('forgetPasswordText').element.find('.fr-label').css('color','#A5A5A5');
    },

    _popBasicSetData: function () {
        var basicAttr = this.data;
        this.setWidgetValue("reportlets", basicAttr.reportletsName);
        this.setWidgetValue("resources", basicAttr.resourcesName);
        this.setWidgetValue("charset", basicAttr.serverCharSet);
        this.setWidgetValue("servlet", basicAttr.serverletMapping);
        this.setWidgetValue("gzip", basicAttr.isSupportGzip);
        this.setWidgetValue("dongle", basicAttr.isLicUseLock);
        this.setWidgetValue("resserver", basicAttr.isUseResServer);
        this.setWidgetValue("serverpath", basicAttr.resServerPath);
    },

    _popPrintSetData: function () {
        var basicAttr = this.data;
        this.printerCombo.setValue(basicAttr.serverActivePrinterList);

        this.setWidgetValue("flash_page", basicAttr.isPopupFlashPrintSetting);
        this.setWidgetValue("flash_size", basicAttr.isFitPaper);
        this.setWidgetValue("pdf_page", basicAttr.isPopupPdfPrintSetting);
        this.setWidgetValue("applet_page", basicAttr.isPopupAppletPrintSetting);
    },

    _popEmailData: function () {
        var basicAttr = this.data;
        this.setWidgetValue("host", basicAttr.serverName);
        this.setWidgetValue("port", basicAttr.serverPort);
        this.setWidgetValue("encryption", basicAttr.encryptionMethod);
        this.setWidgetValue("username", basicAttr.userName);
        this.setWidgetValue("password", basicAttr.passWord);
        this.setWidgetValue("address", basicAttr.fromAddress);
        this.serverConfig.getWidgetByName("senderTablePane").setRowVisible([1, 2], this.isEmailExpand);
    },

    _popCacheData: function () {
        var basicAttr = this.data;
        this.setWidgetValue("maximum", basicAttr.maxElementsInMemory);
        this.setWidgetValue("principle", basicAttr.memoryStoreEvictionPolicy);
        this.setWidgetValue("idle", basicAttr.timeToIdleSeconds);
        this.setWidgetValue("live", basicAttr.timeToLiveSeconds);
        this.setWidgetValue("reload", basicAttr.alwaysReloadTpl);
    },

    /************* 设置单一登录设置 ***********/
    saveSingleLogin: function () {
        var loginConfiguration = {
            isSingleLogin: this.getWidgetValue("singleLogin"),
            singleLoginMode: this.getWidgetValue("singleLoginMode"),
            isShowLastLoginedInfo: this.getWidgetValue("lastLoginedInfo"),
            isSupportForgetPwd: this.getWidgetValue("forgetPassword")
        };
        var completeFn = function (res, status) {
            if (status === 'success') {
                FR.Msg.toast(FR.i18nText("FS-Generic-Simple_Successfully"));
            }
        };
        var config = {
            url: FR.servletURL + '?op=fr_server&cmd=sc_single_login',
            type: 'POST',
            data: loginConfiguration
        };
        FS.Async.ajax(config, completeFn);
    },

    /************* 设置数据 ***********/
    saveBasicData: function () {
        var basicData = {
            serverCharSet: this.getWidgetValue("charset"),
            serverletMapping: this.getWidgetValue("servlet"),
            isSupportGzip: this.getWidgetValue("gzip"),
            isLicUseLock: this.getWidgetValue("dongle"),
            isUseResServer: this.getWidgetValue("resserver"),
            resServerPath: this.getWidgetValue("serverpath")
        };
        var completeFn = function (res, status) {
            var rs = FR.jsonDecode(res.responseText);
            if (rs.success === 'success') {
                FR.Msg.toast(FR.i18nText("FS-Generic-Simple_Successfully"));
            }
            if (rs.validResServer === false) {
                FR.Msg.toast(FR.i18nText("FS-System-Resource_Path_invalid"));
            }
        };
        var config = {
            url: FR.servletURL + '?op=fr_server&cmd=sc_basic_set',
            type: 'POST',
            data: basicData
        };
        FS.Async.ajax(config, completeFn);
    },

    savePrintData: function () {
        var printData = {
            serverActivePrinterList: this.printerCombo.getValue(),
            isPopupFlashPrintSetting: this.getWidgetValue("flash_page"),
            isFitPaper: this.getWidgetValue("flash_size"),
            isPopupPdfPrintSetting: this.getWidgetValue("pdf_page"),
            isPopupAppletPrintSetting: this.getWidgetValue("applet_page")
        };
        var completeFn = function (res, status) {
            if (status === 'success') {
                FR.Msg.toast(FR.i18nText("FS-Generic-Simple_Successfully"));
            }
        };
        var config = {
            url: FR.servletURL + '?op=fr_server&cmd=sc_print_set',
            type: 'POST',
            data: printData
        };
        FS.Async.ajax(config, completeFn);
    },

    saveEmailData: function () {
        var emailData = {
            host: this.getWidgetValue("host"),
            port: this.getWidgetValue("port"),
            encryption: this.getWidgetValue("encryption"),
            username: this.getWidgetValue("username"),
            password: FR.encrypt(this.getWidgetValue("password")),
            address: this.getWidgetValue("address")
        };
        var completeFn = function (res, status) {
            if (status === 'success') {
                FR.Msg.toast(FR.i18nText("FS-Generic-Simple_Successfully"));
            }
        };
        var config = {
            url: FR.servletURL + '?op=fr_server&cmd=sc_email_set',
            type: 'POST',
            data: emailData
        };
        FS.Async.ajax(config, completeFn);
    },

    saveCacheData: function () {
        var cacheData = {
            maximum: this.getWidgetValue("maximum"),
            principle: this.getWidgetValue("principle"),
            idle: this.getWidgetValue("idle"),
            live: this.getWidgetValue("live"),
            reload: this.getWidgetValue("reload")
        };
        var completeFn = function (res, status) {
            if (status === 'success') {
                FR.Msg.toast(FR.i18nText("FS-Generic-Simple_Successfully"));
            }
        };
        var config = {
            url: FR.servletURL + '?op=fr_server&cmd=sc_cache_set',
            type: 'POST',
            data: cacheData
        };
        FS.Async.ajax(config, completeFn);
    },

    /*************登录设置*************/
    /**
     * 登录页配置标签页
     * 同 fs 平台样式部分
     */
    loginMgrModule: function () {
        var self = this;
        var colSize = [80, 131, 'fill'];
        var rowSize = [21, 52, 25, 150, 30];
        return {
            title: FR.i18nText("FS-Setting-Login_Page"),
            content: {
                widgetName: 'LOGINSETPANE',
                type: 'tablepane',
                colSize: colSize,
                rowSize: rowSize,
                vgap: 20,
                items: [
                    self._createLoginPageTypeConfig(),
                    self._createLoginPageUrlConfig(),
                    self._createLoginImgUploadConfig(),
                    [null, {}, $('<img/>').addClass('fs_csview_loginimg')],
                    [{
                        type: 'quickbutton',
                        style: 'blue',
                        text: FR.i18nText("FS-Frame-Simple_Save"),
                        handler: function () {
                            self.saveLoginPageData();
                        }
                    }, null, null]
                ]
            }
        };
    },

    /**
     * 创建登录页类型选择选项
     * @private
     */
    _createLoginPageTypeConfig: function () {
        var self = this;
        return [
            null,
            {
                type: 'llabel',
                value: FR.i18nText("FS-Setting-Customize_Login")
            },
            {
                widgetName: "mgrLoginPageTypeRadioGroup",
                type: 'radiogroup',
                assureSelect: true,
                width: 270,
                height: 21,
                items: [
                    {
                        text: FR.i18nText("FS-Setting-Login_Background"),
                        value: 1,
                        width: 135
                    },
                    {
                        text: FR.i18nText("FS-Setting-Login_URL"),
                        value: 2,
                        width: 135
                    }
                ],
                listeners: [{
                    eventName: "afteredit",
                    action: function () {
                        var widget = this.getWidgetByName("mgrLoginPageTypeRadioGroup");
                        if (widget && widget.getValue() === 1) {
                            self._showLoginPageImg();
                        } else {
                            self._showLoginPageURL();
                        }
                    }
                }],
                columnsInRow: 2
            }
        ]
    },

    /**
     * 创建登录页标签 Url 配置部分
     * @private
     */
    _createLoginPageUrlConfig: function () {
        return [
            null,
            {},
            {
                widgetName: "mgrLoginPageUrlPane",
                type: 'tablepane',
                colSize: [122, 322],
                rowSize: [21, 21],
                vgap: 10,
                items: [
                    [{type: 'llabel', value: FR.i18nText("FS-Setting-Login_URL_Detail")}, null],
                    [null, {widgetName: "mgrLoginPageUrlText", type: 'text'}]
                ]
            }
        ]
    },

    /**
     * 创建登录页标签自定义图片上传配置部分
     * @private
     */
    _createLoginImgUploadConfig: function () {
        var self = this;
        return [
            null,
            {
                el: $('<div/>')
            },
            {
                type: 'multifile',
                widgetName: "mgrLoginPageImgUpload",
                maxlength: 1,
                accept: '.png.jpg.gif',
                hideFileList: true,
                height: 32,
                width: 32,
                tooltipText: FR.i18nText("FS-Setting-BG_Upload_ToolTip"),
                listeners: [
                    {
                        eventName: "afteredit",
                        action: function () {
                            var widget = this.getWidgetByName("mgrLoginPageImgUpload");
                            if (widget) {
                                var attachid = widget.getValue().attach_id;
                                var url = FR.servletURL + ('?op=fr_attach&cmd=ah_image&id=' + attachid + '&isAdjust=false');
                                self.loginImgView.attr('src', url);
                                $('td', widget.element).remove();
                            }
                        }
                    }
                ]
            }
        ]
    },

    /**
     * 显示登录页自定义图片配置部分
     * @private
     */
    _showLoginPageImg: function () {
        var sc = this.serverConfig;
        var attr = this.data;
        sc.getWidgetByName('LOGINSETPANE').setRowVisible([1], false);
        sc.getWidgetByName('LOGINSETPANE').setRowVisible([2, 3], true);
        var url = FR.servletURL + (
            attr.loginimg ? ('?op=fr_attach&cmd=ah_image&id=' + attr.loginimg + '&isAdjust=false') :
                '?op=resource&resource=/com/fr/fs/resources/images/oem/signin.jpg'
        );
        //缓存登录页图片预览配置
        this.loginImgView = $('.fs_csview_loginimg');
        this.loginImgView.attr('src', url);
    },

    /**
     * 显示登录页 Url 配置部分
     * @private
     */
    _showLoginPageURL: function () {
        var sc = this.serverConfig;
        sc.getWidgetByName('LOGINSETPANE').setRowVisible([1], true);
        sc.getWidgetByName('LOGINSETPANE').setRowVisible([2, 3], false);
    },

    /**
     * 保存登录页配置数据
     */
    saveLoginPageData: function () {
        var sc = this.serverConfig;
        var jo = {};
        var isLoginImg = (sc.getWidgetByName("mgrLoginPageTypeRadioGroup").getValue() === 1);
        jo.isLoginImg = isLoginImg;
        if (isLoginImg) {
            var loginPageAttach = sc.getWidgetByName("mgrLoginPageImgUpload").getValue();
            if (loginPageAttach && loginPageAttach.attach_id) {
                jo.loginImgId = loginPageAttach.attach_id;
            }
        } else {
            var loginUrl = sc.getWidgetByName("mgrLoginPageUrlText").getValue();
            if (loginUrl) {
                jo.loginUrl = loginUrl;
            }
        }
        var completeFn = function (res, status) {
            if (status === 'success') {
                FR.Msg.toast(FR.i18nText("FS-Generic-Simple_Successfully"));
            }
        };
        var config = {
            url: FR.servletURL + '?op=fs_manager&cmd=fs_set_login_page',
            type: 'POST',
            data: jo
        };
        FS.Async.ajax(config, completeFn);
    }
};