FS.UserManagerItems = FS.Plugin.UserManagerItems;
FS.UserManagerTools = FS.Plugin.UserManagerTools;

/**
 * Coder: Sean
 * Date: 14-4-14
 * Time: 下午6:21
 */
FS.USERMGR = FSUM = {
    STATIC: {
        KEYWORD: "",//搜索的关键字
        SORT: {
            username: true,  //用户名当前升降序标记  true为升序 false为降序
            realname: true,  //真实姓名当前升降序标记
            depart: true,  //部门职务升降序标记
            role: true  //角色升降序标记
        },
        SORTKEY: '',
        STARTIDX: 0,//记录下本页的起始索引序号
        PAGECOUNT: 10 //每页多少条
    },
    Constants: {
        userLimitConfigPanelWD: "userLimitConfigPanel",
        userLimitConfigTableWD: "userLimitConfigTable",
        userLimitUnauthorizedPanelWD: "userLimitUnauthorizedPanel",
        userLimitAuthorizedPanelWD: "userLimitAuthorizedPanel",
        userLimitUnauthorizedListWD: "userLimitUnauthorizedList",
        userLimitAuthorizedListWD: "userLimitAuthorizedList",
        userLimitUnauthorizedListPanelWD: "userLimitUnauthorizedListPanel",
        userLimitAuthorizedListPanelWD: "userLimitAuthorizedListPanel",
        userLimitAuthMoveRightButtonWD: "userLimitAuthMoveRightButton",
        userLimitAuthMoveLeftButtonWD: "userLimitAuthMoveLeftButton",
        customRoleListSyncItemCls: "fs_sys_user_customRoleSyncItem",
        customRoleListItemCls: "fs_cs_srole_item",
        customRoleListWD: "customRoleListWD",
        sroleuserListWD: "sroleuserlistWD",
        departMultiTreeWD: "departMultiTreeWD",
        userSearchWD: "userSearchWD"
    },

    init: function (renderer) {
        this.STATIC = {
            KEYWORD: "",
            SORT: {
                username: true,
                realname: true,
                depart: true,
                role: true
            },
            SORTKEY: '',
            STARTIDX: 0,
            PAGECOUNT: 10
        },//还原下排序相关
            FR.$defaultImport('/com/fr/fs/web/css/manager/fs_usermgr.css', 'css');
        this.preLoadData();
        this.mainPane = renderer;
        if (!FS.isGradeAuthorityOpen() || FS.isAdmin()) {
            //没有开启多级权限分配或者是管理员登录时,才能使用设置面板。
            this.createSetPane(renderer);
        }
        var items = [
            this.userModule(),
            this.institutionModule(),
            this.sRoleModule()
        ];
        var initActions = [
            function () {

            }, function () {

            }, function () {

            }
        ];
        // 用户登录数限制
        if (FS.config.userLimit > 0 && FS.isAdmin()) {
            items.push(this.userLimitTabConfig());
            initActions.push(function () {
                this.getWidgetByName(FSUM.Constants.userLimitAuthMoveLeftButtonWD).setEnable(false);
                this.getWidgetByName(FSUM.Constants.userLimitAuthMoveRightButtonWD).setEnable(false);
                this.getWidgetByName(FSUM.Constants.userLimitConfigTableWD).element.css("overflow", "auto");
                this.getWidgetByName(FSUM.Constants.userLimitUnauthorizedPanelWD).element.css({
                    position: "relative",
                    overflow: "visible"
                });
                this.getWidgetByName(FSUM.Constants.userLimitAuthorizedPanelWD).element.css({
                    position: "relative",
                    overflow: "visible"
                });
                this.getWidgetByName(FSUM.Constants.userLimitUnauthorizedListPanelWD).element.css("position", "relative");
                this.getWidgetByName(FSUM.Constants.userLimitAuthorizedListPanelWD).element.css("position", "relative");
                this.getWidgetByName(FSUM.Constants.userLimitUnauthorizedListWD).element.css("position", "relative");
                this.getWidgetByName(FSUM.Constants.userLimitAuthorizedListWD).element.css("position", "relative");
                this.getWidgetByName(FSUM.Constants.userLimitConfigTableWD).element.css("position", "relative");
            });
        }

        for (var i = 0; i < FS.Plugin.UserManagerItems.length; i++) {
            var newItem = FS.Plugin.UserManagerItems[i];
            var ui = newItem.ui;
            if (ui) {
                items.push(ui);
                initActions.push(newItem.action);
            }
        }

        this.tabPane = new FS.LTabPane({
            width: '100%',
            height: '100%',
            style: 'blue',
            top: 15,
            left: 20,
            marginLeft: 40,
            items: items,
            renderEl: renderer,
            initAfterActions: initActions
        });
    },
    /**
     * 用户管理页面加载预处理数据
     */
    preLoadData: function () {
        var self = this;
        //获取用户认证方式
        this.loginAuthenticateType = FS.Trans.ajax({
            url: FR.servletURL + "?op=fs_load&cmd=loginAuthenticateType",
            returnString: true
        });
        //获取服务器数据集和同步数据集配置信息
        self.syncdata = FS.Sync.ajax({
            url: FR.servletURL + '?op=fs_manager&cmd=fs_get_syncdatainfo',
            type: 'POST'
        });
        //是否开启同步数据集 0:内置hsql,1:同步数据集,2:内置同步数据集
        var state = FS.Trans.getTableDataSyncState();
        this.isSyncOn = (state.type !== 0);
    },

    isHttp: function () {
        return this.loginAuthenticateType === 'http';
    },
    /**
     * 判断是否是LDAP认证
     * @returns {boolean} 返回是否是LDAP认证
     */
    isAuthLdap: function () {
        if (this.loginAuthenticateType == 'ldap') {
            return true;
        } else {
            return false;
        }
    },
    /**
     * 判断是否是平台内置认证方式
     * @returns {boolean}
     */
    isAuthDefault: function () {
        if (this.loginAuthenticateType == 'default') {
            return true;
        } else {
            return false;
        }
    },
    /**
     * 生称拉下设置面板
     * @param anchor 固定dom
     */
    createSetPane: function (anchor) {
        var self = this;
        var confirmPanel = {
            type: 'confirm',
            fit: true,
            doSize: true,
            closeAfterAction: false,
            btnsAlignment: 'left',
            needSeparate: 8,
            onOK: function () {
                self._saveOrSyncData();
            },
            onCancel: function () {
                self.popAuthSetData(self.floatPane);
                self.popSyncSetData(self.floatPane);
                self.floatPane.doSlide();
            },
            contentWidget: {
                type: "tablepane",
                widgetName: "scrollSetPane",
                colSize: ["fill"],
                rowSize: ["auto"],
                scrollable: true,
                items: [
                    [self._createSetPaneContent()]
                ]
            }
        };
        self.floatPane = FR.createWidget({
            type: 'floatpane',
            anchor: anchor,
            contentHeight: 375,
            contentWidget: confirmPanel
        });
        self.floatPane.getWidgetByName("scrollSetPane").element.css({
            position: 'relative',
            'overflow-y': 'auto'
        });
        self.floatPane.getWidgetByName("authModeRadioGroup").element.css({
            position: 'relative'
        });
        if (!self.isAuthDefault()) {
            self.floatPane.getWidgetByName("passwordCombo").setEnable(false);
            self.floatPane.getWidgetByName("encryptionCombo").setEnable(false);
        }
        this.popAuthSetData(self.floatPane);
        this.popSyncSetData(self.floatPane);
    },
    _saveOrSyncData: function () {
        var self = this;
        var isSaveSuccess = true;
        //Sean: 必须全部同步按顺序进行，因为同步数据集的设置需要先判断LDAP
        //用户认证方式设置保存
        var authtype = self.floatPane.getWidgetByName("authModeRadioGroup").getValue();
        var re = FS.Sync.ajax({
            url: FR.servletURL + "?op=fs_load&cmd=installLoginAuthenticateType",
            data: {loginAuthenticateType: authtype}
        });
        isSaveSuccess = re.success && isSaveSuccess;
        if (isSaveSuccess) {
            var result = self.saveAuthConfig(authtype, self.floatPane);
            self.loginAuthenticateType = authtype;
            isSaveSuccess = result.success && isSaveSuccess;
        }
        //同步数据集设置保存
        var syncOn = self.floatPane.getWidgetByName("syncOpenSwitch").getValue();
        if (syncOn) {
            var data = self.getDSWidgetData(self.floatPane);
            //只有同步数据集的时候会有同步频率
            data.rate = self.floatPane.getWidgetByName("syncRateNumber").getValue();
            var syncRes = FS.Trans.saveTableDataSync(data);
            isSaveSuccess = syncRes.success && isSaveSuccess;
        } else {
            var res = FS.Trans.closeTableDataSync();
            isSaveSuccess = res.success && isSaveSuccess;
        }
        if (isSaveSuccess) {
            FS.signOut();
        } else {
            FR.Msg.toast(FR.i18nText("FS-Generic-Simple_Failed"));
        }
    },

    _createSetPaneContent: function () {
        var typeLen = FS.Plugin.AuthenticateTypePool.length;
        var rowSize = [0, 21];
        var items = this._createFirstSegmentItems();
        var contentItems = this._createContentItems();
        for (var i = 0, len = contentItems.length; i < len; i++) {
            var contentItem = contentItems[i];
            rowSize.push(contentItem.rowHeight);
            items.push(contentItem.el);
        }
        rowSize = rowSize.concat([25, 37, 25, 25, 170, 5]);
        items = items.concat(this._createLastSegmentItems(typeLen));

        return {
            type: 'tablepane',
            widgetName: 'SETTABLE',
            colSize: [20, FR.i18nTextWidth("FS-User-Synchronized_DataSet", 6.5) + 24, 550],
            rowSize: rowSize,
            vgap: 15,
            items: items
        };
    },

    _createFirstSegmentItems: function () {
        var self = this;
        var items = this._createAuthTypeItems();
        return [
            [null, null, {}],

            [{}, {type: 'llabel', value: FR.i18nText("FS-User-Simple_Authentication")},
                {
                    type: 'radiogroup',
                    assureSelect: true,
                    columnsInRow: items.length,
                    widgetName: 'authModeRadioGroup',
                    width: 400,
                    value: 0,
                    items: items,
                    listeners: [
                        {
                            eventName: FR.Events.AFTEREDIT,
                            action: function () {
                                var value = this.getValue();
                                self._doSelectChange(value);
                            }
                        }
                    ]
                }
            ]
        ];
    },

    _createLastSegmentItems: function (typeLen) {
        var self = this;
        return [
            [
                {}, {type: 'llabel', value: FR.i18nText("FS-User-Synchronized_DataSet")},
                {
                    type: 'switch',
                    widgetName: 'syncOpenSwitch',
                    onTurnOff: function () {
                        //关闭同步数据集
                        self.floatPane.getWidgetByName("SETTABLE").setRowVisible([5 + typeLen, 6 + typeLen, 7 + typeLen, 8 + typeLen], false);
                    },
                    onTurnOn: function () {
                        //开启同步数据集
                        var rowArray = self.syncdata.isTransferred ? [5 + typeLen, 7 + typeLen, 8 + typeLen] : [5 + typeLen, 6 + typeLen, 7 + typeLen, 8 + typeLen];
                        self.floatPane.getWidgetByName("SETTABLE").setRowVisible(rowArray, true);
                    }
                }
            ],

            [{}, {}, {
                type: 'llabel',
                width: Math.max(240, 150 + FR.i18nTextWidth("FS-Generic-DS_Server_TableData", 6.5)) + 210,
                value: FR.i18nText('FS-System-First_Login_Info4')
            }],

            [{}, {}, self._createSyncLocationPane()],

            [{}, {}, self._createSynchronizeRateSetPane()],

            [{}, {}, self._createUserAuthSetTable()],

            [null, null, {}]
        ];
    },

    _createAuthTypeItems: function () {
        var items = [
            {value: 'default', text: FR.i18nText("FS-User-Builtin_Authentification")},
            {value: 'ldap', text: FR.i18nText("FS-User-LDAP_Authentification")},
            {value: 'http', text: FR.i18nText("FS-User-Http_Authentification")}
        ];
        $.each(FS.Plugin.AuthenticateTypePool, function (index, item) {
            var obj = {};
            if ($.isFunction(item.defineTypeString)) {
                obj.value = item.defineTypeString.apply(this);
            }
            if ($.isFunction(item.defineTitleString)) {
                obj.text = item.defineTitleString.apply(this);
            }
            items.push(obj);
        });
        return items;
    },

    _createContentItems: function () {
        var content = [
            {
                rowHeight: 260,
                el: [{}, {}, this._createLdapSetTable()]
            },
            {
                rowHeight: 21,
                el: [{}, {}, {type: 'text', widgetName: 'httpurlText', watermark: 'Example: http://localhost/saa'}]
            }
        ];
        $.each(FS.Plugin.AuthenticateTypePool, function (index, item) {
            var obj = {};
            if ($.isFunction(item.defineRowHeightNumber)) {
                obj.rowHeight = item.defineRowHeightNumber.apply(this);
            }
            if ($.isFunction(item.defineUI)) {
                obj.el = item.defineUI.apply(this);
            }
            content.push(obj);
        });
        return content;
    },

    _doSelectChange: function (value) {
        var hiddenRows;
        if (value === 'default') {
            hiddenRows = [2, 3];
            $.each(FS.Plugin.AuthenticateTypePool, function (index) {
                hiddenRows.push(index + 4);
            });

            this.floatPane.getWidgetByName("SETTABLE").setRowVisible(hiddenRows, false);
            this.floatPane.getWidgetByName("passwordCombo").setEnable(true);
            this.floatPane.getWidgetByName("encryptionCombo").setEnable(true);
        } else if (value === 'ldap') {
            this.floatPane.getWidgetByName("SETTABLE").setRowVisible([2], true);
            hiddenRows = [3];
            $.each(FS.Plugin.AuthenticateTypePool, function (index) {
                hiddenRows.push(index + 4);
            });
            this.floatPane.getWidgetByName("SETTABLE").setRowVisible(hiddenRows, false);
            this.floatPane.getWidgetByName("passwordCombo").setEnable(false);
            this.floatPane.getWidgetByName("encryptionCombo").setEnable(false);
        } else if (value === 'http') {
            hiddenRows = [2];
            $.each(FS.Plugin.AuthenticateTypePool, function (index) {
                hiddenRows.push(index + 4);
            });
            this.floatPane.getWidgetByName("SETTABLE").setRowVisible(hiddenRows, false);
            this.floatPane.getWidgetByName("SETTABLE").setRowVisible([3], true);
            this.floatPane.getWidgetByName("passwordCombo").setEnable(false);
            this.floatPane.getWidgetByName("encryptionCombo").setEnable(false);
        } else {
            hiddenRows = [2, 3];
            var visibleIndex = null;
            $.each(FS.Plugin.AuthenticateTypePool, function (index, item) {
                if ($.isFunction(item.defineTypeString)) {
                    if (value == item.defineTypeString.apply()) {
                        visibleIndex = index + 4;
                    } else {
                        hiddenRows.push(index + 4);
                    }
                }
            });
            this.floatPane.getWidgetByName("SETTABLE").setRowVisible(hiddenRows, false);
            this.floatPane.getWidgetByName("SETTABLE").setRowVisible([visibleIndex], true);
            this.floatPane.getWidgetByName("passwordCombo").setEnable(false);
            this.floatPane.getWidgetByName("encryptionCombo").setEnable(false);

        }
    },

    _createLdapSetTable: function () {
        return {
            type: 'tablepane',
            widgetName: 'LDAPSETTABLE',
            colSize: [FR.i18nTextWidth("FS-User-Ldap_Suffix", 6.5) + 45, 210],
            rowSize: [21, 21, 21, 21, 21, 21, 21, 21, 21],
            vgap: 8,
            items: [
                [
                    {type: 'llabel', value: '*URL'},
                    {
                        type: 'text',
                        widgetName: 'urlCombo',
                        watermark: FR.i18nText("FS-Generic-Simple_Example") + ':ldap://192.168.106.201:389'
                    }
                ], [
                    {type: 'llabel', value: FR.i18nText("FS-User-Retrieve_Location")},
                    {
                        type: 'text',
                        widgetName: 'locationText',
                        watermark: FR.i18nText("FS-Generic-Simple_Example") + ':DC=finereport'
                    }
                ], [
                    {type: 'llabel', value: ''},
                    {
                        type: 'checkbox',
                        widgetName: 'retrieveLocAsBaseDN',
                        text: FR.i18nText("FS-User-Retrieve_Location_As_BaseDN"),
                        value: true
                    }
                ], [
                    {type: 'llabel', value: '*' + FR.i18nText("FS-User-Simple_Authentication")},
                    {
                        type: 'combo', widgetName: 'authmodCombo',
                        items: [
                            {
                                'text': 'simple',
                                'value': 1
                            }, {
                                'text': 'strong',
                                'value': 2
                            }, {
                                'text': 'none',
                                'value': 3
                            }
                        ]
                    }
                ], [
                    {type: 'llabel', value: '*' + FR.i18nText("FS-User-Ldap_Context")},
                    {
                        type: 'combo', widgetName: 'contextCombo',
                        items: [
                            {
                                'text': 'com.sun.jndi.ldap.LdapCtxFactory',
                                'value': 1
                            }, {
                                'text': 'com.sun.jndi.ldap.connect.pool',
                                'value': 2
                            }
                        ]
                    }
                ], [
                    {type: 'llabel', value: '*' + FR.i18nText("FS-User-Ldap_Referral")},
                    {
                        type: 'combo', widgetName: 'ReferralCombo',
                        items: [
                            {
                                'text': 'follow',
                                'value': 1
                            }, {
                                'text': 'ignore',
                                'value': 2
                            }, {
                                'text': 'throw',
                                'value': 3
                            }
                        ]
                    }
                ], [
                    {type: 'llabel', value: FR.i18nText("FS-User-Ldap_Suffix")},
                    {
                        type: 'text',
                        widgetName: 'suffixText',
                        watermark: FR.i18nText("FS-Generic-Simple_Example") + ':@finereport.com'
                    }
                ], [
                    {type: 'llabel', value: FR.i18nText("FS-Admin-Simple_Name")},
                    {type: 'text', widgetName: 'adminnameText'}
                ], [
                    {type: 'llabel', value: FR.i18nText("FS-Admin-Admin_Password")},
                    {type: 'password', widgetName: 'adminpwdText'}
                ]
            ]
        };
    },

    _createUserAuthSetTable: function () {
        var self = this;
        var $line = $('<div class="fs-usermgr-line"/>');
        var leftPane = {
            type: 'tablepane',
            widgetName: 'userAuthTable',
            colSize: [Math.max(100, FR.i18nTextWidth("FS-Generic-DS_Server_TableData", 6.5) + 10), 110],
            rowSize: [21, 21, 21, 21, 21, 21],
            vgap: 8,
            items: [
                [
                    {type: 'llabel', value: FR.i18nText("FS-Generic-DS_Server_TableData")},
                    self.getTableDataComboCfg()
                ], [
                    {type: 'llabel', value: FR.i18nText("FS-Generic-Simple_Username")},
                    {type: 'combo', widgetName: 'usernameCombo', items: []}
                ], [
                    {type: 'llabel', value: FR.i18nText("FS-Admin-Full_Name")},
                    {type: 'combo', widgetName: 'fullnameCombo', items: []}
                ], [
                    {type: 'llabel', value: FR.i18nText("FS-Generic-Simple_Password")},
                    {type: 'combo', widgetName: 'passwordCombo', items: []}
                ], [
                    {type: 'llabel', value: FR.i18nText("FS-User-Encryption_Mode")},
                    self.createEncrypComboCfg()
                ], [
                    {},
                    {type: 'text', widgetName: 'customEncrypText'}
                ]
            ]
        };
        var rightPane = {
            type: 'tablepane',
            colSize: [FR.i18nTextWidth("FS-Generic-Simple_Email", 6.5) > 70 ?
                (FR.i18nTextWidth("FS-Generic-Simple_Email", 6.5) + 10) : 70, 110],
            rowSize: [21, 21, 21, 21, 21],
            vgap: 8,
            items: [
                [
                    {type: 'llabel', value: FR.i18nText("FS-User-Simple_Department")},
                    {type: 'combo', widgetName: 'departmentCombo', items: []}
                ], [
                    {type: 'llabel', value: FR.i18nText("FS-User-Simple_Position")},
                    {type: 'combo', widgetName: 'positionCombo', items: []}
                ], [
                    {type: 'llabel', value: FR.i18nText("FS-Generic-Simple_Role")},
                    {type: 'combo', widgetName: 'roleCombo', items: []}
                ], [
                    {type: 'llabel', value: FR.i18nText("FS-Generic-Simple_Email")},
                    {type: 'combo', widgetName: 'emailCombo', items: []}
                ], [
                    {type: 'llabel', value: FR.i18nText("FS-Generic-Mobile_Phone")},
                    {type: 'combo', widgetName: 'mobilephoneCombo', items: []}
                ]
            ]
        };
        return {
            type: 'tablepane',
            colSize: [Math.max(240, 150 + FR.i18nTextWidth("FS-Generic-DS_Server_TableData", 6.5)), 30, 180],
            rowSize: [170],
            vgap: 8,
            items: [
                [
                    leftPane,
                    $('<div/>').append($line),
                    rightPane
                ]
            ]
        };
    },
    _createSyncLocationPane: function () {
        var tab = this;
        return {
            type: 'tablepane',
            widgetName: 'syncLocationPane',
            colSize: [100, 110, 90],
            rowSize: [21],
            vgap: 20,
            items: [
                [
                    {type: 'label', value: FR.i18nText("FS-Generic-Simple_Storage_Location"), textalign: 'left'},
                    {type: 'label', widgetName: 'syncLocation', value: 'xml'},
                    {
                        type: 'quickbutton',
                        widgetName: 'syncTrans',
                        invisible: true,
                        style: 'blue',
                        width: FR.i18nTextWidth("FS-Generic-Simple_Transferring_To_DB", 7),
                        text: FR.i18nText("FS-Generic-Simple_Transferring_To_DB"),
                        handler: function () {
                            var self = this;
                            FR.Msg.confirm(FR.i18nText("FS-System-Dialog_Title"), FR.i18nText("FS-Generic-Simple_Transfer_Tips"), function (t) {
                                if (t) {
                                    FR.showLoadingDialog({
                                        title: FR.i18nText("FS-Generic-Simple_Data_Transferring"),
                                        text: FR.i18nText("FS-Generic-Simple_Transferring")
                                    });
                                    var url = FR.servletURL;
                                    FS.Async.ajax({
                                        url: url,
                                        data: {
                                            op: 'fs_main',
                                            cmd: 'sync_trans'
                                        }
                                    }, function (res, status) {
                                        if (status == 'success') {
                                            FR.hideLoadingDialog();
                                            var resText = FR.jsonDecode(res.responseText).resText;
                                            if (resText === true) {
                                                self.setEnable(false);
                                                tab.floatPane.getWidgetByName("syncLocation").setValue(FR.i18nText("FS-Generic-Simple_DB_Platform"), false);
                                                FR.Msg.alert(FR.i18nText("FS-System-Dialog_Title"), FR.i18nText("FS-Generic-Simple_Transfer_SuccessFully"));
                                            } else {
                                                FR.Msg.alert(FR.i18nText("FS-System-Dialog_Title"), FR.i18nText("FS-Generic-Simple_Transfer_Failed") + resText);
                                            }
                                        }
                                    });
                                }
                            });
                        }
                    }
                ]
            ]
        };
    },
    _createSynchronizeRateSetPane: function () {
        var self = this;
        return {
            type: 'tablepane',
            widgetName: 'synchronizeRateSetPane',
            colSize: [100, 110, 30, 90],
            rowSize: [21],
            vgap: 20,
            items: [
                [
                    {type: 'label', value: FR.i18nText("FS-Generic-Synchronize_Rate"), textalign: 'left'},
                    {type: 'number', widgetName: 'syncRateNumber', value: 10},
                    {type: 'label', value: FR.i18nText("FS-Generic-Sche_Second"), textalign: 'center'},
                    {
                        type: 'quickbutton',
                        style: 'blue',
                        text: FR.i18nText("FS-Generic-Synchronize_Now"),
                        handler: function () {
                            self._saveOrSyncData();
                        }
                    }
                ]
            ]
        };
    },

    popAuthSetData: function (pw) {
        if (this.isAuthDefault()) {
            pw.getWidgetByName('authModeRadioGroup').setValue('default', true);
        } else if (this.isAuthLdap()) {
            var ldapAttrs = FR.jsonDecode(FS.Trans.getLdapAttrs());
            pw.getWidgetByName('authModeRadioGroup').setValue('ldap', true);
            pw.getWidgetByName('urlCombo').setValue(ldapAttrs.ldapUrl);
            pw.getWidgetByName('locationText').setValue(ldapAttrs.ldapSearchBase);
            pw.getWidgetByName('retrieveLocAsBaseDN').setValue(ldapAttrs.retrieveLocAsBaseDN);
            pw.getWidgetByName('authmodCombo').setValue(ldapAttrs.authentication);
            pw.getWidgetByName('contextCombo').setValue(ldapAttrs.contextFactory);
            pw.getWidgetByName('ReferralCombo').setValue(ldapAttrs.referral);
            pw.getWidgetByName('suffixText').setValue(ldapAttrs.principalSuffix);
            pw.getWidgetByName('adminnameText').setValue(ldapAttrs.ldapSystemName);
            pw.getWidgetByName('adminpwdText').setValue(ldapAttrs.ldapSystemPassword);
        } else if (this.isHttp()) {
            pw.getWidgetByName('authModeRadioGroup').setValue('http', true);
            var completeFn = function (res, status) {
                if (status == 'success') {
                    var http = FR.jsonDecode(res.responseText);
                    if (http.url) {
                        pw.getWidgetByName('httpurlText').setValue(http.url);
                    }
                }
            };
            var config = {
                url: FR.servletURL + "?op=fs_set&cmd=sc_http_get"
            };
            FS.Async.ajax(config, completeFn);
        } else {
            var self = this;
            $.each(FS.Plugin.AuthenticateTypePool, function (index, item) {
                if ($.isFunction(item.defineTypeString)) {
                    var mark = item.defineTypeString.apply(self);
                    if (self.loginAuthenticateType === mark) {
                        pw.getWidgetByName('authModeRadioGroup').setValue(mark, true);
                        if ($.isFunction(item.populateData)) {
                            item.populateData.apply(self, [pw]);
                        }
                    }
                }
            });
        }
    },
    /**
     * 导入配置数据
     * @param pw 父容器
     */
    popSyncSetData: function (pw) {
        //同步数据集导入配置数据。
        var syncdata = this.syncdata;
        pw.getWidgetByName("userAuthTable").setRowVisible(5, false);
        if (this.isSyncOn) {
            pw.getWidgetByName("syncOpenSwitch").setValue(true, true);
        } else {
            pw.getWidgetByName("syncOpenSwitch").setValue(false, true);
        }
        if (syncdata.dsName) {
            pw.getWidgetByName("tableDataCombo").setValue(syncdata.dsName);
            this.rebuildDSWidgets(syncdata.dsName, pw);
            if (syncdata.userName > -1) {
                pw.getWidgetByName("usernameCombo").setValue(syncdata.userName);
            }
            if (syncdata.password > -1) {
                pw.getWidgetByName("passwordCombo").setValue(syncdata.password);
            }
            if (syncdata.name > -1) {
                pw.getWidgetByName("fullnameCombo").setValue(syncdata.name);
            }
            if (syncdata.department > -1) {
                pw.getWidgetByName("departmentCombo").setValue(syncdata.department);
            }
            if (syncdata.post > -1) {
                pw.getWidgetByName("positionCombo").setValue(syncdata.post);
            }
            if (syncdata.role > -1) {
                pw.getWidgetByName("roleCombo").setValue(syncdata.role);
            }
            if (syncdata.email > -1) {
                pw.getWidgetByName("emailCombo").setValue(syncdata.email);
            }
            if (syncdata.mobile > -1) {
                pw.getWidgetByName("mobilephoneCombo").setValue(syncdata.mobile);
            }
            if (syncdata.rate) {
                pw.getWidgetByName("syncRateNumber").setValue(syncdata.rate);
            }
            pw.getWidgetByName("SETTABLE").setRowVisible([6 + FS.Plugin.AuthenticateTypePool.length], false);
            if (!syncdata.isTransferred) {
                pw.getWidgetByName("SETTABLE").setRowVisible([6 + FS.Plugin.AuthenticateTypePool.length], true);
                pw.getWidgetByName("syncTrans").setVisible(true);
            }
        }
        this.popEncryptSet(pw, syncdata);
    },

    popEncryptSet: function (pw, syncdata) {
        var combo = pw.getWidgetByName("encryptionCombo");
        if (syncdata.encrypt > -1) {
            combo.setValue(syncdata.encrypt, true);
        } else {
            combo.setValue(0, true);
        }
        if (syncdata.encrypt === 1) {
            pw.getWidgetByName("customEncrypText").setValue(syncdata.myencrypt);
        }
    },
    /**
     * 保存认证方式设置
     * @param {String} type 用户认证方式
     * @param {FR.Widget} pw 父容器
     */
    saveAuthConfig: function (type, pw) {
        var result = {success: true};
        if (type == "ldap") {
            result = FS.Trans.ajax({
                url: FR.servletURL + "?op=fs_load&cmd=installLdapAttrs",
                data: {
                    loginLdapUrl: pw.getWidgetByName('urlCombo').getValue(),
                    ldapSearchBase: pw.getWidgetByName('locationText').getValue(),
                    retrieveLocAsBaseDN: pw.getWidgetByName('retrieveLocAsBaseDN').getValue(),
                    referral: pw.getWidgetByName('ReferralCombo').getText(),
                    authentication: pw.getWidgetByName('authmodCombo').getText(),
                    contextFactory: pw.getWidgetByName('contextCombo').getText(),
                    ldapPrincipalSuffix: pw.getWidgetByName('suffixText').getValue(),
                    ldapSystemName: pw.getWidgetByName('adminnameText').getText(),
                    ldapSystemPassword: pw.getWidgetByName('adminpwdText').getText()
                }
            });
        } else if (type == 'http') {
            result = FS.Trans.ajax({
                url: FR.servletURL + "?op=fs_set&cmd=sc_http_set",
                data: {
                    httpurl: pw.getWidgetByName('httpurlText').getValue()
                }
            });
        } else {
            $.each(FS.Plugin.AuthenticateTypePool, function (index, item) {
                if ($.isFunction(item.defineTypeString) && item.defineTypeString.apply() == type) {
                    return $.isFunction(item.saveDataSync) && item.saveDataSync(pw);
                }
            });
        }
        return result;
    },
    /************用户管理*************/
    userModule: function () {
        var self = this;
        var items = [
            self.createHeaderControl(),
            [self.createUserGridCfg(), null, null, null, null, null]
        ];
        var config = {
            title: FR.i18nText("FS-User-All_Users"),
            content: {
                type: 'panel',
                width: 800,
                height: 400,
                doSize: true,
                contentWidget: {
                    type: 'tablepane',
                    colSize: ['auto', 75, 75, 75, 195, 214],
                    rowSize: [28, 'auto'],
                    vgap: 15,
                    marginLeft: 10,
                    marginRight: 10,
                    items: items
                }
            }
        };
        return config;
    },

    createHeaderControl: function () {
        var self = this;
        var header = [
            {}, {
                type: 'search',
                widgetName: 'searchUser',
                onSearch: function () {
                    var value = this.getValue();
                    self.STATIC.KEYWORD = value;
                    var usergrid = self.tabPane.getWidgetByName("USERINFOGRID");
                    var data = usergrid.options.async.data;
                    data.startIdx = 0;
                    data.keyword = value;
                    usergrid.activedPage = 1;
                    usergrid.refresh();
                }
            }
        ];
        //如果未开启同步数据集则没有添加、导入、删除操作。
        if (!self.isSyncOn) {
            header.unshift(
                null, {
                    type: 'iconbutton',
                    text: FR.i18nText("FS-Generic-Simple_Add"),
                    baseClass: 'fs-usermgr-add',
                    handler: function () {
                        var h = FS.Plugin.UserManagerTools.addUser;
                        if ($.isFunction(h)) {
                            h.apply(self);
                        } else {
                            self.createUserAddDialog();
                        }
                    }
                }, {
                    type: 'iconbutton',
                    text: FR.i18nText("FS-Generic-Import_2"),
                    baseClass: 'fs-usermgr-import',
                    handler: function () {
                        var h = FS.Plugin.UserManagerTools.importUser;
                        if ($.isFunction(h)) {
                            h.apply(self);
                        } else {
                            var dialog = self.createUserImportDialog();
                            dialog.setVisible(true);
                            $('[widgetName=importpane]').append(
                                $('<div style="left: 0px;padding: 20px;height: 30px;position: absolute;width:300px;top:17px">' + FR.i18nText('FS-System-First_Login_Info3') + '</div>')
                            );
                        }
                    }
                }, {
                    type: 'iconbutton',
                    text: FR.i18nText("FS-Generic-Simple_Delete"),
                    baseClass: 'fs-usermgr-delete-blue',
                    handler: function () {
                        FR.Msg.confirm(FR.i18nText("FS-User-Delete_User"), FR.i18nText("FS-Generic-Sure_To_Delete") + "?", function (result) {
                            if (result) {
                                var usrgrid = self.tabPane.getWidgetByName("USERINFOGRID");
                                var selectedData = usrgrid.getSelectedData();
                                var duserids = [];
                                for (var i = 0, len = selectedData.length; i < len; i++) {
                                    duserids.push(selectedData[i].id);
                                }
                                FS.Trans.removeUser(duserids.join(","));
                                usrgrid.refresh();
                            }
                        });
                    }
                }
            );
        } else {
            header.unshift(
                null, {}, {}, {}
            );
        }
        return header;
    },
    createSortCell: function (itemcfg) {
        var grid = this.tabPane.getWidgetByName("USERINFOGRID"), self = this;
        var key = itemcfg.key;
        var keySort = self.STATIC.SORT[key];
        var sortClass = "fs-user-sort-button";
        if (self.STATIC.SORTKEY === key) {
            sortClass = keySort === false ? "fs-user-sort-down" : "fs-user-sort-up";
        }
        var $cell = $('<div/>').addClass(sortClass).click(
            function () {
                self.STATIC.SORT[key] = !self.STATIC.SORT[key];
                var data = {
                    keyword: self.STATIC.KEYWORD,
                    sortBy: key,
                    asc: self.STATIC.SORT[key],
                    startIdx: self.STATIC.STARTIDX,
                    count: self.STATIC.PAGECOUNT,
                    serverID: FS.serverID
                };
                self.STATIC.SORTKEY = key;//记录下当前排序的依据
                FR.ajax({
                    url: FR.servletURL + "?op=fs_set&cmd=auth_getalluserinfo",
                    data: data,
                    complete: function (res, status) {
                        if (status == 'success') {
                            var res = FR.jsonDecode(res.responseText);
                            grid.refresh(res.users);
                        }
                    }
                });
            }
        ).append($('<span/>').text(itemcfg.value));
        return $cell;
    },

    /**
     * 生成用户信息列表控件的配置信息
     * @returns {JSON} 返回配置信息
     */
    createUserGridCfg: function () {
        var self = this;
        var colcfg = [
            {
                key: 'username',
                value: FR.i18nText("FS-Generic-Simple_Username"),
                width: 100,
                onHeadCellCreate: function (colIdx, itemcfg) {
                    return self.createSortCell(itemcfg);
                }
            },
            {
                key: 'realname',
                value: FR.i18nText("FS-Admin-Full_Name"),
                width: 100,
                onHeadCellCreate: function (colIdx, itemcfg) {
                    return self.createSortCell(itemcfg);
                }
            },
            {
                key: 'depart',
                value: FR.i18nText("FS-User-Department_Position"),
                width: 120,
                onHeadCellCreate: function (colIdx, itemcfg) {
                    return self.createSortCell(itemcfg);
                }
            },
            {
                key: 'role',
                value: FR.i18nText("FS-Generic-Simple_Role"),
                width: 100,
                onHeadCellCreate: function (colIdx, itemcfg) {
                    return self.createSortCell(itemcfg);
                }
            },
            {
                key: 'email',
                value: FR.i18nText("FS-Generic-Simple_Email"),
                width: FR.i18nTextWidth("FS-Generic-Simple_Email", 6.5) > 90 ?
                    (FR.i18nTextWidth("FS-Generic-Simple_Email", 6.5) + 20) : 95
            },
            {
                key: 'mobile',
                value: FR.i18nText("FS-Generic-Mobile_Phone"),
                width: 95
            }
        ];
        if (!this.isSyncOn) {
            colcfg.push({
                width: 24,
                onCellCreate: function (rowIdx, colIdx, item, colCfg) {
                    var usrgrid = this;
                    var editBtn = new FR.IconButton({
                        width: 24,
                        height: 24,
                        imgsrc: 'fs-module-edit-white',
                        handler: function () {
                            var okCallback = function () {
                                //编辑用户dialog确定按钮事件
                                var username = editUserDialog.getWidgetByName("USERNAMETEXT").getValue();
                                var realname = editUserDialog.getWidgetByName("FULLNAMETEXT").getValue();
                                var sroleArr = editUserDialog.getWidgetByName("ROLECHECK").getValue();
                                var srole = sroleArr ? sroleArr.join('; ') : '';
                                var user = {
                                    username: username,
                                    realname: realname,
                                    email: editUserDialog.getWidgetByName("EMAILTEXT").getValue(),
                                    mobile: editUserDialog.getWidgetByName("PHONETEXT").getValue(),
                                    id: item.id
                                };
                                if (item.role !== srole) {
                                    user.srole = srole;
                                }
                                if (!self.checkUserValid(username, realname, true)) {
                                    return false;
                                }
                                var result = FS.Trans.addUser(user);
                                if (!result.success) {
                                    FR.Msg.alert(FR.Msg.Alert, FR.i18nText("FS-User-Add_User_Failure"));
                                    return false;
                                }
                                usrgrid.refresh();
                            };
                            var editUserDialog = new FR.Dialog({
                                title: FR.i18nText("FS-User-Edit_User"),
                                text4OK: FR.i18nText("FS-Generic-Simple_OK"),
                                text4Cancel: FR.i18nText("Fine-Engine_FS_Generic_Simple_Cancel"),
                                onOK: function () {
                                    return okCallback.apply(this);
                                },
                                onCancel: function () {
                                },
                                destroyOnClose: true,
                                width: 355,
                                height: 335,
                                confirm: true,
                                border: true,
                                contentWidget: {
                                    type: 'absolute',
                                    items: [
                                        {
                                            x: 20, y: 10, width: 315, height: 40,
                                            type: 'label', textalign: 'left', value: FR.i18nText('FS-System-First_Login_Info2')
                                        },
                                        {
                                            x: 0, y: 50, width: 355, height: 180,
                                            type: 'tablelayout',
                                            columnSize: [FR.i18nTextWidth("FS-User-Reset_Password", 6.5) > 92 ?
                                                (FR.i18nTextWidth("FS-User-Reset_Password", 6.5) + 5) : 92, 16, 180],
                                            rowSize: [21, 21, 24, 21, 21, 21, 21],
                                            vgap: 10,
                                            items: [
                                                [
                                                    {
                                                        el: {
                                                            type: 'llabel',
                                                            textalign: 'right',
                                                            value: '*'+FR.i18nText("FS-Generic-Simple_Username")
                                                        }
                                                    },
                                                    null,
                                                    {el: {type: 'text', widgetName: 'USERNAMETEXT'}}
                                                ],
                                                [
                                                    {
                                                        el: {
                                                            type: 'llabel',
                                                            textalign: 'right',
                                                            value: '*'+FR.i18nText("FS-Admin-Full_Name")
                                                        }
                                                    },
                                                    null,
                                                    {el: {type: 'text', widgetName: 'FULLNAMETEXT'}}
                                                ],
                                                !self.isAuthDefault() ? [] :
                                                    [
                                                        {
                                                            el: {
                                                                type: 'llabel',
                                                                textalign: 'right',
                                                                value: '*'+FR.i18nText("FS-User-Reset_Password")
                                                            }
                                                        },
                                                        null,
                                                        {
                                                            el: {
                                                                type: 'iconbutton',
                                                                widgetName: 'PASSWORDRESET',
                                                                text: FR.i18nText("FS-User-Reset_Password_As"),
                                                                imgsrc: 'fs-usermgr-pwd',
                                                                handler: function () {
                                                                    //重置密码按钮事件
                                                                    item.password = "123456";
                                                                    var result = FS.Trans.addUser(item);
                                                                    if (!result.success) {
                                                                        FR.Msg.toast(FR.i18nText("FS-Generic-Simple_Failed"));
                                                                        return false;
                                                                    }
                                                                    this.setEnable(false);
                                                                    this.element.addClass('fs-usermgr-pwd-done').text(FR.i18nText("FS-User-Password_Reseted"));
                                                                }
                                                            }
                                                        }
                                                    ],
                                                [
                                                    {
                                                        el: {
                                                            type: 'llabel',
                                                            textalign: 'right',
                                                            value: FR.i18nText("FS-Generic-Simple_Email")
                                                        }
                                                    },
                                                    null,
                                                    {el: {type: 'text', widgetName: 'EMAILTEXT'}}
                                                ],
                                                [
                                                    {
                                                        el: {
                                                            type: 'llabel',
                                                            textalign: 'right',
                                                            value: FR.i18nText("FS-Generic-Mobile_Phone")
                                                        }
                                                    },
                                                    null,
                                                    {el: {type: 'text', widgetName: 'PHONETEXT'}}
                                                ],
                                                [
                                                    {
                                                        el: {
                                                            type: 'llabel',
                                                            textalign: 'right',
                                                            value: FR.i18nText("FS-Generic-Simple_Role")
                                                        }
                                                    },
                                                    null,
                                                    {
                                                        el: {
                                                            type: 'combocheckbox',
                                                            widgetName: 'ROLECHECK',
                                                            directEdit: true,
                                                            allowBlank: true,
                                                            widgetUrl: FR.servletURL + "?op=fs_set&cmd=auth_getcustomrole",
                                                            returnArray: true
                                                        }
                                                    }
                                                ]
                                            ]
                                        }
                                    ]
                                }
                            });
                            editUserDialog.setVisible(true);
                            editUserDialog.getWidgetByName("USERNAMETEXT").setValue(item.username);
                            editUserDialog.getWidgetByName("FULLNAMETEXT").setValue(item.realname);
                            editUserDialog.getWidgetByName("EMAILTEXT").setValue(item.email);
                            editUserDialog.getWidgetByName("PHONETEXT").setValue(item.mobile);
                            if (item.role) {
                                editUserDialog.getWidgetByName("ROLECHECK").setValue(item.role.split('; '));
                            }
                        }
                    });
                    return editBtn.element;
                }
            });
            colcfg.push({
                width: 24,
                onCellCreate: function (rowIdx, colIdx, item, colCfg) {
                    var delBtn = new FR.IconButton({
                        width: 24,
                        height: 24,
                        imgsrc: 'fs-module-delete-white',
                        handler: function () {
                            var userTable = self.tabPane.getWidgetByName("USERINFOGRID");
                            //删除用户
                            FR.Msg.confirm(FR.i18nText("FS-User-Delete_User"), FR.i18nText("FS-Generic-Sure_To_Delete") + "?", function (result) {
                                if (result) {
                                    FS.Trans.removeUser(item.id);
                                    userTable.refresh();
                                }
                            });
                        }
                    });
                    return delBtn.element;
                }
            });
        }
        var sortBy = self.STATIC.SORTKEY || 'username';
        var cfg = {
            type: 'quickgrid',
            page: true,
            autoPage: false,
            pageCount: self.STATIC.PAGECOUNT,
            multiSelect: !self.isSyncOn,
            intervalColor: true,
            marginLeft: 10,
            marginRight: 10,
            widgetName: 'USERINFOGRID',
            async: {
                url: FR.servletURL + "?op=fs_set&cmd=auth_getalluserinfo",
                data: {
                    startIdx: 0,
                    count: self.STATIC.PAGECOUNT,
                    serverID: FS.serverID,
                    sortBy: sortBy,
                    asc: self.STATIC.SORT[sortBy]
                }
            },
            onPageTurn: function (active, count, nav) {
                var async = this.options.async;
                var sortBy = self.STATIC.SORTKEY || 'username';
                async.data.startIdx = (active - 1) * count;
                async.data.asc = self.STATIC.SORT[sortBy];
                async.data.sortBy = sortBy;
                self.STATIC.STARTIDX = async.data.startIdx;
                this.refresh();
            },
            onAsyncSuccess: function (res, status) {
                var result = FR.jsonDecode(res);
                this.options.items = result.users;
                this.totalpages = Math.ceil(result.total / 10);
            },
            columnsConfig: colcfg
        };
        return cfg;
    },
    /**
     * 检验用户导入，同步数据集配置和添加用户是数据表字段选择的完整性
     * 只有平台内置认证时，密码和用户名必填；其余情况只有用户名必填。部门和职位必须同时选或者同时不选。
     * @param username 用户名字段
     * @param realname 姓名字段
     * @param password 密码字段
     * @param depart 部门字段
     * @param post 职位字段
     * @returns {boolean} 返回是否数据完整
     */
    checkUserValid: function (username, realname, password, depart, post) {
        if (FR.isEmpty(username)) {
            FR.Msg.alert(FR.i18nText("Fine-Engine_FS_Generic_Simple_Alert"), FR.i18nText("FS-User-User_Can_Not_Be_Null"));
            return false;
        }
        if (FR.isEmpty(realname)) {
            FR.Msg.alert(FR.i18nText("Fine-Engine_FS_Generic_Simple_Alert"), FR.i18nText("FS-Admin-Name_Can_Not_Be_Null"));
            return false;
        }
        if (this.isAuthDefault() && FR.isEmpty(password)) {
            FR.Msg.alert(FR.i18nText("Fine-Engine_FS_Generic_Simple_Alert"), FR.i18nText("FS-Admin-Password_Can_Not_Be_Null"));
            return false;
        }
        if (FR.isEmpty(post) && !FR.isEmpty(depart) || !FR.isEmpty(post) && FR.isEmpty(depart)) {
            FR.Msg.alert(FR.i18nText("Fine-Engine_FS_Generic_Simple_Alert"), FR.i18nText("FS-User-Depart_Post_Together"));
            return false;
        }
        return true;
    },


    createUserAddDialog: function () {
        var self = this;
        var addUserDialog = new FR.Dialog({
            title: FR.i18nText("FS-User-Add_User"),
            text4OK: FR.i18nText("FS-Generic-Simple_OK"),
            text4Cancel: FR.i18nText("Fine-Engine_FS_Generic_Simple_Cancel"),
            onOK: function () {
                //添加用户dialog确定按钮事件
                var userTable = self.tabPane.getWidgetByName("USERINFOGRID");
                var userName = addUserDialog.getWidgetByName("USERNAMETEXT").getValue();
                var realName = addUserDialog.getWidgetByName("FULLNAMETEXT").getValue();
                var password = !self.isAuthDefault() ? "123456" : addUserDialog.getWidgetByName("PASSWORDTEXT").getValue();
                if (!self.checkUserValid(userName, realName, password)) {
                    return false;
                }
                var sroleArr = addUserDialog.getWidgetByName("ROLECHECK").getValue();
                var user = {
                    username: userName,
                    realname: realName,
                    password: password,
                    email: addUserDialog.getWidgetByName("EMAILTEXT").getValue(),
                    mobile: addUserDialog.getWidgetByName("PHONETEXT").getValue(),
                    srole: sroleArr ? sroleArr.join('; ') : ''
                };
                var result = FS.Trans.addUser(user);
                if (!result.success) {
                    FR.Msg.alert(FR.Msg.Alert, FR.i18nText("FS-User-Add_User_Failure"));
                    return false;
                }
                userTable.refresh();
            },
            onCancel: function () {
            },
            destroyOnClose: true,
            animate: false,
            width: 355,
            height: 325,
            confirm: true,
            border: true,
            closable: true,
            contentWidget: {
                type: 'absolute',
                items: [
                    {
                        x: 20, y: 10, width: 315, height: 40,
                        type: 'label', textalign: 'left', value: FR.i18nText('FS-System-First_Login_Info2')
                    },
                    {
                        x: 0, y: 50, width: 350, height: 180,
                        type: 'tablelayout',
                        columnSize: [FR.i18nTextWidth("FS-Generic-Simple_Email", 6.5) > 90 ?
                            (FR.i18nTextWidth("FS-Generic-Simple_Email", 6.5) + 8) : 92, 16, 180],
                        rowSize: [21, 21, 21, 21, 21, 21, 21],
                        vgap: 10,
                        items: [
                            [
                                {
                                    el: {
                                        type: 'llabel',
                                        textalign: 'right',
                                        value: '*' + FR.i18nText("FS-Generic-Simple_Username")
                                    }
                                },
                                null,
                                {el: {type: 'text', widgetName: 'USERNAMETEXT'}}
                            ],
                            [
                                {
                                    el: {
                                        type: 'llabel',
                                        textalign: 'right',
                                        value: '*' + FR.i18nText("FS-Admin-Full_Name")
                                    }
                                },
                                null,
                                {el: {type: 'text', widgetName: 'FULLNAMETEXT'}}
                            ],
                            !self.isAuthDefault() ? [] :
                                [
                                    {
                                        el: {
                                            type: 'llabel',
                                            textalign: 'right',
                                            value: '*' + FR.i18nText("FS-Generic-Simple_Password")
                                        }
                                    },
                                    null,
                                    {el: {type: 'password', widgetName: 'PASSWORDTEXT'}}
                                ],
                            [
                                {
                                    el: {
                                        type: 'llabel',
                                        textalign: 'right',
                                        value: FR.i18nText("FS-Generic-Simple_Email")
                                    }
                                },
                                null,
                                {el: {type: 'text', widgetName: 'EMAILTEXT'}}
                            ],
                            [
                                {
                                    el: {
                                        type: 'llabel',
                                        textalign: 'right',
                                        value: FR.i18nText("FS-Generic-Mobile_Phone")
                                    }
                                },
                                null,
                                {el: {type: 'text', widgetName: 'PHONETEXT'}}
                            ],
                            [
                                {
                                    el: {
                                        type: 'llabel',
                                        textalign: 'right',
                                        value: FR.i18nText("FS-Generic-Simple_Role")
                                    }
                                },
                                null,
                                {
                                    el: {
                                        type: 'combocheckbox',
                                        widgetName: 'ROLECHECK',
                                        directEdit: true,
                                        allowBlank: true,
                                        customData: false,
                                        widgetUrl: FR.servletURL + "?op=fs_set&cmd=auth_getcustomrole",
                                        returnArray: true
                                    }
                                }
                            ]
                        ]
                    }
                ]
            }
        });
        addUserDialog.setVisible(true);
    },

    /**
     * 生成用户导入对话框
     */
    createUserImportDialog: function () {
        var self = this;
        var encryptCfg = FS.Trans.ajax({
            url: FR.servletURL + "?op=fs_manager&cmd=gethsqlpv"
        });
        var importDialog = new FR.Dialog({
            title: FR.i18nText("FS-User_Import_User"),
            widgetName: 'importpane',
            width: 350,
            height: 445,
            confirm: true,
            border: true,
            closable: true,
            contentWidget: {
                type: 'tablepane',
                colSize: [350],
                rowSize: [55, 350],
                items: [
                    [{}], [self.getUserImportConfig()]
                ]
            },
            closeAfterAction: false,
            destroyOnClose: true,
            onOK: function () {
                var data = self.getDSWidgetData(importDialog);
                if (!data) {
                    return false;
                }
                self.doImportUsers({res: data});
                importDialog.doClose();
            },
            onCancel: function () {
                this.doClose();
            }
        });
        if (!self.isAuthDefault()) {
            importDialog.getWidgetByName("passwordCombo").setEnable(false);
            importDialog.getWidgetByName("encryptionCombo").setEnable(false);
        }
        this.popEncryptSet(importDialog, encryptCfg);
        return importDialog;
    },

    /**
     * 加密方式是否改变(用户导入)
     * @param oldEncrypt 旧加密方式
     * @param newEncrypt 新加密方式
     * @returns {boolean} 返回加密方式是否改变
     */
    hasEncryptChanged: function (oldEncrypt, newEncrypt) {
        if (oldEncrypt.encrypt != newEncrypt.encrypt) {
            return true;
        } else if (newEncrypt.encrypt === 1 && oldEncrypt.myencrypt != newEncrypt.myencrypt) {
            return true;
        }
        return false;
    },

    doImportUsers: function (data) {
        var self = this,
            usergrid = this.tabPane.getWidgetByName("USERINFOGRID");
        var $loading = this._createLoading();
        $loading.appendTo(this.mainPane);
        var completeFn = function (res, status) {
            if (status == 'success') {
                var importres = FR.jsonDecode(res.responseText);
                if (importres.query) {
                    FR.Msg.confirm(FR.i18nText("FS-Generic-Simple_Warning"), importres.query + '?',
                        function (result) {
                            if (result) {
                                data.clearall = true;
                                self.doImportUsers(data);
                            }
                            $loading.remove();
                        });
                    return;
                }
                if (importres.hasDuplicated) {
                    FR.Msg.confirm(FR.i18nText("FS-Generic-Simple_Warning"), importres.warnings + '?',
                        function (result) {
                            if (result) {
                                self.addDuplicatedUsers($loading);
                            } else {
                                usergrid.refresh();
                                $loading.remove();
                            }
                        });
                } else {
                    usergrid.refresh();
                    $loading.remove();
                }
            } else {
                $loading.remove();
            }
        };
        var config = {
            url: FR.servletURL + "?op=fs_manager&cmd=importUser",
            data: data
        };
        FS.Async.ajax(config, completeFn);
    },

    _createLoading: function () {
        var $loading = $('<div class="fs-usermgr-loading"/>');
        return $loading;
    },
    /**
     * 用户导入界面配置
     * @returns {*}
     */
    getUserImportConfig: function () {
        var self = this;
        //提示信息
        var $tip = $('<div class="fs-usermgr-tip-icon"></div>').click(
            function () {
                var $tipContext = $('<div class="fs-usermgr-tip-context">' +
                    FR.i18nText("FS-User-Sync_Dataset_Config_Tip") +
                    '</div>');
                var left = $(this).offset().left + $(this).width();
                var top = $(this).offset().top + $(this).height();
                $tipContext.appendTo($('body')).css({
                    position: 'absolute',
                    left: left,
                    top: top,
                    'z-index': FR.widget.opts.zIndex++
                });
                $(document).bind('mousedown.tip', $tipContext, function (e) {
                    var target = e.target;
                    if (!$(target).isChildAndSelfOf('div.fs-usermgr-tip-context')) {
                        $tipContext.remove();
                        $(document).unbind('mousedown.tip');
                    }
                });
            }
        );
        return {
            type: 'tablepane',
            widgetName: 'userAuthTable',
            colSize: [FR.i18nTextWidth("FS-Generic-DS_Server_TableData", 6.5) + 32, 10, 150, 6],
            rowSize: [21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21],
            vgap: 11,
            items: [
                [
                    {
                        type: 'llabel',
                        value: '*' + FR.i18nText("FS-Generic-DS_Server_TableData"),
                        textalign: 'right'
                    }, {},
                    self.getTableDataComboCfg(), $('<div/>').append($tip)
                ], [
                    {type: 'llabel', value: '*' + FR.i18nText("FS-Generic-Simple_Username"), textalign: 'right'}, {},
                    {type: 'combo', widgetName: 'usernameCombo', items: []}
                ], [
                    {type: 'llabel', value: '*' + FR.i18nText("FS-Admin-Full_Name"), textalign: 'right'}, {},
                    {type: 'combo', widgetName: 'fullnameCombo', items: []}
                ], [
                    {type: 'llabel', value: '*' + FR.i18nText("FS-Generic-Simple_Password"), textalign: 'right'}, {},
                    {type: 'combo', widgetName: 'passwordCombo', items: []}
                ], [
                    {type: 'llabel', value: FR.i18nText("FS-User-Encryption_Mode"), textalign: 'right'}, {},
                    self.createEncrypComboCfg()
                ], [
                    {}, {}, {type: 'text', widgetName: 'customEncrypText'}
                ], [
                    {type: 'llabel', value: FR.i18nText("FS-User-Simple_Department"), textalign: 'right'}, {},
                    {type: 'combo', widgetName: 'departmentCombo', items: []}
                ], [
                    {type: 'llabel', value: FR.i18nText("FS-User-Simple_Position"), textalign: 'right'}, {},
                    {type: 'combo', widgetName: 'positionCombo', items: []}
                ], [
                    {type: 'llabel', value: FR.i18nText("FS-Generic-Simple_Role"), textalign: 'right'}, {},
                    {type: 'combo', widgetName: 'roleCombo', items: []}
                ], [
                    {type: 'llabel', value: FR.i18nText("FS-Generic-Simple_Email"), textalign: 'right'}, {},
                    {type: 'combo', widgetName: 'emailCombo', items: []}
                ], [
                    {type: 'llabel', value: FR.i18nText("FS-Generic-Mobile_Phone"), textalign: 'right'}, {},
                    {type: 'combo', widgetName: 'mobilephoneCombo', items: []}
                ]
            ]
        };
    },
    /**
     * 生成服务器数据集下拉框的配置信息
     * @returns {*}
     */
    getTableDataComboCfg: function () {
        var self = this;
        return {
            type: 'combo',
            widgetName: 'tableDataCombo',
            widgetUrl: FR.servletURL + "?op=fs_manager&cmd=fs_get_servertabledata&serverID=" + FS.serverID,
            listeners: [
                {
                    eventName: FR.Events.AFTEREDIT,
                    action: function () {
                        var ds = this.getValue();
                        self.rebuildDSWidgets(ds, this);
                    }
                }
            ]
        };
    },

    /**
     * 获取服务器数据集配置下所有控件的值
     * @param pw 父容器
     * @returns {*}
     */
    getDSWidgetData: function (pw) {
        var self = this;
        var username = pw.getWidgetByName("usernameCombo").getValue(),
            name = pw.getWidgetByName("fullnameCombo").getValue(),
            password = pw.getWidgetByName("passwordCombo").getValue(),
            department = pw.getWidgetByName("departmentCombo").getValue(),
            post = pw.getWidgetByName("positionCombo").getValue(),
            role = pw.getWidgetByName("roleCombo").getValue(),
            mobile = pw.getWidgetByName("mobilephoneCombo").getValue(),
            email = pw.getWidgetByName("emailCombo").getValue()
        if (!this.checkUserValid(username, name, password, department, post)) {
            return null;
        }
        var res = {
            dsName: pw.getWidgetByName("tableDataCombo").getValue(),
            userName: FR.isEmpty(username) ? -1 : username,
            name: FR.isEmpty(name) ? -1 : name,
            password: FR.isEmpty(password) ? -1 : password,
            department: FR.isEmpty(department) ? -1 : department,
            post: FR.isEmpty(post) ? -1 : post,
            role: FR.isEmpty(role) ? -1 : role,
            mobile: FR.isEmpty(mobile) ? -1 : mobile,
            email: FR.isEmpty(email) ? -1 : email,
            encrypt: pw.getWidgetByName("encryptionCombo").getValue()
        };
        if (res.encrypt === 1) {
            res.myencrypt = pw.getWidgetByName("customEncrypText").getValue();
        }
        if (!res.encrypt) {
            res.encrypt = 0;
        }
        return res;
    },
    /**
     * 重置服务器数据集字段选择控件
     * @param ds 服务器数据集名称
     * @param pw 父容器
     */
    rebuildDSWidgets: function (ds, pw) {

        var cols = [];
        if (!FR.isEmpty(ds)) {
            cols = FS.Tools.getColsByTableDataName(ds);
        }
        var widgetNames = ["usernameCombo", "passwordCombo", "fullnameCombo", "departmentCombo",
            "positionCombo", "emailCombo", "mobilephoneCombo", "roleCombo"];
        for (var i = 0; i < 8; i++) {
            var widget = pw.getWidgetByName(widgetNames[i]);
            widget.options.renderEl = widget.element;
            widget.rebuild(cols);
        }
    },

    /**
     * 生成加密下拉框的配置信息
     * @returns {*}
     */
    createEncrypComboCfg: function () {
        return {
            type: 'combo',
            widgetName: 'encryptionCombo',
            allowBlank: true,
            value: 0,
            items: [
                {text: FR.i18nText("FS-User-No_Encryption"), value: 0},
                {text: FR.i18nText("FS-User-Custom_Encryption"), value: 1},
                {text: FR.i18nText("FS-User-MD5_Encryption"), value: 2}
            ],
            listeners: [
                {
                    eventName: FR.Events.AFTEREDIT,
                    action: function () {
                        var val = this.getValue();
                        var table = this.getWidgetByName("userAuthTable");
                        if (val === 1) {
                            table.setRowVisible([5], true);
                        } else {
                            table.setRowVisible([5], false);
                        }
                    }
                }
            ]
        };
    },
    /**
     * 覆盖导入重名用户
     */
    addDuplicatedUsers: function ($loading) {
        var self = this;
        var completeFn = function (res, status) {
            if (status == 'success') {
                if (res.success) {
                    //导入成功
                    self.tabPane.getWidgetByName("USERINFOGRID").refresh();
                }
            }
            $loading.remove();
        };
        var config = {
            url: FR.servletURL + "?op=fs_manager&cmd=importUser",
            data: {
                override: true
            }
        };
        FS.Async.ajax(config, completeFn);
    },
    /************部门管理*************/
    institutionModule: function () {
        var self = this, isSyncOn = this.isSyncOn;
        var filter = function (parentNode, node, newNodes, result, open) {
            if (!newNodes) {
                return null;
            }
            if (!result) {
                result = [];
            }
            for (var i = 0, l = newNodes.length; i < l; i++) {
                var item = newNodes[i];
                var zItem = {};
                zItem.name = item.text;
                if (item.ChildNodes && item.ChildNodes.length > 0) {
                    filter(item, node, item.ChildNodes, result, false);
                }
                zItem.id = item.id;
                zItem.pId = item.parentID || item.parentId;
                zItem.type = item.type;
                zItem.description = item.description;
                zItem.open = (open === false ? open : true);
                if (self._alreadyExists(zItem.id, result)) {
                    continue;
                }
                result.push(zItem);
            }
            return result;
        };
        var paneWidth = 230, paneHeight = 375,
            dpadd = null, dpedit = null,
            postedit = null, postdel = null,
            useredit = null, userdel = null;
        if (!isSyncOn) {
            dpadd = this._createDpmgrTool();
            dpedit = this._createDptreeTool();
            postedit = this._createPostTool();
            useredit = this._createUserTool();
        }

        var keyupFunction = function (e) {
            (function () {
                if (!FR.isNavKeyPress(e)) {
                    var val = this.getValue();
                    var departmentsNode = self.tabPane.getWidgetByName("DEPARTMENTTABLETREE");
                    var result = FS.Sync.ajax({
                        url: FR.servletURL + "?op=fs_set&cmd=auth_getspecialdepart",
                        data: {
                            searchKeyword: val,
                            serverID: FS.serverID
                        },
                        type: 'POST'
                    });
                    var newTreeNodes = departmentsNode.options.setting.async.dataFilter("fsUserDepartmentTableTree", result, result);
                    var allOldNodes = departmentsNode.getNodes();
                    var allOldNodesNum = allOldNodes.length;
                    //刷新Tree，（1）清空所有Node（2）添加新的Nodes
                    for (var i = 0; i < allOldNodesNum; i++) {
                        departmentsNode.removeNode(allOldNodes[0]);
                    }
                    departmentsNode.addNodes(null, newTreeNodes, true);
                }
            }).createDelegate(this).defer(500);
        };
        var config = {
            title: FR.i18nText("FS-Generic-Simple_Institution"),
            content: {
                type: 'panel',
                width: 800,
                height: 510,
                doSize: true,
                contentWidget: {
                    type: 'absolute',
                    widgetName: 'INSTITUTLAYOUT',
                    items: [
                        //机构部门管理
                        {
                            el: {
                                type: "panel",
                                width: paneWidth,
                                height: paneHeight,
                                title: FR.i18nText("FS-User-Department_Management"),
                                border: true,
                                doSize: true,
                                tools: dpadd,
                                contentWidget: {
                                    type: 'border',
                                    items: [{
                                        region: 'center',
                                        el: {
                                            type: 'fstabletree',
                                            widgetName: 'DEPARTMENTTABLETREE',
                                            treeID: 'fsUserDepartmentTableTree',
                                            height: '100%',
                                            width: '100%',
                                            alwaysShowTools: false,
                                            toolMargin: 0,
                                            itemHoverCls: 'fs-sys-tabletree-item-hover',
                                            setting: {
                                                view: {
                                                    showIcon: false  //不显示每个节点前的ICON
                                                },
                                                data: {
                                                    simpleData: {
                                                        enable: true,
                                                        idKey: "id",
                                                        pidKey: "pId",
                                                        rootPId: "-2"
                                                    }
                                                },
                                                async: {
                                                    enable: true,
                                                    url: FR.servletURL + "?op=fs_set&cmd=auth_getspecialdepart",
                                                    dataFilter: filter,
                                                    data: {
                                                        serverID: FS.serverID
                                                    }
                                                },
                                                callback: {
                                                    onClick: function (e, treeId, treeNode) {
                                                        //选择部门显示部门下的职位列表
                                                        var nodeid = treeNode.id,
                                                            postlist = self.tabPane.getWidgetByName("POSTLIST"),
                                                            userlist = self.tabPane.getWidgetByName("USERLIST");
                                                        userlist.clear();
                                                        postlist.refresh({
                                                            async: {
                                                                url: FR.servletURL + "?op=fs_set&cmd=auth_getjrole_post",
                                                                data: {
                                                                    departid: nodeid,
                                                                    serverID: FS.serverID
                                                                }
                                                            }
                                                        });
                                                    }
                                                }
                                            },
                                            tools: dpedit
                                        }
                                    }, {
                                        region: 'north',
                                        el: {
                                            type: 'search',
                                            width: 308,
                                            autoSearch: true,
                                            onKeyup: keyupFunction
                                        },
                                        height: 28
                                    }],
                                    width: 308
                                }
                            }, x: 0, y: 0
                        },
                        //职位管理
                        {
                            el: {
                                type: "panel",
                                title: FR.i18nText("FS-User-Post_Management"),
                                border: true,
                                width: paneWidth,
                                height: paneHeight,
                                tools: postedit,
                                contentWidget: {
                                    type: 'quicklist',
                                    widgetName: "POSTLIST",
                                    height: '100%',
                                    alwaysShowTools: false,
                                    itemCanBeSelect: true,
                                    showField: 'postName',
                                    valueField: 'postId',
                                    tools: isSyncOn ? null : [
                                            {
                                                iconCls: 'fs-module-delete-white',
                                                iconCls4Hover: 'fs-module-delete-white-hover'
                                            }
                                        ],
                                    onItemToolClick: function (toolindex, index) {
                                        //删除职位
                                        var depart = self.tabPane.getWidgetByName("DEPARTMENTTABLETREE").getSelectedNodes()[0];
                                        var postlist = self.tabPane.getWidgetByName("POSTLIST");
                                        var userlist = self.tabPane.getWidgetByName("USERLIST");
                                        if (!depart) {
                                            return;
                                        }
                                        FR.Msg.confirm(FR.i18nText("Fine-Engine_FS_Frame_Delete_Data"), FR.i18nText("FS-Generic-Sure_To_Delete") + "?", function (result) {
                                            if (result) {
                                                var completeFn = function (res, status) {
                                                    if (status == 'success') {
                                                        var re = FR.jsonDecode(res.responseText);
                                                        if (re.success) {
                                                            userlist.clear();
                                                            userlist.element.data('users', null);
                                                            postlist.remove(index);
                                                        }
                                                    }
                                                };
                                                var config = {
                                                    url: FR.servletURL + "?op=fs_set&cmd=auth_removejrole_post",
                                                    data: {
                                                        departid: depart.id,
                                                        postid: postlist.getValueAtIndex(index)
                                                    },
                                                    type: 'POST'
                                                };
                                                FS.Async.ajax(config, completeFn);
                                            }
                                        });
                                    },
                                    onItemSelect: function () {
                                        var data = self._getPostAndDepart();
                                        var userlist = self.tabPane.getWidgetByName("USERLIST");
                                        if (!data) {
                                            return;
                                        }
                                        data = $.extend(data, {serverID: FS.serverID});

                                        userlist.refresh({
                                            async: {
                                                url: FR.servletURL + "?op=fs_set&cmd=auth_getallemployee",
                                                data: data
                                            }
                                        });
                                    }
                                }
                            }, x: 270, y: 0
                        },
                        //人员管理
                        {
                            el: {
                                type: "panel",
                                width: paneWidth,
                                height: paneHeight,
                                title: FR.i18nText("FS-User-Personnel_Management"),
                                border: true,
                                tools: useredit,
                                contentWidget: {
                                    type: 'quicklist',
                                    widgetName: 'USERLIST',
                                    scrollLoading: true,
                                    height: '100%',
                                    alwaysShowTools: false,
                                    itemCanBeSelect: true,
                                    onAsyncSuccess: function (items) {
                                        this.element.data("users", items);
                                    },
                                    dataFilter: function (item) {
                                        return {
                                            text: item.text,
                                            value: item.userid
                                        };
                                    },
                                    tools: isSyncOn ? null : [
                                            {
                                                iconCls: 'fs-module-delete-white',
                                                iconCls4Hover: 'fs-module-delete-white-hover'
                                            }
                                        ],
                                    onItemToolClick: function (toolindex, index) {
                                        var userlist = self.tabPane.getWidgetByName("USERLIST");
                                        //删除人员
                                        FR.Msg.confirm(FR.i18nText("Fine-Engine_FS_Frame_Delete_Data"), FR.i18nText("FS-Generic-Sure_To_Delete") + "?", function (result) {
                                            if (result) {
                                                var users = userlist.element.data("users");
                                                var uid = users[index].id;
                                                var data = self._getPostAndDepart();
                                                var completeFn = function (res, status) {
                                                    if (status == 'success') {
                                                        var re = FR.jsonDecode(res.responseText);
                                                        if (re.success) {
                                                            userlist.remove(index);
                                                            users.splice(index, 1);
                                                            userlist.element.data("users", users);
                                                        }
                                                    }
                                                };
                                                var config = {
                                                    data: {
                                                        userid: uid,
                                                        departid: data.departid,
                                                        postid: data.postid
                                                    },
                                                    url: FR.servletURL + "?op=fs_set&cmd=auth_removeemployee",
                                                    type: 'POST'
                                                };
                                                FS.Async.ajax(config, completeFn);
                                            }
                                        });
                                    }
                                }
                            }, x: 540, y: 0
                        }
                    ]
                }
            }
        };
        return config;
    },
    /************角色管理*************/
    sRoleModule: function () {
        var self = this;
        var paneWidth = 230, paneHeight = 375;
        //只有管理员才能使用增加自定义角色按钮
        var operation = FS.Plugin.GradeAuthority.Operation;
        var items = [];
        var sradd;
        if (operation && operation.item && $.isFunction(operation.item.action) && FR.Plugin.validLevel(FS.Plugin.GradeAuthority.Operation, operation.item)) {
            operation.item.action.call(this, items);
            if (items.length > 0) {//非0说明是管理员或者装了分级权限管理插件
                sradd = this._createSRolemgrTool();
            }
        }
        var useredit = this._createSRoleUserTool();

        var keyupFunction = function (e) {
            (function () {
                if (!FR.isNavKeyPress(e)) {
                    var val = this.getValue();
                    var roleList = self.tabPane.getWidgetByName(FSUM.Constants.customRoleListWD);
                    roleList.refresh({
                        async: {
                            url: FR.servletURL + "?op=fs_set&cmd=auth_getcustomrole",
                            data: {
                                dataFilter: val,
                                serverID: FS.serverID
                            }
                        }
                    });
                }
            }).createDelegate(this).defer(500);
        };
        var customRoleList = {
            type: 'quicklist',
            scrollLoading: true,
            async: {
                url: FR.servletURL + '?op=fs_set&cmd=auth_getcustomrole',
                data: {
                    serverID: FS.serverID
                }
            },
            onBeforeItemCreate: function (element, opts) {
                if (opts.id < 0 || opts.isSync) {
                    element.addClass(FSUM.Constants.customRoleListSyncItemCls);
                } else {
                    element.addClass(FSUM.Constants.customRoleListItemCls);
                }
                element.attr("id", opts.id);
            },
            valueField: 'id',
            width: 200,
            height: 400,
            itemCanBeSelect: true
        };
        customRoleList.widgetName = FSUM.Constants.customRoleListWD;
        //编辑按钮
        $.extend(customRoleList, {
            tools: [
                {
                    iconCls: 'fs-module-delete-white',
                    iconCls4Hover: 'fs-module-delete-white-hover'
                },
                {
                    iconCls: 'fs-module-edit-white',
                    iconCls4Hover: 'fs-module-edit-white-hover'
                }
            ],
            alwaysShowTools: false,
            onItemToolClick: function (toolindex, index, e) {
                e.stopEvent();
                var customRoleList = self.tabPane.getWidgetByName(FSUM.Constants.customRoleListWD);

                if (toolindex === 1) {
                    //编辑
                    var roleId = customRoleList.getValueAtIndex(index);
                    var roleName = customRoleList.getTextAtIndex(index);
                    FR.Msg.prompt(FR.i18nText("Fine-Engine_Edit_Role"), FR.i18nText("Fine-Engine_Platform_Role_Name"), roleName,
                        function (value) {
                            if (value) {
                                if (value.length > 0) {
                                    var customRole = FS.Trans.updateRoleUsers({
                                        role: {
                                            id: roleId,
                                            name: value
                                        }
                                    });
                                    if (customRole.illegal) {
                                        FR.Msg.alert(FR.i18nText('Fine-Engine_FS_Generic_Simple_Wrong'), FR.i18nText("FS-Privilege-Role_Name_Exists"));
                                        return false;
                                    }
                                    customRoleList.setTextAtIndex(index, value);
                                } else {
                                    // 角色名称为空
                                    FR.Msg.alert(FR.i18nText("Fine-Engine_FS_Generic_Simple_Alert"), FR.i18nText("FS-User-Empty_Custom_Role"));
                                    return false;
                                }
                            }
                        }, 225
                    );
                    e.stopEvent();
                } else {
                    //删除
                    var sroleId = customRoleList.getValueAtIndex(index);
                    FR.Msg.confirm(FR.i18nText("Fine-Engine_FS_Frame_Delete_Data"), FR.i18nText("FS-Generic-Sure_To_Delete") + '?', function (result) {
                        if (result) {
                            //先向后台请求删除数据，请求成功再在web端删除
                            FS.Trans.removeRole({
                                id: sroleId
                            });
                            customRoleList.remove(index);
                            if (customRoleList.getItemLength() > 0) {
                                customRoleList.selectItemByIndex(0, true);
                            } else {
                                self.tabPane.getWidgetByName(FSUM.Constants.sroleuserListWD).clear();
                            }
                        }
                    });
                }
                customRoleList.options.listItems[index].element.mouseup();
            },
            onCustomItemSelect: function () {
                var userlist = self.tabPane.getWidgetByName(FSUM.Constants.sroleuserListWD);
                userlist.refresh({
                    async: {
                        url: FR.servletURL + "?op=fs_set&cmd=auth_getsroleusers",
                        data: {
                            id: this.getValue(),
                            serverID: FS.serverID
                        }
                    }
                });
            },

            dataFilter: function (item) {
                return {
                    text: item.text,
                    value: item.id,
                    id: item.id,
                    isSync: item.isSync
                };
            },
            showToolCondition: function (item) {
                return !item.options.isSync;
            }
        });
        var config = {
            title: FR.i18nText("FS-Generic-Simple_Role"),
            content: {
                type: 'panel',
                width: 800,
                height: 510,
                doSize: true,
                contentWidget: {
                    type: 'absolute',
                    widgetName: 'SROLELAYOUT',
                    items: [
                        //角色管理
                        {
                            el: {
                                type: "panel",
                                width: paneWidth,
                                height: paneHeight,
                                title: FR.i18nText("FS-Generic-Simple_Role_Management"),
                                border: true,
                                doSize: true,
                                tools: sradd,
                                contentWidget: {
                                    type: 'border',
                                    items: [{
                                        region: 'center',
                                        el: customRoleList
                                    }, {
                                        region: 'north',
                                        el: {
                                            type: 'search',
                                            width: 308,
                                            autoSearch: true,
                                            onKeyup: keyupFunction
                                        },
                                        height: 28
                                    }],
                                    width: 308
                                }
                            }, x: 0, y: 0
                        },
                        //人员管理
                        {
                            el: {
                                type: "panel",
                                width: paneWidth,
                                height: paneHeight,
                                title: FR.i18nText("FS-User-Personnel_Management"),
                                border: true,
                                tools: useredit,
                                contentWidget: {
                                    type: 'quicklist',
                                    widgetName: FSUM.Constants.sroleuserListWD,
                                    scrollLoading: true,
                                    height: '100%',
                                    alwaysShowTools: false,
                                    itemCanBeSelect: true,
                                    onAsyncSuccess: function (items) {
                                        this.element.data("users", items);
                                    },
                                    dataFilter: function (item) {
                                        return {
                                            text: item.text,
                                            value: item.userid
                                        };
                                    },
                                    tools: [
                                        {
                                            iconCls: 'fs-module-delete-white',
                                            iconCls4Hover: 'fs-module-delete-white-hover'
                                        }
                                    ],
                                    onItemToolClick: function (toolindex, index) {
                                        var userlist = self.tabPane.getWidgetByName(FSUM.Constants.sroleuserListWD);
                                        //删除人员
                                        FR.Msg.confirm(FR.i18nText("Fine-Engine_FS_Frame_Delete_Data"), FR.i18nText("FS-Generic-Sure_To_Delete") + "?", function (result) {
                                            if (result) {
                                                var users = userlist.element.data("users");
                                                var uid = users[index].userid;
                                                var completeFn = function (res, status) {
                                                    if (status == 'success') {
                                                        var re = FR.jsonDecode(res.responseText);
                                                        if (re.success) {
                                                            userlist.remove(index);
                                                            users.splice(index, 1);
                                                            userlist.element.data("users", users);
                                                        } else {
                                                            FR.Msg.alert(FR.i18nText('Fine-Engine_FS_Generic_Simple_Wrong'), re.failed);
                                                        }
                                                    }
                                                };
                                                var sroleList = self.tabPane.getWidgetByName(FSUM.Constants.customRoleListWD);
                                                var config = {
                                                    data: {
                                                        userid: uid,
                                                        id: sroleList.getValue()
                                                    },
                                                    url: FR.servletURL + "?op=fs_set&cmd=auth_removesroleuser",
                                                    type: 'POST'
                                                };
                                                FS.Async.ajax(config, completeFn);
                                            }
                                        });
                                    },
                                    showToolCondition: function (item) {
                                        var customRoleList = self.tabPane.getWidgetByName(FSUM.Constants.customRoleListWD);
                                        var customRoleId = customRoleList.getValue();
                                        if (!customRoleId) {
                                            return false;
                                        }
                                        return !customRoleList.getItemById(customRoleId).options.isSync;
                                    }
                                }
                            }, x: 270, y: 0
                        }
                    ]
                }
            }
        };
        return config;
    },
    /**
     * 部门管理Panel的添加按钮
     */
    _createDpmgrTool: function () {
        var self = this;
        var cfg = [
            {
                iconCls: 'fs-module-add-white',
                width: 24,
                height: 24,
                handler: function () {
                    //添加部门
                    var selecteDepart = self.tabPane.getWidgetByName("DEPARTMENTTABLETREE").getSelectedNodes()[0];
                    if (!selecteDepart) {
                        FR.Msg.alert(FR.i18nText("Fine-Engine_FS_Generic_Simple_Alert"), FR.i18nText("FS-User-Do_Select_Department"));
                        return;
                    }
                    FR.Msg.prompt(FR.i18nText("FS-User-Add_Department"), FR.i18nText("FS-User-Department_Name"), "",
                        function (value) {
                            if (value) {
                                if (value.length > 0) {
                                    var departid = selecteDepart.id;
                                    var result = FS.Trans.addDepart({parentID: departid, text: value});
                                    if (result.success) {
                                        var node = {
                                            id: result.id,
                                            name: value,
                                            pId: departid,
                                            open: true
                                        };
                                        self.tabPane.getWidgetByName("DEPARTMENTTABLETREE").addNodes(selecteDepart, node, true);
                                    } else {
                                        FR.Msg.alert(FR.i18nText("Fine-Engine_FS_Generic_Simple_Alert"), FR.i18nText("FS-User-Same_Department"));
                                        return false;
                                    }
                                } else {
                                    // 部门名称为空
                                    FR.Msg.alert(FR.i18nText("Fine-Engine_FS_Generic_Simple_Alert"), FR.i18nText("FS-User-Empty_Department"));
                                    return false;
                                }
                            }
                        },
                        225
                    );
                }
            }
        ];
        return cfg;
    },
    /**
     * 自定义角色管理Panel的添加按钮
     */
    _createSRolemgrTool: function () {
        var self = this;
        var cfg = [
            {
                iconCls: 'fs-module-add-white',
                width: 24,
                height: 24,
                handler: function (e) {
                    //添加角色
                    var roleName = self.createUnRepeatName();
                    FR.Msg.prompt(FR.i18nText("Fine-Engine_Add_Role"), FR.i18nText("Fine-Engine_Platform_Role_Name"), roleName,
                        function (value) {
                            if (value) {
                                if (value.length > 0) {
                                    var customRole = FS.Trans.updateRoleUsers({
                                        role: {
                                            name: value
                                        }
                                    });
                                    if (customRole.illegal) {
                                        FR.Msg.alert(FR.i18nText('Fine-Engine_FS_Generic_Simple_Wrong'), FR.i18nText("FS-Privilege-Role_Name_Exists"));
                                        return false;
                                    } else {
                                        self.tabPane.getWidgetByName(FSUM.Constants.customRoleListWD).addItem(customRole, true);
                                    }
                                } else {
                                    // 角色名称为空
                                    FR.Msg.alert(FR.i18nText("Fine-Engine_FS_Generic_Simple_Alert"), FR.i18nText("FS-User-Empty_Custom_Role"));
                                    return false;
                                }
                            }
                        }, 225
                    );
                    e.stopEvent();
                }
            }
        ];
        return cfg;
    },
    createUnRepeatName: function (name) {
        if (name === null || name === undefined) {
            name = FR.i18nText("FS-Privilege-Normal_Role");
        }
        var customRoleList = this.tabPane.getWidgetByName(FSUM.Constants.customRoleListWD);
        var allRoles = customRoleList.getAllItemText();
        if (allRoles.length === 0) {
            return name + "1";
        }
        for (var i = 1; i < 10000; i++) {
            var newName = name + i;
            for (var m = 0; m < allRoles.length; m++) {
                if (allRoles[m] == newName) {
                    break;
                }
                if (m == allRoles.length - 1) {
                    return newName;
                }
            }
        }
    },

    /**
     * 部门管理Tabletree编辑和删除
     * @private
     */
    _createDptreeTool: function () {
        var self = this;
        var cfg = [
            {
                rootToolHide: true,
                iconCls: 'fs-module-edit-white',
                hoverCls: 'fs-module-edit-white-over',
                //编辑按钮事件
                onToolClick: function (e) {
                    var nodeID = $(this).data('nodeID');
                    var departTT = self.tabPane.getWidgetByName("DEPARTMENTTABLETREE");
                    var preDeleteNode = departTT.getNodeById(nodeID);
                    departTT.selectNode(preDeleteNode);
                    FR.Msg.prompt(FR.i18nText("FS-User-Edit_Department"),
                        FR.i18nText("FS-User-Department_Name"),
                        preDeleteNode.name,
                        function (value) {
                            if (value) {
                                var selecteDepart = departTT.getSelectedNodes()[0];
                                var departid = selecteDepart.id;
                                var result = FS.Trans.addDepart({id: departid, text: value});
                                if (result.success) {
                                    selecteDepart.name = value;
                                    departTT.updateNode(selecteDepart);
                                } else {
                                    FR.Msg.alert(FR.i18nText("Fine-Engine_FS_Generic_Simple_Alert"), FR.i18nText("FS-User-Same_Department"));
                                }
                            }
                        },
                        225);
                    e.stopEvent();
                }
            },
            {
                rootToolHide: true,
                iconCls: 'fs-module-delete-white',
                hoverCls: 'fs-module-delete-white-hover',
                //删除按钮事件
                onToolClick: function (e) {
                    var nodeID = $(this).data('nodeID');
                    var departTT = self.tabPane.getWidgetByName("DEPARTMENTTABLETREE");
                    var preDeleteNode = departTT.getNodeById(nodeID);
                    departTT.selectNode(preDeleteNode);
                    FR.Msg.confirm(FR.i18nText("Fine-Engine_FS_Frame_Delete_Data"), FR.i18nText("FS-Generic-Sure_To_Delete") + '?', function (result) {
                        if (result) {
                            //先向后台请求删除数据，请求成功再在web端删除
                            var departmentId = departTT.getSelectedNodes()[0].id;
                            FS.Trans.removeDepart(departmentId);
                            departTT.removeSelectedNodes();
                        }
                    });
                    e.stopEvent();
                }
            }
        ];
        return cfg;
    },

    /**
     * 职位列表编辑按钮
     * @private
     */
    _createPostTool: function () {
        var self = this;
        var cfg = [
            {
                iconCls: 'fs-module-edit-white',
                width: 24,
                height: 24,
                handler: function () {
                    self._createPostEditDialog();
                }
            }
        ];
        return cfg;
    },

    /**
     * 人员列表编辑按钮
     * @private
     */
    _createUserTool: function () {
        var self = this;
        var cfg = [
            {
                iconCls: 'fs-module-edit-white',
                width: 24,
                height: 24,
                handler: function () {
                    var dp = self._getPostAndDepart();
                    //用户添加
                    self._createUserDialog(dp);
                }
            }
        ];
        return cfg;
    },
    /**
     * 自定义角色人员列表编辑按钮
     * @private
     */
    _createSRoleUserTool: function () {
        var self = this;
        var cfg = [
            {
                iconCls: 'fs-module-edit-white',
                width: 24,
                height: 24,
                handler: function () {
                    var customRoleList = self.tabPane.getWidgetByName(FSUM.Constants.customRoleListWD);
                    var customRoleId = customRoleList.getValue();
                    var customRoleName = customRoleList.getText();
                    if (!customRoleId) {
                        return;
                    }
                    var isSync = customRoleList.getItemById(customRoleId).options.isSync;
                    //用户添加
                    self._createSRoleUserDialog({
                        name: customRoleName,
                        id: customRoleId,
                        isSync: isSync
                    });
                }
            }
        ];
        return cfg;
    },
    /**
     * 生成添加和编辑职位的对话框
     * @private
     */
    _createPostEditDialog: function () {
        var self = this;
        var depart = this.tabPane.getWidgetByName("DEPARTMENTTABLETREE").getSelectedNodes()[0];
        if (!depart) {
            return;
        }
        var departid = depart.id;
        var postlist = this.tabPane.getWidgetByName("POSTLIST");
        var toAddList = [], toDelList = [];
        var dialog = new FR.Dialog({
            confirm: true,
            needSeparate: 8,
            height: 450,
            width: 300,
            title: FR.i18nText("FS-User-Post_Management"),
            destroyOnClose: true,
            resizeable: false,
            onOK: function () {
                var delResult = true, addResult = true;
                if (toDelList.length) {
                    var re = FS.Trans.removePostsFromDepart({
                        departid: departid,
                        postid: toDelList.join(',')
                    });
                    delResult = re.success;
                }
                if (toAddList.length) {
                    var re = FS.Trans.addPostsToDepart({
                        departid: departid,
                        postid: toAddList.join(',')
                    });
                    addResult = re.success;
                }
                if (addResult && delResult) {
                    postlist.refresh();
                } else {
                    FR.Msg.toast(FR.i18nText("FS-Generic-Simple_Failed"));
                }
            },
            contentWidget: {
                type: 'border',
                items: [
                    {
                        region: 'north',
                        height: 1,
                        el: $('<div/>')
                    },
                    {
                        region: 'center',
                        el: {
                            type: 'search',
                            autoSearch: true,
                            widgetName: 'POSTNAMETEXT',
                            onKeyup: function (e) {
                                var val = this.getValue(), data = {departid: depart.id};
                                if (val) {
                                    data.keyword = val;
                                }
                                var allpost = dialog.getWidgetByName('ALLPOSTLIST');
                                if (!FR.isNavKeyPress(e)) {
                                    setTimeout(function () {
                                        allpost.clear();
                                        data = $.extend(data, {serverID: FS.serverID});

                                        allpost.refresh({
                                            async: {
                                                url: FR.servletURL + "?op=fs_set&cmd=auth_getfilterposts",
                                                data: data
                                            }
                                        });
                                    }, 100);
                                }
                            }
                        }
                    },
                    {
                        region: 'west',
                        width: 1,
                        el: $('<div/>')
                    },
                    {
                        region: 'east',
                        width: 24,
                        el: {
                            type: 'iconbutton',
                            widgetName: 'POSTADDBTN',
                            imgsrc: 'fs-usermgr-add-blue',
                            handler: function () {
                                //职位列表添加职位
                                var newpost = dialog.getWidgetByName("POSTNAMETEXT").getValue();
                                if (!newpost) {
                                    FR.Msg.alert(FR.i18nText("Fine-Engine_FS_Generic_Simple_Alert"), FR.i18nText("FS-User-Position_Can_Not_Be_Null"));
                                    return;
                                }
                                var id = FS.Trans.addPost({postname: newpost});
                                if (id > 0) {
                                    dialog.getWidgetByName("ALLPOSTLIST").addItem({
                                        text: newpost,
                                        id: id
                                    });
                                } else {
                                    FR.Msg.alert(FR.i18nText("Fine-Engine_FS_Generic_Simple_Alert"), FR.i18nText("FS-User-Add_Position_Failure"));
                                }
                            }
                        }
                    },
                    {
                        region: 'south',
                        height: 342,
                        el: {
                            type: 'quicklist',
                            widgetName: 'ALLPOSTLIST',
                            alwaysShowTools: false,
                            itemCanBeSelect: true,
                            paddingLeft: 0,
                            valueField: 'id',
                            async: {
                                url: FR.servletURL + "?op=fs_set&cmd=auth_getfilterposts",
                                data: {
                                    departid: departid,
                                    serverID: FS.serverID
                                }
                            },
                            tools: [
                                {
                                    iconCls: 'fs-module-delete-white',
                                    iconCls4Hover: 'fs-module-delete-white-hover'
                                }
                            ],
                            onBeforeItemCreate: function (element, options) {
                                var $check = new FR.CheckBox({
                                    renderEl: element,
                                    height: this.options.height,
                                    value: options.inDepart ? true : false,
                                    listeners: [{
                                        eventName: FR.Events.STATECHANGE,
                                        action: function () {
                                            var id = options.id;
                                            if (this.getValue()) {
                                                if (toDelList.length === toDelList.removeWeakEqual(id).length) {
                                                    toAddList.push(id);
                                                }
                                            } else {
                                                if (toAddList.length === toAddList.removeWeakEqual(id).length) {
                                                    toDelList.push(id);
                                                }
                                            }
                                        }
                                    }]
                                });
                                if (options.auth === false) {
                                    $check.setEnable(false);
                                }
                            },
                            onItemToolClick: function (toolindex, index) {
                                var allpostlist = dialog.getWidgetByName('ALLPOSTLIST');
                                var selpost = allpostlist.getValueAtIndex(index);
                                if (!selpost) {
                                    return;
                                }
                                if (allpostlist.options.items[index].auth === false) {
                                    FR.Msg.alert(FR.i18nText("Fine-Engine_FS_Generic_Simple_Wrong"), FR.i18nText("FS-Privilege-No_Privilege") + FR.i18nText("FS-Generic-Simple_Delete"));
                                    return;
                                }
                                //删除职位
                                FR.Msg.confirm(FR.i18nText("Fine-Engine_FS_Frame_Delete_Data"), FR.i18nText("FS-Generic-Sure_To_Delete") + "?", function (result) {
                                    if (result) {
                                        var completeFn = function (res, status) {
                                            if (status == 'success') {
                                                var re = FR.jsonDecode(res.responseText);
                                                if (re.success) {
                                                    toAddList.removeWeakEqual(selpost);
                                                    allpostlist.remove(index);
                                                }
                                            }
                                        };
                                        var config = {
                                            url: FR.servletURL + "?op=fs_set&cmd=auth_removepost",
                                            data: {
                                                id: selpost
                                            },
                                            type: 'POST'
                                        };
                                        FS.Async.ajax(config, completeFn);
                                    }
                                });
                            }
                        }
                    }
                ]
            }
        });
        dialog.setVisible(true);
    },

    /**
     * 生成添加和删除用户的对话框
     * @param data 初始化数据
     * @private
     */
    _createUserDialog: function (data) {
        var self = this;
        var $userOptPane = FS.Tools.createPublicUserOptPane({
                url: FR.servletURL + "?op=fs_set&cmd=auth_getfilterusers",
                type: 'POST',
                data: data
            }),
            userlist = this.tabPane.getWidgetByName('USERLIST');
        var staffLabelWidth = FR.i18nTextWidth("FS-User-Simple_Staff", 7);
        var userDialog = new FR.Dialog({
            confirm: true,
            title: FR.i18nText("FS-User-Personnel_Management"),
            width: 550,
            height: 445,
            doSize: true,
            destroyOnClose: true,
            contentWidget: {
                type: 'absolute',
                widgetName: 'USERABSOLUTE',
                items: [
                    {
                        el: {
                            type: 'label',
                            widgetName: 'POSTNAME',
                            wrap: false,
                            fontsize: 14,
                            color: '#676767',
                            width: 220,
                            value: data.departname + '-' + data.postname,
                            title: data.departname + '-' + data.postname,
                            height: 21
                        }, x: 15, y: 12
                    },
                    {
                        el: {
                            type: 'label',
                            width: staffLabelWidth,
                            value: FR.i18nText("FS-User-Simple_Staff"),
                            fontsize: 14
                        }, x: 295 - staffLabelWidth, y: 14
                    },
                    {
                        el: {
                            type: 'search',
                            width: 210,
                            autoSearch: true,
                            widgetName: FSUM.Constants.userSearchWD,
                            height: 21,
                            watermark: FR.i18nText("Fine-Engine_Search"),
                            onKeyup: function (e) {
                                if (self.filerid != null) {
                                    clearTimeout(self.filerid);
                                    self.filerid = null;
                                }
                                if (!FR.isNavKeyPress(e)) {
                                    var val = this.getValue();
                                    var dp = {
                                        departid: data.departid,
                                        postid: data.postid
                                    };
                                    if (val) {
                                        dp.keyword = val;
                                    }
                                    self.filerid = setTimeout(function () {
                                        $userOptPane.refresh(dp, $userOptPane.seluser, $userOptPane.alluser, function () {
                                            $userOptPane.seluser.empty();
                                            $userOptPane.alluser.empty();
                                        });
                                    }, 200);
                                }
                            }
                        }, x: 300, y: 14
                    },
                    {el: $userOptPane, x: 15, y: 50}
                ]
            },
            onOK: function () {
                var addids = $userOptPane.getAddlist, delids = $userOptPane.getDellist;
                //批量添加人员
                if (addids.length) {
                    FS.Trans.addEmployee({
                        userid: addids.join(','),
                        departid: data.departid,
                        postid: data.postid
                    });
                }
                //批量删除人员
                if (delids.length) {
                    FS.Trans.removeEmployee({
                        userid: delids.join(','),
                        departid: data.departid,
                        postid: data.postid
                    });
                }
                data = $.extend(data, {serverID: FS.serverID});

                userlist.refresh({
                    async: {
                        url: FR.servletURL + "?op=fs_set&cmd=auth_getallemployee",
                        data: data
                    }
                });
            }
        });
        userDialog.setVisible(true);
    },

    /**
     * 普通角色生成添加和删除用户的对话框
     * @param data 初始化数据
     * @private
     */
    _createSRoleUserDialog: function (role) {
        var $userOptPane = FS.Tools.createPublicUserOptPane({
            url: FR.servletURL + "?op=fs_set&cmd=auth_getfilterusers",
            type: 'POST',
            data: {
                roleName: role.name
            },
            isSync: role.isSync
        });
        var depLabelWidth = FR.i18nTextWidth("FS-User-Simple_Department", 7);
        var staffLabelWidth = FR.i18nTextWidth("FS-User-Simple_Staff", 7);
        var userlist = this.tabPane.getWidgetByName(FSUM.Constants.sroleuserListWD);
        var userDialog = new FR.Dialog({
            confirm: true,
            title: FR.i18nText("FS-User-Personnel_Management"),
            width: 550,
            height: 445,
            doSize: true,
            destroyOnClose: true,
            contentWidget: {
                type: 'absolute',
                items: [
                    {
                        el: {
                            type: 'label',
                            width: depLabelWidth,
                            value: FR.i18nText("FS-User-Simple_Department"),
                            fontsize: 14
                        }, x: 15, y: 14
                    },
                    {
                        el: {
                            type: 'treecombobox',
                            mutiSelection: true,
                            widgetName: FSUM.Constants.departMultiTreeWD,
                            width: 210,
                            height: 21,
                            fontSize: 12,
                            watermark: FR.i18nText("Fine-Engine_Search"),
                            widgetUrl: FR.servletURL + "?op=fs_set&cmd=auth_dpu_tree&type=3",
                            returnFullPath: true,
                            selectLeafOnly: true,
                            listeners: [{
                                eventName: 'afteredit',
                                action: function () {
                                    var department = this.getValue();
                                    var keyword = userDialog.getWidgetByName(FSUM.Constants.userSearchWD);
                                    var dp = {
                                        depart: department,
                                        keyword: keyword.getValue(),
                                        roleName: role.name
                                    };
                                    $userOptPane.refresh(dp, $userOptPane.seluser, $userOptPane.alluser, function () {
                                        $userOptPane.seluser.empty();
                                        $userOptPane.alluser.empty();
                                    });

                                }
                            }]
                        }, x: depLabelWidth + 20, y: 14
                    },
                    {
                        el: {
                            type: 'label',
                            width: staffLabelWidth,
                            value: FR.i18nText("FS-User-Simple_Staff"),
                            fontsize: 14
                        }, x: 315 - staffLabelWidth, y: 14
                    },
                    {
                        el: {
                            type: 'search',
                            width: 210,
                            autoSearch: true,
                            widgetName: FSUM.Constants.userSearchWD,
                            watermark: FR.i18nText("Fine-Engine_Search"),
                            height: 21,
                            onKeyup: function (e) {
                                if (!FR.isNavKeyPress(e)) {
                                    var departTree = userDialog.getWidgetByName(FSUM.Constants.departMultiTreeWD);
                                    var keyword = this.getValue();
                                    var dp = {
                                        depart: departTree.getValue(),
                                        keyword: keyword,
                                        roleName: role.name
                                    };
                                    setTimeout(function () {
                                        $userOptPane.refresh(dp, $userOptPane.seluser, $userOptPane.alluser, function () {
                                            $userOptPane.seluser.empty();
                                            $userOptPane.alluser.empty();
                                        });
                                    }, 100);
                                }
                            }
                        }, x: 320, y: 14
                    },
                    {el: $userOptPane, x: 15, y: 50}
                ]
            },
            onOK: function () {
                var addids = $userOptPane.getAddlist, delids = $userOptPane.getDellist;
                var customRole = FS.Trans.updateRoleUsers({
                    role: role,
                    addids: addids.join(','),
                    delids: delids.join(',')
                });
                if (customRole.illegal) {
                    FR.Msg.alert(FR.i18nText('Fine-Engine_FS_Generic_Simple_Wrong'), FR.i18nText("FS-Privilege-Role_Name_Exists"));
                    return false;
                }
                userlist.refresh({
                    async: {
                        url: FR.servletURL + "?op=fs_set&cmd=auth_getsroleusers",
                        data: {
                            id: role.id,
                            serverID: FS.serverID
                        }
                    }
                });
            },
            onBeforeClose: function () {
                var departTree = userDialog.getWidgetByName(FSUM.Constants.departMultiTreeWD);
                departTree._showView = FR.emptyFn;//REPORT-4627 暂时用删showview函数来处理.todo 怎么在组件层面系统解决此类问题
            }
        });
        userDialog.setVisible(true);
    },

    /**
     * 获取选中的部门和职位
     * @returns {*}
     * @private
     */
    _getPostAndDepart: function () {
        var depart = this.tabPane.getWidgetByName("DEPARTMENTTABLETREE").getSelectedNodes()[0],
            post = this.tabPane.getWidgetByName("POSTLIST");
        if (depart && post) {
            return {
                departname: depart.name,
                departid: depart.id,
                postid: post.getValue(),
                postname: post.getText()
            };
        } else {
            return null;
        }
    },

    _alreadyExists: function (id, result) {
        for (var i = 0; i < result.length; i++) {
            if (result[i].id === id) {
                return true;
            }
        }
        return false;
    },

    /**
     * 用户登录管理
     */
    userLimitTabConfig: function () {
        var self = this;
        return {
            title: FR.i18nText("FS-User-Platform_User_Management"),
            content: {
                type: 'panel',
                widgetName: FSUM.Constants.userLimitConfigPanelWD,
                doSize: true,
                width: 650,
                height: 460,
                closeAfterAction: false,
                contentWidget: {
                    type: 'tablepane',
                    widgetName: FSUM.Constants.userLimitConfigTableWD,
                    colSize: [270, 18, 44, 18, 'fill'],
                    rowSize: [24, 420],
                    scrollable: true,
                    vgap: 8,
                    items: [
                        [
                            null, null, null, null, self._createUserLimitTip()
                        ], [
                            self._createUserPanel(false),
                            {}, self._createUserAuthButtons(),
                            {}, self._createUserPanel(true)
                        ]
                    ]
                }
            }
        };
    },

    _createUserLimitTip: function () {
        return $('<div/>').addClass("fs-user-limit-tip").append(
            $('<span/>').text(FR.i18nText("FS-User-User_Limit_Tip_Left") + " " +
                FS.config.userLimit + " " + FR.i18nText("FS-User-User_Limit_Tip_Right")
            )
        );
    },

    _createUserPanel: function (isAuthorizedList) {
        var self = this;
        var userPanelOptions = isAuthorizedList ? {
                panelWidgetName: FSUM.Constants.userLimitUnauthorizedPanelWD,
                panelTitle: FR.i18nText("FS-User-Authorized_Users"),
                listWidgetName: FSUM.Constants.userLimitAuthorizedListWD,
                listPanelWidgetName: FSUM.Constants.userLimitAuthorizedListPanelWD,
                listUrl: FR.servletURL + "?op=fs_set&cmd=auth_getall_loginusers&type=fs"
            } : {
                panelWidgetName: FSUM.Constants.userLimitAuthorizedPanelWD,
                panelTitle: FR.i18nText("FS-User-Unauthorized_Users"),
                listWidgetName: FSUM.Constants.userLimitUnauthorizedListWD,
                listPanelWidgetName: FSUM.Constants.userLimitUnauthorizedListPanelWD,
                listUrl: FR.servletURL + "?op=fs_set&cmd=auth_getallusers&exclude=fs_login"
            };
        var searchFunc = function (e) {
            if (self.searchId != null) {
                clearTimeout(self.searchId);
                self.searchId = null;
            }
            self.searchId = setTimeout(function () {
                if (!FR.isNavKeyPress(e)) {
                    var val = this.getValue();
                    var userList = self.tabPane.getWidgetByName(userPanelOptions.listWidgetName);
                    userList.refresh({
                        async: {
                            url: userPanelOptions.listUrl,
                            data: {
                                dataFilter: val
                            }
                        }
                    });
                }
            }.createDelegate(this), 200);
        };
        var items = [
            [{
                type: 'search',
                width: 268,
                autoSearch: true,
                onKeyup: searchFunc
            }],
            [{
                type: 'panel',
                widgetName: userPanelOptions.listPanelWidgetName,
                width: 268,
                height: 346,
                doSize: true,
                contentWidget: {
                    type: 'quicklist',
                    width: 268,
                    fit: false,
                    scrollLoading: true,
                    widgetName: userPanelOptions.listWidgetName,
                    async: {
                        url: userPanelOptions.listUrl,
                        data: {
                            serverID: FS.serverID
                        }
                    },
                    dataFilter: function (user) {
                        return {
                            text: (user.realname || "") + '(' + user.username + ')',
                            value: user.username,
                            realname: user.realname
                        };
                    },
                    itemCanBeSelect: true,
                    onItemSelect: function () {
                        self.setAuthButtonStatus();
                    }
                }
            }]
        ];
        return {
            type: 'panel',
            fit: false,
            title: userPanelOptions.panelTitle,
            width: 270,
            height: 375,
            widgetName: userPanelOptions.panelWidgetName,
            border: true,
            contentWidget: {
                type: 'tablepane',
                colSize: [270],
                rowSize: [28, 'fill'],
                items: items
            }
        };
    },

    _createUserAuthButtons: function () {
        var self = this;
        return {
            type: 'tablepane',
            colSize: ['fill'],
            rowSize: [148, 24, 30, 24, 'fill'],
            items: [
                [[]], [{
                    type: 'iconbutton',
                    widgetName: FSUM.Constants.userLimitAuthMoveRightButtonWD,
                    baseClass: 'fs-user-auth-move-right-icon',
                    imgsrc: 'fs-user-auth-move-right',
                    width: 44,
                    height: 24,
                    handler: function () {
                        var unauthorizedList = self.tabPane.getWidgetByName(FSUM.Constants.userLimitUnauthorizedListWD);
                        var index = unauthorizedList.getSelectedIndex();
                        if (index == null) {
                            return;
                        }
                        self.setLoginUser(index, false);
                    }
                }], [[]], [{
                    type: 'iconbutton',
                    widgetName: FSUM.Constants.userLimitAuthMoveLeftButtonWD,
                    baseClass: 'fs-user-auth-move-left-icon',
                    imgsrc: 'fs-user-auth-move-left',
                    width: 44,
                    height: 24,
                    handler: function () {
                        var authorizedList = self.tabPane.getWidgetByName(FSUM.Constants.userLimitAuthorizedListWD);
                        var index = authorizedList.getSelectedIndex();
                        if (index === null) {
                            return;
                        }
                        self.setLoginUser(index, true);
                    }
                }], [[]]
            ]
        };
    },

    /**
     * 支持移动端访问用户设置设置按钮状态
     */
    setAuthButtonStatus: function () {
        var pane = this.tabPane;
        var authorizedList = pane.getWidgetByName(FSUM.Constants.userLimitAuthorizedListWD),
            unauthorizedList = pane.getWidgetByName(FSUM.Constants.userLimitUnauthorizedListWD);
        var moveLeftButton = pane.getWidgetByName(FSUM.Constants.userLimitAuthMoveLeftButtonWD),
            moveRightButton = pane.getWidgetByName(FSUM.Constants.userLimitAuthMoveRightButtonWD);
        var enableLeft = true,
            enableRight = true;
        enableLeft &= !FR.isNull(authorizedList.getSelectedIndex());
        enableLeft &= authorizedList.getItemLength() !== 0;
        moveLeftButton.setEnable(Boolean(enableLeft));
        enableRight &= !FR.isNull(unauthorizedList.getSelectedIndex());
        enableRight &= unauthorizedList.getItemLength() !== 0;
        enableRight &= authorizedList.getItemLength() < FS.config.userLimit;
        moveRightButton.setEnable(Boolean(enableRight));
    },

    /**
     * 设置允许平台登录的用户
     * @param index 列表中的索引顺序
     * @param isRemove 是否为移除操作
     */
    setLoginUser: function (index, isRemove) {
        var self = this;
        var sourceList = isRemove ? this.tabPane.getWidgetByName(FSUM.Constants.userLimitAuthorizedListWD)
            : this.tabPane.getWidgetByName(FSUM.Constants.userLimitUnauthorizedListWD);
        var targetList = isRemove ? this.tabPane.getWidgetByName(FSUM.Constants.userLimitUnauthorizedListWD)
            : this.tabPane.getWidgetByName(FSUM.Constants.userLimitAuthorizedListWD);
        var username = sourceList.getValue();
        var realname = sourceList.options.listItems[index].options.realname;
        var cmd = isRemove ? "auth_removeloginuser" : "auth_addloginuser";
        var completeFn = function (res, status) {
            if (status == "success") {
                var success = FR.jsonDecode(res.responseText).success;
                if (success) {
                    sourceList.remove(index);
                    targetList.addItem({
                        text: (realname || "") + '(' + username + ')',
                        value: username,
                        realname: realname
                    });
                    //重新选取
                    if (sourceList.getItemLength() === 0) {
                        index = -1;
                    } else if (index >= sourceList.getItemLength()) {
                        index = sourceList.getItemLength() - 1;
                    }
                    if (index !== -1) {
                        sourceList.selectItemByIndex(index);
                    }
                    self.setAuthButtonStatus();
                }
            }
        };
        var config = {
            url: FR.servletURL + "?op=fs_set&cmd=" + cmd + "&type=fs",
            type: "POST",
            data: {
                'username': username
            }
        };
        FS.Async.ajax(config, completeFn);
    }
}
;
